/* Device.c generated by valac 0.43.92, the Vala compiler
 * generated from Device.vala, do not modify */

/*
 * Device.vala
 *
 * Copyright 2012-2018 Tony George <teejeetech@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */
/* Functions and classes for handling disk partitions */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <gtk/gtk.h>

#define TYPE_DEVICE (device_get_type ())
#define DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DEVICE, Device))
#define DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DEVICE, DeviceClass))
#define IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DEVICE))
#define IS_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DEVICE))
#define DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DEVICE, DeviceClass))

typedef struct _Device Device;
typedef struct _DeviceClass DeviceClass;
typedef struct _DevicePrivate DevicePrivate;

#define TYPE_MOUNT_ENTRY (mount_entry_get_type ())
#define MOUNT_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MOUNT_ENTRY, MountEntry))
#define MOUNT_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MOUNT_ENTRY, MountEntryClass))
#define IS_MOUNT_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MOUNT_ENTRY))
#define IS_MOUNT_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MOUNT_ENTRY))
#define MOUNT_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MOUNT_ENTRY, MountEntryClass))

typedef struct _MountEntry MountEntry;
typedef struct _MountEntryClass MountEntryClass;
enum  {
	DEVICE_0_PROPERTY,
	DEVICE_FREE_BYTES_PROPERTY,
	DEVICE_SIZE_PROPERTY,
	DEVICE_USED_PROPERTY,
	DEVICE_FREE_PROPERTY,
	DEVICE_IS_MOUNTED_PROPERTY,
	DEVICE_FULL_NAME_WITH_ALIAS_PROPERTY,
	DEVICE_FULL_NAME_WITH_PARENT_PROPERTY,
	DEVICE_SHORT_NAME_WITH_ALIAS_PROPERTY,
	DEVICE_SHORT_NAME_WITH_PARENT_PROPERTY,
	DEVICE_DEVICE_NAME_WITH_PARENT_PROPERTY,
	DEVICE_NUM_PROPERTIES
};
static GParamSpec* device_properties[DEVICE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _MountEntryPrivate MountEntryPrivate;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_match_info_unref0(var) ((var == NULL) ? NULL : (var = (g_match_info_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_TIMEOUT_COUNTER (timeout_counter_get_type ())
#define TIMEOUT_COUNTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TIMEOUT_COUNTER, TimeoutCounter))
#define TIMEOUT_COUNTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TIMEOUT_COUNTER, TimeoutCounterClass))
#define IS_TIMEOUT_COUNTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TIMEOUT_COUNTER))
#define IS_TIMEOUT_COUNTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TIMEOUT_COUNTER))
#define TIMEOUT_COUNTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TIMEOUT_COUNTER, TimeoutCounterClass))

typedef struct _TimeoutCounter TimeoutCounter;
typedef struct _TimeoutCounterClass TimeoutCounterClass;

struct _Device {
	GObject parent_instance;
	DevicePrivate * priv;
	gchar* device;
	gchar* name;
	gchar* kname;
	gchar* pkname;
	gchar* pkname_toplevel;
	gchar* mapped_name;
	gchar* uuid;
	gchar* label;
	gchar* partuuid;
	gchar* partlabel;
	gint major;
	gint minor;
	gchar* device_mapper;
	gchar* device_by_uuid;
	gchar* device_by_label;
	gchar* device_by_partuuid;
	gchar* device_by_partlabel;
	gchar* type;
	gchar* fstype;
	gint order;
	gchar* vendor;
	gchar* model;
	gchar* serial;
	gchar* revision;
	gboolean removable;
	gboolean read_only;
	guint64 size_bytes;
	guint64 used_bytes;
	guint64 available_bytes;
	gchar* used_percent;
	gchar* dist_info;
	GeeArrayList* mount_points;
	GeeArrayList* symlinks;
	Device* parent;
	GeeArrayList* children;
};

struct _DeviceClass {
	GObjectClass parent_class;
};

struct _MountEntry {
	GObject parent_instance;
	MountEntryPrivate * priv;
	Device* device;
	gchar* mount_point;
	gchar* mount_options;
};

struct _MountEntryClass {
	GObjectClass parent_class;
};

static gpointer device_parent_class = NULL;
extern gdouble device_KB;
gdouble device_KB = (gdouble) 1000;
extern gdouble device_MB;
gdouble device_MB = 0.0;
extern gdouble device_GB;
gdouble device_GB = 0.0;
extern gdouble device_KiB;
gdouble device_KiB = (gdouble) 1024;
extern gdouble device_MiB;
gdouble device_MiB = 0.0;
extern gdouble device_GiB;
gdouble device_GiB = 0.0;
static gchar* device_lsblk_version;
static gchar* device_lsblk_version = NULL;
static gboolean device_lsblk_is_ancient;
static gboolean device_lsblk_is_ancient = FALSE;
static GeeArrayList* device_device_list;
static GeeArrayList* device_device_list = NULL;
extern gboolean tee_jee_logging_LOG_DEBUG;

GType device_get_type (void) G_GNUC_CONST;
GType mount_entry_get_type (void) G_GNUC_CONST;
Device* device_new (void);
Device* device_construct (GType object_type);
void device_test_lsblk_version (void);
gint tee_jee_process_helper_exec_sync (const gchar* cmd,
                                       gchar* * std_out,
                                       gchar* * std_err);
gboolean device_is_mounted_at_path (Device* self,
                                    const gchar* subvolname,
                                    const gchar* mount_path);
gboolean device_has_linux_filesystem (Device* self);
gboolean device_is_encrypted_partition (Device* self);
gboolean device_is_on_encrypted_partition (Device* self);
gboolean device_is_lvm_partition (Device* self);
gboolean device_has_children (Device* self);
Device* device_first_linux_child (Device* self);
gboolean device_has_parent (Device* self);
GeeArrayList* device_get_filesystems (gboolean get_space,
                                      gboolean get_mounts);
GeeArrayList* device_get_block_devices_using_lsblk (const gchar* dev_name);
GeeArrayList* device_get_disk_space_using_df (const gchar* dev_name_or_mount_point);
Device* device_find_device_in_list (GeeArrayList* list,
                                    const gchar* _dev_alias);
GeeArrayList* device_get_mounted_filesystems_using_mtab (void);
void tee_jee_logging_log_debug (const gchar* message);
static void device_find_child_devices (GeeArrayList* list,
                                Device* parent);
static void device_find_toplevel_parent (GeeArrayList* list,
                                  Device* dev);
static void device_find_child_devices_using_dmsetup (GeeArrayList* list);
void tee_jee_logging_log_error (const gchar* message,
                                gboolean highlight,
                                gboolean is_warning);
MountEntry* mount_entry_new (Device* device,
                             const gchar* mount_point,
                             const gchar* mount_options);
MountEntry* mount_entry_construct (GType object_type,
                                   Device* device,
                                   const gchar* mount_point,
                                   const gchar* mount_options);
gchar* tee_jee_file_system_path_combine (const gchar* path1,
                                         const gchar* path2);
gboolean tee_jee_file_system_file_exists (const gchar* file_path);
GeeArrayList* device_get_block_devices_using_blkid (const gchar* dev_name);
gint tee_jee_process_helper_exec_script_sync (const gchar* script,
                                              gchar* * std_out,
                                              gchar* * std_err,
                                              gboolean supress_errors,
                                              gboolean run_as_admin,
                                              gboolean cleanup_tmp,
                                              gboolean print_to_terminal);
gchar* tee_jee_file_system_escape_single_quote (const gchar* file_path);
gchar* device_resolve_device_name (const gchar* dev_alias);
gchar* device_get_device_uuid (const gchar* device);
gchar* tee_jee_file_system_file_read (const gchar* file_path);
Device* device_get_device_by_uuid (const gchar* uuid);
Device* device_get_device_by_name (const gchar* file_name);
Device* device_get_device_by_path (const gchar* path_to_check);
GeeArrayList* device_get_device_mount_points (const gchar* dev_name_or_uuid);
gboolean device_device_is_mounted (const gchar* dev_name_or_uuid);
gboolean device_mount_point_in_use (const gchar* mount_point);
gboolean tee_jee_file_system_file_is_symlink (const gchar* file_path);
gchar* tee_jee_file_system_file_get_symlink_target (const gchar* file_path);
void device_copy_fields_from (Device* self,
                              Device* dev2);
Device* device_query_changes (Device* self);
void device_query_disk_space (Device* self);
gboolean device_automount_udisks (const gchar* dev_name_or_uuid,
                                  GtkWindow* parent_window);
void tee_jee_gtk_helper_gtk_messagebox (const gchar* title,
                                        const gchar* message,
                                        GtkWindow* parent_win,
                                        gboolean is_error);
gboolean device_automount_udisks_iso (const gchar* iso_file_path,
                                      gchar* * loop_device,
                                      GtkWindow* parent_window);
void tee_jee_logging_log_msg (const gchar* message,
                              gboolean highlight);
gboolean device_unmount_udisks (const gchar* dev_name_or_uuid,
                                GtkWindow* parent_window);
Device* device_luks_unlock (Device* luks_device,
                            const gchar* mapped_name,
                            const gchar* passphrase,
                            GtkWindow* parent_window,
                            gchar* * message,
                            gchar* * details);
GType timeout_counter_get_type (void) G_GNUC_CONST;
TimeoutCounter* timeout_counter_new (void);
TimeoutCounter* timeout_counter_construct (GType object_type);
void timeout_counter_kill_process_on_timeout (TimeoutCounter* self,
                                              const gchar* process_to_kill,
                                              gint seconds_to_wait,
                                              gboolean exit_app);
void timeout_counter_stop (TimeoutCounter* self);
gchar* tee_jee_gtk_helper_gtk_inputbox (const gchar* title,
                                        const gchar* message,
                                        GtkWindow* parent_win,
                                        gboolean mask_password);
gboolean device_luks_lock (const gchar* kname,
                           GtkWindow* parent_window);
gboolean device_mount (const gchar* dev_name_or_uuid,
                       const gchar* mount_point,
                       const gchar* mount_options,
                       gboolean silent);
gboolean tee_jee_file_system_dir_create (const gchar* dir_path,
                                         gboolean show_message);
gboolean device_unmount (const gchar* mount_point);
gchar* device_get_device_name_with_parent (Device* self);
gchar* device_automount (const gchar* dev_name_or_uuid,
                         const gchar* mount_options,
                         const gchar* mount_prefix);
gchar* device_description (Device* self);
gchar* device_description_formatted (Device* self);
gchar* tee_jee_file_system_format_file_size (guint64 size,
                                             gboolean binary_units,
                                             const gchar* unit,
                                             gboolean show_units,
                                             gint decimals);
gchar* device_get_short_name_with_parent (Device* self);
gchar* device_description_simple (Device* self);
gchar* device_description_simple_formatted (Device* self);
gchar* device_description_full_free (Device* self);
guint64 device_get_free_bytes (Device* self);
gchar* device_description_free (Device* self);
gchar* device_description_full (Device* self);
gchar* device_get_used (Device* self);
gchar* device_get_size (Device* self);
gchar* device_description_usage (Device* self);
gchar* device_tooltip_text (Device* self);
static gchar* device_display_name (Device* self,
                            gboolean short_name,
                            gboolean show_label,
                            gboolean show_parent,
                            gboolean show_alias);
void device_test_all (void);
void device_print_device_list (GeeArrayList* list);
void device_print_device_mounts (GeeArrayList* list);
void device_print_device_disk_space (GeeArrayList* list);
gchar* device_get_free (Device* self);
gboolean device_get_is_mounted (Device* self);
gchar* device_get_full_name_with_alias (Device* self);
gchar* device_get_full_name_with_parent (Device* self);
gchar* device_get_short_name_with_alias (Device* self);
static void device_finalize (GObject * obj);
static void _vala_device_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

Device*
device_construct (GType object_type)
{
	Device * self = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
#line 94 "Utility/Device.vala"
	self = (Device*) g_object_new (object_type, NULL);
#line 95 "Utility/Device.vala"
	_tmp0_ = gee_array_list_new (TYPE_MOUNT_ENTRY, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 95 "Utility/Device.vala"
	_g_object_unref0 (self->mount_points);
#line 95 "Utility/Device.vala"
	self->mount_points = _tmp0_;
#line 96 "Utility/Device.vala"
	_tmp1_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 96 "Utility/Device.vala"
	_g_object_unref0 (self->symlinks);
#line 96 "Utility/Device.vala"
	self->symlinks = _tmp1_;
#line 97 "Utility/Device.vala"
	_tmp2_ = gee_array_list_new (TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 97 "Utility/Device.vala"
	_g_object_unref0 (self->children);
#line 97 "Utility/Device.vala"
	self->children = _tmp2_;
#line 99 "Utility/Device.vala"
	device_test_lsblk_version ();
#line 94 "Utility/Device.vala"
	return self;
#line 357 "Device.c"
}

Device*
device_new (void)
{
#line 94 "Utility/Device.vala"
	return device_construct (TYPE_DEVICE);
#line 365 "Device.c"
}

void
device_test_lsblk_version (void)
{
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gint status = 0;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gint _tmp7_;
#line 104 "Utility/Device.vala"
	_tmp1_ = device_lsblk_version;
#line 104 "Utility/Device.vala"
	if (_tmp1_ != NULL) {
#line 383 "Device.c"
		const gchar* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
#line 104 "Utility/Device.vala"
		_tmp2_ = device_lsblk_version;
#line 104 "Utility/Device.vala"
		_tmp3_ = strlen (_tmp2_);
#line 104 "Utility/Device.vala"
		_tmp4_ = _tmp3_;
#line 104 "Utility/Device.vala"
		_tmp0_ = _tmp4_ > 0;
#line 395 "Device.c"
	} else {
#line 104 "Utility/Device.vala"
		_tmp0_ = FALSE;
#line 399 "Device.c"
	}
#line 104 "Utility/Device.vala"
	if (_tmp0_) {
#line 105 "Utility/Device.vala"
		return;
#line 405 "Device.c"
	}
#line 109 "Utility/Device.vala"
	_tmp7_ = tee_jee_process_helper_exec_sync ("lsblk --bytes --pairs --output HOTPLUG,PKNAME,VENDOR,SERIAL,REV", &_tmp5_, &_tmp6_);
#line 109 "Utility/Device.vala"
	_g_free0 (std_out);
#line 109 "Utility/Device.vala"
	std_out = _tmp5_;
#line 109 "Utility/Device.vala"
	_g_free0 (std_err);
#line 109 "Utility/Device.vala"
	std_err = _tmp6_;
#line 109 "Utility/Device.vala"
	status = _tmp7_;
#line 110 "Utility/Device.vala"
	if (status == 0) {
#line 421 "Device.c"
		const gchar* _tmp8_;
		gchar* _tmp9_;
#line 111 "Utility/Device.vala"
		_tmp8_ = std_out;
#line 111 "Utility/Device.vala"
		_tmp9_ = g_strdup (_tmp8_);
#line 111 "Utility/Device.vala"
		_g_free0 (device_lsblk_version);
#line 111 "Utility/Device.vala"
		device_lsblk_version = _tmp9_;
#line 112 "Utility/Device.vala"
		device_lsblk_is_ancient = FALSE;
#line 434 "Device.c"
	} else {
		gchar* _tmp10_;
#line 115 "Utility/Device.vala"
		_tmp10_ = g_strdup ("ancient");
#line 115 "Utility/Device.vala"
		_g_free0 (device_lsblk_version);
#line 115 "Utility/Device.vala"
		device_lsblk_version = _tmp10_;
#line 116 "Utility/Device.vala"
		device_lsblk_is_ancient = TRUE;
#line 445 "Device.c"
	}
#line 102 "Utility/Device.vala"
	_g_free0 (std_err);
#line 102 "Utility/Device.vala"
	_g_free0 (std_out);
#line 451 "Device.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 160 "Utility/Device.vala"
	return self ? g_object_ref (self) : NULL;
#line 459 "Device.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
#line 1473 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1473 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1474 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1474 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1474 "glib-2.0.vapi"
	return result;
#line 478 "Device.c"
}

gboolean
device_is_mounted_at_path (Device* self,
                           const gchar* subvolname,
                           const gchar* mount_path)
{
	gboolean result = FALSE;
#line 158 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 158 "Utility/Device.vala"
	g_return_val_if_fail (subvolname != NULL, FALSE);
#line 158 "Utility/Device.vala"
	g_return_val_if_fail (mount_path != NULL, FALSE);
#line 493 "Device.c"
	{
		GeeArrayList* _mnt_list = NULL;
		GeeArrayList* _tmp0_;
		GeeArrayList* _tmp1_;
		gint _mnt_size = 0;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _mnt_index = 0;
#line 160 "Utility/Device.vala"
		_tmp0_ = self->mount_points;
#line 160 "Utility/Device.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 160 "Utility/Device.vala"
		_mnt_list = _tmp1_;
#line 160 "Utility/Device.vala"
		_tmp2_ = _mnt_list;
#line 160 "Utility/Device.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 160 "Utility/Device.vala"
		_tmp4_ = _tmp3_;
#line 160 "Utility/Device.vala"
		_mnt_size = _tmp4_;
#line 160 "Utility/Device.vala"
		_mnt_index = -1;
#line 160 "Utility/Device.vala"
		while (TRUE) {
#line 521 "Device.c"
			MountEntry* mnt = NULL;
			GeeArrayList* _tmp5_;
			gpointer _tmp6_;
			MountEntry* _tmp7_;
			const gchar* _tmp8_;
#line 160 "Utility/Device.vala"
			_mnt_index = _mnt_index + 1;
#line 160 "Utility/Device.vala"
			if (!(_mnt_index < _mnt_size)) {
#line 160 "Utility/Device.vala"
				break;
#line 533 "Device.c"
			}
#line 160 "Utility/Device.vala"
			_tmp5_ = _mnt_list;
#line 160 "Utility/Device.vala"
			_tmp6_ = gee_abstract_list_get ((GeeAbstractList*) _tmp5_, _mnt_index);
#line 160 "Utility/Device.vala"
			mnt = (MountEntry*) _tmp6_;
#line 161 "Utility/Device.vala"
			_tmp7_ = mnt;
#line 161 "Utility/Device.vala"
			_tmp8_ = _tmp7_->mount_point;
#line 161 "Utility/Device.vala"
			if (g_strcmp0 (_tmp8_, mount_path) == 0) {
#line 547 "Device.c"
				gint _tmp9_;
				gint _tmp10_;
#line 162 "Utility/Device.vala"
				_tmp9_ = strlen (subvolname);
#line 162 "Utility/Device.vala"
				_tmp10_ = _tmp9_;
#line 162 "Utility/Device.vala"
				if (_tmp10_ == 0) {
#line 163 "Utility/Device.vala"
					result = TRUE;
#line 163 "Utility/Device.vala"
					_g_object_unref0 (mnt);
#line 163 "Utility/Device.vala"
					_g_object_unref0 (_mnt_list);
#line 163 "Utility/Device.vala"
					return result;
#line 564 "Device.c"
				} else {
					gboolean _tmp11_ = FALSE;
					MountEntry* _tmp12_;
					const gchar* _tmp13_;
					gchar* _tmp14_;
					gchar* _tmp15_;
					gboolean _tmp16_;
#line 165 "Utility/Device.vala"
					_tmp12_ = mnt;
#line 165 "Utility/Device.vala"
					_tmp13_ = _tmp12_->mount_options;
#line 165 "Utility/Device.vala"
					_tmp14_ = g_strdup_printf ("subvol=%s", subvolname);
#line 165 "Utility/Device.vala"
					_tmp15_ = _tmp14_;
#line 165 "Utility/Device.vala"
					_tmp16_ = string_contains (_tmp13_, _tmp15_);
#line 165 "Utility/Device.vala"
					_g_free0 (_tmp15_);
#line 165 "Utility/Device.vala"
					if (_tmp16_) {
#line 165 "Utility/Device.vala"
						_tmp11_ = TRUE;
#line 588 "Device.c"
					} else {
						MountEntry* _tmp17_;
						const gchar* _tmp18_;
						gchar* _tmp19_;
						gchar* _tmp20_;
#line 166 "Utility/Device.vala"
						_tmp17_ = mnt;
#line 166 "Utility/Device.vala"
						_tmp18_ = _tmp17_->mount_options;
#line 166 "Utility/Device.vala"
						_tmp19_ = g_strdup_printf ("subvol=/%s", subvolname);
#line 166 "Utility/Device.vala"
						_tmp20_ = _tmp19_;
#line 166 "Utility/Device.vala"
						_tmp11_ = string_contains (_tmp18_, _tmp20_);
#line 166 "Utility/Device.vala"
						_g_free0 (_tmp20_);
#line 606 "Device.c"
					}
#line 165 "Utility/Device.vala"
					if (_tmp11_) {
#line 168 "Utility/Device.vala"
						result = TRUE;
#line 168 "Utility/Device.vala"
						_g_object_unref0 (mnt);
#line 168 "Utility/Device.vala"
						_g_object_unref0 (_mnt_list);
#line 168 "Utility/Device.vala"
						return result;
#line 618 "Device.c"
					}
				}
			}
#line 160 "Utility/Device.vala"
			_g_object_unref0 (mnt);
#line 624 "Device.c"
		}
#line 160 "Utility/Device.vala"
		_g_object_unref0 (_mnt_list);
#line 628 "Device.c"
	}
#line 173 "Utility/Device.vala"
	result = FALSE;
#line 173 "Utility/Device.vala"
	return result;
#line 634 "Device.c"
}

gboolean
device_has_linux_filesystem (Device* self)
{
	gboolean result = FALSE;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 177 "Utility/Device.vala"
	static GQuark _tmp2_label0 = 0;
#line 177 "Utility/Device.vala"
	static GQuark _tmp2_label1 = 0;
#line 177 "Utility/Device.vala"
	static GQuark _tmp2_label2 = 0;
#line 177 "Utility/Device.vala"
	static GQuark _tmp2_label3 = 0;
#line 177 "Utility/Device.vala"
	static GQuark _tmp2_label4 = 0;
#line 177 "Utility/Device.vala"
	static GQuark _tmp2_label5 = 0;
#line 177 "Utility/Device.vala"
	static GQuark _tmp2_label6 = 0;
#line 177 "Utility/Device.vala"
	static GQuark _tmp2_label7 = 0;
#line 177 "Utility/Device.vala"
	static GQuark _tmp2_label8 = 0;
#line 177 "Utility/Device.vala"
	static GQuark _tmp2_label9 = 0;
#line 177 "Utility/Device.vala"
	static GQuark _tmp2_label10 = 0;
#line 177 "Utility/Device.vala"
	static GQuark _tmp2_label11 = 0;
#line 177 "Utility/Device.vala"
	static GQuark _tmp2_label12 = 0;
#line 177 "Utility/Device.vala"
	static GQuark _tmp2_label13 = 0;
#line 177 "Utility/Device.vala"
	static GQuark _tmp2_label14 = 0;
#line 177 "Utility/Device.vala"
	static GQuark _tmp2_label15 = 0;
#line 176 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 177 "Utility/Device.vala"
	_tmp0_ = self->fstype;
#line 177 "Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 177 "Utility/Device.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 177 "Utility/Device.vala"
	if ((((((((((((((((_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("ext2")))) || (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("ext3"))))) || (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("ext4"))))) || (_tmp3_ == ((0 != _tmp2_label3) ? _tmp2_label3 : (_tmp2_label3 = g_quark_from_static_string ("f2fs"))))) || (_tmp3_ == ((0 != _tmp2_label4) ? _tmp2_label4 : (_tmp2_label4 = g_quark_from_static_string ("reiserfs"))))) || (_tmp3_ == ((0 != _tmp2_label5) ? _tmp2_label5 : (_tmp2_label5 = g_quark_from_static_string ("reiser4"))))) || (_tmp3_ == ((0 != _tmp2_label6) ? _tmp2_label6 : (_tmp2_label6 = g_quark_from_static_string ("xfs"))))) || (_tmp3_ == ((0 != _tmp2_label7) ? _tmp2_label7 : (_tmp2_label7 = g_quark_from_static_string ("jfs"))))) || (_tmp3_ == ((0 != _tmp2_label8) ? _tmp2_label8 : (_tmp2_label8 = g_quark_from_static_string ("zfs"))))) || (_tmp3_ == ((0 != _tmp2_label9) ? _tmp2_label9 : (_tmp2_label9 = g_quark_from_static_string ("btrfs"))))) || (_tmp3_ == ((0 != _tmp2_label10) ? _tmp2_label10 : (_tmp2_label10 = g_quark_from_static_string ("lvm"))))) || (_tmp3_ == ((0 != _tmp2_label11) ? _tmp2_label11 : (_tmp2_label11 = g_quark_from_static_string ("lvm2"))))) || (_tmp3_ == ((0 != _tmp2_label12) ? _tmp2_label12 : (_tmp2_label12 = g_quark_from_static_string ("lvm2_member"))))) || (_tmp3_ == ((0 != _tmp2_label13) ? _tmp2_label13 : (_tmp2_label13 = g_quark_from_static_string ("luks"))))) || (_tmp3_ == ((0 != _tmp2_label14) ? _tmp2_label14 : (_tmp2_label14 = g_quark_from_static_string ("crypt"))))) || (_tmp3_ == ((0 != _tmp2_label15) ? _tmp2_label15 : (_tmp2_label15 = g_quark_from_static_string ("crypto_luks"))))) {
#line 177 "Utility/Device.vala"
		switch (0) {
#line 688 "Device.c"
			default:
			{
#line 194 "Utility/Device.vala"
				result = TRUE;
#line 194 "Utility/Device.vala"
				return result;
#line 695 "Device.c"
			}
		}
	} else {
#line 177 "Utility/Device.vala"
		switch (0) {
#line 701 "Device.c"
			default:
			{
#line 196 "Utility/Device.vala"
				result = FALSE;
#line 196 "Utility/Device.vala"
				return result;
#line 708 "Device.c"
			}
		}
	}
}

gboolean
device_is_encrypted_partition (Device* self)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
#line 200 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 201 "Utility/Device.vala"
	_tmp1_ = self->type;
#line 201 "Utility/Device.vala"
	if (g_strcmp0 (_tmp1_, "part") == 0) {
#line 726 "Device.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 201 "Utility/Device.vala"
		_tmp2_ = self->fstype;
#line 201 "Utility/Device.vala"
		_tmp3_ = g_utf8_strdown (_tmp2_, (gssize) -1);
#line 201 "Utility/Device.vala"
		_tmp4_ = _tmp3_;
#line 201 "Utility/Device.vala"
		_tmp0_ = string_contains (_tmp4_, "luks");
#line 201 "Utility/Device.vala"
		_g_free0 (_tmp4_);
#line 740 "Device.c"
	} else {
#line 201 "Utility/Device.vala"
		_tmp0_ = FALSE;
#line 744 "Device.c"
	}
#line 201 "Utility/Device.vala"
	result = _tmp0_;
#line 201 "Utility/Device.vala"
	return result;
#line 750 "Device.c"
}

gboolean
device_is_on_encrypted_partition (Device* self)
{
	gboolean result = FALSE;
	const gchar* _tmp0_;
#line 204 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 205 "Utility/Device.vala"
	_tmp0_ = self->type;
#line 205 "Utility/Device.vala"
	result = g_strcmp0 (_tmp0_, "crypt") == 0;
#line 205 "Utility/Device.vala"
	return result;
#line 766 "Device.c"
}

gboolean
device_is_lvm_partition (Device* self)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
#line 208 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 209 "Utility/Device.vala"
	_tmp1_ = self->type;
#line 209 "Utility/Device.vala"
	if (g_strcmp0 (_tmp1_, "part") == 0) {
#line 781 "Device.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 209 "Utility/Device.vala"
		_tmp2_ = self->fstype;
#line 209 "Utility/Device.vala"
		_tmp3_ = g_utf8_strdown (_tmp2_, (gssize) -1);
#line 209 "Utility/Device.vala"
		_tmp4_ = _tmp3_;
#line 209 "Utility/Device.vala"
		_tmp0_ = string_contains (_tmp4_, "lvm2_member");
#line 209 "Utility/Device.vala"
		_g_free0 (_tmp4_);
#line 795 "Device.c"
	} else {
#line 209 "Utility/Device.vala"
		_tmp0_ = FALSE;
#line 799 "Device.c"
	}
#line 209 "Utility/Device.vala"
	result = _tmp0_;
#line 209 "Utility/Device.vala"
	return result;
#line 805 "Device.c"
}

gboolean
device_has_children (Device* self)
{
	gboolean result = FALSE;
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 212 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 213 "Utility/Device.vala"
	_tmp0_ = self->children;
#line 213 "Utility/Device.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 213 "Utility/Device.vala"
	_tmp2_ = _tmp1_;
#line 213 "Utility/Device.vala"
	result = _tmp2_ > 0;
#line 213 "Utility/Device.vala"
	return result;
#line 827 "Device.c"
}

Device*
device_first_linux_child (Device* self)
{
	Device* result = NULL;
#line 216 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 836 "Device.c"
	{
		GeeArrayList* _child_list = NULL;
		GeeArrayList* _tmp0_;
		GeeArrayList* _tmp1_;
		gint _child_size = 0;
		GeeArrayList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _child_index = 0;
#line 218 "Utility/Device.vala"
		_tmp0_ = self->children;
#line 218 "Utility/Device.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 218 "Utility/Device.vala"
		_child_list = _tmp1_;
#line 218 "Utility/Device.vala"
		_tmp2_ = _child_list;
#line 218 "Utility/Device.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 218 "Utility/Device.vala"
		_tmp4_ = _tmp3_;
#line 218 "Utility/Device.vala"
		_child_size = _tmp4_;
#line 218 "Utility/Device.vala"
		_child_index = -1;
#line 218 "Utility/Device.vala"
		while (TRUE) {
#line 864 "Device.c"
			Device* child = NULL;
			GeeArrayList* _tmp5_;
			gpointer _tmp6_;
			Device* _tmp7_;
#line 218 "Utility/Device.vala"
			_child_index = _child_index + 1;
#line 218 "Utility/Device.vala"
			if (!(_child_index < _child_size)) {
#line 218 "Utility/Device.vala"
				break;
#line 875 "Device.c"
			}
#line 218 "Utility/Device.vala"
			_tmp5_ = _child_list;
#line 218 "Utility/Device.vala"
			_tmp6_ = gee_abstract_list_get ((GeeAbstractList*) _tmp5_, _child_index);
#line 218 "Utility/Device.vala"
			child = (Device*) _tmp6_;
#line 219 "Utility/Device.vala"
			_tmp7_ = child;
#line 219 "Utility/Device.vala"
			if (device_has_linux_filesystem (_tmp7_)) {
#line 220 "Utility/Device.vala"
				result = child;
#line 220 "Utility/Device.vala"
				_g_object_unref0 (_child_list);
#line 220 "Utility/Device.vala"
				return result;
#line 893 "Device.c"
			}
#line 218 "Utility/Device.vala"
			_g_object_unref0 (child);
#line 897 "Device.c"
		}
#line 218 "Utility/Device.vala"
		_g_object_unref0 (_child_list);
#line 901 "Device.c"
	}
#line 224 "Utility/Device.vala"
	result = NULL;
#line 224 "Utility/Device.vala"
	return result;
#line 907 "Device.c"
}

gboolean
device_has_parent (Device* self)
{
	gboolean result = FALSE;
	Device* _tmp0_;
#line 227 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 228 "Utility/Device.vala"
	_tmp0_ = self->parent;
#line 228 "Utility/Device.vala"
	result = _tmp0_ != NULL;
#line 228 "Utility/Device.vala"
	return result;
#line 923 "Device.c"
}

GeeArrayList*
device_get_filesystems (gboolean get_space,
                        gboolean get_mounts)
{
	GeeArrayList* result = NULL;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp41_;
	gint _tmp42_;
	gint _tmp43_;
	gchar* _tmp44_;
	gchar* _tmp45_;
#line 238 "Utility/Device.vala"
	_tmp0_ = device_get_block_devices_using_lsblk ("");
#line 238 "Utility/Device.vala"
	list = _tmp0_;
#line 240 "Utility/Device.vala"
	if (get_space) {
#line 944 "Device.c"
		GeeArrayList* list_df = NULL;
		GeeArrayList* _tmp1_;
#line 242 "Utility/Device.vala"
		_tmp1_ = device_get_disk_space_using_df ("");
#line 242 "Utility/Device.vala"
		list_df = _tmp1_;
#line 951 "Device.c"
		{
			GeeArrayList* _dev_df_list = NULL;
			GeeArrayList* _tmp2_;
			GeeArrayList* _tmp3_;
			gint _dev_df_size = 0;
			GeeArrayList* _tmp4_;
			gint _tmp5_;
			gint _tmp6_;
			gint _dev_df_index = 0;
#line 243 "Utility/Device.vala"
			_tmp2_ = list_df;
#line 243 "Utility/Device.vala"
			_tmp3_ = _g_object_ref0 (_tmp2_);
#line 243 "Utility/Device.vala"
			_dev_df_list = _tmp3_;
#line 243 "Utility/Device.vala"
			_tmp4_ = _dev_df_list;
#line 243 "Utility/Device.vala"
			_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 243 "Utility/Device.vala"
			_tmp6_ = _tmp5_;
#line 243 "Utility/Device.vala"
			_dev_df_size = _tmp6_;
#line 243 "Utility/Device.vala"
			_dev_df_index = -1;
#line 243 "Utility/Device.vala"
			while (TRUE) {
#line 979 "Device.c"
				Device* dev_df = NULL;
				GeeArrayList* _tmp7_;
				gpointer _tmp8_;
				Device* dev = NULL;
				GeeArrayList* _tmp9_;
				Device* _tmp10_;
				const gchar* _tmp11_;
				Device* _tmp12_;
				Device* _tmp13_;
#line 243 "Utility/Device.vala"
				_dev_df_index = _dev_df_index + 1;
#line 243 "Utility/Device.vala"
				if (!(_dev_df_index < _dev_df_size)) {
#line 243 "Utility/Device.vala"
					break;
#line 995 "Device.c"
				}
#line 243 "Utility/Device.vala"
				_tmp7_ = _dev_df_list;
#line 243 "Utility/Device.vala"
				_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _dev_df_index);
#line 243 "Utility/Device.vala"
				dev_df = (Device*) _tmp8_;
#line 244 "Utility/Device.vala"
				_tmp9_ = list;
#line 244 "Utility/Device.vala"
				_tmp10_ = dev_df;
#line 244 "Utility/Device.vala"
				_tmp11_ = _tmp10_->uuid;
#line 244 "Utility/Device.vala"
				_tmp12_ = device_find_device_in_list (_tmp9_, _tmp11_);
#line 244 "Utility/Device.vala"
				dev = _tmp12_;
#line 245 "Utility/Device.vala"
				_tmp13_ = dev;
#line 245 "Utility/Device.vala"
				if (_tmp13_ != NULL) {
#line 1017 "Device.c"
					Device* _tmp14_;
					Device* _tmp15_;
					Device* _tmp16_;
					Device* _tmp17_;
					Device* _tmp18_;
					Device* _tmp19_;
					Device* _tmp20_;
					Device* _tmp21_;
					const gchar* _tmp22_;
					gchar* _tmp23_;
#line 246 "Utility/Device.vala"
					_tmp14_ = dev;
#line 246 "Utility/Device.vala"
					_tmp15_ = dev_df;
#line 246 "Utility/Device.vala"
					_tmp14_->size_bytes = _tmp15_->size_bytes;
#line 247 "Utility/Device.vala"
					_tmp16_ = dev;
#line 247 "Utility/Device.vala"
					_tmp17_ = dev_df;
#line 247 "Utility/Device.vala"
					_tmp16_->used_bytes = _tmp17_->used_bytes;
#line 248 "Utility/Device.vala"
					_tmp18_ = dev;
#line 248 "Utility/Device.vala"
					_tmp19_ = dev_df;
#line 248 "Utility/Device.vala"
					_tmp18_->available_bytes = _tmp19_->available_bytes;
#line 249 "Utility/Device.vala"
					_tmp20_ = dev;
#line 249 "Utility/Device.vala"
					_tmp21_ = dev_df;
#line 249 "Utility/Device.vala"
					_tmp22_ = _tmp21_->used_percent;
#line 249 "Utility/Device.vala"
					_tmp23_ = g_strdup (_tmp22_);
#line 249 "Utility/Device.vala"
					_g_free0 (_tmp20_->used_percent);
#line 249 "Utility/Device.vala"
					_tmp20_->used_percent = _tmp23_;
#line 1058 "Device.c"
				}
#line 243 "Utility/Device.vala"
				_g_object_unref0 (dev);
#line 243 "Utility/Device.vala"
				_g_object_unref0 (dev_df);
#line 1064 "Device.c"
			}
#line 243 "Utility/Device.vala"
			_g_object_unref0 (_dev_df_list);
#line 1068 "Device.c"
		}
#line 240 "Utility/Device.vala"
		_g_object_unref0 (list_df);
#line 1072 "Device.c"
	}
#line 254 "Utility/Device.vala"
	if (get_mounts) {
#line 1076 "Device.c"
		GeeArrayList* list_mtab = NULL;
		GeeArrayList* _tmp24_;
#line 256 "Utility/Device.vala"
		_tmp24_ = device_get_mounted_filesystems_using_mtab ();
#line 256 "Utility/Device.vala"
		list_mtab = _tmp24_;
#line 1083 "Device.c"
		{
			GeeArrayList* _dev_mtab_list = NULL;
			GeeArrayList* _tmp25_;
			GeeArrayList* _tmp26_;
			gint _dev_mtab_size = 0;
			GeeArrayList* _tmp27_;
			gint _tmp28_;
			gint _tmp29_;
			gint _dev_mtab_index = 0;
#line 257 "Utility/Device.vala"
			_tmp25_ = list_mtab;
#line 257 "Utility/Device.vala"
			_tmp26_ = _g_object_ref0 (_tmp25_);
#line 257 "Utility/Device.vala"
			_dev_mtab_list = _tmp26_;
#line 257 "Utility/Device.vala"
			_tmp27_ = _dev_mtab_list;
#line 257 "Utility/Device.vala"
			_tmp28_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp27_);
#line 257 "Utility/Device.vala"
			_tmp29_ = _tmp28_;
#line 257 "Utility/Device.vala"
			_dev_mtab_size = _tmp29_;
#line 257 "Utility/Device.vala"
			_dev_mtab_index = -1;
#line 257 "Utility/Device.vala"
			while (TRUE) {
#line 1111 "Device.c"
				Device* dev_mtab = NULL;
				GeeArrayList* _tmp30_;
				gpointer _tmp31_;
				Device* dev = NULL;
				GeeArrayList* _tmp32_;
				Device* _tmp33_;
				const gchar* _tmp34_;
				Device* _tmp35_;
				Device* _tmp36_;
#line 257 "Utility/Device.vala"
				_dev_mtab_index = _dev_mtab_index + 1;
#line 257 "Utility/Device.vala"
				if (!(_dev_mtab_index < _dev_mtab_size)) {
#line 257 "Utility/Device.vala"
					break;
#line 1127 "Device.c"
				}
#line 257 "Utility/Device.vala"
				_tmp30_ = _dev_mtab_list;
#line 257 "Utility/Device.vala"
				_tmp31_ = gee_abstract_list_get ((GeeAbstractList*) _tmp30_, _dev_mtab_index);
#line 257 "Utility/Device.vala"
				dev_mtab = (Device*) _tmp31_;
#line 258 "Utility/Device.vala"
				_tmp32_ = list;
#line 258 "Utility/Device.vala"
				_tmp33_ = dev_mtab;
#line 258 "Utility/Device.vala"
				_tmp34_ = _tmp33_->uuid;
#line 258 "Utility/Device.vala"
				_tmp35_ = device_find_device_in_list (_tmp32_, _tmp34_);
#line 258 "Utility/Device.vala"
				dev = _tmp35_;
#line 259 "Utility/Device.vala"
				_tmp36_ = dev;
#line 259 "Utility/Device.vala"
				if (_tmp36_ != NULL) {
#line 1149 "Device.c"
					Device* _tmp37_;
					Device* _tmp38_;
					GeeArrayList* _tmp39_;
					GeeArrayList* _tmp40_;
#line 260 "Utility/Device.vala"
					_tmp37_ = dev;
#line 260 "Utility/Device.vala"
					_tmp38_ = dev_mtab;
#line 260 "Utility/Device.vala"
					_tmp39_ = _tmp38_->mount_points;
#line 260 "Utility/Device.vala"
					_tmp40_ = _g_object_ref0 (_tmp39_);
#line 260 "Utility/Device.vala"
					_g_object_unref0 (_tmp37_->mount_points);
#line 260 "Utility/Device.vala"
					_tmp37_->mount_points = _tmp40_;
#line 1166 "Device.c"
				}
#line 257 "Utility/Device.vala"
				_g_object_unref0 (dev);
#line 257 "Utility/Device.vala"
				_g_object_unref0 (dev_mtab);
#line 1172 "Device.c"
			}
#line 257 "Utility/Device.vala"
			_g_object_unref0 (_dev_mtab_list);
#line 1176 "Device.c"
		}
#line 254 "Utility/Device.vala"
		_g_object_unref0 (list_mtab);
#line 1180 "Device.c"
	}
#line 269 "Utility/Device.vala"
	_tmp41_ = list;
#line 269 "Utility/Device.vala"
	_tmp42_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp41_);
#line 269 "Utility/Device.vala"
	_tmp43_ = _tmp42_;
#line 269 "Utility/Device.vala"
	_tmp44_ = g_strdup_printf ("Device: get_filesystems(): %d", _tmp43_);
#line 269 "Utility/Device.vala"
	_tmp45_ = _tmp44_;
#line 269 "Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp45_);
#line 269 "Utility/Device.vala"
	_g_free0 (_tmp45_);
#line 271 "Utility/Device.vala"
	result = list;
#line 271 "Utility/Device.vala"
	return result;
#line 1200 "Device.c"
}

static void
device_find_child_devices (GeeArrayList* list,
                           Device* parent)
{
	gboolean _tmp0_ = FALSE;
#line 274 "Utility/Device.vala"
	g_return_if_fail (list != NULL);
#line 274 "Utility/Device.vala"
	g_return_if_fail (parent != NULL);
#line 275 "Utility/Device.vala"
	if (device_lsblk_is_ancient) {
#line 1214 "Device.c"
		const gchar* _tmp1_;
#line 275 "Utility/Device.vala"
		_tmp1_ = parent->type;
#line 275 "Utility/Device.vala"
		_tmp0_ = g_strcmp0 (_tmp1_, "disk") == 0;
#line 1220 "Device.c"
	} else {
#line 275 "Utility/Device.vala"
		_tmp0_ = FALSE;
#line 1224 "Device.c"
	}
#line 275 "Utility/Device.vala"
	if (_tmp0_) {
#line 1228 "Device.c"
		{
			GeeArrayList* _part_list = NULL;
			GeeArrayList* _tmp2_;
			gint _part_size = 0;
			GeeArrayList* _tmp3_;
			gint _tmp4_;
			gint _tmp5_;
			gint _part_index = 0;
#line 276 "Utility/Device.vala"
			_tmp2_ = _g_object_ref0 (list);
#line 276 "Utility/Device.vala"
			_part_list = _tmp2_;
#line 276 "Utility/Device.vala"
			_tmp3_ = _part_list;
#line 276 "Utility/Device.vala"
			_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 276 "Utility/Device.vala"
			_tmp5_ = _tmp4_;
#line 276 "Utility/Device.vala"
			_part_size = _tmp5_;
#line 276 "Utility/Device.vala"
			_part_index = -1;
#line 276 "Utility/Device.vala"
			while (TRUE) {
#line 1253 "Device.c"
				Device* part = NULL;
				GeeArrayList* _tmp6_;
				gpointer _tmp7_;
				gboolean _tmp8_ = FALSE;
				Device* _tmp9_;
				const gchar* _tmp10_;
				const gchar* _tmp11_;
#line 276 "Utility/Device.vala"
				_part_index = _part_index + 1;
#line 276 "Utility/Device.vala"
				if (!(_part_index < _part_size)) {
#line 276 "Utility/Device.vala"
					break;
#line 1267 "Device.c"
				}
#line 276 "Utility/Device.vala"
				_tmp6_ = _part_list;
#line 276 "Utility/Device.vala"
				_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _part_index);
#line 276 "Utility/Device.vala"
				part = (Device*) _tmp7_;
#line 277 "Utility/Device.vala"
				_tmp9_ = part;
#line 277 "Utility/Device.vala"
				_tmp10_ = _tmp9_->kname;
#line 277 "Utility/Device.vala"
				_tmp11_ = parent->kname;
#line 277 "Utility/Device.vala"
				if (g_strcmp0 (_tmp10_, _tmp11_) != 0) {
#line 1283 "Device.c"
					Device* _tmp12_;
					const gchar* _tmp13_;
					const gchar* _tmp14_;
#line 277 "Utility/Device.vala"
					_tmp12_ = part;
#line 277 "Utility/Device.vala"
					_tmp13_ = _tmp12_->kname;
#line 277 "Utility/Device.vala"
					_tmp14_ = parent->kname;
#line 277 "Utility/Device.vala"
					_tmp8_ = g_str_has_prefix (_tmp13_, _tmp14_);
#line 1295 "Device.c"
				} else {
#line 277 "Utility/Device.vala"
					_tmp8_ = FALSE;
#line 1299 "Device.c"
				}
#line 277 "Utility/Device.vala"
				if (_tmp8_) {
#line 1303 "Device.c"
					GeeArrayList* _tmp15_;
					Device* _tmp16_;
					Device* _tmp17_;
					Device* _tmp18_;
					Device* _tmp19_;
					const gchar* _tmp20_;
					gchar* _tmp21_;
					const gchar* _tmp22_;
					Device* _tmp23_;
					const gchar* _tmp24_;
					gchar* _tmp25_;
					gchar* _tmp26_;
#line 278 "Utility/Device.vala"
					_tmp15_ = parent->children;
#line 278 "Utility/Device.vala"
					_tmp16_ = part;
#line 278 "Utility/Device.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp15_, _tmp16_);
#line 279 "Utility/Device.vala"
					_tmp17_ = part;
#line 279 "Utility/Device.vala"
					_tmp18_ = _g_object_ref0 (parent);
#line 279 "Utility/Device.vala"
					_g_object_unref0 (_tmp17_->parent);
#line 279 "Utility/Device.vala"
					_tmp17_->parent = _tmp18_;
#line 280 "Utility/Device.vala"
					_tmp19_ = part;
#line 280 "Utility/Device.vala"
					_tmp20_ = parent->kname;
#line 280 "Utility/Device.vala"
					_tmp21_ = g_strdup (_tmp20_);
#line 280 "Utility/Device.vala"
					_g_free0 (_tmp19_->pkname);
#line 280 "Utility/Device.vala"
					_tmp19_->pkname = _tmp21_;
#line 281 "Utility/Device.vala"
					_tmp22_ = parent->kname;
#line 281 "Utility/Device.vala"
					_tmp23_ = part;
#line 281 "Utility/Device.vala"
					_tmp24_ = _tmp23_->kname;
#line 281 "Utility/Device.vala"
					_tmp25_ = g_strdup_printf ("%s -> %s", _tmp22_, _tmp24_);
#line 281 "Utility/Device.vala"
					_tmp26_ = _tmp25_;
#line 281 "Utility/Device.vala"
					tee_jee_logging_log_debug (_tmp26_);
#line 281 "Utility/Device.vala"
					_g_free0 (_tmp26_);
#line 1354 "Device.c"
				}
#line 276 "Utility/Device.vala"
				_g_object_unref0 (part);
#line 1358 "Device.c"
			}
#line 276 "Utility/Device.vala"
			_g_object_unref0 (_part_list);
#line 1362 "Device.c"
		}
	} else {
		{
			GeeArrayList* _part_list = NULL;
			GeeArrayList* _tmp27_;
			gint _part_size = 0;
			GeeArrayList* _tmp28_;
			gint _tmp29_;
			gint _tmp30_;
			gint _part_index = 0;
#line 286 "Utility/Device.vala"
			_tmp27_ = _g_object_ref0 (list);
#line 286 "Utility/Device.vala"
			_part_list = _tmp27_;
#line 286 "Utility/Device.vala"
			_tmp28_ = _part_list;
#line 286 "Utility/Device.vala"
			_tmp29_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp28_);
#line 286 "Utility/Device.vala"
			_tmp30_ = _tmp29_;
#line 286 "Utility/Device.vala"
			_part_size = _tmp30_;
#line 286 "Utility/Device.vala"
			_part_index = -1;
#line 286 "Utility/Device.vala"
			while (TRUE) {
#line 1389 "Device.c"
				Device* part = NULL;
				GeeArrayList* _tmp31_;
				gpointer _tmp32_;
				Device* _tmp33_;
				const gchar* _tmp34_;
				const gchar* _tmp35_;
#line 286 "Utility/Device.vala"
				_part_index = _part_index + 1;
#line 286 "Utility/Device.vala"
				if (!(_part_index < _part_size)) {
#line 286 "Utility/Device.vala"
					break;
#line 1402 "Device.c"
				}
#line 286 "Utility/Device.vala"
				_tmp31_ = _part_list;
#line 286 "Utility/Device.vala"
				_tmp32_ = gee_abstract_list_get ((GeeAbstractList*) _tmp31_, _part_index);
#line 286 "Utility/Device.vala"
				part = (Device*) _tmp32_;
#line 287 "Utility/Device.vala"
				_tmp33_ = part;
#line 287 "Utility/Device.vala"
				_tmp34_ = _tmp33_->pkname;
#line 287 "Utility/Device.vala"
				_tmp35_ = parent->kname;
#line 287 "Utility/Device.vala"
				if (g_strcmp0 (_tmp34_, _tmp35_) == 0) {
#line 1418 "Device.c"
					GeeArrayList* _tmp36_;
					Device* _tmp37_;
					Device* _tmp38_;
					Device* _tmp39_;
#line 288 "Utility/Device.vala"
					_tmp36_ = parent->children;
#line 288 "Utility/Device.vala"
					_tmp37_ = part;
#line 288 "Utility/Device.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp36_, _tmp37_);
#line 289 "Utility/Device.vala"
					_tmp38_ = part;
#line 289 "Utility/Device.vala"
					_tmp39_ = _g_object_ref0 (parent);
#line 289 "Utility/Device.vala"
					_g_object_unref0 (_tmp38_->parent);
#line 289 "Utility/Device.vala"
					_tmp38_->parent = _tmp39_;
#line 1437 "Device.c"
				}
#line 286 "Utility/Device.vala"
				_g_object_unref0 (part);
#line 1441 "Device.c"
			}
#line 286 "Utility/Device.vala"
			_g_object_unref0 (_part_list);
#line 1445 "Device.c"
		}
	}
}

static void
device_find_toplevel_parent (GeeArrayList* list,
                             Device* dev)
{
	const gchar* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gchar* top_kname = NULL;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp21_;
	gchar* _tmp22_;
#line 295 "Utility/Device.vala"
	g_return_if_fail (list != NULL);
#line 295 "Utility/Device.vala"
	g_return_if_fail (dev != NULL);
#line 297 "Utility/Device.vala"
	_tmp0_ = dev->pkname;
#line 297 "Utility/Device.vala"
	_tmp1_ = strlen (_tmp0_);
#line 297 "Utility/Device.vala"
	_tmp2_ = _tmp1_;
#line 297 "Utility/Device.vala"
	if (_tmp2_ == 0) {
#line 297 "Utility/Device.vala"
		return;
#line 1476 "Device.c"
	}
#line 299 "Utility/Device.vala"
	_tmp3_ = dev->pkname;
#line 299 "Utility/Device.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 299 "Utility/Device.vala"
	top_kname = _tmp4_;
#line 1484 "Device.c"
	{
		GeeArrayList* _part_list = NULL;
		GeeArrayList* _tmp5_;
		gint _part_size = 0;
		GeeArrayList* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		gint _part_index = 0;
#line 301 "Utility/Device.vala"
		_tmp5_ = _g_object_ref0 (list);
#line 301 "Utility/Device.vala"
		_part_list = _tmp5_;
#line 301 "Utility/Device.vala"
		_tmp6_ = _part_list;
#line 301 "Utility/Device.vala"
		_tmp7_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp6_);
#line 301 "Utility/Device.vala"
		_tmp8_ = _tmp7_;
#line 301 "Utility/Device.vala"
		_part_size = _tmp8_;
#line 301 "Utility/Device.vala"
		_part_index = -1;
#line 301 "Utility/Device.vala"
		while (TRUE) {
#line 1509 "Device.c"
			Device* part = NULL;
			GeeArrayList* _tmp9_;
			gpointer _tmp10_;
			Device* _tmp11_;
			const gchar* _tmp12_;
			const gchar* _tmp13_;
#line 301 "Utility/Device.vala"
			_part_index = _part_index + 1;
#line 301 "Utility/Device.vala"
			if (!(_part_index < _part_size)) {
#line 301 "Utility/Device.vala"
				break;
#line 1522 "Device.c"
			}
#line 301 "Utility/Device.vala"
			_tmp9_ = _part_list;
#line 301 "Utility/Device.vala"
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _part_index);
#line 301 "Utility/Device.vala"
			part = (Device*) _tmp10_;
#line 302 "Utility/Device.vala"
			_tmp11_ = part;
#line 302 "Utility/Device.vala"
			_tmp12_ = _tmp11_->kname;
#line 302 "Utility/Device.vala"
			_tmp13_ = top_kname;
#line 302 "Utility/Device.vala"
			if (g_strcmp0 (_tmp12_, _tmp13_) == 0) {
#line 1538 "Device.c"
				Device* _tmp14_;
				const gchar* _tmp15_;
				gint _tmp16_;
				gint _tmp17_;
#line 303 "Utility/Device.vala"
				_tmp14_ = part;
#line 303 "Utility/Device.vala"
				_tmp15_ = _tmp14_->pkname;
#line 303 "Utility/Device.vala"
				_tmp16_ = strlen (_tmp15_);
#line 303 "Utility/Device.vala"
				_tmp17_ = _tmp16_;
#line 303 "Utility/Device.vala"
				if (_tmp17_ > 0) {
#line 1553 "Device.c"
					Device* _tmp18_;
					const gchar* _tmp19_;
					gchar* _tmp20_;
#line 304 "Utility/Device.vala"
					_tmp18_ = part;
#line 304 "Utility/Device.vala"
					_tmp19_ = _tmp18_->pkname;
#line 304 "Utility/Device.vala"
					_tmp20_ = g_strdup (_tmp19_);
#line 304 "Utility/Device.vala"
					_g_free0 (top_kname);
#line 304 "Utility/Device.vala"
					top_kname = _tmp20_;
#line 1567 "Device.c"
				}
			}
#line 301 "Utility/Device.vala"
			_g_object_unref0 (part);
#line 1572 "Device.c"
		}
#line 301 "Utility/Device.vala"
		_g_object_unref0 (_part_list);
#line 1576 "Device.c"
	}
#line 309 "Utility/Device.vala"
	_tmp21_ = top_kname;
#line 309 "Utility/Device.vala"
	_tmp22_ = g_strdup (_tmp21_);
#line 309 "Utility/Device.vala"
	_g_free0 (dev->pkname_toplevel);
#line 309 "Utility/Device.vala"
	dev->pkname_toplevel = _tmp22_;
#line 295 "Utility/Device.vala"
	_g_free0 (top_kname);
#line 1588 "Device.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1304 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1305 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1305 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1306 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1306 "glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1307 "glib-2.0.vapi"
	result = _result_;
#line 1307 "glib-2.0.vapi"
	return result;
#line 1612 "Device.c"
}

static void
device_find_child_devices_using_dmsetup (GeeArrayList* list)
{
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	GRegex* rex = NULL;
	GMatchInfo* match = NULL;
	const gchar* _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	GError* _inner_error0_ = NULL;
#line 314 "Utility/Device.vala"
	g_return_if_fail (list != NULL);
#line 317 "Utility/Device.vala"
	tee_jee_process_helper_exec_sync ("dmsetup deps -o blkdevname", &_tmp0_, &_tmp1_);
#line 317 "Utility/Device.vala"
	_g_free0 (std_out);
#line 317 "Utility/Device.vala"
	std_out = _tmp0_;
#line 317 "Utility/Device.vala"
	_g_free0 (std_err);
#line 317 "Utility/Device.vala"
	std_err = _tmp1_;
#line 328 "Utility/Device.vala"
	_tmp2_ = std_out;
#line 328 "Utility/Device.vala"
	_tmp4_ = _tmp3_ = g_strsplit (_tmp2_, "\n", 0);
#line 1644 "Device.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 328 "Utility/Device.vala"
		line_collection = _tmp4_;
#line 328 "Utility/Device.vala"
		line_collection_length1 = _vala_array_length (_tmp3_);
#line 328 "Utility/Device.vala"
		for (line_it = 0; line_it < _vala_array_length (_tmp3_); line_it = line_it + 1) {
#line 1656 "Device.c"
			gchar* _tmp5_;
			gchar* line = NULL;
#line 328 "Utility/Device.vala"
			_tmp5_ = g_strdup (line_collection[line_it]);
#line 328 "Utility/Device.vala"
			line = _tmp5_;
#line 1663 "Device.c"
			{
				const gchar* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
				gint _tmp9_;
				gint _tmp10_;
				gboolean _tmp11_;
#line 329 "Utility/Device.vala"
				_tmp6_ = line;
#line 329 "Utility/Device.vala"
				_tmp7_ = string_strip (_tmp6_);
#line 329 "Utility/Device.vala"
				_tmp8_ = _tmp7_;
#line 329 "Utility/Device.vala"
				_tmp9_ = strlen (_tmp8_);
#line 329 "Utility/Device.vala"
				_tmp10_ = _tmp9_;
#line 329 "Utility/Device.vala"
				_tmp11_ = _tmp10_ == 0;
#line 329 "Utility/Device.vala"
				_g_free0 (_tmp8_);
#line 329 "Utility/Device.vala"
				if (_tmp11_) {
#line 329 "Utility/Device.vala"
					_g_free0 (line);
#line 329 "Utility/Device.vala"
					continue;
#line 1691 "Device.c"
				}
				{
					GRegex* _tmp12_ = NULL;
					GRegex* _tmp13_;
					GRegex* _tmp14_;
					GRegex* _tmp15_;
					const gchar* _tmp16_;
					GMatchInfo* _tmp17_ = NULL;
					gboolean _tmp18_;
#line 333 "Utility/Device.vala"
					_tmp13_ = g_regex_new ("([^:]*)\\:.*\\((.*)\\)", 0, 0, &_inner_error0_);
#line 333 "Utility/Device.vala"
					_tmp12_ = _tmp13_;
#line 333 "Utility/Device.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1707 "Device.c"
						goto __catch42_g_error;
					}
#line 333 "Utility/Device.vala"
					_tmp14_ = _tmp12_;
#line 333 "Utility/Device.vala"
					_tmp12_ = NULL;
#line 333 "Utility/Device.vala"
					_g_regex_unref0 (rex);
#line 333 "Utility/Device.vala"
					rex = _tmp14_;
#line 335 "Utility/Device.vala"
					_tmp15_ = rex;
#line 335 "Utility/Device.vala"
					_tmp16_ = line;
#line 335 "Utility/Device.vala"
					_tmp18_ = g_regex_match (_tmp15_, _tmp16_, 0, &_tmp17_);
#line 335 "Utility/Device.vala"
					_g_match_info_unref0 (match);
#line 335 "Utility/Device.vala"
					match = _tmp17_;
#line 335 "Utility/Device.vala"
					if (_tmp18_) {
#line 1730 "Device.c"
						gchar* child_name = NULL;
						GMatchInfo* _tmp19_;
						gchar* _tmp20_;
						gchar* _tmp21_;
						gchar* _tmp22_;
						gchar* _tmp23_;
						gchar* parent_kname = NULL;
						GMatchInfo* _tmp24_;
						gchar* _tmp25_;
						gchar* _tmp26_;
						gchar* _tmp27_;
						gchar* _tmp28_;
						Device* parent = NULL;
						Device* child = NULL;
						gboolean _tmp51_ = FALSE;
						Device* _tmp52_;
#line 337 "Utility/Device.vala"
						_tmp19_ = match;
#line 337 "Utility/Device.vala"
						_tmp20_ = g_match_info_fetch (_tmp19_, 1);
#line 337 "Utility/Device.vala"
						_tmp21_ = _tmp20_;
#line 337 "Utility/Device.vala"
						_tmp22_ = string_strip (_tmp21_);
#line 337 "Utility/Device.vala"
						_tmp23_ = _tmp22_;
#line 337 "Utility/Device.vala"
						_g_free0 (_tmp21_);
#line 337 "Utility/Device.vala"
						child_name = _tmp23_;
#line 338 "Utility/Device.vala"
						_tmp24_ = match;
#line 338 "Utility/Device.vala"
						_tmp25_ = g_match_info_fetch (_tmp24_, 2);
#line 338 "Utility/Device.vala"
						_tmp26_ = _tmp25_;
#line 338 "Utility/Device.vala"
						_tmp27_ = string_strip (_tmp26_);
#line 338 "Utility/Device.vala"
						_tmp28_ = _tmp27_;
#line 338 "Utility/Device.vala"
						_g_free0 (_tmp26_);
#line 338 "Utility/Device.vala"
						parent_kname = _tmp28_;
#line 340 "Utility/Device.vala"
						parent = NULL;
#line 1777 "Device.c"
						{
							GeeArrayList* _dev_list = NULL;
							GeeArrayList* _tmp29_;
							gint _dev_size = 0;
							GeeArrayList* _tmp30_;
							gint _tmp31_;
							gint _tmp32_;
							gint _dev_index = 0;
#line 341 "Utility/Device.vala"
							_tmp29_ = _g_object_ref0 (list);
#line 341 "Utility/Device.vala"
							_dev_list = _tmp29_;
#line 341 "Utility/Device.vala"
							_tmp30_ = _dev_list;
#line 341 "Utility/Device.vala"
							_tmp31_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp30_);
#line 341 "Utility/Device.vala"
							_tmp32_ = _tmp31_;
#line 341 "Utility/Device.vala"
							_dev_size = _tmp32_;
#line 341 "Utility/Device.vala"
							_dev_index = -1;
#line 341 "Utility/Device.vala"
							while (TRUE) {
#line 1802 "Device.c"
								Device* dev = NULL;
								GeeArrayList* _tmp33_;
								gpointer _tmp34_;
								Device* _tmp35_;
								const gchar* _tmp36_;
								const gchar* _tmp37_;
#line 341 "Utility/Device.vala"
								_dev_index = _dev_index + 1;
#line 341 "Utility/Device.vala"
								if (!(_dev_index < _dev_size)) {
#line 341 "Utility/Device.vala"
									break;
#line 1815 "Device.c"
								}
#line 341 "Utility/Device.vala"
								_tmp33_ = _dev_list;
#line 341 "Utility/Device.vala"
								_tmp34_ = gee_abstract_list_get ((GeeAbstractList*) _tmp33_, _dev_index);
#line 341 "Utility/Device.vala"
								dev = (Device*) _tmp34_;
#line 342 "Utility/Device.vala"
								_tmp35_ = dev;
#line 342 "Utility/Device.vala"
								_tmp36_ = _tmp35_->kname;
#line 342 "Utility/Device.vala"
								_tmp37_ = parent_kname;
#line 342 "Utility/Device.vala"
								if (g_strcmp0 (_tmp36_, _tmp37_) == 0) {
#line 1831 "Device.c"
									Device* _tmp38_;
									Device* _tmp39_;
#line 343 "Utility/Device.vala"
									_tmp38_ = dev;
#line 343 "Utility/Device.vala"
									_tmp39_ = _g_object_ref0 (_tmp38_);
#line 343 "Utility/Device.vala"
									_g_object_unref0 (parent);
#line 343 "Utility/Device.vala"
									parent = _tmp39_;
#line 344 "Utility/Device.vala"
									_g_object_unref0 (dev);
#line 344 "Utility/Device.vala"
									break;
#line 1846 "Device.c"
								}
#line 341 "Utility/Device.vala"
								_g_object_unref0 (dev);
#line 1850 "Device.c"
							}
#line 341 "Utility/Device.vala"
							_g_object_unref0 (_dev_list);
#line 1854 "Device.c"
						}
#line 348 "Utility/Device.vala"
						child = NULL;
#line 1858 "Device.c"
						{
							GeeArrayList* _dev_list = NULL;
							GeeArrayList* _tmp40_;
							gint _dev_size = 0;
							GeeArrayList* _tmp41_;
							gint _tmp42_;
							gint _tmp43_;
							gint _dev_index = 0;
#line 349 "Utility/Device.vala"
							_tmp40_ = _g_object_ref0 (list);
#line 349 "Utility/Device.vala"
							_dev_list = _tmp40_;
#line 349 "Utility/Device.vala"
							_tmp41_ = _dev_list;
#line 349 "Utility/Device.vala"
							_tmp42_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp41_);
#line 349 "Utility/Device.vala"
							_tmp43_ = _tmp42_;
#line 349 "Utility/Device.vala"
							_dev_size = _tmp43_;
#line 349 "Utility/Device.vala"
							_dev_index = -1;
#line 349 "Utility/Device.vala"
							while (TRUE) {
#line 1883 "Device.c"
								Device* dev = NULL;
								GeeArrayList* _tmp44_;
								gpointer _tmp45_;
								Device* _tmp46_;
								const gchar* _tmp47_;
								const gchar* _tmp48_;
#line 349 "Utility/Device.vala"
								_dev_index = _dev_index + 1;
#line 349 "Utility/Device.vala"
								if (!(_dev_index < _dev_size)) {
#line 349 "Utility/Device.vala"
									break;
#line 1896 "Device.c"
								}
#line 349 "Utility/Device.vala"
								_tmp44_ = _dev_list;
#line 349 "Utility/Device.vala"
								_tmp45_ = gee_abstract_list_get ((GeeAbstractList*) _tmp44_, _dev_index);
#line 349 "Utility/Device.vala"
								dev = (Device*) _tmp45_;
#line 350 "Utility/Device.vala"
								_tmp46_ = dev;
#line 350 "Utility/Device.vala"
								_tmp47_ = _tmp46_->mapped_name;
#line 350 "Utility/Device.vala"
								_tmp48_ = child_name;
#line 350 "Utility/Device.vala"
								if (g_strcmp0 (_tmp47_, _tmp48_) == 0) {
#line 1912 "Device.c"
									Device* _tmp49_;
									Device* _tmp50_;
#line 351 "Utility/Device.vala"
									_tmp49_ = dev;
#line 351 "Utility/Device.vala"
									_tmp50_ = _g_object_ref0 (_tmp49_);
#line 351 "Utility/Device.vala"
									_g_object_unref0 (child);
#line 351 "Utility/Device.vala"
									child = _tmp50_;
#line 352 "Utility/Device.vala"
									_g_object_unref0 (dev);
#line 352 "Utility/Device.vala"
									break;
#line 1927 "Device.c"
								}
#line 349 "Utility/Device.vala"
								_g_object_unref0 (dev);
#line 1931 "Device.c"
							}
#line 349 "Utility/Device.vala"
							_g_object_unref0 (_dev_list);
#line 1935 "Device.c"
						}
#line 356 "Utility/Device.vala"
						_tmp52_ = parent;
#line 356 "Utility/Device.vala"
						if (_tmp52_ != NULL) {
#line 1941 "Device.c"
							Device* _tmp53_;
#line 356 "Utility/Device.vala"
							_tmp53_ = child;
#line 356 "Utility/Device.vala"
							_tmp51_ = _tmp53_ != NULL;
#line 1947 "Device.c"
						} else {
#line 356 "Utility/Device.vala"
							_tmp51_ = FALSE;
#line 1951 "Device.c"
						}
#line 356 "Utility/Device.vala"
						if (_tmp51_) {
#line 1955 "Device.c"
							Device* _tmp54_;
							Device* _tmp55_;
							const gchar* _tmp56_;
							gchar* _tmp57_;
#line 357 "Utility/Device.vala"
							_tmp54_ = child;
#line 357 "Utility/Device.vala"
							_tmp55_ = parent;
#line 357 "Utility/Device.vala"
							_tmp56_ = _tmp55_->kname;
#line 357 "Utility/Device.vala"
							_tmp57_ = g_strdup (_tmp56_);
#line 357 "Utility/Device.vala"
							_g_free0 (_tmp54_->pkname);
#line 357 "Utility/Device.vala"
							_tmp54_->pkname = _tmp57_;
#line 1972 "Device.c"
						}
#line 335 "Utility/Device.vala"
						_g_object_unref0 (child);
#line 335 "Utility/Device.vala"
						_g_object_unref0 (parent);
#line 335 "Utility/Device.vala"
						_g_free0 (parent_kname);
#line 335 "Utility/Device.vala"
						_g_free0 (child_name);
#line 1982 "Device.c"
					} else {
						const gchar* _tmp58_;
						gchar* _tmp59_;
						gchar* _tmp60_;
#line 363 "Utility/Device.vala"
						_tmp58_ = line;
#line 363 "Utility/Device.vala"
						_tmp59_ = g_strdup_printf ("no-match: %s", _tmp58_);
#line 363 "Utility/Device.vala"
						_tmp60_ = _tmp59_;
#line 363 "Utility/Device.vala"
						tee_jee_logging_log_debug (_tmp60_);
#line 363 "Utility/Device.vala"
						_g_free0 (_tmp60_);
#line 1997 "Device.c"
					}
#line 331 "Utility/Device.vala"
					_g_regex_unref0 (_tmp12_);
#line 2001 "Device.c"
				}
				goto __finally42;
				__catch42_g_error:
				{
					GError* e = NULL;
					GError* _tmp61_;
					const gchar* _tmp62_;
#line 331 "Utility/Device.vala"
					e = _inner_error0_;
#line 331 "Utility/Device.vala"
					_inner_error0_ = NULL;
#line 367 "Utility/Device.vala"
					_tmp61_ = e;
#line 367 "Utility/Device.vala"
					_tmp62_ = _tmp61_->message;
#line 367 "Utility/Device.vala"
					tee_jee_logging_log_error (_tmp62_, FALSE, FALSE);
#line 331 "Utility/Device.vala"
					_g_error_free0 (e);
#line 2021 "Device.c"
				}
				__finally42:
#line 331 "Utility/Device.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 331 "Utility/Device.vala"
					_g_free0 (line);
#line 331 "Utility/Device.vala"
					line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 331 "Utility/Device.vala"
					_g_match_info_unref0 (match);
#line 331 "Utility/Device.vala"
					_g_regex_unref0 (rex);
#line 331 "Utility/Device.vala"
					_g_free0 (std_err);
#line 331 "Utility/Device.vala"
					_g_free0 (std_out);
#line 331 "Utility/Device.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 331 "Utility/Device.vala"
					g_clear_error (&_inner_error0_);
#line 331 "Utility/Device.vala"
					return;
#line 2044 "Device.c"
				}
#line 328 "Utility/Device.vala"
				_g_free0 (line);
#line 2048 "Device.c"
			}
		}
#line 328 "Utility/Device.vala"
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 2053 "Device.c"
	}
#line 314 "Utility/Device.vala"
	_g_match_info_unref0 (match);
#line 314 "Utility/Device.vala"
	_g_regex_unref0 (rex);
#line 314 "Utility/Device.vala"
	_g_free0 (std_err);
#line 314 "Utility/Device.vala"
	_g_free0 (std_out);
#line 2063 "Device.c"
}

static gint64
int64_parse (const gchar* str)
{
	gint64 result = 0LL;
#line 722 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0LL);
#line 723 "glib-2.0.vapi"
	result = g_ascii_strtoll (str, NULL, (guint) 0);
#line 723 "glib-2.0.vapi"
	return result;
#line 2076 "Device.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 1477 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1477 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1477 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1478 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1478 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 2098 "Device.c"
	} else {
#line 1478 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 2102 "Device.c"
	}
#line 1478 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1478 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 2108 "Device.c"
	} else {
#line 1478 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 2112 "Device.c"
	}
#line 1478 "glib-2.0.vapi"
	if (_tmp0_) {
#line 2116 "Device.c"
		gchar* _tmp2_;
#line 1479 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1479 "glib-2.0.vapi"
		result = _tmp2_;
#line 1479 "glib-2.0.vapi"
		return result;
#line 2124 "Device.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1482 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1482 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1482 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1482 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1482 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1482 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1482 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1482 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 2152 "Device.c"
				goto __catch45_g_regex_error;
			}
#line 1482 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1482 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1482 "glib-2.0.vapi"
			return NULL;
#line 2161 "Device.c"
		}
#line 1483 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1483 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1483 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1483 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1483 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1483 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 2175 "Device.c"
				goto __catch45_g_regex_error;
			}
#line 1483 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1483 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1483 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1483 "glib-2.0.vapi"
			return NULL;
#line 2186 "Device.c"
		}
#line 1483 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1483 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1483 "glib-2.0.vapi"
		result = _tmp10_;
#line 1483 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1483 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1483 "glib-2.0.vapi"
		return result;
#line 2200 "Device.c"
	}
	goto __finally45;
	__catch45_g_regex_error:
	{
		GError* e = NULL;
#line 1481 "glib-2.0.vapi"
		e = _inner_error0_;
#line 1481 "glib-2.0.vapi"
		_inner_error0_ = NULL;
#line 1485 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1481 "glib-2.0.vapi"
		_g_error_free0 (e);
#line 2214 "Device.c"
	}
	__finally45:
#line 1481 "glib-2.0.vapi"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1481 "glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1481 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1481 "glib-2.0.vapi"
		return NULL;
#line 2225 "Device.c"
	}
}

GeeArrayList*
device_get_block_devices_using_lsblk (const gchar* dev_name)
{
	GeeArrayList* result = NULL;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gchar* cmd = NULL;
	gint ret_val = 0;
	GRegex* rex = NULL;
	GMatchInfo* match = NULL;
	gint _tmp3_;
	gint _tmp4_;
	const gchar* _tmp9_;
	gchar* _tmp10_ = NULL;
	gchar* _tmp11_ = NULL;
	gint _tmp12_;
	gint index = 0;
	const gchar* _tmp13_;
	gchar** _tmp14_;
	gchar** _tmp15_;
	GeeArrayList* _tmp263_;
	GeeArrayList* _tmp264_;
	GError* _inner_error0_ = NULL;
#line 373 "Utility/Device.vala"
	g_return_val_if_fail (dev_name != NULL, NULL);
#line 380 "Utility/Device.vala"
	device_test_lsblk_version ();
#line 382 "Utility/Device.vala"
	_tmp0_ = gee_array_list_new (TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 382 "Utility/Device.vala"
	list = _tmp0_;
#line 391 "Utility/Device.vala"
	if (device_lsblk_is_ancient) {
#line 2264 "Device.c"
		gchar* _tmp1_;
#line 392 "Utility/Device.vala"
		_tmp1_ = g_strdup ("lsblk --bytes --pairs --output NAME,KNAME,LABEL,UUID,TYPE,FSTYPE,SIZE," \
"MOUNTPOINT,MODEL,RO,RM,MAJ:MIN");
#line 392 "Utility/Device.vala"
		_g_free0 (cmd);
#line 392 "Utility/Device.vala"
		cmd = _tmp1_;
#line 2272 "Device.c"
	} else {
		gchar* _tmp2_;
#line 395 "Utility/Device.vala"
		_tmp2_ = g_strdup ("lsblk --bytes --pairs --output NAME,KNAME,LABEL,UUID,TYPE,FSTYPE,SIZE," \
"MOUNTPOINT,MODEL,RO,HOTPLUG,MAJ:MIN,PARTLABEL,PARTUUID,PKNAME,VENDOR,S" \
"ERIAL,REV");
#line 395 "Utility/Device.vala"
		_g_free0 (cmd);
#line 395 "Utility/Device.vala"
		cmd = _tmp2_;
#line 2281 "Device.c"
	}
#line 398 "Utility/Device.vala"
	_tmp3_ = strlen (dev_name);
#line 398 "Utility/Device.vala"
	_tmp4_ = _tmp3_;
#line 398 "Utility/Device.vala"
	if (_tmp4_ > 0) {
#line 2289 "Device.c"
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
#line 399 "Utility/Device.vala"
		_tmp5_ = cmd;
#line 399 "Utility/Device.vala"
		_tmp6_ = g_strdup_printf (" %s", dev_name);
#line 399 "Utility/Device.vala"
		_tmp7_ = _tmp6_;
#line 399 "Utility/Device.vala"
		_tmp8_ = g_strconcat (_tmp5_, _tmp7_, NULL);
#line 399 "Utility/Device.vala"
		_g_free0 (cmd);
#line 399 "Utility/Device.vala"
		cmd = _tmp8_;
#line 399 "Utility/Device.vala"
		_g_free0 (_tmp7_);
#line 2308 "Device.c"
	}
#line 402 "Utility/Device.vala"
	_tmp9_ = cmd;
#line 402 "Utility/Device.vala"
	_tmp12_ = tee_jee_process_helper_exec_sync (_tmp9_, &_tmp10_, &_tmp11_);
#line 402 "Utility/Device.vala"
	_g_free0 (std_out);
#line 402 "Utility/Device.vala"
	std_out = _tmp10_;
#line 402 "Utility/Device.vala"
	_g_free0 (std_err);
#line 402 "Utility/Device.vala"
	std_err = _tmp11_;
#line 402 "Utility/Device.vala"
	ret_val = _tmp12_;
#line 423 "Utility/Device.vala"
	index = -1;
#line 425 "Utility/Device.vala"
	_tmp13_ = std_out;
#line 425 "Utility/Device.vala"
	_tmp15_ = _tmp14_ = g_strsplit (_tmp13_, "\n", 0);
#line 2330 "Device.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 425 "Utility/Device.vala"
		line_collection = _tmp15_;
#line 425 "Utility/Device.vala"
		line_collection_length1 = _vala_array_length (_tmp14_);
#line 425 "Utility/Device.vala"
		for (line_it = 0; line_it < _vala_array_length (_tmp14_); line_it = line_it + 1) {
#line 2342 "Device.c"
			gchar* _tmp16_;
			gchar* line = NULL;
#line 425 "Utility/Device.vala"
			_tmp16_ = g_strdup (line_collection[line_it]);
#line 425 "Utility/Device.vala"
			line = _tmp16_;
#line 2349 "Device.c"
			{
				const gchar* _tmp17_;
				gchar* _tmp18_;
				gchar* _tmp19_;
				gint _tmp20_;
				gint _tmp21_;
				gboolean _tmp22_;
#line 426 "Utility/Device.vala"
				_tmp17_ = line;
#line 426 "Utility/Device.vala"
				_tmp18_ = string_strip (_tmp17_);
#line 426 "Utility/Device.vala"
				_tmp19_ = _tmp18_;
#line 426 "Utility/Device.vala"
				_tmp20_ = strlen (_tmp19_);
#line 426 "Utility/Device.vala"
				_tmp21_ = _tmp20_;
#line 426 "Utility/Device.vala"
				_tmp22_ = _tmp21_ == 0;
#line 426 "Utility/Device.vala"
				_g_free0 (_tmp19_);
#line 426 "Utility/Device.vala"
				if (_tmp22_) {
#line 426 "Utility/Device.vala"
					_g_free0 (line);
#line 426 "Utility/Device.vala"
					continue;
#line 2377 "Device.c"
				}
				{
					GRegex* _tmp29_;
					const gchar* _tmp30_;
					GMatchInfo* _tmp31_ = NULL;
					gboolean _tmp32_;
#line 429 "Utility/Device.vala"
					if (device_lsblk_is_ancient) {
#line 2386 "Device.c"
						GRegex* _tmp23_ = NULL;
						GRegex* _tmp24_;
						GRegex* _tmp25_;
#line 430 "Utility/Device.vala"
						_tmp24_ = g_regex_new ("NAME=\"(.*)\" KNAME=\"(.*)\" LABEL=\"(.*)\" UUID=\"(.*)\" TYPE=\"(.*)\"" \
" FSTYPE=\"(.*)\" SIZE=\"(.*)\" MOUNTPOINT=\"(.*)\" MODEL=\"(.*)\" RO=\"" \
"([0-9]+)\" RM=\"([0-9]+)\" MAJ:MIN=\"([0-9:]+)\"", 0, 0, &_inner_error0_);
#line 430 "Utility/Device.vala"
						_tmp23_ = _tmp24_;
#line 430 "Utility/Device.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2396 "Device.c"
							goto __catch43_g_error;
						}
#line 430 "Utility/Device.vala"
						_tmp25_ = _tmp23_;
#line 430 "Utility/Device.vala"
						_tmp23_ = NULL;
#line 430 "Utility/Device.vala"
						_g_regex_unref0 (rex);
#line 430 "Utility/Device.vala"
						rex = _tmp25_;
#line 429 "Utility/Device.vala"
						_g_regex_unref0 (_tmp23_);
#line 2409 "Device.c"
					} else {
						GRegex* _tmp26_ = NULL;
						GRegex* _tmp27_;
						GRegex* _tmp28_;
#line 433 "Utility/Device.vala"
						_tmp27_ = g_regex_new ("NAME=\"(.*)\" KNAME=\"(.*)\" LABEL=\"(.*)\" UUID=\"(.*)\" TYPE=\"(.*)\"" \
" FSTYPE=\"(.*)\" SIZE=\"(.*)\" MOUNTPOINT=\"(.*)\" MODEL=\"(.*)\" RO=\"" \
"([0-9]+)\" HOTPLUG=\"([0-9]+)\" MAJ:MIN=\"([0-9:]+)\" PARTLABEL=\"(.*)" \
"\" PARTUUID=\"(.*)\" PKNAME=\"(.*)\" VENDOR=\"(.*)\" SERIAL=\"(.*)\" R" \
"EV=\"(.*)\"", 0, 0, &_inner_error0_);
#line 433 "Utility/Device.vala"
						_tmp26_ = _tmp27_;
#line 433 "Utility/Device.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2420 "Device.c"
							goto __catch43_g_error;
						}
#line 433 "Utility/Device.vala"
						_tmp28_ = _tmp26_;
#line 433 "Utility/Device.vala"
						_tmp26_ = NULL;
#line 433 "Utility/Device.vala"
						_g_regex_unref0 (rex);
#line 433 "Utility/Device.vala"
						rex = _tmp28_;
#line 429 "Utility/Device.vala"
						_g_regex_unref0 (_tmp26_);
#line 2433 "Device.c"
					}
#line 436 "Utility/Device.vala"
					_tmp29_ = rex;
#line 436 "Utility/Device.vala"
					_tmp30_ = line;
#line 436 "Utility/Device.vala"
					_tmp32_ = g_regex_match (_tmp29_, _tmp30_, 0, &_tmp31_);
#line 436 "Utility/Device.vala"
					_g_match_info_unref0 (match);
#line 436 "Utility/Device.vala"
					match = _tmp31_;
#line 436 "Utility/Device.vala"
					if (_tmp32_) {
#line 2447 "Device.c"
						Device* pi = NULL;
						Device* _tmp33_;
						gint pos = 0;
						Device* _tmp34_;
						GMatchInfo* _tmp35_;
						gchar* _tmp36_;
						gchar* _tmp37_;
						gchar* _tmp38_;
						Device* _tmp39_;
						GMatchInfo* _tmp40_;
						gchar* _tmp41_;
						gchar* _tmp42_;
						gchar* _tmp43_;
						Device* _tmp44_;
						GMatchInfo* _tmp45_;
						gchar* _tmp46_;
						Device* _tmp47_;
						GMatchInfo* _tmp48_;
						gchar* _tmp49_;
						gchar* _tmp50_;
						gchar* _tmp51_;
						Device* _tmp52_;
						GMatchInfo* _tmp53_;
						gchar* _tmp54_;
						gchar* _tmp55_;
						gchar* _tmp56_;
						gchar* _tmp57_;
						gchar* _tmp58_;
						Device* _tmp59_;
						GMatchInfo* _tmp60_;
						gchar* _tmp61_;
						gchar* _tmp62_;
						gchar* _tmp63_;
						gchar* _tmp64_;
						gchar* _tmp65_;
						const gchar* _tmp66_ = NULL;
						Device* _tmp67_;
						const gchar* _tmp68_;
						Device* _tmp71_;
						gchar* _tmp72_;
						const gchar* _tmp73_ = NULL;
						Device* _tmp74_;
						const gchar* _tmp75_;
						Device* _tmp78_;
						gchar* _tmp79_;
						Device* _tmp80_;
						GMatchInfo* _tmp81_;
						gchar* _tmp82_;
						gchar* _tmp83_;
						gchar* _tmp84_;
						gchar* _tmp85_;
						gchar* mp = NULL;
						GMatchInfo* _tmp86_;
						gchar* _tmp87_;
						gchar* _tmp88_;
						gchar* _tmp89_;
						gchar* _tmp90_;
						const gchar* _tmp91_;
						gint _tmp92_;
						gint _tmp93_;
						Device* _tmp100_;
						GMatchInfo* _tmp101_;
						gchar* _tmp102_;
						gchar* _tmp103_;
						gchar* _tmp104_;
						Device* _tmp105_;
						GMatchInfo* _tmp106_;
						gchar* _tmp107_;
						gchar* _tmp108_;
						gchar* _tmp109_;
						gchar* _tmp110_;
						Device* _tmp111_;
						GMatchInfo* _tmp112_;
						gchar* _tmp113_;
						gchar* _tmp114_;
						gchar* _tmp115_;
						gchar* _tmp116_;
						gchar* txt = NULL;
						GMatchInfo* _tmp117_;
						gchar* _tmp118_;
						gchar* _tmp119_;
						gchar* _tmp120_;
						gchar* _tmp121_;
						const gchar* _tmp122_;
						Device* _tmp163_;
						Device* _tmp164_;
						Device* _tmp165_;
						const gchar* _tmp166_;
						gchar* _tmp167_;
						Device* _tmp168_;
						const gchar* _tmp169_;
						gint _tmp170_;
						gint _tmp171_;
						Device* _tmp176_;
						const gchar* _tmp177_;
						gint _tmp178_;
						gint _tmp179_;
						Device* _tmp184_;
						const gchar* _tmp185_;
						gint _tmp186_;
						gint _tmp187_;
						Device* _tmp192_;
						const gchar* _tmp193_;
						gint _tmp194_;
						gint _tmp195_;
						GeeArrayList* _tmp200_;
						Device* _tmp201_;
#line 438 "Utility/Device.vala"
						_tmp33_ = device_new ();
#line 438 "Utility/Device.vala"
						pi = _tmp33_;
#line 440 "Utility/Device.vala"
						pos = 0;
#line 442 "Utility/Device.vala"
						_tmp34_ = pi;
#line 442 "Utility/Device.vala"
						_tmp35_ = match;
#line 442 "Utility/Device.vala"
						pos = pos + 1;
#line 442 "Utility/Device.vala"
						_tmp36_ = g_match_info_fetch (_tmp35_, pos);
#line 442 "Utility/Device.vala"
						_tmp37_ = _tmp36_;
#line 442 "Utility/Device.vala"
						_tmp38_ = string_strip (_tmp37_);
#line 442 "Utility/Device.vala"
						_g_free0 (_tmp34_->name);
#line 442 "Utility/Device.vala"
						_tmp34_->name = _tmp38_;
#line 442 "Utility/Device.vala"
						_g_free0 (_tmp37_);
#line 443 "Utility/Device.vala"
						_tmp39_ = pi;
#line 443 "Utility/Device.vala"
						_tmp40_ = match;
#line 443 "Utility/Device.vala"
						pos = pos + 1;
#line 443 "Utility/Device.vala"
						_tmp41_ = g_match_info_fetch (_tmp40_, pos);
#line 443 "Utility/Device.vala"
						_tmp42_ = _tmp41_;
#line 443 "Utility/Device.vala"
						_tmp43_ = string_strip (_tmp42_);
#line 443 "Utility/Device.vala"
						_g_free0 (_tmp39_->kname);
#line 443 "Utility/Device.vala"
						_tmp39_->kname = _tmp43_;
#line 443 "Utility/Device.vala"
						_g_free0 (_tmp42_);
#line 445 "Utility/Device.vala"
						_tmp44_ = pi;
#line 445 "Utility/Device.vala"
						_tmp45_ = match;
#line 445 "Utility/Device.vala"
						pos = pos + 1;
#line 445 "Utility/Device.vala"
						_tmp46_ = g_match_info_fetch (_tmp45_, pos);
#line 445 "Utility/Device.vala"
						_g_free0 (_tmp44_->label);
#line 445 "Utility/Device.vala"
						_tmp44_->label = _tmp46_;
#line 446 "Utility/Device.vala"
						_tmp47_ = pi;
#line 446 "Utility/Device.vala"
						_tmp48_ = match;
#line 446 "Utility/Device.vala"
						pos = pos + 1;
#line 446 "Utility/Device.vala"
						_tmp49_ = g_match_info_fetch (_tmp48_, pos);
#line 446 "Utility/Device.vala"
						_tmp50_ = _tmp49_;
#line 446 "Utility/Device.vala"
						_tmp51_ = string_strip (_tmp50_);
#line 446 "Utility/Device.vala"
						_g_free0 (_tmp47_->uuid);
#line 446 "Utility/Device.vala"
						_tmp47_->uuid = _tmp51_;
#line 446 "Utility/Device.vala"
						_g_free0 (_tmp50_);
#line 448 "Utility/Device.vala"
						_tmp52_ = pi;
#line 448 "Utility/Device.vala"
						_tmp53_ = match;
#line 448 "Utility/Device.vala"
						pos = pos + 1;
#line 448 "Utility/Device.vala"
						_tmp54_ = g_match_info_fetch (_tmp53_, pos);
#line 448 "Utility/Device.vala"
						_tmp55_ = _tmp54_;
#line 448 "Utility/Device.vala"
						_tmp56_ = string_strip (_tmp55_);
#line 448 "Utility/Device.vala"
						_tmp57_ = _tmp56_;
#line 448 "Utility/Device.vala"
						_tmp58_ = g_utf8_strdown (_tmp57_, (gssize) -1);
#line 448 "Utility/Device.vala"
						_g_free0 (_tmp52_->type);
#line 448 "Utility/Device.vala"
						_tmp52_->type = _tmp58_;
#line 448 "Utility/Device.vala"
						_g_free0 (_tmp57_);
#line 448 "Utility/Device.vala"
						_g_free0 (_tmp55_);
#line 450 "Utility/Device.vala"
						_tmp59_ = pi;
#line 450 "Utility/Device.vala"
						_tmp60_ = match;
#line 450 "Utility/Device.vala"
						pos = pos + 1;
#line 450 "Utility/Device.vala"
						_tmp61_ = g_match_info_fetch (_tmp60_, pos);
#line 450 "Utility/Device.vala"
						_tmp62_ = _tmp61_;
#line 450 "Utility/Device.vala"
						_tmp63_ = string_strip (_tmp62_);
#line 450 "Utility/Device.vala"
						_tmp64_ = _tmp63_;
#line 450 "Utility/Device.vala"
						_tmp65_ = g_utf8_strdown (_tmp64_, (gssize) -1);
#line 450 "Utility/Device.vala"
						_g_free0 (_tmp59_->fstype);
#line 450 "Utility/Device.vala"
						_tmp59_->fstype = _tmp65_;
#line 450 "Utility/Device.vala"
						_g_free0 (_tmp64_);
#line 450 "Utility/Device.vala"
						_g_free0 (_tmp62_);
#line 451 "Utility/Device.vala"
						_tmp67_ = pi;
#line 451 "Utility/Device.vala"
						_tmp68_ = _tmp67_->fstype;
#line 451 "Utility/Device.vala"
						if (g_strcmp0 (_tmp68_, "crypto_luks") == 0) {
#line 451 "Utility/Device.vala"
							_tmp66_ = "luks";
#line 2683 "Device.c"
						} else {
							Device* _tmp69_;
							const gchar* _tmp70_;
#line 451 "Utility/Device.vala"
							_tmp69_ = pi;
#line 451 "Utility/Device.vala"
							_tmp70_ = _tmp69_->fstype;
#line 451 "Utility/Device.vala"
							_tmp66_ = _tmp70_;
#line 2693 "Device.c"
						}
#line 451 "Utility/Device.vala"
						_tmp71_ = pi;
#line 451 "Utility/Device.vala"
						_tmp72_ = g_strdup (_tmp66_);
#line 451 "Utility/Device.vala"
						_g_free0 (_tmp71_->fstype);
#line 451 "Utility/Device.vala"
						_tmp71_->fstype = _tmp72_;
#line 452 "Utility/Device.vala"
						_tmp74_ = pi;
#line 452 "Utility/Device.vala"
						_tmp75_ = _tmp74_->fstype;
#line 452 "Utility/Device.vala"
						if (g_strcmp0 (_tmp75_, "lvm2_member") == 0) {
#line 452 "Utility/Device.vala"
							_tmp73_ = "lvm2";
#line 2711 "Device.c"
						} else {
							Device* _tmp76_;
							const gchar* _tmp77_;
#line 452 "Utility/Device.vala"
							_tmp76_ = pi;
#line 452 "Utility/Device.vala"
							_tmp77_ = _tmp76_->fstype;
#line 452 "Utility/Device.vala"
							_tmp73_ = _tmp77_;
#line 2721 "Device.c"
						}
#line 452 "Utility/Device.vala"
						_tmp78_ = pi;
#line 452 "Utility/Device.vala"
						_tmp79_ = g_strdup (_tmp73_);
#line 452 "Utility/Device.vala"
						_g_free0 (_tmp78_->fstype);
#line 452 "Utility/Device.vala"
						_tmp78_->fstype = _tmp79_;
#line 454 "Utility/Device.vala"
						_tmp80_ = pi;
#line 454 "Utility/Device.vala"
						_tmp81_ = match;
#line 454 "Utility/Device.vala"
						pos = pos + 1;
#line 454 "Utility/Device.vala"
						_tmp82_ = g_match_info_fetch (_tmp81_, pos);
#line 454 "Utility/Device.vala"
						_tmp83_ = _tmp82_;
#line 454 "Utility/Device.vala"
						_tmp84_ = string_strip (_tmp83_);
#line 454 "Utility/Device.vala"
						_tmp85_ = _tmp84_;
#line 454 "Utility/Device.vala"
						_tmp80_->size_bytes = (guint64) int64_parse (_tmp85_);
#line 454 "Utility/Device.vala"
						_g_free0 (_tmp85_);
#line 454 "Utility/Device.vala"
						_g_free0 (_tmp83_);
#line 456 "Utility/Device.vala"
						_tmp86_ = match;
#line 456 "Utility/Device.vala"
						pos = pos + 1;
#line 456 "Utility/Device.vala"
						_tmp87_ = g_match_info_fetch (_tmp86_, pos);
#line 456 "Utility/Device.vala"
						_tmp88_ = _tmp87_;
#line 456 "Utility/Device.vala"
						_tmp89_ = string_strip (_tmp88_);
#line 456 "Utility/Device.vala"
						_tmp90_ = _tmp89_;
#line 456 "Utility/Device.vala"
						_g_free0 (_tmp88_);
#line 456 "Utility/Device.vala"
						mp = _tmp90_;
#line 457 "Utility/Device.vala"
						_tmp91_ = mp;
#line 457 "Utility/Device.vala"
						_tmp92_ = strlen (_tmp91_);
#line 457 "Utility/Device.vala"
						_tmp93_ = _tmp92_;
#line 457 "Utility/Device.vala"
						if (_tmp93_ > 0) {
#line 2775 "Device.c"
							Device* _tmp94_;
							GeeArrayList* _tmp95_;
							Device* _tmp96_;
							const gchar* _tmp97_;
							MountEntry* _tmp98_;
							MountEntry* _tmp99_;
#line 458 "Utility/Device.vala"
							_tmp94_ = pi;
#line 458 "Utility/Device.vala"
							_tmp95_ = _tmp94_->mount_points;
#line 458 "Utility/Device.vala"
							_tmp96_ = pi;
#line 458 "Utility/Device.vala"
							_tmp97_ = mp;
#line 458 "Utility/Device.vala"
							_tmp98_ = mount_entry_new (_tmp96_, _tmp97_, "");
#line 458 "Utility/Device.vala"
							_tmp99_ = _tmp98_;
#line 458 "Utility/Device.vala"
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp95_, _tmp99_);
#line 458 "Utility/Device.vala"
							_g_object_unref0 (_tmp99_);
#line 2798 "Device.c"
						}
#line 461 "Utility/Device.vala"
						_tmp100_ = pi;
#line 461 "Utility/Device.vala"
						_tmp101_ = match;
#line 461 "Utility/Device.vala"
						pos = pos + 1;
#line 461 "Utility/Device.vala"
						_tmp102_ = g_match_info_fetch (_tmp101_, pos);
#line 461 "Utility/Device.vala"
						_tmp103_ = _tmp102_;
#line 461 "Utility/Device.vala"
						_tmp104_ = string_strip (_tmp103_);
#line 461 "Utility/Device.vala"
						_g_free0 (_tmp100_->model);
#line 461 "Utility/Device.vala"
						_tmp100_->model = _tmp104_;
#line 461 "Utility/Device.vala"
						_g_free0 (_tmp103_);
#line 463 "Utility/Device.vala"
						_tmp105_ = pi;
#line 463 "Utility/Device.vala"
						_tmp106_ = match;
#line 463 "Utility/Device.vala"
						pos = pos + 1;
#line 463 "Utility/Device.vala"
						_tmp107_ = g_match_info_fetch (_tmp106_, pos);
#line 463 "Utility/Device.vala"
						_tmp108_ = _tmp107_;
#line 463 "Utility/Device.vala"
						_tmp109_ = string_strip (_tmp108_);
#line 463 "Utility/Device.vala"
						_tmp110_ = _tmp109_;
#line 463 "Utility/Device.vala"
						_tmp105_->read_only = g_strcmp0 (_tmp110_, "1") == 0;
#line 463 "Utility/Device.vala"
						_g_free0 (_tmp110_);
#line 463 "Utility/Device.vala"
						_g_free0 (_tmp108_);
#line 465 "Utility/Device.vala"
						_tmp111_ = pi;
#line 465 "Utility/Device.vala"
						_tmp112_ = match;
#line 465 "Utility/Device.vala"
						pos = pos + 1;
#line 465 "Utility/Device.vala"
						_tmp113_ = g_match_info_fetch (_tmp112_, pos);
#line 465 "Utility/Device.vala"
						_tmp114_ = _tmp113_;
#line 465 "Utility/Device.vala"
						_tmp115_ = string_strip (_tmp114_);
#line 465 "Utility/Device.vala"
						_tmp116_ = _tmp115_;
#line 465 "Utility/Device.vala"
						_tmp111_->removable = g_strcmp0 (_tmp116_, "1") == 0;
#line 465 "Utility/Device.vala"
						_g_free0 (_tmp116_);
#line 465 "Utility/Device.vala"
						_g_free0 (_tmp114_);
#line 467 "Utility/Device.vala"
						_tmp117_ = match;
#line 467 "Utility/Device.vala"
						pos = pos + 1;
#line 467 "Utility/Device.vala"
						_tmp118_ = g_match_info_fetch (_tmp117_, pos);
#line 467 "Utility/Device.vala"
						_tmp119_ = _tmp118_;
#line 467 "Utility/Device.vala"
						_tmp120_ = string_strip (_tmp119_);
#line 467 "Utility/Device.vala"
						_tmp121_ = _tmp120_;
#line 467 "Utility/Device.vala"
						_g_free0 (_tmp119_);
#line 467 "Utility/Device.vala"
						txt = _tmp121_;
#line 468 "Utility/Device.vala"
						_tmp122_ = txt;
#line 468 "Utility/Device.vala"
						if (string_contains (_tmp122_, ":")) {
#line 2878 "Device.c"
							Device* _tmp123_;
							const gchar* _tmp124_;
							gchar** _tmp125_;
							gchar** _tmp126_;
							gchar** _tmp127_;
							gint _tmp127__length1;
							const gchar* _tmp128_;
							Device* _tmp129_;
							const gchar* _tmp130_;
							gchar** _tmp131_;
							gchar** _tmp132_;
							gchar** _tmp133_;
							gint _tmp133__length1;
							const gchar* _tmp134_;
#line 469 "Utility/Device.vala"
							_tmp123_ = pi;
#line 469 "Utility/Device.vala"
							_tmp124_ = txt;
#line 469 "Utility/Device.vala"
							_tmp126_ = _tmp125_ = g_strsplit (_tmp124_, ":", 0);
#line 469 "Utility/Device.vala"
							_tmp127_ = _tmp126_;
#line 469 "Utility/Device.vala"
							_tmp127__length1 = _vala_array_length (_tmp125_);
#line 469 "Utility/Device.vala"
							_tmp128_ = _tmp127_[0];
#line 469 "Utility/Device.vala"
							_tmp123_->major = atoi (_tmp128_);
#line 469 "Utility/Device.vala"
							_tmp127_ = (_vala_array_free (_tmp127_, _tmp127__length1, (GDestroyNotify) g_free), NULL);
#line 470 "Utility/Device.vala"
							_tmp129_ = pi;
#line 470 "Utility/Device.vala"
							_tmp130_ = txt;
#line 470 "Utility/Device.vala"
							_tmp132_ = _tmp131_ = g_strsplit (_tmp130_, ":", 0);
#line 470 "Utility/Device.vala"
							_tmp133_ = _tmp132_;
#line 470 "Utility/Device.vala"
							_tmp133__length1 = _vala_array_length (_tmp131_);
#line 470 "Utility/Device.vala"
							_tmp134_ = _tmp133_[1];
#line 470 "Utility/Device.vala"
							_tmp129_->minor = atoi (_tmp134_);
#line 470 "Utility/Device.vala"
							_tmp133_ = (_vala_array_free (_tmp133_, _tmp133__length1, (GDestroyNotify) g_free), NULL);
#line 2925 "Device.c"
						}
#line 473 "Utility/Device.vala"
						if (!device_lsblk_is_ancient) {
#line 2929 "Device.c"
							Device* _tmp135_;
							GMatchInfo* _tmp136_;
							gchar* _tmp137_;
							Device* _tmp138_;
							GMatchInfo* _tmp139_;
							gchar* _tmp140_;
							gchar* _tmp141_;
							gchar* _tmp142_;
							Device* _tmp143_;
							GMatchInfo* _tmp144_;
							gchar* _tmp145_;
							gchar* _tmp146_;
							gchar* _tmp147_;
							Device* _tmp148_;
							GMatchInfo* _tmp149_;
							gchar* _tmp150_;
							gchar* _tmp151_;
							gchar* _tmp152_;
							Device* _tmp153_;
							GMatchInfo* _tmp154_;
							gchar* _tmp155_;
							gchar* _tmp156_;
							gchar* _tmp157_;
							Device* _tmp158_;
							GMatchInfo* _tmp159_;
							gchar* _tmp160_;
							gchar* _tmp161_;
							gchar* _tmp162_;
#line 475 "Utility/Device.vala"
							_tmp135_ = pi;
#line 475 "Utility/Device.vala"
							_tmp136_ = match;
#line 475 "Utility/Device.vala"
							pos = pos + 1;
#line 475 "Utility/Device.vala"
							_tmp137_ = g_match_info_fetch (_tmp136_, pos);
#line 475 "Utility/Device.vala"
							_g_free0 (_tmp135_->partlabel);
#line 475 "Utility/Device.vala"
							_tmp135_->partlabel = _tmp137_;
#line 476 "Utility/Device.vala"
							_tmp138_ = pi;
#line 476 "Utility/Device.vala"
							_tmp139_ = match;
#line 476 "Utility/Device.vala"
							pos = pos + 1;
#line 476 "Utility/Device.vala"
							_tmp140_ = g_match_info_fetch (_tmp139_, pos);
#line 476 "Utility/Device.vala"
							_tmp141_ = _tmp140_;
#line 476 "Utility/Device.vala"
							_tmp142_ = string_strip (_tmp141_);
#line 476 "Utility/Device.vala"
							_g_free0 (_tmp138_->partuuid);
#line 476 "Utility/Device.vala"
							_tmp138_->partuuid = _tmp142_;
#line 476 "Utility/Device.vala"
							_g_free0 (_tmp141_);
#line 478 "Utility/Device.vala"
							_tmp143_ = pi;
#line 478 "Utility/Device.vala"
							_tmp144_ = match;
#line 478 "Utility/Device.vala"
							pos = pos + 1;
#line 478 "Utility/Device.vala"
							_tmp145_ = g_match_info_fetch (_tmp144_, pos);
#line 478 "Utility/Device.vala"
							_tmp146_ = _tmp145_;
#line 478 "Utility/Device.vala"
							_tmp147_ = string_strip (_tmp146_);
#line 478 "Utility/Device.vala"
							_g_free0 (_tmp143_->pkname);
#line 478 "Utility/Device.vala"
							_tmp143_->pkname = _tmp147_;
#line 478 "Utility/Device.vala"
							_g_free0 (_tmp146_);
#line 479 "Utility/Device.vala"
							_tmp148_ = pi;
#line 479 "Utility/Device.vala"
							_tmp149_ = match;
#line 479 "Utility/Device.vala"
							pos = pos + 1;
#line 479 "Utility/Device.vala"
							_tmp150_ = g_match_info_fetch (_tmp149_, pos);
#line 479 "Utility/Device.vala"
							_tmp151_ = _tmp150_;
#line 479 "Utility/Device.vala"
							_tmp152_ = string_strip (_tmp151_);
#line 479 "Utility/Device.vala"
							_g_free0 (_tmp148_->vendor);
#line 479 "Utility/Device.vala"
							_tmp148_->vendor = _tmp152_;
#line 479 "Utility/Device.vala"
							_g_free0 (_tmp151_);
#line 480 "Utility/Device.vala"
							_tmp153_ = pi;
#line 480 "Utility/Device.vala"
							_tmp154_ = match;
#line 480 "Utility/Device.vala"
							pos = pos + 1;
#line 480 "Utility/Device.vala"
							_tmp155_ = g_match_info_fetch (_tmp154_, pos);
#line 480 "Utility/Device.vala"
							_tmp156_ = _tmp155_;
#line 480 "Utility/Device.vala"
							_tmp157_ = string_strip (_tmp156_);
#line 480 "Utility/Device.vala"
							_g_free0 (_tmp153_->serial);
#line 480 "Utility/Device.vala"
							_tmp153_->serial = _tmp157_;
#line 480 "Utility/Device.vala"
							_g_free0 (_tmp156_);
#line 481 "Utility/Device.vala"
							_tmp158_ = pi;
#line 481 "Utility/Device.vala"
							_tmp159_ = match;
#line 481 "Utility/Device.vala"
							pos = pos + 1;
#line 481 "Utility/Device.vala"
							_tmp160_ = g_match_info_fetch (_tmp159_, pos);
#line 481 "Utility/Device.vala"
							_tmp161_ = _tmp160_;
#line 481 "Utility/Device.vala"
							_tmp162_ = string_strip (_tmp161_);
#line 481 "Utility/Device.vala"
							_g_free0 (_tmp158_->revision);
#line 481 "Utility/Device.vala"
							_tmp158_->revision = _tmp162_;
#line 481 "Utility/Device.vala"
							_g_free0 (_tmp161_);
#line 3060 "Device.c"
						}
#line 484 "Utility/Device.vala"
						_tmp163_ = pi;
#line 484 "Utility/Device.vala"
						index = index + 1;
#line 484 "Utility/Device.vala"
						_tmp163_->order = index;
#line 485 "Utility/Device.vala"
						_tmp164_ = pi;
#line 485 "Utility/Device.vala"
						_tmp165_ = pi;
#line 485 "Utility/Device.vala"
						_tmp166_ = _tmp165_->kname;
#line 485 "Utility/Device.vala"
						_tmp167_ = g_strdup_printf ("/dev/%s", _tmp166_);
#line 485 "Utility/Device.vala"
						_g_free0 (_tmp164_->device);
#line 485 "Utility/Device.vala"
						_tmp164_->device = _tmp167_;
#line 487 "Utility/Device.vala"
						_tmp168_ = pi;
#line 487 "Utility/Device.vala"
						_tmp169_ = _tmp168_->uuid;
#line 487 "Utility/Device.vala"
						_tmp170_ = strlen (_tmp169_);
#line 487 "Utility/Device.vala"
						_tmp171_ = _tmp170_;
#line 487 "Utility/Device.vala"
						if (_tmp171_ > 0) {
#line 3090 "Device.c"
							Device* _tmp172_;
							Device* _tmp173_;
							const gchar* _tmp174_;
							gchar* _tmp175_;
#line 488 "Utility/Device.vala"
							_tmp172_ = pi;
#line 488 "Utility/Device.vala"
							_tmp173_ = pi;
#line 488 "Utility/Device.vala"
							_tmp174_ = _tmp173_->uuid;
#line 488 "Utility/Device.vala"
							_tmp175_ = g_strdup_printf ("/dev/disk/by-uuid/%s", _tmp174_);
#line 488 "Utility/Device.vala"
							_g_free0 (_tmp172_->device_by_uuid);
#line 488 "Utility/Device.vala"
							_tmp172_->device_by_uuid = _tmp175_;
#line 3107 "Device.c"
						}
#line 491 "Utility/Device.vala"
						_tmp176_ = pi;
#line 491 "Utility/Device.vala"
						_tmp177_ = _tmp176_->label;
#line 491 "Utility/Device.vala"
						_tmp178_ = strlen (_tmp177_);
#line 491 "Utility/Device.vala"
						_tmp179_ = _tmp178_;
#line 491 "Utility/Device.vala"
						if (_tmp179_ > 0) {
#line 3119 "Device.c"
							Device* _tmp180_;
							Device* _tmp181_;
							const gchar* _tmp182_;
							gchar* _tmp183_;
#line 492 "Utility/Device.vala"
							_tmp180_ = pi;
#line 492 "Utility/Device.vala"
							_tmp181_ = pi;
#line 492 "Utility/Device.vala"
							_tmp182_ = _tmp181_->label;
#line 492 "Utility/Device.vala"
							_tmp183_ = g_strdup_printf ("/dev/disk/by-label/%s", _tmp182_);
#line 492 "Utility/Device.vala"
							_g_free0 (_tmp180_->device_by_label);
#line 492 "Utility/Device.vala"
							_tmp180_->device_by_label = _tmp183_;
#line 3136 "Device.c"
						}
#line 495 "Utility/Device.vala"
						_tmp184_ = pi;
#line 495 "Utility/Device.vala"
						_tmp185_ = _tmp184_->partuuid;
#line 495 "Utility/Device.vala"
						_tmp186_ = strlen (_tmp185_);
#line 495 "Utility/Device.vala"
						_tmp187_ = _tmp186_;
#line 495 "Utility/Device.vala"
						if (_tmp187_ > 0) {
#line 3148 "Device.c"
							Device* _tmp188_;
							Device* _tmp189_;
							const gchar* _tmp190_;
							gchar* _tmp191_;
#line 496 "Utility/Device.vala"
							_tmp188_ = pi;
#line 496 "Utility/Device.vala"
							_tmp189_ = pi;
#line 496 "Utility/Device.vala"
							_tmp190_ = _tmp189_->partuuid;
#line 496 "Utility/Device.vala"
							_tmp191_ = g_strdup_printf ("/dev/disk/by-partuuid/%s", _tmp190_);
#line 496 "Utility/Device.vala"
							_g_free0 (_tmp188_->device_by_partuuid);
#line 496 "Utility/Device.vala"
							_tmp188_->device_by_partuuid = _tmp191_;
#line 3165 "Device.c"
						}
#line 499 "Utility/Device.vala"
						_tmp192_ = pi;
#line 499 "Utility/Device.vala"
						_tmp193_ = _tmp192_->partlabel;
#line 499 "Utility/Device.vala"
						_tmp194_ = strlen (_tmp193_);
#line 499 "Utility/Device.vala"
						_tmp195_ = _tmp194_;
#line 499 "Utility/Device.vala"
						if (_tmp195_ > 0) {
#line 3177 "Device.c"
							Device* _tmp196_;
							Device* _tmp197_;
							const gchar* _tmp198_;
							gchar* _tmp199_;
#line 500 "Utility/Device.vala"
							_tmp196_ = pi;
#line 500 "Utility/Device.vala"
							_tmp197_ = pi;
#line 500 "Utility/Device.vala"
							_tmp198_ = _tmp197_->partlabel;
#line 500 "Utility/Device.vala"
							_tmp199_ = g_strdup_printf ("/dev/disk/by-partlabel/%s", _tmp198_);
#line 500 "Utility/Device.vala"
							_g_free0 (_tmp196_->device_by_partlabel);
#line 500 "Utility/Device.vala"
							_tmp196_->device_by_partlabel = _tmp199_;
#line 3194 "Device.c"
						}
#line 508 "Utility/Device.vala"
						_tmp200_ = list;
#line 508 "Utility/Device.vala"
						_tmp201_ = pi;
#line 508 "Utility/Device.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp200_, _tmp201_);
#line 436 "Utility/Device.vala"
						_g_free0 (txt);
#line 436 "Utility/Device.vala"
						_g_free0 (mp);
#line 436 "Utility/Device.vala"
						_g_object_unref0 (pi);
#line 3208 "Device.c"
					} else {
						const gchar* _tmp202_;
						gchar* _tmp203_;
						gchar* _tmp204_;
#line 512 "Utility/Device.vala"
						_tmp202_ = line;
#line 512 "Utility/Device.vala"
						_tmp203_ = g_strdup_printf ("no-match: %s", _tmp202_);
#line 512 "Utility/Device.vala"
						_tmp204_ = _tmp203_;
#line 512 "Utility/Device.vala"
						tee_jee_logging_log_debug (_tmp204_);
#line 512 "Utility/Device.vala"
						_g_free0 (_tmp204_);
#line 3223 "Device.c"
					}
				}
				goto __finally43;
				__catch43_g_error:
				{
					GError* e = NULL;
					GError* _tmp205_;
					const gchar* _tmp206_;
#line 428 "Utility/Device.vala"
					e = _inner_error0_;
#line 428 "Utility/Device.vala"
					_inner_error0_ = NULL;
#line 516 "Utility/Device.vala"
					_tmp205_ = e;
#line 516 "Utility/Device.vala"
					_tmp206_ = _tmp205_->message;
#line 516 "Utility/Device.vala"
					tee_jee_logging_log_error (_tmp206_, FALSE, FALSE);
#line 428 "Utility/Device.vala"
					_g_error_free0 (e);
#line 3244 "Device.c"
				}
				__finally43:
#line 428 "Utility/Device.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 428 "Utility/Device.vala"
					_g_free0 (line);
#line 428 "Utility/Device.vala"
					line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 428 "Utility/Device.vala"
					_g_match_info_unref0 (match);
#line 428 "Utility/Device.vala"
					_g_regex_unref0 (rex);
#line 428 "Utility/Device.vala"
					_g_free0 (cmd);
#line 428 "Utility/Device.vala"
					_g_free0 (std_err);
#line 428 "Utility/Device.vala"
					_g_free0 (std_out);
#line 428 "Utility/Device.vala"
					_g_object_unref0 (list);
#line 428 "Utility/Device.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 428 "Utility/Device.vala"
					g_clear_error (&_inner_error0_);
#line 428 "Utility/Device.vala"
					return NULL;
#line 3271 "Device.c"
				}
#line 425 "Utility/Device.vala"
				_g_free0 (line);
#line 3275 "Device.c"
			}
		}
#line 425 "Utility/Device.vala"
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 3280 "Device.c"
	}
	{
		GeeArrayList* _dev_list = NULL;
		GeeArrayList* _tmp207_;
		GeeArrayList* _tmp208_;
		gint _dev_size = 0;
		GeeArrayList* _tmp209_;
		gint _tmp210_;
		gint _tmp211_;
		gint _dev_index = 0;
#line 527 "Utility/Device.vala"
		_tmp207_ = list;
#line 527 "Utility/Device.vala"
		_tmp208_ = _g_object_ref0 (_tmp207_);
#line 527 "Utility/Device.vala"
		_dev_list = _tmp208_;
#line 527 "Utility/Device.vala"
		_tmp209_ = _dev_list;
#line 527 "Utility/Device.vala"
		_tmp210_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp209_);
#line 527 "Utility/Device.vala"
		_tmp211_ = _tmp210_;
#line 527 "Utility/Device.vala"
		_dev_size = _tmp211_;
#line 527 "Utility/Device.vala"
		_dev_index = -1;
#line 527 "Utility/Device.vala"
		while (TRUE) {
#line 3309 "Device.c"
			Device* dev = NULL;
			GeeArrayList* _tmp212_;
			gpointer _tmp213_;
			gchar* dev_by_uuid = NULL;
			Device* _tmp214_;
			const gchar* _tmp215_;
			gchar* _tmp216_;
			const gchar* _tmp217_;
#line 527 "Utility/Device.vala"
			_dev_index = _dev_index + 1;
#line 527 "Utility/Device.vala"
			if (!(_dev_index < _dev_size)) {
#line 527 "Utility/Device.vala"
				break;
#line 3324 "Device.c"
			}
#line 527 "Utility/Device.vala"
			_tmp212_ = _dev_list;
#line 527 "Utility/Device.vala"
			_tmp213_ = gee_abstract_list_get ((GeeAbstractList*) _tmp212_, _dev_index);
#line 527 "Utility/Device.vala"
			dev = (Device*) _tmp213_;
#line 528 "Utility/Device.vala"
			_tmp214_ = dev;
#line 528 "Utility/Device.vala"
			_tmp215_ = _tmp214_->uuid;
#line 528 "Utility/Device.vala"
			_tmp216_ = tee_jee_file_system_path_combine ("/dev/disk/by-uuid/", _tmp215_);
#line 528 "Utility/Device.vala"
			dev_by_uuid = _tmp216_;
#line 529 "Utility/Device.vala"
			_tmp217_ = dev_by_uuid;
#line 529 "Utility/Device.vala"
			if (tee_jee_file_system_file_exists (_tmp217_)) {
#line 3344 "Device.c"
				Device* _tmp218_;
				GeeArrayList* _tmp219_;
				const gchar* _tmp220_;
#line 530 "Utility/Device.vala"
				_tmp218_ = dev;
#line 530 "Utility/Device.vala"
				_tmp219_ = _tmp218_->symlinks;
#line 530 "Utility/Device.vala"
				_tmp220_ = dev_by_uuid;
#line 530 "Utility/Device.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp219_, _tmp220_);
#line 3356 "Device.c"
			}
#line 527 "Utility/Device.vala"
			_g_free0 (dev_by_uuid);
#line 527 "Utility/Device.vala"
			_g_object_unref0 (dev);
#line 3362 "Device.c"
		}
#line 527 "Utility/Device.vala"
		_g_object_unref0 (_dev_list);
#line 3366 "Device.c"
	}
	{
		GFile* f_dev_mapper = NULL;
		GFile* _tmp221_;
		GFileEnumerator* enumerator = NULL;
		GFile* _tmp222_;
		gchar* _tmp223_;
		gchar* _tmp224_;
		GFileEnumerator* _tmp225_;
		GFileEnumerator* _tmp226_;
		GFileInfo* info = NULL;
#line 538 "Utility/Device.vala"
		_tmp221_ = g_file_new_for_path ("/dev/mapper");
#line 538 "Utility/Device.vala"
		f_dev_mapper = _tmp221_;
#line 540 "Utility/Device.vala"
		_tmp222_ = f_dev_mapper;
#line 540 "Utility/Device.vala"
		_tmp223_ = g_strdup_printf ("%s,%s", G_FILE_ATTRIBUTE_STANDARD_NAME, G_FILE_ATTRIBUTE_STANDARD_SYMLINK_TARGET);
#line 540 "Utility/Device.vala"
		_tmp224_ = _tmp223_;
#line 540 "Utility/Device.vala"
		_tmp225_ = g_file_enumerate_children (_tmp222_, _tmp224_, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 540 "Utility/Device.vala"
		_tmp226_ = _tmp225_;
#line 540 "Utility/Device.vala"
		_g_free0 (_tmp224_);
#line 540 "Utility/Device.vala"
		enumerator = _tmp226_;
#line 540 "Utility/Device.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 540 "Utility/Device.vala"
			_g_object_unref0 (f_dev_mapper);
#line 3400 "Device.c"
			goto __catch44_g_error;
		}
#line 546 "Utility/Device.vala"
		while (TRUE) {
#line 3405 "Device.c"
			GFileInfo* _tmp227_ = NULL;
			GFileEnumerator* _tmp228_;
			GFileInfo* _tmp229_;
			GFileInfo* _tmp230_;
			GFileInfo* _tmp231_;
			GFileInfo* _tmp232_;
			const gchar* _tmp233_;
			GFile* f_mapped = NULL;
			GFile* _tmp234_;
			GFileInfo* _tmp235_;
			const gchar* _tmp236_;
			GFile* _tmp237_;
			gchar* mapped_file = NULL;
			GFile* _tmp238_;
			gchar* _tmp239_;
			gchar* mapped_device = NULL;
			GFileInfo* _tmp240_;
			const gchar* _tmp241_;
			gchar* _tmp242_;
			const gchar* _tmp243_;
			gchar* _tmp244_;
#line 546 "Utility/Device.vala"
			_tmp228_ = enumerator;
#line 546 "Utility/Device.vala"
			_tmp229_ = g_file_enumerator_next_file (_tmp228_, NULL, &_inner_error0_);
#line 546 "Utility/Device.vala"
			_tmp227_ = _tmp229_;
#line 546 "Utility/Device.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 546 "Utility/Device.vala"
				_g_object_unref0 (info);
#line 546 "Utility/Device.vala"
				_g_object_unref0 (enumerator);
#line 546 "Utility/Device.vala"
				_g_object_unref0 (f_dev_mapper);
#line 3441 "Device.c"
				goto __catch44_g_error;
			}
#line 546 "Utility/Device.vala"
			_tmp230_ = _tmp227_;
#line 546 "Utility/Device.vala"
			_tmp227_ = NULL;
#line 546 "Utility/Device.vala"
			_g_object_unref0 (info);
#line 546 "Utility/Device.vala"
			info = _tmp230_;
#line 546 "Utility/Device.vala"
			_tmp231_ = info;
#line 546 "Utility/Device.vala"
			if (!(_tmp231_ != NULL)) {
#line 546 "Utility/Device.vala"
				_g_object_unref0 (_tmp227_);
#line 546 "Utility/Device.vala"
				break;
#line 3460 "Device.c"
			}
#line 548 "Utility/Device.vala"
			_tmp232_ = info;
#line 548 "Utility/Device.vala"
			_tmp233_ = g_file_info_get_name (_tmp232_);
#line 548 "Utility/Device.vala"
			if (g_strcmp0 (_tmp233_, "control") == 0) {
#line 548 "Utility/Device.vala"
				_g_object_unref0 (_tmp227_);
#line 548 "Utility/Device.vala"
				continue;
#line 3472 "Device.c"
			}
#line 550 "Utility/Device.vala"
			_tmp234_ = f_dev_mapper;
#line 550 "Utility/Device.vala"
			_tmp235_ = info;
#line 550 "Utility/Device.vala"
			_tmp236_ = g_file_info_get_name (_tmp235_);
#line 550 "Utility/Device.vala"
			_tmp237_ = g_file_resolve_relative_path (_tmp234_, _tmp236_);
#line 550 "Utility/Device.vala"
			f_mapped = _tmp237_;
#line 552 "Utility/Device.vala"
			_tmp238_ = f_mapped;
#line 552 "Utility/Device.vala"
			_tmp239_ = g_file_get_path (_tmp238_);
#line 552 "Utility/Device.vala"
			mapped_file = _tmp239_;
#line 553 "Utility/Device.vala"
			_tmp240_ = info;
#line 553 "Utility/Device.vala"
			_tmp241_ = g_file_info_get_symlink_target (_tmp240_);
#line 553 "Utility/Device.vala"
			_tmp242_ = g_strdup (_tmp241_);
#line 553 "Utility/Device.vala"
			mapped_device = _tmp242_;
#line 554 "Utility/Device.vala"
			_tmp243_ = mapped_device;
#line 554 "Utility/Device.vala"
			_tmp244_ = string_replace (_tmp243_, "..", "/dev");
#line 554 "Utility/Device.vala"
			_g_free0 (mapped_device);
#line 554 "Utility/Device.vala"
			mapped_device = _tmp244_;
#line 3506 "Device.c"
			{
				GeeArrayList* _dev_list = NULL;
				GeeArrayList* _tmp245_;
				GeeArrayList* _tmp246_;
				gint _dev_size = 0;
				GeeArrayList* _tmp247_;
				gint _tmp248_;
				gint _tmp249_;
				gint _dev_index = 0;
#line 560 "Utility/Device.vala"
				_tmp245_ = list;
#line 560 "Utility/Device.vala"
				_tmp246_ = _g_object_ref0 (_tmp245_);
#line 560 "Utility/Device.vala"
				_dev_list = _tmp246_;
#line 560 "Utility/Device.vala"
				_tmp247_ = _dev_list;
#line 560 "Utility/Device.vala"
				_tmp248_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp247_);
#line 560 "Utility/Device.vala"
				_tmp249_ = _tmp248_;
#line 560 "Utility/Device.vala"
				_dev_size = _tmp249_;
#line 560 "Utility/Device.vala"
				_dev_index = -1;
#line 560 "Utility/Device.vala"
				while (TRUE) {
#line 3534 "Device.c"
					Device* dev = NULL;
					GeeArrayList* _tmp250_;
					gpointer _tmp251_;
					Device* _tmp252_;
					const gchar* _tmp253_;
					const gchar* _tmp254_;
#line 560 "Utility/Device.vala"
					_dev_index = _dev_index + 1;
#line 560 "Utility/Device.vala"
					if (!(_dev_index < _dev_size)) {
#line 560 "Utility/Device.vala"
						break;
#line 3547 "Device.c"
					}
#line 560 "Utility/Device.vala"
					_tmp250_ = _dev_list;
#line 560 "Utility/Device.vala"
					_tmp251_ = gee_abstract_list_get ((GeeAbstractList*) _tmp250_, _dev_index);
#line 560 "Utility/Device.vala"
					dev = (Device*) _tmp251_;
#line 561 "Utility/Device.vala"
					_tmp252_ = dev;
#line 561 "Utility/Device.vala"
					_tmp253_ = _tmp252_->device;
#line 561 "Utility/Device.vala"
					_tmp254_ = mapped_device;
#line 561 "Utility/Device.vala"
					if (g_strcmp0 (_tmp253_, _tmp254_) == 0) {
#line 3563 "Device.c"
						Device* _tmp255_;
						const gchar* _tmp256_;
						gchar* _tmp257_;
						Device* _tmp258_;
						GeeArrayList* _tmp259_;
						const gchar* _tmp260_;
#line 562 "Utility/Device.vala"
						_tmp255_ = dev;
#line 562 "Utility/Device.vala"
						_tmp256_ = mapped_file;
#line 562 "Utility/Device.vala"
						_tmp257_ = string_replace (_tmp256_, "/dev/mapper/", "");
#line 562 "Utility/Device.vala"
						_g_free0 (_tmp255_->mapped_name);
#line 562 "Utility/Device.vala"
						_tmp255_->mapped_name = _tmp257_;
#line 563 "Utility/Device.vala"
						_tmp258_ = dev;
#line 563 "Utility/Device.vala"
						_tmp259_ = _tmp258_->symlinks;
#line 563 "Utility/Device.vala"
						_tmp260_ = mapped_file;
#line 563 "Utility/Device.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp259_, _tmp260_);
#line 565 "Utility/Device.vala"
						_g_object_unref0 (dev);
#line 565 "Utility/Device.vala"
						break;
#line 3592 "Device.c"
					}
#line 560 "Utility/Device.vala"
					_g_object_unref0 (dev);
#line 3596 "Device.c"
				}
#line 560 "Utility/Device.vala"
				_g_object_unref0 (_dev_list);
#line 3600 "Device.c"
			}
#line 546 "Utility/Device.vala"
			_g_free0 (mapped_device);
#line 546 "Utility/Device.vala"
			_g_free0 (mapped_file);
#line 546 "Utility/Device.vala"
			_g_object_unref0 (f_mapped);
#line 546 "Utility/Device.vala"
			_g_object_unref0 (_tmp227_);
#line 3610 "Device.c"
		}
#line 536 "Utility/Device.vala"
		_g_object_unref0 (info);
#line 536 "Utility/Device.vala"
		_g_object_unref0 (enumerator);
#line 536 "Utility/Device.vala"
		_g_object_unref0 (f_dev_mapper);
#line 3618 "Device.c"
	}
	goto __finally44;
	__catch44_g_error:
	{
		GError* e = NULL;
		GError* _tmp261_;
		const gchar* _tmp262_;
#line 536 "Utility/Device.vala"
		e = _inner_error0_;
#line 536 "Utility/Device.vala"
		_inner_error0_ = NULL;
#line 571 "Utility/Device.vala"
		_tmp261_ = e;
#line 571 "Utility/Device.vala"
		_tmp262_ = _tmp261_->message;
#line 571 "Utility/Device.vala"
		tee_jee_logging_log_error (_tmp262_, FALSE, FALSE);
#line 536 "Utility/Device.vala"
		_g_error_free0 (e);
#line 3638 "Device.c"
	}
	__finally44:
#line 536 "Utility/Device.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 536 "Utility/Device.vala"
		_g_match_info_unref0 (match);
#line 536 "Utility/Device.vala"
		_g_regex_unref0 (rex);
#line 536 "Utility/Device.vala"
		_g_free0 (cmd);
#line 536 "Utility/Device.vala"
		_g_free0 (std_err);
#line 536 "Utility/Device.vala"
		_g_free0 (std_out);
#line 536 "Utility/Device.vala"
		_g_object_unref0 (list);
#line 536 "Utility/Device.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 536 "Utility/Device.vala"
		g_clear_error (&_inner_error0_);
#line 536 "Utility/Device.vala"
		return NULL;
#line 3661 "Device.c"
	}
#line 574 "Utility/Device.vala"
	_tmp263_ = list;
#line 574 "Utility/Device.vala"
	_tmp264_ = _g_object_ref0 (_tmp263_);
#line 574 "Utility/Device.vala"
	_g_object_unref0 (device_device_list);
#line 574 "Utility/Device.vala"
	device_device_list = _tmp264_;
#line 3671 "Device.c"
	{
		GeeArrayList* _part_list = NULL;
		GeeArrayList* _tmp265_;
		GeeArrayList* _tmp266_;
		gint _part_size = 0;
		GeeArrayList* _tmp267_;
		gint _tmp268_;
		gint _tmp269_;
		gint _part_index = 0;
#line 576 "Utility/Device.vala"
		_tmp265_ = list;
#line 576 "Utility/Device.vala"
		_tmp266_ = _g_object_ref0 (_tmp265_);
#line 576 "Utility/Device.vala"
		_part_list = _tmp266_;
#line 576 "Utility/Device.vala"
		_tmp267_ = _part_list;
#line 576 "Utility/Device.vala"
		_tmp268_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp267_);
#line 576 "Utility/Device.vala"
		_tmp269_ = _tmp268_;
#line 576 "Utility/Device.vala"
		_part_size = _tmp269_;
#line 576 "Utility/Device.vala"
		_part_index = -1;
#line 576 "Utility/Device.vala"
		while (TRUE) {
#line 3699 "Device.c"
			Device* part = NULL;
			GeeArrayList* _tmp270_;
			gpointer _tmp271_;
			GeeArrayList* _tmp272_;
			Device* _tmp273_;
			GeeArrayList* _tmp274_;
			Device* _tmp275_;
#line 576 "Utility/Device.vala"
			_part_index = _part_index + 1;
#line 576 "Utility/Device.vala"
			if (!(_part_index < _part_size)) {
#line 576 "Utility/Device.vala"
				break;
#line 3713 "Device.c"
			}
#line 576 "Utility/Device.vala"
			_tmp270_ = _part_list;
#line 576 "Utility/Device.vala"
			_tmp271_ = gee_abstract_list_get ((GeeAbstractList*) _tmp270_, _part_index);
#line 576 "Utility/Device.vala"
			part = (Device*) _tmp271_;
#line 577 "Utility/Device.vala"
			_tmp272_ = list;
#line 577 "Utility/Device.vala"
			_tmp273_ = part;
#line 577 "Utility/Device.vala"
			device_find_child_devices (_tmp272_, _tmp273_);
#line 578 "Utility/Device.vala"
			_tmp274_ = list;
#line 578 "Utility/Device.vala"
			_tmp275_ = part;
#line 578 "Utility/Device.vala"
			device_find_toplevel_parent (_tmp274_, _tmp275_);
#line 576 "Utility/Device.vala"
			_g_object_unref0 (part);
#line 3735 "Device.c"
		}
#line 576 "Utility/Device.vala"
		_g_object_unref0 (_part_list);
#line 3739 "Device.c"
	}
	{
		gint i = 0;
		GeeArrayList* _tmp276_;
		gint _tmp277_;
		gint _tmp278_;
#line 584 "Utility/Device.vala"
		_tmp276_ = list;
#line 584 "Utility/Device.vala"
		_tmp277_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp276_);
#line 584 "Utility/Device.vala"
		_tmp278_ = _tmp277_;
#line 584 "Utility/Device.vala"
		i = _tmp278_ - 1;
#line 3754 "Device.c"
		{
			gboolean _tmp279_ = FALSE;
#line 584 "Utility/Device.vala"
			_tmp279_ = TRUE;
#line 584 "Utility/Device.vala"
			while (TRUE) {
#line 3761 "Device.c"
				GeeArrayList* _tmp280_;
				gpointer _tmp281_;
				Device* _tmp282_;
				const gchar* _tmp283_;
				gboolean _tmp284_;
#line 584 "Utility/Device.vala"
				if (!_tmp279_) {
#line 584 "Utility/Device.vala"
					i = i - 1;
#line 3771 "Device.c"
				}
#line 584 "Utility/Device.vala"
				_tmp279_ = FALSE;
#line 584 "Utility/Device.vala"
				if (!(i >= 0)) {
#line 584 "Utility/Device.vala"
					break;
#line 3779 "Device.c"
				}
#line 585 "Utility/Device.vala"
				_tmp280_ = list;
#line 585 "Utility/Device.vala"
				_tmp281_ = gee_abstract_list_get ((GeeAbstractList*) _tmp280_, i);
#line 585 "Utility/Device.vala"
				_tmp282_ = (Device*) _tmp281_;
#line 585 "Utility/Device.vala"
				_tmp283_ = _tmp282_->type;
#line 585 "Utility/Device.vala"
				_tmp284_ = g_strcmp0 (_tmp283_, "raid5") == 0;
#line 585 "Utility/Device.vala"
				_g_object_unref0 (_tmp282_);
#line 585 "Utility/Device.vala"
				if (_tmp284_) {
#line 3795 "Device.c"
					GeeArrayList* _tmp301_;
					gpointer _tmp302_;
					Device* _tmp303_;
					gchar* _tmp304_;
					{
						gint j = 0;
#line 589 "Utility/Device.vala"
						j = i - 1;
#line 3804 "Device.c"
						{
							gboolean _tmp285_ = FALSE;
#line 589 "Utility/Device.vala"
							_tmp285_ = TRUE;
#line 589 "Utility/Device.vala"
							while (TRUE) {
#line 3811 "Device.c"
								GeeArrayList* _tmp286_;
								gpointer _tmp287_;
								Device* _tmp288_;
								const gchar* _tmp289_;
								GeeArrayList* _tmp290_;
								gpointer _tmp291_;
								Device* _tmp292_;
								const gchar* _tmp293_;
								gboolean _tmp294_;
#line 589 "Utility/Device.vala"
								if (!_tmp285_) {
#line 589 "Utility/Device.vala"
									j = j - 1;
#line 3825 "Device.c"
								}
#line 589 "Utility/Device.vala"
								_tmp285_ = FALSE;
#line 589 "Utility/Device.vala"
								if (!(j >= 0)) {
#line 589 "Utility/Device.vala"
									break;
#line 3833 "Device.c"
								}
#line 590 "Utility/Device.vala"
								_tmp286_ = list;
#line 590 "Utility/Device.vala"
								_tmp287_ = gee_abstract_list_get ((GeeAbstractList*) _tmp286_, j);
#line 590 "Utility/Device.vala"
								_tmp288_ = (Device*) _tmp287_;
#line 590 "Utility/Device.vala"
								_tmp289_ = _tmp288_->kname;
#line 590 "Utility/Device.vala"
								_tmp290_ = list;
#line 590 "Utility/Device.vala"
								_tmp291_ = gee_abstract_list_get ((GeeAbstractList*) _tmp290_, i);
#line 590 "Utility/Device.vala"
								_tmp292_ = (Device*) _tmp291_;
#line 590 "Utility/Device.vala"
								_tmp293_ = _tmp292_->pkname;
#line 590 "Utility/Device.vala"
								_tmp294_ = g_strcmp0 (_tmp289_, _tmp293_) == 0;
#line 590 "Utility/Device.vala"
								_g_object_unref0 (_tmp292_);
#line 590 "Utility/Device.vala"
								_g_object_unref0 (_tmp288_);
#line 590 "Utility/Device.vala"
								if (_tmp294_) {
#line 3859 "Device.c"
									GeeArrayList* _tmp295_;
									gpointer _tmp296_;
									Device* _tmp297_;
									GeeArrayList* _tmp298_;
									gpointer _tmp299_;
									Device* _tmp300_;
#line 591 "Utility/Device.vala"
									_tmp295_ = list;
#line 591 "Utility/Device.vala"
									_tmp296_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp295_, j);
#line 591 "Utility/Device.vala"
									_tmp297_ = (Device*) _tmp296_;
#line 591 "Utility/Device.vala"
									_g_object_unref0 (_tmp297_);
#line 592 "Utility/Device.vala"
									_tmp298_ = list;
#line 592 "Utility/Device.vala"
									_tmp299_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp298_, j - 1);
#line 592 "Utility/Device.vala"
									_tmp300_ = (Device*) _tmp299_;
#line 592 "Utility/Device.vala"
									_g_object_unref0 (_tmp300_);
#line 593 "Utility/Device.vala"
									i = i - 1;
#line 594 "Utility/Device.vala"
									break;
#line 3886 "Device.c"
								}
							}
						}
					}
#line 599 "Utility/Device.vala"
					_tmp301_ = list;
#line 599 "Utility/Device.vala"
					_tmp302_ = gee_abstract_list_get ((GeeAbstractList*) _tmp301_, i);
#line 599 "Utility/Device.vala"
					_tmp303_ = (Device*) _tmp302_;
#line 599 "Utility/Device.vala"
					_tmp304_ = g_strdup ("");
#line 599 "Utility/Device.vala"
					_g_free0 (_tmp303_->pkname);
#line 599 "Utility/Device.vala"
					_tmp303_->pkname = _tmp304_;
#line 599 "Utility/Device.vala"
					_g_object_unref0 (_tmp303_);
#line 3905 "Device.c"
					{
						gint j = 0;
						GeeArrayList* _tmp305_;
						gint _tmp306_;
						gint _tmp307_;
#line 603 "Utility/Device.vala"
						_tmp305_ = list;
#line 603 "Utility/Device.vala"
						_tmp306_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp305_);
#line 603 "Utility/Device.vala"
						_tmp307_ = _tmp306_;
#line 603 "Utility/Device.vala"
						j = _tmp307_ - 1;
#line 3919 "Device.c"
						{
							gboolean _tmp308_ = FALSE;
#line 603 "Utility/Device.vala"
							_tmp308_ = TRUE;
#line 603 "Utility/Device.vala"
							while (TRUE) {
#line 3926 "Device.c"
								GeeArrayList* _tmp309_;
								gpointer _tmp310_;
								Device* _tmp311_;
								const gchar* _tmp312_;
								GeeArrayList* _tmp313_;
								gpointer _tmp314_;
								Device* _tmp315_;
								const gchar* _tmp316_;
								gboolean _tmp317_;
#line 603 "Utility/Device.vala"
								if (!_tmp308_) {
#line 603 "Utility/Device.vala"
									j = j - 1;
#line 3940 "Device.c"
								}
#line 603 "Utility/Device.vala"
								_tmp308_ = FALSE;
#line 603 "Utility/Device.vala"
								if (!(j > i)) {
#line 603 "Utility/Device.vala"
									break;
#line 3948 "Device.c"
								}
#line 604 "Utility/Device.vala"
								_tmp309_ = list;
#line 604 "Utility/Device.vala"
								_tmp310_ = gee_abstract_list_get ((GeeAbstractList*) _tmp309_, j);
#line 604 "Utility/Device.vala"
								_tmp311_ = (Device*) _tmp310_;
#line 604 "Utility/Device.vala"
								_tmp312_ = _tmp311_->pkname;
#line 604 "Utility/Device.vala"
								_tmp313_ = list;
#line 604 "Utility/Device.vala"
								_tmp314_ = gee_abstract_list_get ((GeeAbstractList*) _tmp313_, i);
#line 604 "Utility/Device.vala"
								_tmp315_ = (Device*) _tmp314_;
#line 604 "Utility/Device.vala"
								_tmp316_ = _tmp315_->kname;
#line 604 "Utility/Device.vala"
								_tmp317_ = g_strcmp0 (_tmp312_, _tmp316_) == 0;
#line 604 "Utility/Device.vala"
								_g_object_unref0 (_tmp315_);
#line 604 "Utility/Device.vala"
								_g_object_unref0 (_tmp311_);
#line 604 "Utility/Device.vala"
								if (_tmp317_) {
#line 3974 "Device.c"
									{
										gint k = 0;
#line 605 "Utility/Device.vala"
										k = j - 1;
#line 3979 "Device.c"
										{
											gboolean _tmp318_ = FALSE;
#line 605 "Utility/Device.vala"
											_tmp318_ = TRUE;
#line 605 "Utility/Device.vala"
											while (TRUE) {
#line 3986 "Device.c"
												GeeArrayList* _tmp319_;
												gpointer _tmp320_;
												Device* _tmp321_;
												const gchar* _tmp322_;
												GeeArrayList* _tmp323_;
												gpointer _tmp324_;
												Device* _tmp325_;
												const gchar* _tmp326_;
												gboolean _tmp327_;
#line 605 "Utility/Device.vala"
												if (!_tmp318_) {
#line 605 "Utility/Device.vala"
													k = k - 1;
#line 4000 "Device.c"
												}
#line 605 "Utility/Device.vala"
												_tmp318_ = FALSE;
#line 605 "Utility/Device.vala"
												if (!(k >= 0)) {
#line 605 "Utility/Device.vala"
													break;
#line 4008 "Device.c"
												}
#line 606 "Utility/Device.vala"
												_tmp319_ = list;
#line 606 "Utility/Device.vala"
												_tmp320_ = gee_abstract_list_get ((GeeAbstractList*) _tmp319_, k);
#line 606 "Utility/Device.vala"
												_tmp321_ = (Device*) _tmp320_;
#line 606 "Utility/Device.vala"
												_tmp322_ = _tmp321_->kname;
#line 606 "Utility/Device.vala"
												_tmp323_ = list;
#line 606 "Utility/Device.vala"
												_tmp324_ = gee_abstract_list_get ((GeeAbstractList*) _tmp323_, j);
#line 606 "Utility/Device.vala"
												_tmp325_ = (Device*) _tmp324_;
#line 606 "Utility/Device.vala"
												_tmp326_ = _tmp325_->kname;
#line 606 "Utility/Device.vala"
												_tmp327_ = g_strcmp0 (_tmp322_, _tmp326_) == 0;
#line 606 "Utility/Device.vala"
												_g_object_unref0 (_tmp325_);
#line 606 "Utility/Device.vala"
												_g_object_unref0 (_tmp321_);
#line 606 "Utility/Device.vala"
												if (_tmp327_) {
#line 4034 "Device.c"
													GeeArrayList* _tmp328_;
													gpointer _tmp329_;
													Device* _tmp330_;
#line 607 "Utility/Device.vala"
													_tmp328_ = list;
#line 607 "Utility/Device.vala"
													_tmp329_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp328_, k);
#line 607 "Utility/Device.vala"
													_tmp330_ = (Device*) _tmp329_;
#line 607 "Utility/Device.vala"
													_g_object_unref0 (_tmp330_);
#line 608 "Utility/Device.vala"
													j = j - 1;
#line 4048 "Device.c"
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}
	{
		gint i = 0;
		GeeArrayList* _tmp331_;
		gint _tmp332_;
		gint _tmp333_;
#line 617 "Utility/Device.vala"
		_tmp331_ = list;
#line 617 "Utility/Device.vala"
		_tmp332_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp331_);
#line 617 "Utility/Device.vala"
		_tmp333_ = _tmp332_;
#line 617 "Utility/Device.vala"
		i = _tmp333_ - 1;
#line 4074 "Device.c"
		{
			gboolean _tmp334_ = FALSE;
#line 617 "Utility/Device.vala"
			_tmp334_ = TRUE;
#line 617 "Utility/Device.vala"
			while (TRUE) {
#line 4081 "Device.c"
				GeeArrayList* _tmp335_;
				gpointer _tmp336_;
				Device* _tmp337_;
				const gchar* _tmp338_;
				gboolean _tmp339_;
#line 617 "Utility/Device.vala"
				if (!_tmp334_) {
#line 617 "Utility/Device.vala"
					i = i - 1;
#line 4091 "Device.c"
				}
#line 617 "Utility/Device.vala"
				_tmp334_ = FALSE;
#line 617 "Utility/Device.vala"
				if (!(i >= 0)) {
#line 617 "Utility/Device.vala"
					break;
#line 4099 "Device.c"
				}
#line 618 "Utility/Device.vala"
				_tmp335_ = list;
#line 618 "Utility/Device.vala"
				_tmp336_ = gee_abstract_list_get ((GeeAbstractList*) _tmp335_, i);
#line 618 "Utility/Device.vala"
				_tmp337_ = (Device*) _tmp336_;
#line 618 "Utility/Device.vala"
				_tmp338_ = _tmp337_->type;
#line 618 "Utility/Device.vala"
				_tmp339_ = g_strcmp0 (_tmp338_, "raid5") == 0;
#line 618 "Utility/Device.vala"
				_g_object_unref0 (_tmp337_);
#line 618 "Utility/Device.vala"
				if (_tmp339_) {
#line 4115 "Device.c"
					GeeArrayList* _tmp340_;
					gpointer _tmp341_;
					Device* _tmp342_;
					gchar* _tmp343_;
					GeeArrayList* _tmp344_;
					gpointer _tmp345_;
					Device* _tmp346_;
					GeeArrayList* _tmp347_;
					gpointer _tmp348_;
					Device* _tmp349_;
					const gchar* _tmp350_;
					gchar* _tmp351_;
#line 620 "Utility/Device.vala"
					_tmp340_ = list;
#line 620 "Utility/Device.vala"
					_tmp341_ = gee_abstract_list_get ((GeeAbstractList*) _tmp340_, i);
#line 620 "Utility/Device.vala"
					_tmp342_ = (Device*) _tmp341_;
#line 620 "Utility/Device.vala"
					_tmp343_ = g_strdup ("disk");
#line 620 "Utility/Device.vala"
					_g_free0 (_tmp342_->type);
#line 620 "Utility/Device.vala"
					_tmp342_->type = _tmp343_;
#line 620 "Utility/Device.vala"
					_g_object_unref0 (_tmp342_);
#line 621 "Utility/Device.vala"
					_tmp344_ = list;
#line 621 "Utility/Device.vala"
					_tmp345_ = gee_abstract_list_get ((GeeAbstractList*) _tmp344_, i);
#line 621 "Utility/Device.vala"
					_tmp346_ = (Device*) _tmp345_;
#line 621 "Utility/Device.vala"
					_tmp347_ = list;
#line 621 "Utility/Device.vala"
					_tmp348_ = gee_abstract_list_get ((GeeAbstractList*) _tmp347_, i);
#line 621 "Utility/Device.vala"
					_tmp349_ = (Device*) _tmp348_;
#line 621 "Utility/Device.vala"
					_tmp350_ = _tmp349_->name;
#line 621 "Utility/Device.vala"
					_tmp351_ = g_strdup (_tmp350_);
#line 621 "Utility/Device.vala"
					_g_free0 (_tmp346_->model);
#line 621 "Utility/Device.vala"
					_tmp346_->model = _tmp351_;
#line 621 "Utility/Device.vala"
					_g_object_unref0 (_tmp349_);
#line 621 "Utility/Device.vala"
					_g_object_unref0 (_tmp346_);
#line 4166 "Device.c"
					{
						gint j = 0;
						GeeArrayList* _tmp352_;
						gint _tmp353_;
						gint _tmp354_;
#line 624 "Utility/Device.vala"
						_tmp352_ = list;
#line 624 "Utility/Device.vala"
						_tmp353_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp352_);
#line 624 "Utility/Device.vala"
						_tmp354_ = _tmp353_;
#line 624 "Utility/Device.vala"
						j = _tmp354_ - 1;
#line 4180 "Device.c"
						{
							gboolean _tmp355_ = FALSE;
#line 624 "Utility/Device.vala"
							_tmp355_ = TRUE;
#line 624 "Utility/Device.vala"
							while (TRUE) {
#line 4187 "Device.c"
								gboolean _tmp356_ = FALSE;
								gboolean _tmp357_ = FALSE;
#line 624 "Utility/Device.vala"
								if (!_tmp355_) {
#line 624 "Utility/Device.vala"
									j = j - 1;
#line 4194 "Device.c"
								}
#line 624 "Utility/Device.vala"
								_tmp355_ = FALSE;
#line 624 "Utility/Device.vala"
								if (!(j >= 0)) {
#line 624 "Utility/Device.vala"
									break;
#line 4202 "Device.c"
								}
#line 625 "Utility/Device.vala"
								if (i != j) {
#line 4206 "Device.c"
									GeeArrayList* _tmp358_;
									gpointer _tmp359_;
									Device* _tmp360_;
									const gchar* _tmp361_;
#line 625 "Utility/Device.vala"
									_tmp358_ = list;
#line 625 "Utility/Device.vala"
									_tmp359_ = gee_abstract_list_get ((GeeAbstractList*) _tmp358_, j);
#line 625 "Utility/Device.vala"
									_tmp360_ = (Device*) _tmp359_;
#line 625 "Utility/Device.vala"
									_tmp361_ = _tmp360_->type;
#line 625 "Utility/Device.vala"
									_tmp357_ = g_strcmp0 (_tmp361_, "raid5") == 0;
#line 625 "Utility/Device.vala"
									_g_object_unref0 (_tmp360_);
#line 4223 "Device.c"
								} else {
#line 625 "Utility/Device.vala"
									_tmp357_ = FALSE;
#line 4227 "Device.c"
								}
#line 625 "Utility/Device.vala"
								if (_tmp357_) {
#line 4231 "Device.c"
									GeeArrayList* _tmp362_;
									gpointer _tmp363_;
									Device* _tmp364_;
									const gchar* _tmp365_;
									GeeArrayList* _tmp366_;
									gpointer _tmp367_;
									Device* _tmp368_;
									const gchar* _tmp369_;
#line 625 "Utility/Device.vala"
									_tmp362_ = list;
#line 625 "Utility/Device.vala"
									_tmp363_ = gee_abstract_list_get ((GeeAbstractList*) _tmp362_, j);
#line 625 "Utility/Device.vala"
									_tmp364_ = (Device*) _tmp363_;
#line 625 "Utility/Device.vala"
									_tmp365_ = _tmp364_->kname;
#line 625 "Utility/Device.vala"
									_tmp366_ = list;
#line 625 "Utility/Device.vala"
									_tmp367_ = gee_abstract_list_get ((GeeAbstractList*) _tmp366_, i);
#line 625 "Utility/Device.vala"
									_tmp368_ = (Device*) _tmp367_;
#line 625 "Utility/Device.vala"
									_tmp369_ = _tmp368_->kname;
#line 625 "Utility/Device.vala"
									_tmp356_ = g_strcmp0 (_tmp365_, _tmp369_) == 0;
#line 625 "Utility/Device.vala"
									_g_object_unref0 (_tmp368_);
#line 625 "Utility/Device.vala"
									_g_object_unref0 (_tmp364_);
#line 4262 "Device.c"
								} else {
#line 625 "Utility/Device.vala"
									_tmp356_ = FALSE;
#line 4266 "Device.c"
								}
#line 625 "Utility/Device.vala"
								if (_tmp356_) {
#line 4270 "Device.c"
									GeeArrayList* _tmp370_;
									gpointer _tmp371_;
									Device* _tmp372_;
#line 626 "Utility/Device.vala"
									_tmp370_ = list;
#line 626 "Utility/Device.vala"
									_tmp371_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp370_, j);
#line 626 "Utility/Device.vala"
									_tmp372_ = (Device*) _tmp371_;
#line 626 "Utility/Device.vala"
									_g_object_unref0 (_tmp372_);
#line 627 "Utility/Device.vala"
									if (j < i) {
#line 628 "Utility/Device.vala"
										i = i - 1;
#line 4286 "Device.c"
									}
								}
							}
						}
					}
				}
			}
		}
	}
	{
		gint i = 0;
		GeeArrayList* _tmp373_;
		gint _tmp374_;
		gint _tmp375_;
#line 637 "Utility/Device.vala"
		_tmp373_ = list;
#line 637 "Utility/Device.vala"
		_tmp374_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp373_);
#line 637 "Utility/Device.vala"
		_tmp375_ = _tmp374_;
#line 637 "Utility/Device.vala"
		i = _tmp375_ - 1;
#line 4309 "Device.c"
		{
			gboolean _tmp376_ = FALSE;
#line 637 "Utility/Device.vala"
			_tmp376_ = TRUE;
#line 637 "Utility/Device.vala"
			while (TRUE) {
#line 4316 "Device.c"
				GeeArrayList* _tmp377_;
				gpointer _tmp378_;
				Device* _tmp379_;
				const gchar* _tmp380_;
				gboolean _tmp381_;
#line 637 "Utility/Device.vala"
				if (!_tmp376_) {
#line 637 "Utility/Device.vala"
					i = i - 1;
#line 4326 "Device.c"
				}
#line 637 "Utility/Device.vala"
				_tmp376_ = FALSE;
#line 637 "Utility/Device.vala"
				if (!(i >= 0)) {
#line 637 "Utility/Device.vala"
					break;
#line 4334 "Device.c"
				}
#line 638 "Utility/Device.vala"
				_tmp377_ = list;
#line 638 "Utility/Device.vala"
				_tmp378_ = gee_abstract_list_get ((GeeAbstractList*) _tmp377_, i);
#line 638 "Utility/Device.vala"
				_tmp379_ = (Device*) _tmp378_;
#line 638 "Utility/Device.vala"
				_tmp380_ = _tmp379_->type;
#line 638 "Utility/Device.vala"
				_tmp381_ = g_strcmp0 (_tmp380_, "dmraid") == 0;
#line 638 "Utility/Device.vala"
				_g_object_unref0 (_tmp379_);
#line 638 "Utility/Device.vala"
				if (_tmp381_) {
#line 4350 "Device.c"
					GeeArrayList* _tmp395_;
					gpointer _tmp396_;
					Device* _tmp397_;
					gchar* _tmp398_;
					{
						gint j = 0;
#line 642 "Utility/Device.vala"
						j = i - 1;
#line 4359 "Device.c"
						{
							gboolean _tmp382_ = FALSE;
#line 642 "Utility/Device.vala"
							_tmp382_ = TRUE;
#line 642 "Utility/Device.vala"
							while (TRUE) {
#line 4366 "Device.c"
								GeeArrayList* _tmp383_;
								gpointer _tmp384_;
								Device* _tmp385_;
								const gchar* _tmp386_;
								GeeArrayList* _tmp387_;
								gpointer _tmp388_;
								Device* _tmp389_;
								const gchar* _tmp390_;
								gboolean _tmp391_;
#line 642 "Utility/Device.vala"
								if (!_tmp382_) {
#line 642 "Utility/Device.vala"
									j = j - 1;
#line 4380 "Device.c"
								}
#line 642 "Utility/Device.vala"
								_tmp382_ = FALSE;
#line 642 "Utility/Device.vala"
								if (!(j >= 0)) {
#line 642 "Utility/Device.vala"
									break;
#line 4388 "Device.c"
								}
#line 643 "Utility/Device.vala"
								_tmp383_ = list;
#line 643 "Utility/Device.vala"
								_tmp384_ = gee_abstract_list_get ((GeeAbstractList*) _tmp383_, j);
#line 643 "Utility/Device.vala"
								_tmp385_ = (Device*) _tmp384_;
#line 643 "Utility/Device.vala"
								_tmp386_ = _tmp385_->kname;
#line 643 "Utility/Device.vala"
								_tmp387_ = list;
#line 643 "Utility/Device.vala"
								_tmp388_ = gee_abstract_list_get ((GeeAbstractList*) _tmp387_, i);
#line 643 "Utility/Device.vala"
								_tmp389_ = (Device*) _tmp388_;
#line 643 "Utility/Device.vala"
								_tmp390_ = _tmp389_->pkname;
#line 643 "Utility/Device.vala"
								_tmp391_ = g_strcmp0 (_tmp386_, _tmp390_) == 0;
#line 643 "Utility/Device.vala"
								_g_object_unref0 (_tmp389_);
#line 643 "Utility/Device.vala"
								_g_object_unref0 (_tmp385_);
#line 643 "Utility/Device.vala"
								if (_tmp391_) {
#line 4414 "Device.c"
									GeeArrayList* _tmp392_;
									gpointer _tmp393_;
									Device* _tmp394_;
#line 644 "Utility/Device.vala"
									_tmp392_ = list;
#line 644 "Utility/Device.vala"
									_tmp393_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp392_, j);
#line 644 "Utility/Device.vala"
									_tmp394_ = (Device*) _tmp393_;
#line 644 "Utility/Device.vala"
									_g_object_unref0 (_tmp394_);
#line 645 "Utility/Device.vala"
									i = i - 1;
#line 646 "Utility/Device.vala"
									break;
#line 4430 "Device.c"
								}
							}
						}
					}
#line 651 "Utility/Device.vala"
					_tmp395_ = list;
#line 651 "Utility/Device.vala"
					_tmp396_ = gee_abstract_list_get ((GeeAbstractList*) _tmp395_, i);
#line 651 "Utility/Device.vala"
					_tmp397_ = (Device*) _tmp396_;
#line 651 "Utility/Device.vala"
					_tmp398_ = g_strdup ("");
#line 651 "Utility/Device.vala"
					_g_free0 (_tmp397_->pkname);
#line 651 "Utility/Device.vala"
					_tmp397_->pkname = _tmp398_;
#line 651 "Utility/Device.vala"
					_g_object_unref0 (_tmp397_);
#line 4449 "Device.c"
					{
						gint j = 0;
						GeeArrayList* _tmp399_;
						gint _tmp400_;
						gint _tmp401_;
#line 655 "Utility/Device.vala"
						_tmp399_ = list;
#line 655 "Utility/Device.vala"
						_tmp400_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp399_);
#line 655 "Utility/Device.vala"
						_tmp401_ = _tmp400_;
#line 655 "Utility/Device.vala"
						j = _tmp401_ - 1;
#line 4463 "Device.c"
						{
							gboolean _tmp402_ = FALSE;
#line 655 "Utility/Device.vala"
							_tmp402_ = TRUE;
#line 655 "Utility/Device.vala"
							while (TRUE) {
#line 4470 "Device.c"
								GeeArrayList* _tmp403_;
								gpointer _tmp404_;
								Device* _tmp405_;
								const gchar* _tmp406_;
								GeeArrayList* _tmp407_;
								gpointer _tmp408_;
								Device* _tmp409_;
								const gchar* _tmp410_;
								gboolean _tmp411_;
#line 655 "Utility/Device.vala"
								if (!_tmp402_) {
#line 655 "Utility/Device.vala"
									j = j - 1;
#line 4484 "Device.c"
								}
#line 655 "Utility/Device.vala"
								_tmp402_ = FALSE;
#line 655 "Utility/Device.vala"
								if (!(j > i)) {
#line 655 "Utility/Device.vala"
									break;
#line 4492 "Device.c"
								}
#line 656 "Utility/Device.vala"
								_tmp403_ = list;
#line 656 "Utility/Device.vala"
								_tmp404_ = gee_abstract_list_get ((GeeAbstractList*) _tmp403_, j);
#line 656 "Utility/Device.vala"
								_tmp405_ = (Device*) _tmp404_;
#line 656 "Utility/Device.vala"
								_tmp406_ = _tmp405_->pkname;
#line 656 "Utility/Device.vala"
								_tmp407_ = list;
#line 656 "Utility/Device.vala"
								_tmp408_ = gee_abstract_list_get ((GeeAbstractList*) _tmp407_, i);
#line 656 "Utility/Device.vala"
								_tmp409_ = (Device*) _tmp408_;
#line 656 "Utility/Device.vala"
								_tmp410_ = _tmp409_->kname;
#line 656 "Utility/Device.vala"
								_tmp411_ = g_strcmp0 (_tmp406_, _tmp410_) == 0;
#line 656 "Utility/Device.vala"
								_g_object_unref0 (_tmp409_);
#line 656 "Utility/Device.vala"
								_g_object_unref0 (_tmp405_);
#line 656 "Utility/Device.vala"
								if (_tmp411_) {
#line 4518 "Device.c"
									{
										gint k = 0;
#line 657 "Utility/Device.vala"
										k = j - 1;
#line 4523 "Device.c"
										{
											gboolean _tmp412_ = FALSE;
#line 657 "Utility/Device.vala"
											_tmp412_ = TRUE;
#line 657 "Utility/Device.vala"
											while (TRUE) {
#line 4530 "Device.c"
												GeeArrayList* _tmp413_;
												gpointer _tmp414_;
												Device* _tmp415_;
												const gchar* _tmp416_;
												GeeArrayList* _tmp417_;
												gpointer _tmp418_;
												Device* _tmp419_;
												const gchar* _tmp420_;
												gboolean _tmp421_;
#line 657 "Utility/Device.vala"
												if (!_tmp412_) {
#line 657 "Utility/Device.vala"
													k = k - 1;
#line 4544 "Device.c"
												}
#line 657 "Utility/Device.vala"
												_tmp412_ = FALSE;
#line 657 "Utility/Device.vala"
												if (!(k >= 0)) {
#line 657 "Utility/Device.vala"
													break;
#line 4552 "Device.c"
												}
#line 658 "Utility/Device.vala"
												_tmp413_ = list;
#line 658 "Utility/Device.vala"
												_tmp414_ = gee_abstract_list_get ((GeeAbstractList*) _tmp413_, k);
#line 658 "Utility/Device.vala"
												_tmp415_ = (Device*) _tmp414_;
#line 658 "Utility/Device.vala"
												_tmp416_ = _tmp415_->kname;
#line 658 "Utility/Device.vala"
												_tmp417_ = list;
#line 658 "Utility/Device.vala"
												_tmp418_ = gee_abstract_list_get ((GeeAbstractList*) _tmp417_, j);
#line 658 "Utility/Device.vala"
												_tmp419_ = (Device*) _tmp418_;
#line 658 "Utility/Device.vala"
												_tmp420_ = _tmp419_->kname;
#line 658 "Utility/Device.vala"
												_tmp421_ = g_strcmp0 (_tmp416_, _tmp420_) == 0;
#line 658 "Utility/Device.vala"
												_g_object_unref0 (_tmp419_);
#line 658 "Utility/Device.vala"
												_g_object_unref0 (_tmp415_);
#line 658 "Utility/Device.vala"
												if (_tmp421_) {
#line 4578 "Device.c"
													GeeArrayList* _tmp422_;
													gpointer _tmp423_;
													Device* _tmp424_;
#line 659 "Utility/Device.vala"
													_tmp422_ = list;
#line 659 "Utility/Device.vala"
													_tmp423_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp422_, k);
#line 659 "Utility/Device.vala"
													_tmp424_ = (Device*) _tmp423_;
#line 659 "Utility/Device.vala"
													_g_object_unref0 (_tmp424_);
#line 660 "Utility/Device.vala"
													j = j - 1;
#line 4592 "Device.c"
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}
	{
		gint i = 0;
		GeeArrayList* _tmp425_;
		gint _tmp426_;
		gint _tmp427_;
#line 669 "Utility/Device.vala"
		_tmp425_ = list;
#line 669 "Utility/Device.vala"
		_tmp426_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp425_);
#line 669 "Utility/Device.vala"
		_tmp427_ = _tmp426_;
#line 669 "Utility/Device.vala"
		i = _tmp427_ - 1;
#line 4618 "Device.c"
		{
			gboolean _tmp428_ = FALSE;
#line 669 "Utility/Device.vala"
			_tmp428_ = TRUE;
#line 669 "Utility/Device.vala"
			while (TRUE) {
#line 4625 "Device.c"
				GeeArrayList* _tmp429_;
				gpointer _tmp430_;
				Device* _tmp431_;
				const gchar* _tmp432_;
				gboolean _tmp433_;
#line 669 "Utility/Device.vala"
				if (!_tmp428_) {
#line 669 "Utility/Device.vala"
					i = i - 1;
#line 4635 "Device.c"
				}
#line 669 "Utility/Device.vala"
				_tmp428_ = FALSE;
#line 669 "Utility/Device.vala"
				if (!(i >= 0)) {
#line 669 "Utility/Device.vala"
					break;
#line 4643 "Device.c"
				}
#line 670 "Utility/Device.vala"
				_tmp429_ = list;
#line 670 "Utility/Device.vala"
				_tmp430_ = gee_abstract_list_get ((GeeAbstractList*) _tmp429_, i);
#line 670 "Utility/Device.vala"
				_tmp431_ = (Device*) _tmp430_;
#line 670 "Utility/Device.vala"
				_tmp432_ = _tmp431_->type;
#line 670 "Utility/Device.vala"
				_tmp433_ = g_strcmp0 (_tmp432_, "dmraid") == 0;
#line 670 "Utility/Device.vala"
				_g_object_unref0 (_tmp431_);
#line 670 "Utility/Device.vala"
				if (_tmp433_) {
#line 4659 "Device.c"
					GeeArrayList* _tmp434_;
					gpointer _tmp435_;
					Device* _tmp436_;
					gchar* _tmp437_;
					GeeArrayList* _tmp438_;
					gpointer _tmp439_;
					Device* _tmp440_;
					GeeArrayList* _tmp441_;
					gpointer _tmp442_;
					Device* _tmp443_;
					const gchar* _tmp444_;
					gchar* _tmp445_;
#line 672 "Utility/Device.vala"
					_tmp434_ = list;
#line 672 "Utility/Device.vala"
					_tmp435_ = gee_abstract_list_get ((GeeAbstractList*) _tmp434_, i);
#line 672 "Utility/Device.vala"
					_tmp436_ = (Device*) _tmp435_;
#line 672 "Utility/Device.vala"
					_tmp437_ = g_strdup ("disk");
#line 672 "Utility/Device.vala"
					_g_free0 (_tmp436_->type);
#line 672 "Utility/Device.vala"
					_tmp436_->type = _tmp437_;
#line 672 "Utility/Device.vala"
					_g_object_unref0 (_tmp436_);
#line 673 "Utility/Device.vala"
					_tmp438_ = list;
#line 673 "Utility/Device.vala"
					_tmp439_ = gee_abstract_list_get ((GeeAbstractList*) _tmp438_, i);
#line 673 "Utility/Device.vala"
					_tmp440_ = (Device*) _tmp439_;
#line 673 "Utility/Device.vala"
					_tmp441_ = list;
#line 673 "Utility/Device.vala"
					_tmp442_ = gee_abstract_list_get ((GeeAbstractList*) _tmp441_, i);
#line 673 "Utility/Device.vala"
					_tmp443_ = (Device*) _tmp442_;
#line 673 "Utility/Device.vala"
					_tmp444_ = _tmp443_->name;
#line 673 "Utility/Device.vala"
					_tmp445_ = g_strdup (_tmp444_);
#line 673 "Utility/Device.vala"
					_g_free0 (_tmp440_->model);
#line 673 "Utility/Device.vala"
					_tmp440_->model = _tmp445_;
#line 673 "Utility/Device.vala"
					_g_object_unref0 (_tmp443_);
#line 673 "Utility/Device.vala"
					_g_object_unref0 (_tmp440_);
#line 4710 "Device.c"
					{
						gint j = 0;
						GeeArrayList* _tmp446_;
						gint _tmp447_;
						gint _tmp448_;
#line 676 "Utility/Device.vala"
						_tmp446_ = list;
#line 676 "Utility/Device.vala"
						_tmp447_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp446_);
#line 676 "Utility/Device.vala"
						_tmp448_ = _tmp447_;
#line 676 "Utility/Device.vala"
						j = _tmp448_ - 1;
#line 4724 "Device.c"
						{
							gboolean _tmp449_ = FALSE;
#line 676 "Utility/Device.vala"
							_tmp449_ = TRUE;
#line 676 "Utility/Device.vala"
							while (TRUE) {
#line 4731 "Device.c"
								gboolean _tmp450_ = FALSE;
								gboolean _tmp451_ = FALSE;
#line 676 "Utility/Device.vala"
								if (!_tmp449_) {
#line 676 "Utility/Device.vala"
									j = j - 1;
#line 4738 "Device.c"
								}
#line 676 "Utility/Device.vala"
								_tmp449_ = FALSE;
#line 676 "Utility/Device.vala"
								if (!(j >= 0)) {
#line 676 "Utility/Device.vala"
									break;
#line 4746 "Device.c"
								}
#line 677 "Utility/Device.vala"
								if (i != j) {
#line 4750 "Device.c"
									GeeArrayList* _tmp452_;
									gpointer _tmp453_;
									Device* _tmp454_;
									const gchar* _tmp455_;
#line 677 "Utility/Device.vala"
									_tmp452_ = list;
#line 677 "Utility/Device.vala"
									_tmp453_ = gee_abstract_list_get ((GeeAbstractList*) _tmp452_, j);
#line 677 "Utility/Device.vala"
									_tmp454_ = (Device*) _tmp453_;
#line 677 "Utility/Device.vala"
									_tmp455_ = _tmp454_->type;
#line 677 "Utility/Device.vala"
									_tmp451_ = g_strcmp0 (_tmp455_, "dmraid") == 0;
#line 677 "Utility/Device.vala"
									_g_object_unref0 (_tmp454_);
#line 4767 "Device.c"
								} else {
#line 677 "Utility/Device.vala"
									_tmp451_ = FALSE;
#line 4771 "Device.c"
								}
#line 677 "Utility/Device.vala"
								if (_tmp451_) {
#line 4775 "Device.c"
									GeeArrayList* _tmp456_;
									gpointer _tmp457_;
									Device* _tmp458_;
									const gchar* _tmp459_;
									GeeArrayList* _tmp460_;
									gpointer _tmp461_;
									Device* _tmp462_;
									const gchar* _tmp463_;
#line 677 "Utility/Device.vala"
									_tmp456_ = list;
#line 677 "Utility/Device.vala"
									_tmp457_ = gee_abstract_list_get ((GeeAbstractList*) _tmp456_, j);
#line 677 "Utility/Device.vala"
									_tmp458_ = (Device*) _tmp457_;
#line 677 "Utility/Device.vala"
									_tmp459_ = _tmp458_->kname;
#line 677 "Utility/Device.vala"
									_tmp460_ = list;
#line 677 "Utility/Device.vala"
									_tmp461_ = gee_abstract_list_get ((GeeAbstractList*) _tmp460_, i);
#line 677 "Utility/Device.vala"
									_tmp462_ = (Device*) _tmp461_;
#line 677 "Utility/Device.vala"
									_tmp463_ = _tmp462_->kname;
#line 677 "Utility/Device.vala"
									_tmp450_ = g_strcmp0 (_tmp459_, _tmp463_) == 0;
#line 677 "Utility/Device.vala"
									_g_object_unref0 (_tmp462_);
#line 677 "Utility/Device.vala"
									_g_object_unref0 (_tmp458_);
#line 4806 "Device.c"
								} else {
#line 677 "Utility/Device.vala"
									_tmp450_ = FALSE;
#line 4810 "Device.c"
								}
#line 677 "Utility/Device.vala"
								if (_tmp450_) {
#line 4814 "Device.c"
									GeeArrayList* _tmp464_;
									gpointer _tmp465_;
									Device* _tmp466_;
#line 678 "Utility/Device.vala"
									_tmp464_ = list;
#line 678 "Utility/Device.vala"
									_tmp465_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp464_, j);
#line 678 "Utility/Device.vala"
									_tmp466_ = (Device*) _tmp465_;
#line 678 "Utility/Device.vala"
									_g_object_unref0 (_tmp466_);
#line 679 "Utility/Device.vala"
									if (j < i) {
#line 680 "Utility/Device.vala"
										i = i - 1;
#line 4830 "Device.c"
									}
								}
							}
						}
					}
				}
			}
		}
	}
#line 689 "Utility/Device.vala"
	if (device_lsblk_is_ancient) {
#line 4842 "Device.c"
		GeeArrayList* _tmp467_;
#line 690 "Utility/Device.vala"
		_tmp467_ = list;
#line 690 "Utility/Device.vala"
		device_find_child_devices_using_dmsetup (_tmp467_);
#line 4848 "Device.c"
	}
#line 697 "Utility/Device.vala"
	result = list;
#line 697 "Utility/Device.vala"
	_g_match_info_unref0 (match);
#line 697 "Utility/Device.vala"
	_g_regex_unref0 (rex);
#line 697 "Utility/Device.vala"
	_g_free0 (cmd);
#line 697 "Utility/Device.vala"
	_g_free0 (std_err);
#line 697 "Utility/Device.vala"
	_g_free0 (std_out);
#line 697 "Utility/Device.vala"
	return result;
#line 4864 "Device.c"
}

GeeArrayList*
device_get_block_devices_using_blkid (const gchar* dev_name)
{
	GeeArrayList* result = NULL;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gchar* cmd = NULL;
	gint ret_val = 0;
	GRegex* rex = NULL;
	GMatchInfo* match = NULL;
	gchar* _tmp1_ = NULL;
	gint _tmp2_;
	gint _tmp3_;
	gchar* _tmp6_;
	const gchar* _tmp8_;
	gchar* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	gint _tmp11_;
	const gchar* _tmp21_;
	gchar** _tmp22_;
	gchar** _tmp23_;
	GeeArrayList* _tmp104_;
	gint _tmp105_;
	gint _tmp106_;
	gchar* _tmp107_;
	gchar* _tmp108_;
	GError* _inner_error0_ = NULL;
#line 701 "Utility/Device.vala"
	g_return_val_if_fail (dev_name != NULL, NULL);
#line 706 "Utility/Device.vala"
	_tmp0_ = gee_array_list_new (TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 706 "Utility/Device.vala"
	list = _tmp0_;
#line 715 "Utility/Device.vala"
	_tmp2_ = strlen (dev_name);
#line 715 "Utility/Device.vala"
	_tmp3_ = _tmp2_;
#line 715 "Utility/Device.vala"
	if (_tmp3_ > 0) {
#line 4908 "Device.c"
		gchar* _tmp4_;
#line 715 "Utility/Device.vala"
		_tmp4_ = g_strconcat (" ", dev_name, NULL);
#line 715 "Utility/Device.vala"
		_g_free0 (_tmp1_);
#line 715 "Utility/Device.vala"
		_tmp1_ = _tmp4_;
#line 4916 "Device.c"
	} else {
		gchar* _tmp5_;
#line 715 "Utility/Device.vala"
		_tmp5_ = g_strdup ("");
#line 715 "Utility/Device.vala"
		_g_free0 (_tmp1_);
#line 715 "Utility/Device.vala"
		_tmp1_ = _tmp5_;
#line 4925 "Device.c"
	}
#line 715 "Utility/Device.vala"
	_tmp6_ = g_strconcat ("/sbin/blkid", _tmp1_, NULL);
#line 715 "Utility/Device.vala"
	_g_free0 (cmd);
#line 715 "Utility/Device.vala"
	cmd = _tmp6_;
#line 717 "Utility/Device.vala"
	if (tee_jee_logging_LOG_DEBUG) {
#line 4935 "Device.c"
		const gchar* _tmp7_;
#line 718 "Utility/Device.vala"
		_tmp7_ = cmd;
#line 718 "Utility/Device.vala"
		tee_jee_logging_log_debug (_tmp7_);
#line 4941 "Device.c"
	}
#line 721 "Utility/Device.vala"
	_tmp8_ = cmd;
#line 721 "Utility/Device.vala"
	_tmp11_ = tee_jee_process_helper_exec_script_sync (_tmp8_, &_tmp9_, &_tmp10_, FALSE, FALSE, TRUE, FALSE);
#line 721 "Utility/Device.vala"
	_g_free0 (std_out);
#line 721 "Utility/Device.vala"
	std_out = _tmp9_;
#line 721 "Utility/Device.vala"
	_g_free0 (std_err);
#line 721 "Utility/Device.vala"
	std_err = _tmp10_;
#line 721 "Utility/Device.vala"
	ret_val = _tmp11_;
#line 722 "Utility/Device.vala"
	if (ret_val != 0) {
#line 4959 "Device.c"
		gchar* msg = NULL;
		gchar* _tmp12_;
		gchar* _tmp13_ = NULL;
		gint _tmp14_;
		gint _tmp15_;
		const gchar* _tmp18_;
		gchar* _tmp19_;
		const gchar* _tmp20_;
#line 723 "Utility/Device.vala"
		_tmp12_ = g_strconcat ("blkid: ", _ ("Failed to get partition list"), NULL);
#line 723 "Utility/Device.vala"
		msg = _tmp12_;
#line 724 "Utility/Device.vala"
		_tmp14_ = strlen (dev_name);
#line 724 "Utility/Device.vala"
		_tmp15_ = _tmp14_;
#line 724 "Utility/Device.vala"
		if (_tmp15_ > 0) {
#line 4978 "Device.c"
			gchar* _tmp16_;
#line 724 "Utility/Device.vala"
			_tmp16_ = g_strconcat (": ", dev_name, NULL);
#line 724 "Utility/Device.vala"
			_g_free0 (_tmp13_);
#line 724 "Utility/Device.vala"
			_tmp13_ = _tmp16_;
#line 4986 "Device.c"
		} else {
			gchar* _tmp17_;
#line 724 "Utility/Device.vala"
			_tmp17_ = g_strdup ("");
#line 724 "Utility/Device.vala"
			_g_free0 (_tmp13_);
#line 724 "Utility/Device.vala"
			_tmp13_ = _tmp17_;
#line 4995 "Device.c"
		}
#line 724 "Utility/Device.vala"
		_tmp18_ = msg;
#line 724 "Utility/Device.vala"
		_tmp19_ = g_strconcat (_tmp18_, _tmp13_, NULL);
#line 724 "Utility/Device.vala"
		_g_free0 (msg);
#line 724 "Utility/Device.vala"
		msg = _tmp19_;
#line 725 "Utility/Device.vala"
		_tmp20_ = msg;
#line 725 "Utility/Device.vala"
		tee_jee_logging_log_error (_tmp20_, FALSE, FALSE);
#line 726 "Utility/Device.vala"
		result = list;
#line 726 "Utility/Device.vala"
		_g_free0 (_tmp13_);
#line 726 "Utility/Device.vala"
		_g_free0 (msg);
#line 726 "Utility/Device.vala"
		_g_free0 (_tmp1_);
#line 726 "Utility/Device.vala"
		_g_match_info_unref0 (match);
#line 726 "Utility/Device.vala"
		_g_regex_unref0 (rex);
#line 726 "Utility/Device.vala"
		_g_free0 (cmd);
#line 726 "Utility/Device.vala"
		_g_free0 (std_err);
#line 726 "Utility/Device.vala"
		_g_free0 (std_out);
#line 726 "Utility/Device.vala"
		return result;
#line 5029 "Device.c"
	}
#line 739 "Utility/Device.vala"
	_tmp21_ = std_out;
#line 739 "Utility/Device.vala"
	_tmp23_ = _tmp22_ = g_strsplit (_tmp21_, "\n", 0);
#line 5035 "Device.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 739 "Utility/Device.vala"
		line_collection = _tmp23_;
#line 739 "Utility/Device.vala"
		line_collection_length1 = _vala_array_length (_tmp22_);
#line 739 "Utility/Device.vala"
		for (line_it = 0; line_it < _vala_array_length (_tmp22_); line_it = line_it + 1) {
#line 5047 "Device.c"
			gchar* _tmp24_;
			gchar* line = NULL;
#line 739 "Utility/Device.vala"
			_tmp24_ = g_strdup (line_collection[line_it]);
#line 739 "Utility/Device.vala"
			line = _tmp24_;
#line 5054 "Device.c"
			{
				const gchar* _tmp25_;
				gchar* _tmp26_;
				gchar* _tmp27_;
				gint _tmp28_;
				gint _tmp29_;
				gboolean _tmp30_;
				Device* pi = NULL;
				Device* _tmp31_;
				Device* _tmp32_;
				const gchar* _tmp33_;
				gchar** _tmp34_;
				gchar** _tmp35_;
				gchar** _tmp36_;
				gint _tmp36__length1;
				const gchar* _tmp37_;
				gchar* _tmp38_;
				Device* _tmp39_;
				const gchar* _tmp40_;
				gint _tmp41_;
				gint _tmp42_;
				Device* _tmp43_;
				const gchar* _tmp44_;
				gboolean _tmp45_ = FALSE;
				gboolean _tmp46_ = FALSE;
				gboolean _tmp47_ = FALSE;
				Device* _tmp48_;
				const gchar* _tmp49_;
				Device* _tmp98_;
				const gchar* _tmp99_;
				gint _tmp100_;
				gint _tmp101_;
#line 740 "Utility/Device.vala"
				_tmp25_ = line;
#line 740 "Utility/Device.vala"
				_tmp26_ = string_strip (_tmp25_);
#line 740 "Utility/Device.vala"
				_tmp27_ = _tmp26_;
#line 740 "Utility/Device.vala"
				_tmp28_ = strlen (_tmp27_);
#line 740 "Utility/Device.vala"
				_tmp29_ = _tmp28_;
#line 740 "Utility/Device.vala"
				_tmp30_ = _tmp29_ == 0;
#line 740 "Utility/Device.vala"
				_g_free0 (_tmp27_);
#line 740 "Utility/Device.vala"
				if (_tmp30_) {
#line 740 "Utility/Device.vala"
					_g_free0 (line);
#line 740 "Utility/Device.vala"
					continue;
#line 5107 "Device.c"
				}
#line 742 "Utility/Device.vala"
				_tmp31_ = device_new ();
#line 742 "Utility/Device.vala"
				pi = _tmp31_;
#line 744 "Utility/Device.vala"
				_tmp32_ = pi;
#line 744 "Utility/Device.vala"
				_tmp33_ = line;
#line 744 "Utility/Device.vala"
				_tmp35_ = _tmp34_ = g_strsplit (_tmp33_, ":", 0);
#line 744 "Utility/Device.vala"
				_tmp36_ = _tmp35_;
#line 744 "Utility/Device.vala"
				_tmp36__length1 = _vala_array_length (_tmp34_);
#line 744 "Utility/Device.vala"
				_tmp37_ = _tmp36_[0];
#line 744 "Utility/Device.vala"
				_tmp38_ = string_strip (_tmp37_);
#line 744 "Utility/Device.vala"
				_g_free0 (_tmp32_->device);
#line 744 "Utility/Device.vala"
				_tmp32_->device = _tmp38_;
#line 744 "Utility/Device.vala"
				_tmp36_ = (_vala_array_free (_tmp36_, _tmp36__length1, (GDestroyNotify) g_free), NULL);
#line 746 "Utility/Device.vala"
				_tmp39_ = pi;
#line 746 "Utility/Device.vala"
				_tmp40_ = _tmp39_->device;
#line 746 "Utility/Device.vala"
				_tmp41_ = strlen (_tmp40_);
#line 746 "Utility/Device.vala"
				_tmp42_ = _tmp41_;
#line 746 "Utility/Device.vala"
				if (_tmp42_ == 0) {
#line 746 "Utility/Device.vala"
					_g_object_unref0 (pi);
#line 746 "Utility/Device.vala"
					_g_free0 (line);
#line 746 "Utility/Device.vala"
					continue;
#line 5149 "Device.c"
				}
#line 750 "Utility/Device.vala"
				_tmp43_ = pi;
#line 750 "Utility/Device.vala"
				_tmp44_ = _tmp43_->device;
#line 750 "Utility/Device.vala"
				if (!g_str_has_prefix (_tmp44_, "/dev/")) {
#line 751 "Utility/Device.vala"
					_g_object_unref0 (pi);
#line 751 "Utility/Device.vala"
					_g_free0 (line);
#line 751 "Utility/Device.vala"
					continue;
#line 5163 "Device.c"
				}
#line 754 "Utility/Device.vala"
				_tmp48_ = pi;
#line 754 "Utility/Device.vala"
				_tmp49_ = _tmp48_->device;
#line 754 "Utility/Device.vala"
				if (g_str_has_prefix (_tmp49_, "/dev/sd")) {
#line 754 "Utility/Device.vala"
					_tmp47_ = TRUE;
#line 5173 "Device.c"
				} else {
					Device* _tmp50_;
					const gchar* _tmp51_;
#line 754 "Utility/Device.vala"
					_tmp50_ = pi;
#line 754 "Utility/Device.vala"
					_tmp51_ = _tmp50_->device;
#line 754 "Utility/Device.vala"
					_tmp47_ = g_str_has_prefix (_tmp51_, "/dev/hd");
#line 5183 "Device.c"
				}
#line 754 "Utility/Device.vala"
				if (_tmp47_) {
#line 754 "Utility/Device.vala"
					_tmp46_ = TRUE;
#line 5189 "Device.c"
				} else {
					Device* _tmp52_;
					const gchar* _tmp53_;
#line 754 "Utility/Device.vala"
					_tmp52_ = pi;
#line 754 "Utility/Device.vala"
					_tmp53_ = _tmp52_->device;
#line 754 "Utility/Device.vala"
					_tmp46_ = g_str_has_prefix (_tmp53_, "/dev/mapper/");
#line 5199 "Device.c"
				}
#line 754 "Utility/Device.vala"
				if (_tmp46_) {
#line 754 "Utility/Device.vala"
					_tmp45_ = TRUE;
#line 5205 "Device.c"
				} else {
					Device* _tmp54_;
					const gchar* _tmp55_;
#line 754 "Utility/Device.vala"
					_tmp54_ = pi;
#line 754 "Utility/Device.vala"
					_tmp55_ = _tmp54_->device;
#line 754 "Utility/Device.vala"
					_tmp45_ = g_str_has_prefix (_tmp55_, "/dev/dm");
#line 5215 "Device.c"
				}
#line 754 "Utility/Device.vala"
				if (_tmp45_) {
#line 5219 "Device.c"
				} else {
					Device* _tmp56_;
					const gchar* _tmp57_;
#line 757 "Utility/Device.vala"
					_tmp56_ = pi;
#line 757 "Utility/Device.vala"
					_tmp57_ = _tmp56_->device;
#line 757 "Utility/Device.vala"
					if (g_str_has_prefix (_tmp57_, "/dev/disk/by-uuid/")) {
#line 5229 "Device.c"
						Device* _tmp58_;
						Device* _tmp59_;
						const gchar* _tmp60_;
						gchar* _tmp61_;
#line 759 "Utility/Device.vala"
						_tmp58_ = pi;
#line 759 "Utility/Device.vala"
						_tmp59_ = pi;
#line 759 "Utility/Device.vala"
						_tmp60_ = _tmp59_->device;
#line 759 "Utility/Device.vala"
						_tmp61_ = string_replace (_tmp60_, "/dev/disk/by-uuid/", "");
#line 759 "Utility/Device.vala"
						_g_free0 (_tmp58_->uuid);
#line 759 "Utility/Device.vala"
						_tmp58_->uuid = _tmp61_;
#line 5246 "Device.c"
					} else {
#line 762 "Utility/Device.vala"
						_g_object_unref0 (pi);
#line 762 "Utility/Device.vala"
						_g_free0 (line);
#line 762 "Utility/Device.vala"
						continue;
#line 5254 "Device.c"
					}
				}
				{
					GRegex* _tmp62_ = NULL;
					GRegex* _tmp63_;
					GRegex* _tmp64_;
					GRegex* _tmp65_;
					const gchar* _tmp66_;
					GMatchInfo* _tmp67_ = NULL;
					gboolean _tmp68_;
					GRegex* _tmp72_ = NULL;
					GRegex* _tmp73_;
					GRegex* _tmp74_;
					GRegex* _tmp75_;
					const gchar* _tmp76_;
					GMatchInfo* _tmp77_ = NULL;
					gboolean _tmp78_;
					GRegex* _tmp84_ = NULL;
					GRegex* _tmp85_;
					GRegex* _tmp86_;
					GRegex* _tmp87_;
					const gchar* _tmp88_;
					GMatchInfo* _tmp89_ = NULL;
					gboolean _tmp90_;
#line 768 "Utility/Device.vala"
					_tmp63_ = g_regex_new ("LABEL=\\\"([^\\\"]*)\\\"", 0, 0, &_inner_error0_);
#line 768 "Utility/Device.vala"
					_tmp62_ = _tmp63_;
#line 768 "Utility/Device.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5285 "Device.c"
						goto __catch46_g_error;
					}
#line 768 "Utility/Device.vala"
					_tmp64_ = _tmp62_;
#line 768 "Utility/Device.vala"
					_tmp62_ = NULL;
#line 768 "Utility/Device.vala"
					_g_regex_unref0 (rex);
#line 768 "Utility/Device.vala"
					rex = _tmp64_;
#line 769 "Utility/Device.vala"
					_tmp65_ = rex;
#line 769 "Utility/Device.vala"
					_tmp66_ = line;
#line 769 "Utility/Device.vala"
					_tmp68_ = g_regex_match (_tmp65_, _tmp66_, 0, &_tmp67_);
#line 769 "Utility/Device.vala"
					_g_match_info_unref0 (match);
#line 769 "Utility/Device.vala"
					match = _tmp67_;
#line 769 "Utility/Device.vala"
					if (_tmp68_) {
#line 5308 "Device.c"
						Device* _tmp69_;
						GMatchInfo* _tmp70_;
						gchar* _tmp71_;
#line 770 "Utility/Device.vala"
						_tmp69_ = pi;
#line 770 "Utility/Device.vala"
						_tmp70_ = match;
#line 770 "Utility/Device.vala"
						_tmp71_ = g_match_info_fetch (_tmp70_, 1);
#line 770 "Utility/Device.vala"
						_g_free0 (_tmp69_->label);
#line 770 "Utility/Device.vala"
						_tmp69_->label = _tmp71_;
#line 5322 "Device.c"
					}
#line 773 "Utility/Device.vala"
					_tmp73_ = g_regex_new ("UUID=\\\"([^\\\"]*)\\\"", 0, 0, &_inner_error0_);
#line 773 "Utility/Device.vala"
					_tmp72_ = _tmp73_;
#line 773 "Utility/Device.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 773 "Utility/Device.vala"
						_g_regex_unref0 (_tmp62_);
#line 5332 "Device.c"
						goto __catch46_g_error;
					}
#line 773 "Utility/Device.vala"
					_tmp74_ = _tmp72_;
#line 773 "Utility/Device.vala"
					_tmp72_ = NULL;
#line 773 "Utility/Device.vala"
					_g_regex_unref0 (rex);
#line 773 "Utility/Device.vala"
					rex = _tmp74_;
#line 774 "Utility/Device.vala"
					_tmp75_ = rex;
#line 774 "Utility/Device.vala"
					_tmp76_ = line;
#line 774 "Utility/Device.vala"
					_tmp78_ = g_regex_match (_tmp75_, _tmp76_, 0, &_tmp77_);
#line 774 "Utility/Device.vala"
					_g_match_info_unref0 (match);
#line 774 "Utility/Device.vala"
					match = _tmp77_;
#line 774 "Utility/Device.vala"
					if (_tmp78_) {
#line 5355 "Device.c"
						Device* _tmp79_;
						GMatchInfo* _tmp80_;
						gchar* _tmp81_;
						gchar* _tmp82_;
						gchar* _tmp83_;
#line 775 "Utility/Device.vala"
						_tmp79_ = pi;
#line 775 "Utility/Device.vala"
						_tmp80_ = match;
#line 775 "Utility/Device.vala"
						_tmp81_ = g_match_info_fetch (_tmp80_, 1);
#line 775 "Utility/Device.vala"
						_tmp82_ = _tmp81_;
#line 775 "Utility/Device.vala"
						_tmp83_ = string_strip (_tmp82_);
#line 775 "Utility/Device.vala"
						_g_free0 (_tmp79_->uuid);
#line 775 "Utility/Device.vala"
						_tmp79_->uuid = _tmp83_;
#line 775 "Utility/Device.vala"
						_g_free0 (_tmp82_);
#line 5377 "Device.c"
					}
#line 778 "Utility/Device.vala"
					_tmp85_ = g_regex_new ("TYPE=\\\"([^\\\"]*)\\\"", 0, 0, &_inner_error0_);
#line 778 "Utility/Device.vala"
					_tmp84_ = _tmp85_;
#line 778 "Utility/Device.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 778 "Utility/Device.vala"
						_g_regex_unref0 (_tmp72_);
#line 778 "Utility/Device.vala"
						_g_regex_unref0 (_tmp62_);
#line 5389 "Device.c"
						goto __catch46_g_error;
					}
#line 778 "Utility/Device.vala"
					_tmp86_ = _tmp84_;
#line 778 "Utility/Device.vala"
					_tmp84_ = NULL;
#line 778 "Utility/Device.vala"
					_g_regex_unref0 (rex);
#line 778 "Utility/Device.vala"
					rex = _tmp86_;
#line 779 "Utility/Device.vala"
					_tmp87_ = rex;
#line 779 "Utility/Device.vala"
					_tmp88_ = line;
#line 779 "Utility/Device.vala"
					_tmp90_ = g_regex_match (_tmp87_, _tmp88_, 0, &_tmp89_);
#line 779 "Utility/Device.vala"
					_g_match_info_unref0 (match);
#line 779 "Utility/Device.vala"
					match = _tmp89_;
#line 779 "Utility/Device.vala"
					if (_tmp90_) {
#line 5412 "Device.c"
						Device* _tmp91_;
						GMatchInfo* _tmp92_;
						gchar* _tmp93_;
						gchar* _tmp94_;
						gchar* _tmp95_;
#line 780 "Utility/Device.vala"
						_tmp91_ = pi;
#line 780 "Utility/Device.vala"
						_tmp92_ = match;
#line 780 "Utility/Device.vala"
						_tmp93_ = g_match_info_fetch (_tmp92_, 1);
#line 780 "Utility/Device.vala"
						_tmp94_ = _tmp93_;
#line 780 "Utility/Device.vala"
						_tmp95_ = string_strip (_tmp94_);
#line 780 "Utility/Device.vala"
						_g_free0 (_tmp91_->fstype);
#line 780 "Utility/Device.vala"
						_tmp91_->fstype = _tmp95_;
#line 780 "Utility/Device.vala"
						_g_free0 (_tmp94_);
#line 5434 "Device.c"
					}
#line 767 "Utility/Device.vala"
					_g_regex_unref0 (_tmp84_);
#line 767 "Utility/Device.vala"
					_g_regex_unref0 (_tmp72_);
#line 767 "Utility/Device.vala"
					_g_regex_unref0 (_tmp62_);
#line 5442 "Device.c"
				}
				goto __finally46;
				__catch46_g_error:
				{
					GError* e = NULL;
					GError* _tmp96_;
					const gchar* _tmp97_;
#line 767 "Utility/Device.vala"
					e = _inner_error0_;
#line 767 "Utility/Device.vala"
					_inner_error0_ = NULL;
#line 784 "Utility/Device.vala"
					_tmp96_ = e;
#line 784 "Utility/Device.vala"
					_tmp97_ = _tmp96_->message;
#line 784 "Utility/Device.vala"
					tee_jee_logging_log_error (_tmp97_, FALSE, FALSE);
#line 767 "Utility/Device.vala"
					_g_error_free0 (e);
#line 5462 "Device.c"
				}
				__finally46:
#line 767 "Utility/Device.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 767 "Utility/Device.vala"
					_g_object_unref0 (pi);
#line 767 "Utility/Device.vala"
					_g_free0 (line);
#line 767 "Utility/Device.vala"
					line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 767 "Utility/Device.vala"
					_g_free0 (_tmp1_);
#line 767 "Utility/Device.vala"
					_g_match_info_unref0 (match);
#line 767 "Utility/Device.vala"
					_g_regex_unref0 (rex);
#line 767 "Utility/Device.vala"
					_g_free0 (cmd);
#line 767 "Utility/Device.vala"
					_g_free0 (std_err);
#line 767 "Utility/Device.vala"
					_g_free0 (std_out);
#line 767 "Utility/Device.vala"
					_g_object_unref0 (list);
#line 767 "Utility/Device.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 767 "Utility/Device.vala"
					g_clear_error (&_inner_error0_);
#line 767 "Utility/Device.vala"
					return NULL;
#line 5493 "Device.c"
				}
#line 789 "Utility/Device.vala"
				_tmp98_ = pi;
#line 789 "Utility/Device.vala"
				_tmp99_ = _tmp98_->uuid;
#line 789 "Utility/Device.vala"
				_tmp100_ = strlen (_tmp99_);
#line 789 "Utility/Device.vala"
				_tmp101_ = _tmp100_;
#line 789 "Utility/Device.vala"
				if (_tmp101_ > 0) {
#line 5505 "Device.c"
					GeeArrayList* _tmp102_;
					Device* _tmp103_;
#line 790 "Utility/Device.vala"
					_tmp102_ = list;
#line 790 "Utility/Device.vala"
					_tmp103_ = pi;
#line 790 "Utility/Device.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp102_, _tmp103_);
#line 5514 "Device.c"
				}
#line 739 "Utility/Device.vala"
				_g_object_unref0 (pi);
#line 739 "Utility/Device.vala"
				_g_free0 (line);
#line 5520 "Device.c"
			}
		}
#line 739 "Utility/Device.vala"
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 5525 "Device.c"
	}
#line 794 "Utility/Device.vala"
	_tmp104_ = list;
#line 794 "Utility/Device.vala"
	_tmp105_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp104_);
#line 794 "Utility/Device.vala"
	_tmp106_ = _tmp105_;
#line 794 "Utility/Device.vala"
	_tmp107_ = g_strdup_printf ("Device: get_block_devices_using_blkid(): %d", _tmp106_);
#line 794 "Utility/Device.vala"
	_tmp108_ = _tmp107_;
#line 794 "Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp108_);
#line 794 "Utility/Device.vala"
	_g_free0 (_tmp108_);
#line 796 "Utility/Device.vala"
	result = list;
#line 796 "Utility/Device.vala"
	_g_free0 (_tmp1_);
#line 796 "Utility/Device.vala"
	_g_match_info_unref0 (match);
#line 796 "Utility/Device.vala"
	_g_regex_unref0 (rex);
#line 796 "Utility/Device.vala"
	_g_free0 (cmd);
#line 796 "Utility/Device.vala"
	_g_free0 (std_err);
#line 796 "Utility/Device.vala"
	_g_free0 (std_out);
#line 796 "Utility/Device.vala"
	return result;
#line 5557 "Device.c"
}

static guint64
uint64_parse (const gchar* str)
{
	guint64 result = 0ULL;
#line 782 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0ULL);
#line 783 "glib-2.0.vapi"
	result = g_ascii_strtoull (str, NULL, (guint) 0);
#line 783 "glib-2.0.vapi"
	return result;
#line 5570 "Device.c"
}

GeeArrayList*
device_get_disk_space_using_df (const gchar* dev_name_or_mount_point)
{
	GeeArrayList* result = NULL;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gchar* cmd = NULL;
	gint ret_val = 0;
	gchar* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	const gchar* _tmp11_;
	gchar* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	gint _tmp14_;
	gchar** lines = NULL;
	const gchar* _tmp15_;
	gchar** _tmp16_;
	gchar** _tmp17_;
	gint lines_length1;
	gint _lines_size_;
	gint line_num = 0;
	gchar** _tmp18_;
	gint _tmp18__length1;
	GeeArrayList* _tmp73_;
	gint _tmp74_;
	gint _tmp75_;
	gchar* _tmp76_;
	gchar* _tmp77_;
#line 799 "Utility/Device.vala"
	g_return_val_if_fail (dev_name_or_mount_point != NULL, NULL);
#line 806 "Utility/Device.vala"
	_tmp0_ = gee_array_list_new (TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 806 "Utility/Device.vala"
	list = _tmp0_;
#line 813 "Utility/Device.vala"
	_tmp1_ = g_strdup ("df -T -B1");
#line 813 "Utility/Device.vala"
	_g_free0 (cmd);
#line 813 "Utility/Device.vala"
	cmd = _tmp1_;
#line 815 "Utility/Device.vala"
	_tmp2_ = strlen (dev_name_or_mount_point);
#line 815 "Utility/Device.vala"
	_tmp3_ = _tmp2_;
#line 815 "Utility/Device.vala"
	if (_tmp3_ > 0) {
#line 5622 "Device.c"
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 816 "Utility/Device.vala"
		_tmp4_ = cmd;
#line 816 "Utility/Device.vala"
		_tmp5_ = tee_jee_file_system_escape_single_quote (dev_name_or_mount_point);
#line 816 "Utility/Device.vala"
		_tmp6_ = _tmp5_;
#line 816 "Utility/Device.vala"
		_tmp7_ = g_strdup_printf (" '%s'", _tmp6_);
#line 816 "Utility/Device.vala"
		_tmp8_ = _tmp7_;
#line 816 "Utility/Device.vala"
		_tmp9_ = g_strconcat (_tmp4_, _tmp8_, NULL);
#line 816 "Utility/Device.vala"
		_g_free0 (cmd);
#line 816 "Utility/Device.vala"
		cmd = _tmp9_;
#line 816 "Utility/Device.vala"
		_g_free0 (_tmp8_);
#line 816 "Utility/Device.vala"
		_g_free0 (_tmp6_);
#line 5649 "Device.c"
	}
#line 819 "Utility/Device.vala"
	if (tee_jee_logging_LOG_DEBUG) {
#line 5653 "Device.c"
		const gchar* _tmp10_;
#line 820 "Utility/Device.vala"
		_tmp10_ = cmd;
#line 820 "Utility/Device.vala"
		tee_jee_logging_log_debug (_tmp10_);
#line 5659 "Device.c"
	}
#line 823 "Utility/Device.vala"
	_tmp11_ = cmd;
#line 823 "Utility/Device.vala"
	_tmp14_ = tee_jee_process_helper_exec_sync (_tmp11_, &_tmp12_, &_tmp13_);
#line 823 "Utility/Device.vala"
	_g_free0 (std_out);
#line 823 "Utility/Device.vala"
	std_out = _tmp12_;
#line 823 "Utility/Device.vala"
	_g_free0 (std_err);
#line 823 "Utility/Device.vala"
	std_err = _tmp13_;
#line 823 "Utility/Device.vala"
	ret_val = _tmp14_;
#line 838 "Utility/Device.vala"
	_tmp15_ = std_out;
#line 838 "Utility/Device.vala"
	_tmp17_ = _tmp16_ = g_strsplit (_tmp15_, "\n", 0);
#line 838 "Utility/Device.vala"
	lines = _tmp17_;
#line 838 "Utility/Device.vala"
	lines_length1 = _vala_array_length (_tmp16_);
#line 838 "Utility/Device.vala"
	_lines_size_ = lines_length1;
#line 840 "Utility/Device.vala"
	line_num = 0;
#line 841 "Utility/Device.vala"
	_tmp18_ = lines;
#line 841 "Utility/Device.vala"
	_tmp18__length1 = lines_length1;
#line 5691 "Device.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 841 "Utility/Device.vala"
		line_collection = _tmp18_;
#line 841 "Utility/Device.vala"
		line_collection_length1 = _tmp18__length1;
#line 841 "Utility/Device.vala"
		for (line_it = 0; line_it < _tmp18__length1; line_it = line_it + 1) {
#line 5703 "Device.c"
			gchar* _tmp19_;
			gchar* line = NULL;
#line 841 "Utility/Device.vala"
			_tmp19_ = g_strdup (line_collection[line_it]);
#line 841 "Utility/Device.vala"
			line = _tmp19_;
#line 5710 "Device.c"
			{
				const gchar* _tmp20_;
				gchar* _tmp21_;
				gchar* _tmp22_;
				gint _tmp23_;
				gint _tmp24_;
				gboolean _tmp25_;
				Device* pi = NULL;
				Device* _tmp26_;
				gint k = 0;
				const gchar* _tmp27_;
				gchar** _tmp28_;
				gchar** _tmp29_;
				Device* _tmp59_;
				Device* _tmp60_;
				const gchar* _tmp61_;
				gchar* _tmp62_;
				Device* _tmp63_;
				Device* _tmp64_;
				const gchar* _tmp65_;
				gchar* _tmp66_;
				Device* _tmp67_;
				const gchar* _tmp68_;
				gint _tmp69_;
				gint _tmp70_;
#line 843 "Utility/Device.vala"
				line_num = line_num + 1;
#line 843 "Utility/Device.vala"
				if (line_num == 1) {
#line 843 "Utility/Device.vala"
					_g_free0 (line);
#line 843 "Utility/Device.vala"
					continue;
#line 5744 "Device.c"
				}
#line 844 "Utility/Device.vala"
				_tmp20_ = line;
#line 844 "Utility/Device.vala"
				_tmp21_ = string_strip (_tmp20_);
#line 844 "Utility/Device.vala"
				_tmp22_ = _tmp21_;
#line 844 "Utility/Device.vala"
				_tmp23_ = strlen (_tmp22_);
#line 844 "Utility/Device.vala"
				_tmp24_ = _tmp23_;
#line 844 "Utility/Device.vala"
				_tmp25_ = _tmp24_ == 0;
#line 844 "Utility/Device.vala"
				_g_free0 (_tmp22_);
#line 844 "Utility/Device.vala"
				if (_tmp25_) {
#line 844 "Utility/Device.vala"
					_g_free0 (line);
#line 844 "Utility/Device.vala"
					continue;
#line 5766 "Device.c"
				}
#line 846 "Utility/Device.vala"
				_tmp26_ = device_new ();
#line 846 "Utility/Device.vala"
				pi = _tmp26_;
#line 850 "Utility/Device.vala"
				k = 1;
#line 851 "Utility/Device.vala"
				_tmp27_ = line;
#line 851 "Utility/Device.vala"
				_tmp29_ = _tmp28_ = g_strsplit (_tmp27_, " ", 0);
#line 5778 "Device.c"
				{
					gchar** val_collection = NULL;
					gint val_collection_length1 = 0;
					gint _val_collection_size_ = 0;
					gint val_it = 0;
#line 851 "Utility/Device.vala"
					val_collection = _tmp29_;
#line 851 "Utility/Device.vala"
					val_collection_length1 = _vala_array_length (_tmp28_);
#line 851 "Utility/Device.vala"
					for (val_it = 0; val_it < _vala_array_length (_tmp28_); val_it = val_it + 1) {
#line 5790 "Device.c"
						gchar* _tmp30_;
						gchar* val = NULL;
#line 851 "Utility/Device.vala"
						_tmp30_ = g_strdup (val_collection[val_it]);
#line 851 "Utility/Device.vala"
						val = _tmp30_;
#line 5797 "Device.c"
						{
							const gchar* _tmp31_;
							gchar* _tmp32_;
							gchar* _tmp33_;
							gint _tmp34_;
							gint _tmp35_;
							gboolean _tmp36_;
							gint _tmp37_;
#line 853 "Utility/Device.vala"
							_tmp31_ = val;
#line 853 "Utility/Device.vala"
							_tmp32_ = string_strip (_tmp31_);
#line 853 "Utility/Device.vala"
							_tmp33_ = _tmp32_;
#line 853 "Utility/Device.vala"
							_tmp34_ = strlen (_tmp33_);
#line 853 "Utility/Device.vala"
							_tmp35_ = _tmp34_;
#line 853 "Utility/Device.vala"
							_tmp36_ = _tmp35_ == 0;
#line 853 "Utility/Device.vala"
							_g_free0 (_tmp33_);
#line 853 "Utility/Device.vala"
							if (_tmp36_) {
#line 853 "Utility/Device.vala"
								_g_free0 (val);
#line 853 "Utility/Device.vala"
								continue;
#line 5826 "Device.c"
							}
#line 855 "Utility/Device.vala"
							_tmp37_ = k;
#line 855 "Utility/Device.vala"
							k = _tmp37_ + 1;
#line 855 "Utility/Device.vala"
							switch (_tmp37_) {
#line 855 "Utility/Device.vala"
								case 1:
#line 5836 "Device.c"
								{
									Device* _tmp38_;
									const gchar* _tmp39_;
									gchar* _tmp40_;
#line 857 "Utility/Device.vala"
									_tmp38_ = pi;
#line 857 "Utility/Device.vala"
									_tmp39_ = val;
#line 857 "Utility/Device.vala"
									_tmp40_ = string_strip (_tmp39_);
#line 857 "Utility/Device.vala"
									_g_free0 (_tmp38_->device);
#line 857 "Utility/Device.vala"
									_tmp38_->device = _tmp40_;
#line 858 "Utility/Device.vala"
									break;
#line 5853 "Device.c"
								}
#line 855 "Utility/Device.vala"
								case 2:
#line 5857 "Device.c"
								{
									Device* _tmp41_;
									const gchar* _tmp42_;
									gchar* _tmp43_;
#line 860 "Utility/Device.vala"
									_tmp41_ = pi;
#line 860 "Utility/Device.vala"
									_tmp42_ = val;
#line 860 "Utility/Device.vala"
									_tmp43_ = string_strip (_tmp42_);
#line 860 "Utility/Device.vala"
									_g_free0 (_tmp41_->fstype);
#line 860 "Utility/Device.vala"
									_tmp41_->fstype = _tmp43_;
#line 861 "Utility/Device.vala"
									break;
#line 5874 "Device.c"
								}
#line 855 "Utility/Device.vala"
								case 3:
#line 5878 "Device.c"
								{
									Device* _tmp44_;
									const gchar* _tmp45_;
									gchar* _tmp46_;
									gchar* _tmp47_;
#line 863 "Utility/Device.vala"
									_tmp44_ = pi;
#line 863 "Utility/Device.vala"
									_tmp45_ = val;
#line 863 "Utility/Device.vala"
									_tmp46_ = string_strip (_tmp45_);
#line 863 "Utility/Device.vala"
									_tmp47_ = _tmp46_;
#line 863 "Utility/Device.vala"
									_tmp44_->size_bytes = uint64_parse (_tmp47_);
#line 863 "Utility/Device.vala"
									_g_free0 (_tmp47_);
#line 864 "Utility/Device.vala"
									break;
#line 5898 "Device.c"
								}
#line 855 "Utility/Device.vala"
								case 4:
#line 5902 "Device.c"
								{
									Device* _tmp48_;
									const gchar* _tmp49_;
									gchar* _tmp50_;
									gchar* _tmp51_;
#line 866 "Utility/Device.vala"
									_tmp48_ = pi;
#line 866 "Utility/Device.vala"
									_tmp49_ = val;
#line 866 "Utility/Device.vala"
									_tmp50_ = string_strip (_tmp49_);
#line 866 "Utility/Device.vala"
									_tmp51_ = _tmp50_;
#line 866 "Utility/Device.vala"
									_tmp48_->used_bytes = uint64_parse (_tmp51_);
#line 866 "Utility/Device.vala"
									_g_free0 (_tmp51_);
#line 867 "Utility/Device.vala"
									break;
#line 5922 "Device.c"
								}
#line 855 "Utility/Device.vala"
								case 5:
#line 5926 "Device.c"
								{
									Device* _tmp52_;
									const gchar* _tmp53_;
									gchar* _tmp54_;
									gchar* _tmp55_;
#line 869 "Utility/Device.vala"
									_tmp52_ = pi;
#line 869 "Utility/Device.vala"
									_tmp53_ = val;
#line 869 "Utility/Device.vala"
									_tmp54_ = string_strip (_tmp53_);
#line 869 "Utility/Device.vala"
									_tmp55_ = _tmp54_;
#line 869 "Utility/Device.vala"
									_tmp52_->available_bytes = uint64_parse (_tmp55_);
#line 869 "Utility/Device.vala"
									_g_free0 (_tmp55_);
#line 870 "Utility/Device.vala"
									break;
#line 5946 "Device.c"
								}
#line 855 "Utility/Device.vala"
								case 6:
#line 5950 "Device.c"
								{
									Device* _tmp56_;
									const gchar* _tmp57_;
									gchar* _tmp58_;
#line 872 "Utility/Device.vala"
									_tmp56_ = pi;
#line 872 "Utility/Device.vala"
									_tmp57_ = val;
#line 872 "Utility/Device.vala"
									_tmp58_ = string_strip (_tmp57_);
#line 872 "Utility/Device.vala"
									_g_free0 (_tmp56_->used_percent);
#line 872 "Utility/Device.vala"
									_tmp56_->used_percent = _tmp58_;
#line 873 "Utility/Device.vala"
									break;
#line 5967 "Device.c"
								}
#line 855 "Utility/Device.vala"
								case 7:
#line 5971 "Device.c"
								{
#line 879 "Utility/Device.vala"
									break;
#line 5975 "Device.c"
								}
								default:
#line 855 "Utility/Device.vala"
								break;
#line 5980 "Device.c"
							}
#line 851 "Utility/Device.vala"
							_g_free0 (val);
#line 5984 "Device.c"
						}
					}
#line 851 "Utility/Device.vala"
					val_collection = (_vala_array_free (val_collection, val_collection_length1, (GDestroyNotify) g_free), NULL);
#line 5989 "Device.c"
				}
#line 892 "Utility/Device.vala"
				_tmp59_ = pi;
#line 892 "Utility/Device.vala"
				_tmp60_ = pi;
#line 892 "Utility/Device.vala"
				_tmp61_ = _tmp60_->device;
#line 892 "Utility/Device.vala"
				_tmp62_ = device_resolve_device_name (_tmp61_);
#line 892 "Utility/Device.vala"
				_g_free0 (_tmp59_->device);
#line 892 "Utility/Device.vala"
				_tmp59_->device = _tmp62_;
#line 896 "Utility/Device.vala"
				_tmp63_ = pi;
#line 896 "Utility/Device.vala"
				_tmp64_ = pi;
#line 896 "Utility/Device.vala"
				_tmp65_ = _tmp64_->device;
#line 896 "Utility/Device.vala"
				_tmp66_ = device_get_device_uuid (_tmp65_);
#line 896 "Utility/Device.vala"
				_g_free0 (_tmp63_->uuid);
#line 896 "Utility/Device.vala"
				_tmp63_->uuid = _tmp66_;
#line 900 "Utility/Device.vala"
				_tmp67_ = pi;
#line 900 "Utility/Device.vala"
				_tmp68_ = _tmp67_->uuid;
#line 900 "Utility/Device.vala"
				_tmp69_ = strlen (_tmp68_);
#line 900 "Utility/Device.vala"
				_tmp70_ = _tmp69_;
#line 900 "Utility/Device.vala"
				if (_tmp70_ > 0) {
#line 6025 "Device.c"
					GeeArrayList* _tmp71_;
					Device* _tmp72_;
#line 901 "Utility/Device.vala"
					_tmp71_ = list;
#line 901 "Utility/Device.vala"
					_tmp72_ = pi;
#line 901 "Utility/Device.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp71_, _tmp72_);
#line 6034 "Device.c"
				}
#line 841 "Utility/Device.vala"
				_g_object_unref0 (pi);
#line 841 "Utility/Device.vala"
				_g_free0 (line);
#line 6040 "Device.c"
			}
		}
	}
#line 905 "Utility/Device.vala"
	_tmp73_ = list;
#line 905 "Utility/Device.vala"
	_tmp74_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp73_);
#line 905 "Utility/Device.vala"
	_tmp75_ = _tmp74_;
#line 905 "Utility/Device.vala"
	_tmp76_ = g_strdup_printf ("Device: get_disk_space_using_df(): %d", _tmp75_);
#line 905 "Utility/Device.vala"
	_tmp77_ = _tmp76_;
#line 905 "Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp77_);
#line 905 "Utility/Device.vala"
	_g_free0 (_tmp77_);
#line 907 "Utility/Device.vala"
	result = list;
#line 907 "Utility/Device.vala"
	lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 907 "Utility/Device.vala"
	_g_free0 (cmd);
#line 907 "Utility/Device.vala"
	_g_free0 (std_err);
#line 907 "Utility/Device.vala"
	_g_free0 (std_out);
#line 907 "Utility/Device.vala"
	return result;
#line 6070 "Device.c"
}

GeeArrayList*
device_get_mounted_filesystems_using_mtab (void)
{
	GeeArrayList* result = NULL;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	gchar* mtab_path = NULL;
	gchar* _tmp1_;
	gchar* mtab_lines = NULL;
	gchar* _tmp2_;
	GFile* f = NULL;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	GFile* _tmp5_;
	GFile* _tmp6_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	gchar** lines = NULL;
	const gchar* _tmp17_;
	gchar** _tmp18_;
	gchar** _tmp19_;
	gint lines_length1;
	gint _lines_size_;
	GeeArrayList* mount_list = NULL;
	GeeArrayList* _tmp20_;
	GeeArrayList* _tmp99_;
	gint _tmp100_;
	gint _tmp101_;
	gchar* _tmp102_;
	gchar* _tmp103_;
#line 915 "Utility/Device.vala"
	_tmp0_ = gee_array_list_new (TYPE_DEVICE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 915 "Utility/Device.vala"
	list = _tmp0_;
#line 917 "Utility/Device.vala"
	_tmp1_ = g_strdup ("/etc/mtab");
#line 917 "Utility/Device.vala"
	mtab_path = _tmp1_;
#line 918 "Utility/Device.vala"
	_tmp2_ = g_strdup ("");
#line 918 "Utility/Device.vala"
	mtab_lines = _tmp2_;
#line 924 "Utility/Device.vala"
	_tmp3_ = g_strdup ("/proc/mounts");
#line 924 "Utility/Device.vala"
	_g_free0 (mtab_path);
#line 924 "Utility/Device.vala"
	mtab_path = _tmp3_;
#line 925 "Utility/Device.vala"
	_tmp4_ = mtab_path;
#line 925 "Utility/Device.vala"
	_tmp5_ = g_file_new_for_path (_tmp4_);
#line 925 "Utility/Device.vala"
	_g_object_unref0 (f);
#line 925 "Utility/Device.vala"
	f = _tmp5_;
#line 926 "Utility/Device.vala"
	_tmp6_ = f;
#line 926 "Utility/Device.vala"
	if (!g_file_query_exists (_tmp6_, NULL)) {
#line 6133 "Device.c"
		gchar* _tmp7_;
		const gchar* _tmp8_;
		GFile* _tmp9_;
		GFile* _tmp10_;
#line 927 "Utility/Device.vala"
		_tmp7_ = g_strdup ("/proc/self/mounts");
#line 927 "Utility/Device.vala"
		_g_free0 (mtab_path);
#line 927 "Utility/Device.vala"
		mtab_path = _tmp7_;
#line 928 "Utility/Device.vala"
		_tmp8_ = mtab_path;
#line 928 "Utility/Device.vala"
		_tmp9_ = g_file_new_for_path (_tmp8_);
#line 928 "Utility/Device.vala"
		_g_object_unref0 (f);
#line 928 "Utility/Device.vala"
		f = _tmp9_;
#line 929 "Utility/Device.vala"
		_tmp10_ = f;
#line 929 "Utility/Device.vala"
		if (!g_file_query_exists (_tmp10_, NULL)) {
#line 6156 "Device.c"
			gchar* _tmp11_;
			const gchar* _tmp12_;
			GFile* _tmp13_;
			GFile* _tmp14_;
#line 930 "Utility/Device.vala"
			_tmp11_ = g_strdup ("/etc/mtab");
#line 930 "Utility/Device.vala"
			_g_free0 (mtab_path);
#line 930 "Utility/Device.vala"
			mtab_path = _tmp11_;
#line 931 "Utility/Device.vala"
			_tmp12_ = mtab_path;
#line 931 "Utility/Device.vala"
			_tmp13_ = g_file_new_for_path (_tmp12_);
#line 931 "Utility/Device.vala"
			_g_object_unref0 (f);
#line 931 "Utility/Device.vala"
			f = _tmp13_;
#line 932 "Utility/Device.vala"
			_tmp14_ = f;
#line 932 "Utility/Device.vala"
			if (!g_file_query_exists (_tmp14_, NULL)) {
#line 933 "Utility/Device.vala"
				result = list;
#line 933 "Utility/Device.vala"
				_g_object_unref0 (f);
#line 933 "Utility/Device.vala"
				_g_free0 (mtab_lines);
#line 933 "Utility/Device.vala"
				_g_free0 (mtab_path);
#line 933 "Utility/Device.vala"
				return result;
#line 6189 "Device.c"
			}
		}
	}
#line 946 "Utility/Device.vala"
	_tmp15_ = mtab_path;
#line 946 "Utility/Device.vala"
	_tmp16_ = tee_jee_file_system_file_read (_tmp15_);
#line 946 "Utility/Device.vala"
	_g_free0 (mtab_lines);
#line 946 "Utility/Device.vala"
	mtab_lines = _tmp16_;
#line 975 "Utility/Device.vala"
	_tmp17_ = mtab_lines;
#line 975 "Utility/Device.vala"
	_tmp19_ = _tmp18_ = g_strsplit (_tmp17_, "\n", 0);
#line 975 "Utility/Device.vala"
	lines = _tmp19_;
#line 975 "Utility/Device.vala"
	lines_length1 = _vala_array_length (_tmp18_);
#line 975 "Utility/Device.vala"
	_lines_size_ = lines_length1;
#line 976 "Utility/Device.vala"
	_tmp20_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 976 "Utility/Device.vala"
	mount_list = _tmp20_;
#line 6215 "Device.c"
	{
		gint i = 0;
		gchar** _tmp21_;
		gint _tmp21__length1;
#line 978 "Utility/Device.vala"
		_tmp21_ = lines;
#line 978 "Utility/Device.vala"
		_tmp21__length1 = lines_length1;
#line 978 "Utility/Device.vala"
		i = _tmp21__length1 - 1;
#line 6226 "Device.c"
		{
			gboolean _tmp22_ = FALSE;
#line 978 "Utility/Device.vala"
			_tmp22_ = TRUE;
#line 978 "Utility/Device.vala"
			while (TRUE) {
#line 6233 "Device.c"
				gboolean ignoreEntry = FALSE;
				gchar* line = NULL;
				gchar** _tmp24_;
				gint _tmp24__length1;
				const gchar* _tmp25_;
				gchar* _tmp26_;
				const gchar* _tmp27_;
				gint _tmp28_;
				gint _tmp29_;
				Device* pi = NULL;
				Device* _tmp30_;
				MountEntry* mp = NULL;
				Device* _tmp31_;
				MountEntry* _tmp32_;
				gint k = 0;
				const gchar* _tmp33_;
				gchar** _tmp34_;
				gchar** _tmp35_;
				Device* _tmp69_;
				Device* _tmp70_;
				const gchar* _tmp71_;
				gchar* _tmp72_;
				Device* _tmp73_;
				Device* _tmp74_;
				const gchar* _tmp75_;
				gchar* _tmp76_;
				Device* _tmp77_;
				const gchar* _tmp78_;
				gint _tmp79_;
				gint _tmp80_;
#line 978 "Utility/Device.vala"
				if (!_tmp22_) {
#line 6266 "Device.c"
					gint _tmp23_;
#line 978 "Utility/Device.vala"
					_tmp23_ = i;
#line 978 "Utility/Device.vala"
					i = _tmp23_ - 1;
#line 6272 "Device.c"
				}
#line 978 "Utility/Device.vala"
				_tmp22_ = FALSE;
#line 978 "Utility/Device.vala"
				if (!(i >= 0)) {
#line 978 "Utility/Device.vala"
					break;
#line 6280 "Device.c"
				}
#line 980 "Utility/Device.vala"
				ignoreEntry = FALSE;
#line 982 "Utility/Device.vala"
				_tmp24_ = lines;
#line 982 "Utility/Device.vala"
				_tmp24__length1 = lines_length1;
#line 982 "Utility/Device.vala"
				_tmp25_ = _tmp24_[i];
#line 982 "Utility/Device.vala"
				_tmp26_ = string_strip (_tmp25_);
#line 982 "Utility/Device.vala"
				line = _tmp26_;
#line 983 "Utility/Device.vala"
				_tmp27_ = line;
#line 983 "Utility/Device.vala"
				_tmp28_ = strlen (_tmp27_);
#line 983 "Utility/Device.vala"
				_tmp29_ = _tmp28_;
#line 983 "Utility/Device.vala"
				if (_tmp29_ == 0) {
#line 983 "Utility/Device.vala"
					_g_free0 (line);
#line 983 "Utility/Device.vala"
					continue;
#line 6306 "Device.c"
				}
#line 985 "Utility/Device.vala"
				_tmp30_ = device_new ();
#line 985 "Utility/Device.vala"
				pi = _tmp30_;
#line 987 "Utility/Device.vala"
				_tmp31_ = pi;
#line 987 "Utility/Device.vala"
				_tmp32_ = mount_entry_new (_tmp31_, "", "");
#line 987 "Utility/Device.vala"
				mp = _tmp32_;
#line 991 "Utility/Device.vala"
				k = 1;
#line 992 "Utility/Device.vala"
				_tmp33_ = line;
#line 992 "Utility/Device.vala"
				_tmp35_ = _tmp34_ = g_strsplit (_tmp33_, " ", 0);
#line 6324 "Device.c"
				{
					gchar** val_collection = NULL;
					gint val_collection_length1 = 0;
					gint _val_collection_size_ = 0;
					gint val_it = 0;
#line 992 "Utility/Device.vala"
					val_collection = _tmp35_;
#line 992 "Utility/Device.vala"
					val_collection_length1 = _vala_array_length (_tmp34_);
#line 992 "Utility/Device.vala"
					for (val_it = 0; val_it < _vala_array_length (_tmp34_); val_it = val_it + 1) {
#line 6336 "Device.c"
						gchar* _tmp36_;
						gchar* val = NULL;
#line 992 "Utility/Device.vala"
						_tmp36_ = g_strdup (val_collection[val_it]);
#line 992 "Utility/Device.vala"
						val = _tmp36_;
#line 6343 "Device.c"
						{
							const gchar* _tmp37_;
							gchar* _tmp38_;
							gchar* _tmp39_;
							gint _tmp40_;
							gint _tmp41_;
							gboolean _tmp42_;
							gint _tmp43_;
#line 993 "Utility/Device.vala"
							_tmp37_ = val;
#line 993 "Utility/Device.vala"
							_tmp38_ = string_strip (_tmp37_);
#line 993 "Utility/Device.vala"
							_tmp39_ = _tmp38_;
#line 993 "Utility/Device.vala"
							_tmp40_ = strlen (_tmp39_);
#line 993 "Utility/Device.vala"
							_tmp41_ = _tmp40_;
#line 993 "Utility/Device.vala"
							_tmp42_ = _tmp41_ == 0;
#line 993 "Utility/Device.vala"
							_g_free0 (_tmp39_);
#line 993 "Utility/Device.vala"
							if (_tmp42_) {
#line 993 "Utility/Device.vala"
								_g_free0 (val);
#line 993 "Utility/Device.vala"
								continue;
#line 6372 "Device.c"
							}
#line 994 "Utility/Device.vala"
							if (ignoreEntry) {
#line 994 "Utility/Device.vala"
								_g_free0 (val);
#line 994 "Utility/Device.vala"
								break;
#line 6380 "Device.c"
							}
#line 995 "Utility/Device.vala"
							_tmp43_ = k;
#line 995 "Utility/Device.vala"
							k = _tmp43_ + 1;
#line 995 "Utility/Device.vala"
							switch (_tmp43_) {
#line 995 "Utility/Device.vala"
								case 1:
#line 6390 "Device.c"
								{
									Device* _tmp44_;
									const gchar* _tmp45_;
									gchar* _tmp46_;
#line 997 "Utility/Device.vala"
									_tmp44_ = pi;
#line 997 "Utility/Device.vala"
									_tmp45_ = val;
#line 997 "Utility/Device.vala"
									_tmp46_ = string_strip (_tmp45_);
#line 997 "Utility/Device.vala"
									_g_free0 (_tmp44_->device);
#line 997 "Utility/Device.vala"
									_tmp44_->device = _tmp46_;
#line 998 "Utility/Device.vala"
									break;
#line 6407 "Device.c"
								}
#line 995 "Utility/Device.vala"
								case 2:
#line 6411 "Device.c"
								{
									MountEntry* _tmp47_;
									const gchar* _tmp48_;
									gchar* _tmp49_;
									gchar* _tmp50_;
									gchar* _tmp51_;
									MountEntry* _tmp52_;
									const gchar* _tmp53_;
									GeeArrayList* _tmp54_;
									MountEntry* _tmp55_;
									const gchar* _tmp56_;
#line 1000 "Utility/Device.vala"
									_tmp47_ = mp;
#line 1000 "Utility/Device.vala"
									_tmp48_ = val;
#line 1000 "Utility/Device.vala"
									_tmp49_ = string_strip (_tmp48_);
#line 1000 "Utility/Device.vala"
									_tmp50_ = _tmp49_;
#line 1000 "Utility/Device.vala"
									_tmp51_ = string_replace (_tmp50_, "\\040", " ");
#line 1000 "Utility/Device.vala"
									_g_free0 (_tmp47_->mount_point);
#line 1000 "Utility/Device.vala"
									_tmp47_->mount_point = _tmp51_;
#line 1000 "Utility/Device.vala"
									_g_free0 (_tmp50_);
#line 1003 "Utility/Device.vala"
									_tmp52_ = mp;
#line 1003 "Utility/Device.vala"
									_tmp53_ = _tmp52_->mount_point;
#line 1003 "Utility/Device.vala"
									if (string_contains (_tmp53_, "/docker")) {
#line 1004 "Utility/Device.vala"
										ignoreEntry = TRUE;
#line 1005 "Utility/Device.vala"
										break;
#line 6449 "Device.c"
									}
#line 1008 "Utility/Device.vala"
									_tmp54_ = mount_list;
#line 1008 "Utility/Device.vala"
									_tmp55_ = mp;
#line 1008 "Utility/Device.vala"
									_tmp56_ = _tmp55_->mount_point;
#line 1008 "Utility/Device.vala"
									if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp54_, _tmp56_)) {
#line 6459 "Device.c"
										GeeArrayList* _tmp57_;
										MountEntry* _tmp58_;
										const gchar* _tmp59_;
										Device* _tmp60_;
										GeeArrayList* _tmp61_;
										MountEntry* _tmp62_;
#line 1009 "Utility/Device.vala"
										_tmp57_ = mount_list;
#line 1009 "Utility/Device.vala"
										_tmp58_ = mp;
#line 1009 "Utility/Device.vala"
										_tmp59_ = _tmp58_->mount_point;
#line 1009 "Utility/Device.vala"
										gee_abstract_collection_add ((GeeAbstractCollection*) _tmp57_, _tmp59_);
#line 1010 "Utility/Device.vala"
										_tmp60_ = pi;
#line 1010 "Utility/Device.vala"
										_tmp61_ = _tmp60_->mount_points;
#line 1010 "Utility/Device.vala"
										_tmp62_ = mp;
#line 1010 "Utility/Device.vala"
										gee_abstract_collection_add ((GeeAbstractCollection*) _tmp61_, _tmp62_);
#line 6482 "Device.c"
									}
#line 1012 "Utility/Device.vala"
									break;
#line 6486 "Device.c"
								}
#line 995 "Utility/Device.vala"
								case 3:
#line 6490 "Device.c"
								{
									Device* _tmp63_;
									const gchar* _tmp64_;
									gchar* _tmp65_;
#line 1014 "Utility/Device.vala"
									_tmp63_ = pi;
#line 1014 "Utility/Device.vala"
									_tmp64_ = val;
#line 1014 "Utility/Device.vala"
									_tmp65_ = string_strip (_tmp64_);
#line 1014 "Utility/Device.vala"
									_g_free0 (_tmp63_->fstype);
#line 1014 "Utility/Device.vala"
									_tmp63_->fstype = _tmp65_;
#line 1015 "Utility/Device.vala"
									break;
#line 6507 "Device.c"
								}
#line 995 "Utility/Device.vala"
								case 4:
#line 6511 "Device.c"
								{
									MountEntry* _tmp66_;
									const gchar* _tmp67_;
									gchar* _tmp68_;
#line 1017 "Utility/Device.vala"
									_tmp66_ = mp;
#line 1017 "Utility/Device.vala"
									_tmp67_ = val;
#line 1017 "Utility/Device.vala"
									_tmp68_ = string_strip (_tmp67_);
#line 1017 "Utility/Device.vala"
									_g_free0 (_tmp66_->mount_options);
#line 1017 "Utility/Device.vala"
									_tmp66_->mount_options = _tmp68_;
#line 1018 "Utility/Device.vala"
									break;
#line 6528 "Device.c"
								}
								default:
								{
#line 1021 "Utility/Device.vala"
									break;
#line 6534 "Device.c"
								}
							}
#line 992 "Utility/Device.vala"
							_g_free0 (val);
#line 6539 "Device.c"
						}
					}
#line 992 "Utility/Device.vala"
					val_collection = (_vala_array_free (val_collection, val_collection_length1, (GDestroyNotify) g_free), NULL);
#line 6544 "Device.c"
				}
#line 1025 "Utility/Device.vala"
				if (ignoreEntry) {
#line 1025 "Utility/Device.vala"
					_g_object_unref0 (mp);
#line 1025 "Utility/Device.vala"
					_g_object_unref0 (pi);
#line 1025 "Utility/Device.vala"
					_g_free0 (line);
#line 1025 "Utility/Device.vala"
					continue;
#line 6556 "Device.c"
				}
#line 1029 "Utility/Device.vala"
				_tmp69_ = pi;
#line 1029 "Utility/Device.vala"
				_tmp70_ = pi;
#line 1029 "Utility/Device.vala"
				_tmp71_ = _tmp70_->device;
#line 1029 "Utility/Device.vala"
				_tmp72_ = device_resolve_device_name (_tmp71_);
#line 1029 "Utility/Device.vala"
				_g_free0 (_tmp69_->device);
#line 1029 "Utility/Device.vala"
				_tmp69_->device = _tmp72_;
#line 1033 "Utility/Device.vala"
				_tmp73_ = pi;
#line 1033 "Utility/Device.vala"
				_tmp74_ = pi;
#line 1033 "Utility/Device.vala"
				_tmp75_ = _tmp74_->device;
#line 1033 "Utility/Device.vala"
				_tmp76_ = device_get_device_uuid (_tmp75_);
#line 1033 "Utility/Device.vala"
				_g_free0 (_tmp73_->uuid);
#line 1033 "Utility/Device.vala"
				_tmp73_->uuid = _tmp76_;
#line 1037 "Utility/Device.vala"
				_tmp77_ = pi;
#line 1037 "Utility/Device.vala"
				_tmp78_ = _tmp77_->uuid;
#line 1037 "Utility/Device.vala"
				_tmp79_ = strlen (_tmp78_);
#line 1037 "Utility/Device.vala"
				_tmp80_ = _tmp79_;
#line 1037 "Utility/Device.vala"
				if (_tmp80_ > 0) {
#line 6592 "Device.c"
					Device* dev = NULL;
					GeeArrayList* _tmp81_;
					Device* _tmp82_;
					const gchar* _tmp83_;
					Device* _tmp84_;
					Device* _tmp85_;
#line 1038 "Utility/Device.vala"
					_tmp81_ = list;
#line 1038 "Utility/Device.vala"
					_tmp82_ = pi;
#line 1038 "Utility/Device.vala"
					_tmp83_ = _tmp82_->uuid;
#line 1038 "Utility/Device.vala"
					_tmp84_ = device_find_device_in_list (_tmp81_, _tmp83_);
#line 1038 "Utility/Device.vala"
					dev = _tmp84_;
#line 1039 "Utility/Device.vala"
					_tmp85_ = dev;
#line 1039 "Utility/Device.vala"
					if (_tmp85_ == NULL) {
#line 6613 "Device.c"
						GeeArrayList* _tmp86_;
						Device* _tmp87_;
#line 1040 "Utility/Device.vala"
						_tmp86_ = list;
#line 1040 "Utility/Device.vala"
						_tmp87_ = pi;
#line 1040 "Utility/Device.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp86_, _tmp87_);
#line 6622 "Device.c"
					} else {
						{
							GeeArrayList* _item_list = NULL;
							Device* _tmp88_;
							GeeArrayList* _tmp89_;
							GeeArrayList* _tmp90_;
							gint _item_size = 0;
							GeeArrayList* _tmp91_;
							gint _tmp92_;
							gint _tmp93_;
							gint _item_index = 0;
#line 1044 "Utility/Device.vala"
							_tmp88_ = pi;
#line 1044 "Utility/Device.vala"
							_tmp89_ = _tmp88_->mount_points;
#line 1044 "Utility/Device.vala"
							_tmp90_ = _g_object_ref0 (_tmp89_);
#line 1044 "Utility/Device.vala"
							_item_list = _tmp90_;
#line 1044 "Utility/Device.vala"
							_tmp91_ = _item_list;
#line 1044 "Utility/Device.vala"
							_tmp92_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp91_);
#line 1044 "Utility/Device.vala"
							_tmp93_ = _tmp92_;
#line 1044 "Utility/Device.vala"
							_item_size = _tmp93_;
#line 1044 "Utility/Device.vala"
							_item_index = -1;
#line 1044 "Utility/Device.vala"
							while (TRUE) {
#line 6654 "Device.c"
								MountEntry* item = NULL;
								GeeArrayList* _tmp94_;
								gpointer _tmp95_;
								Device* _tmp96_;
								GeeArrayList* _tmp97_;
								MountEntry* _tmp98_;
#line 1044 "Utility/Device.vala"
								_item_index = _item_index + 1;
#line 1044 "Utility/Device.vala"
								if (!(_item_index < _item_size)) {
#line 1044 "Utility/Device.vala"
									break;
#line 6667 "Device.c"
								}
#line 1044 "Utility/Device.vala"
								_tmp94_ = _item_list;
#line 1044 "Utility/Device.vala"
								_tmp95_ = gee_abstract_list_get ((GeeAbstractList*) _tmp94_, _item_index);
#line 1044 "Utility/Device.vala"
								item = (MountEntry*) _tmp95_;
#line 1045 "Utility/Device.vala"
								_tmp96_ = dev;
#line 1045 "Utility/Device.vala"
								_tmp97_ = _tmp96_->mount_points;
#line 1045 "Utility/Device.vala"
								_tmp98_ = item;
#line 1045 "Utility/Device.vala"
								gee_abstract_collection_add ((GeeAbstractCollection*) _tmp97_, _tmp98_);
#line 1044 "Utility/Device.vala"
								_g_object_unref0 (item);
#line 6685 "Device.c"
							}
#line 1044 "Utility/Device.vala"
							_g_object_unref0 (_item_list);
#line 6689 "Device.c"
						}
					}
#line 1037 "Utility/Device.vala"
					_g_object_unref0 (dev);
#line 6694 "Device.c"
				}
#line 978 "Utility/Device.vala"
				_g_object_unref0 (mp);
#line 978 "Utility/Device.vala"
				_g_object_unref0 (pi);
#line 978 "Utility/Device.vala"
				_g_free0 (line);
#line 6702 "Device.c"
			}
		}
	}
#line 1051 "Utility/Device.vala"
	_tmp99_ = list;
#line 1051 "Utility/Device.vala"
	_tmp100_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp99_);
#line 1051 "Utility/Device.vala"
	_tmp101_ = _tmp100_;
#line 1051 "Utility/Device.vala"
	_tmp102_ = g_strdup_printf ("Device: get_mounted_filesystems_using_mtab(): %d", _tmp101_);
#line 1051 "Utility/Device.vala"
	_tmp103_ = _tmp102_;
#line 1051 "Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp103_);
#line 1051 "Utility/Device.vala"
	_g_free0 (_tmp103_);
#line 1053 "Utility/Device.vala"
	result = list;
#line 1053 "Utility/Device.vala"
	_g_object_unref0 (mount_list);
#line 1053 "Utility/Device.vala"
	lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 1053 "Utility/Device.vala"
	_g_object_unref0 (f);
#line 1053 "Utility/Device.vala"
	_g_free0 (mtab_lines);
#line 1053 "Utility/Device.vala"
	_g_free0 (mtab_path);
#line 1053 "Utility/Device.vala"
	return result;
#line 6734 "Device.c"
}

Device*
device_get_device_by_uuid (const gchar* uuid)
{
	Device* result = NULL;
	GeeArrayList* _tmp0_;
	Device* _tmp1_;
#line 1058 "Utility/Device.vala"
	g_return_val_if_fail (uuid != NULL, NULL);
#line 1060 "Utility/Device.vala"
	_tmp0_ = device_device_list;
#line 1060 "Utility/Device.vala"
	_tmp1_ = device_find_device_in_list (_tmp0_, uuid);
#line 1060 "Utility/Device.vala"
	result = _tmp1_;
#line 1060 "Utility/Device.vala"
	return result;
#line 6753 "Device.c"
}

Device*
device_get_device_by_name (const gchar* file_name)
{
	Device* result = NULL;
	GeeArrayList* _tmp0_;
	Device* _tmp1_;
#line 1063 "Utility/Device.vala"
	g_return_val_if_fail (file_name != NULL, NULL);
#line 1065 "Utility/Device.vala"
	_tmp0_ = device_device_list;
#line 1065 "Utility/Device.vala"
	_tmp1_ = device_find_device_in_list (_tmp0_, file_name);
#line 1065 "Utility/Device.vala"
	result = _tmp1_;
#line 1065 "Utility/Device.vala"
	return result;
#line 6772 "Device.c"
}

Device*
device_get_device_by_path (const gchar* path_to_check)
{
	Device* result = NULL;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 1068 "Utility/Device.vala"
	g_return_val_if_fail (path_to_check != NULL, NULL);
#line 1070 "Utility/Device.vala"
	_tmp0_ = device_get_disk_space_using_df (path_to_check);
#line 1070 "Utility/Device.vala"
	list = _tmp0_;
#line 1072 "Utility/Device.vala"
	_tmp1_ = list;
#line 1072 "Utility/Device.vala"
	_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 1072 "Utility/Device.vala"
	_tmp3_ = _tmp2_;
#line 1072 "Utility/Device.vala"
	if (_tmp3_ > 0) {
#line 6798 "Device.c"
		GeeArrayList* _tmp4_;
		gpointer _tmp5_;
#line 1073 "Utility/Device.vala"
		_tmp4_ = list;
#line 1073 "Utility/Device.vala"
		_tmp5_ = gee_abstract_list_get ((GeeAbstractList*) _tmp4_, 0);
#line 1073 "Utility/Device.vala"
		result = (Device*) _tmp5_;
#line 1073 "Utility/Device.vala"
		_g_object_unref0 (list);
#line 1073 "Utility/Device.vala"
		return result;
#line 6811 "Device.c"
	}
#line 1076 "Utility/Device.vala"
	result = NULL;
#line 1076 "Utility/Device.vala"
	_g_object_unref0 (list);
#line 1076 "Utility/Device.vala"
	return result;
#line 6819 "Device.c"
}

gchar*
device_get_device_uuid (const gchar* device)
{
	gchar* result = NULL;
	GeeArrayList* _tmp0_;
	gchar* _tmp14_;
#line 1079 "Utility/Device.vala"
	g_return_val_if_fail (device != NULL, NULL);
#line 1081 "Utility/Device.vala"
	_tmp0_ = device_device_list;
#line 1081 "Utility/Device.vala"
	if (_tmp0_ == NULL) {
#line 6834 "Device.c"
		GeeArrayList* _tmp1_;
#line 1082 "Utility/Device.vala"
		_tmp1_ = device_get_block_devices_using_lsblk ("");
#line 1082 "Utility/Device.vala"
		_g_object_unref0 (device_device_list);
#line 1082 "Utility/Device.vala"
		device_device_list = _tmp1_;
#line 6842 "Device.c"
	}
	{
		GeeArrayList* _dev_list = NULL;
		GeeArrayList* _tmp2_;
		GeeArrayList* _tmp3_;
		gint _dev_size = 0;
		GeeArrayList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _dev_index = 0;
#line 1084 "Utility/Device.vala"
		_tmp2_ = device_device_list;
#line 1084 "Utility/Device.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 1084 "Utility/Device.vala"
		_dev_list = _tmp3_;
#line 1084 "Utility/Device.vala"
		_tmp4_ = _dev_list;
#line 1084 "Utility/Device.vala"
		_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 1084 "Utility/Device.vala"
		_tmp6_ = _tmp5_;
#line 1084 "Utility/Device.vala"
		_dev_size = _tmp6_;
#line 1084 "Utility/Device.vala"
		_dev_index = -1;
#line 1084 "Utility/Device.vala"
		while (TRUE) {
#line 6871 "Device.c"
			Device* dev = NULL;
			GeeArrayList* _tmp7_;
			gpointer _tmp8_;
			Device* _tmp9_;
			const gchar* _tmp10_;
#line 1084 "Utility/Device.vala"
			_dev_index = _dev_index + 1;
#line 1084 "Utility/Device.vala"
			if (!(_dev_index < _dev_size)) {
#line 1084 "Utility/Device.vala"
				break;
#line 6883 "Device.c"
			}
#line 1084 "Utility/Device.vala"
			_tmp7_ = _dev_list;
#line 1084 "Utility/Device.vala"
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _dev_index);
#line 1084 "Utility/Device.vala"
			dev = (Device*) _tmp8_;
#line 1085 "Utility/Device.vala"
			_tmp9_ = dev;
#line 1085 "Utility/Device.vala"
			_tmp10_ = _tmp9_->device;
#line 1085 "Utility/Device.vala"
			if (g_strcmp0 (_tmp10_, device) == 0) {
#line 6897 "Device.c"
				Device* _tmp11_;
				const gchar* _tmp12_;
				gchar* _tmp13_;
#line 1086 "Utility/Device.vala"
				_tmp11_ = dev;
#line 1086 "Utility/Device.vala"
				_tmp12_ = _tmp11_->uuid;
#line 1086 "Utility/Device.vala"
				_tmp13_ = g_strdup (_tmp12_);
#line 1086 "Utility/Device.vala"
				result = _tmp13_;
#line 1086 "Utility/Device.vala"
				_g_object_unref0 (dev);
#line 1086 "Utility/Device.vala"
				_g_object_unref0 (_dev_list);
#line 1086 "Utility/Device.vala"
				return result;
#line 6915 "Device.c"
			}
#line 1084 "Utility/Device.vala"
			_g_object_unref0 (dev);
#line 6919 "Device.c"
		}
#line 1084 "Utility/Device.vala"
		_g_object_unref0 (_dev_list);
#line 6923 "Device.c"
	}
#line 1090 "Utility/Device.vala"
	_tmp14_ = g_strdup ("");
#line 1090 "Utility/Device.vala"
	result = _tmp14_;
#line 1090 "Utility/Device.vala"
	return result;
#line 6931 "Device.c"
}

GeeArrayList*
device_get_device_mount_points (const gchar* dev_name_or_uuid)
{
	GeeArrayList* result = NULL;
	gchar* device = NULL;
	gchar* _tmp0_;
	gchar* uuid = NULL;
	gchar* _tmp1_;
	GeeArrayList* list_mtab = NULL;
	GeeArrayList* _tmp9_;
	Device* dev = NULL;
	GeeArrayList* _tmp10_;
	const gchar* _tmp11_;
	Device* _tmp12_;
	Device* _tmp13_;
#line 1093 "Utility/Device.vala"
	g_return_val_if_fail (dev_name_or_uuid != NULL, NULL);
#line 1094 "Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1094 "Utility/Device.vala"
	device = _tmp0_;
#line 1095 "Utility/Device.vala"
	_tmp1_ = g_strdup ("");
#line 1095 "Utility/Device.vala"
	uuid = _tmp1_;
#line 1097 "Utility/Device.vala"
	if (g_str_has_prefix (dev_name_or_uuid, "/dev")) {
#line 6961 "Device.c"
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 1098 "Utility/Device.vala"
		_tmp2_ = g_strdup (dev_name_or_uuid);
#line 1098 "Utility/Device.vala"
		_g_free0 (device);
#line 1098 "Utility/Device.vala"
		device = _tmp2_;
#line 1099 "Utility/Device.vala"
		_tmp3_ = device_get_device_uuid (dev_name_or_uuid);
#line 1099 "Utility/Device.vala"
		_g_free0 (uuid);
#line 1099 "Utility/Device.vala"
		uuid = _tmp3_;
#line 6976 "Device.c"
	} else {
		gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
#line 1102 "Utility/Device.vala"
		_tmp4_ = g_strdup (dev_name_or_uuid);
#line 1102 "Utility/Device.vala"
		_g_free0 (uuid);
#line 1102 "Utility/Device.vala"
		uuid = _tmp4_;
#line 1103 "Utility/Device.vala"
		_tmp5_ = uuid;
#line 1103 "Utility/Device.vala"
		_tmp6_ = g_strdup_printf ("/dev/disk/by-uuid/%s", _tmp5_);
#line 1103 "Utility/Device.vala"
		_g_free0 (device);
#line 1103 "Utility/Device.vala"
		device = _tmp6_;
#line 1104 "Utility/Device.vala"
		_tmp7_ = device;
#line 1104 "Utility/Device.vala"
		_tmp8_ = device_resolve_device_name (_tmp7_);
#line 1104 "Utility/Device.vala"
		_g_free0 (device);
#line 1104 "Utility/Device.vala"
		device = _tmp8_;
#line 7005 "Device.c"
	}
#line 1107 "Utility/Device.vala"
	_tmp9_ = device_get_mounted_filesystems_using_mtab ();
#line 1107 "Utility/Device.vala"
	list_mtab = _tmp9_;
#line 1109 "Utility/Device.vala"
	_tmp10_ = list_mtab;
#line 1109 "Utility/Device.vala"
	_tmp11_ = uuid;
#line 1109 "Utility/Device.vala"
	_tmp12_ = device_find_device_in_list (_tmp10_, _tmp11_);
#line 1109 "Utility/Device.vala"
	dev = _tmp12_;
#line 1111 "Utility/Device.vala"
	_tmp13_ = dev;
#line 1111 "Utility/Device.vala"
	if (_tmp13_ != NULL) {
#line 7023 "Device.c"
		Device* _tmp14_;
		GeeArrayList* _tmp15_;
		GeeArrayList* _tmp16_;
#line 1112 "Utility/Device.vala"
		_tmp14_ = dev;
#line 1112 "Utility/Device.vala"
		_tmp15_ = _tmp14_->mount_points;
#line 1112 "Utility/Device.vala"
		_tmp16_ = _g_object_ref0 (_tmp15_);
#line 1112 "Utility/Device.vala"
		result = _tmp16_;
#line 1112 "Utility/Device.vala"
		_g_object_unref0 (dev);
#line 1112 "Utility/Device.vala"
		_g_object_unref0 (list_mtab);
#line 1112 "Utility/Device.vala"
		_g_free0 (uuid);
#line 1112 "Utility/Device.vala"
		_g_free0 (device);
#line 1112 "Utility/Device.vala"
		return result;
#line 7045 "Device.c"
	} else {
		GeeArrayList* _tmp17_;
#line 1115 "Utility/Device.vala"
		_tmp17_ = gee_array_list_new (TYPE_MOUNT_ENTRY, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1115 "Utility/Device.vala"
		result = _tmp17_;
#line 1115 "Utility/Device.vala"
		_g_object_unref0 (dev);
#line 1115 "Utility/Device.vala"
		_g_object_unref0 (list_mtab);
#line 1115 "Utility/Device.vala"
		_g_free0 (uuid);
#line 1115 "Utility/Device.vala"
		_g_free0 (device);
#line 1115 "Utility/Device.vala"
		return result;
#line 7062 "Device.c"
	}
#line 1093 "Utility/Device.vala"
	_g_object_unref0 (dev);
#line 1093 "Utility/Device.vala"
	_g_object_unref0 (list_mtab);
#line 1093 "Utility/Device.vala"
	_g_free0 (uuid);
#line 1093 "Utility/Device.vala"
	_g_free0 (device);
#line 7072 "Device.c"
}

gboolean
device_device_is_mounted (const gchar* dev_name_or_uuid)
{
	gboolean result = FALSE;
	GeeArrayList* mps = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 1119 "Utility/Device.vala"
	g_return_val_if_fail (dev_name_or_uuid != NULL, FALSE);
#line 1121 "Utility/Device.vala"
	_tmp0_ = device_get_device_mount_points (dev_name_or_uuid);
#line 1121 "Utility/Device.vala"
	mps = _tmp0_;
#line 1122 "Utility/Device.vala"
	_tmp1_ = mps;
#line 1122 "Utility/Device.vala"
	_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 1122 "Utility/Device.vala"
	_tmp3_ = _tmp2_;
#line 1122 "Utility/Device.vala"
	if (_tmp3_ > 0) {
#line 1123 "Utility/Device.vala"
		result = TRUE;
#line 1123 "Utility/Device.vala"
		_g_object_unref0 (mps);
#line 1123 "Utility/Device.vala"
		return result;
#line 7104 "Device.c"
	}
#line 1126 "Utility/Device.vala"
	result = FALSE;
#line 1126 "Utility/Device.vala"
	_g_object_unref0 (mps);
#line 1126 "Utility/Device.vala"
	return result;
#line 7112 "Device.c"
}

gboolean
device_mount_point_in_use (const gchar* mount_point)
{
	gboolean result = FALSE;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
#line 1129 "Utility/Device.vala"
	g_return_val_if_fail (mount_point != NULL, FALSE);
#line 1130 "Utility/Device.vala"
	_tmp0_ = device_get_mounted_filesystems_using_mtab ();
#line 1130 "Utility/Device.vala"
	list = _tmp0_;
#line 7127 "Device.c"
	{
		GeeArrayList* _dev_list = NULL;
		GeeArrayList* _tmp1_;
		GeeArrayList* _tmp2_;
		gint _dev_size = 0;
		GeeArrayList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _dev_index = 0;
#line 1131 "Utility/Device.vala"
		_tmp1_ = list;
#line 1131 "Utility/Device.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 1131 "Utility/Device.vala"
		_dev_list = _tmp2_;
#line 1131 "Utility/Device.vala"
		_tmp3_ = _dev_list;
#line 1131 "Utility/Device.vala"
		_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 1131 "Utility/Device.vala"
		_tmp5_ = _tmp4_;
#line 1131 "Utility/Device.vala"
		_dev_size = _tmp5_;
#line 1131 "Utility/Device.vala"
		_dev_index = -1;
#line 1131 "Utility/Device.vala"
		while (TRUE) {
#line 7155 "Device.c"
			Device* dev = NULL;
			GeeArrayList* _tmp6_;
			gpointer _tmp7_;
#line 1131 "Utility/Device.vala"
			_dev_index = _dev_index + 1;
#line 1131 "Utility/Device.vala"
			if (!(_dev_index < _dev_size)) {
#line 1131 "Utility/Device.vala"
				break;
#line 7165 "Device.c"
			}
#line 1131 "Utility/Device.vala"
			_tmp6_ = _dev_list;
#line 1131 "Utility/Device.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _dev_index);
#line 1131 "Utility/Device.vala"
			dev = (Device*) _tmp7_;
#line 7173 "Device.c"
			{
				GeeArrayList* _mp_list = NULL;
				Device* _tmp8_;
				GeeArrayList* _tmp9_;
				GeeArrayList* _tmp10_;
				gint _mp_size = 0;
				GeeArrayList* _tmp11_;
				gint _tmp12_;
				gint _tmp13_;
				gint _mp_index = 0;
#line 1132 "Utility/Device.vala"
				_tmp8_ = dev;
#line 1132 "Utility/Device.vala"
				_tmp9_ = _tmp8_->mount_points;
#line 1132 "Utility/Device.vala"
				_tmp10_ = _g_object_ref0 (_tmp9_);
#line 1132 "Utility/Device.vala"
				_mp_list = _tmp10_;
#line 1132 "Utility/Device.vala"
				_tmp11_ = _mp_list;
#line 1132 "Utility/Device.vala"
				_tmp12_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp11_);
#line 1132 "Utility/Device.vala"
				_tmp13_ = _tmp12_;
#line 1132 "Utility/Device.vala"
				_mp_size = _tmp13_;
#line 1132 "Utility/Device.vala"
				_mp_index = -1;
#line 1132 "Utility/Device.vala"
				while (TRUE) {
#line 7204 "Device.c"
					MountEntry* mp = NULL;
					GeeArrayList* _tmp14_;
					gpointer _tmp15_;
					MountEntry* _tmp16_;
					const gchar* _tmp17_;
#line 1132 "Utility/Device.vala"
					_mp_index = _mp_index + 1;
#line 1132 "Utility/Device.vala"
					if (!(_mp_index < _mp_size)) {
#line 1132 "Utility/Device.vala"
						break;
#line 7216 "Device.c"
					}
#line 1132 "Utility/Device.vala"
					_tmp14_ = _mp_list;
#line 1132 "Utility/Device.vala"
					_tmp15_ = gee_abstract_list_get ((GeeAbstractList*) _tmp14_, _mp_index);
#line 1132 "Utility/Device.vala"
					mp = (MountEntry*) _tmp15_;
#line 1133 "Utility/Device.vala"
					_tmp16_ = mp;
#line 1133 "Utility/Device.vala"
					_tmp17_ = _tmp16_->mount_point;
#line 1133 "Utility/Device.vala"
					if (g_str_has_prefix (_tmp17_, mount_point)) {
#line 1135 "Utility/Device.vala"
						result = TRUE;
#line 1135 "Utility/Device.vala"
						_g_object_unref0 (mp);
#line 1135 "Utility/Device.vala"
						_g_object_unref0 (_mp_list);
#line 1135 "Utility/Device.vala"
						_g_object_unref0 (dev);
#line 1135 "Utility/Device.vala"
						_g_object_unref0 (_dev_list);
#line 1135 "Utility/Device.vala"
						_g_object_unref0 (list);
#line 1135 "Utility/Device.vala"
						return result;
#line 7244 "Device.c"
					}
#line 1132 "Utility/Device.vala"
					_g_object_unref0 (mp);
#line 7248 "Device.c"
				}
#line 1132 "Utility/Device.vala"
				_g_object_unref0 (_mp_list);
#line 7252 "Device.c"
			}
#line 1131 "Utility/Device.vala"
			_g_object_unref0 (dev);
#line 7256 "Device.c"
		}
#line 1131 "Utility/Device.vala"
		_g_object_unref0 (_dev_list);
#line 7260 "Device.c"
	}
#line 1139 "Utility/Device.vala"
	result = FALSE;
#line 1139 "Utility/Device.vala"
	_g_object_unref0 (list);
#line 1139 "Utility/Device.vala"
	return result;
#line 7268 "Device.c"
}

gchar*
device_resolve_device_name (const gchar* dev_alias)
{
	gchar* result = NULL;
	Device* dev = NULL;
	GeeArrayList* _tmp0_;
	Device* _tmp1_;
	Device* _tmp2_;
#line 1142 "Utility/Device.vala"
	g_return_val_if_fail (dev_alias != NULL, NULL);
#line 1144 "Utility/Device.vala"
	_tmp0_ = device_device_list;
#line 1144 "Utility/Device.vala"
	_tmp1_ = device_find_device_in_list (_tmp0_, dev_alias);
#line 1144 "Utility/Device.vala"
	dev = _tmp1_;
#line 1146 "Utility/Device.vala"
	_tmp2_ = dev;
#line 1146 "Utility/Device.vala"
	if (_tmp2_ != NULL) {
#line 7291 "Device.c"
		Device* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
#line 1147 "Utility/Device.vala"
		_tmp3_ = dev;
#line 1147 "Utility/Device.vala"
		_tmp4_ = _tmp3_->device;
#line 1147 "Utility/Device.vala"
		_tmp5_ = g_strdup (_tmp4_);
#line 1147 "Utility/Device.vala"
		result = _tmp5_;
#line 1147 "Utility/Device.vala"
		_g_object_unref0 (dev);
#line 1147 "Utility/Device.vala"
		return result;
#line 7307 "Device.c"
	} else {
		gchar* _tmp6_;
#line 1150 "Utility/Device.vala"
		_tmp6_ = g_strdup (dev_alias);
#line 1150 "Utility/Device.vala"
		result = _tmp6_;
#line 1150 "Utility/Device.vala"
		_g_object_unref0 (dev);
#line 1150 "Utility/Device.vala"
		return result;
#line 7318 "Device.c"
	}
#line 1142 "Utility/Device.vala"
	_g_object_unref0 (dev);
#line 7322 "Device.c"
}

Device*
device_find_device_in_list (GeeArrayList* list,
                            const gchar* _dev_alias)
{
	Device* result = NULL;
	gchar* dev_alias = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_;
#line 1154 "Utility/Device.vala"
	g_return_val_if_fail (list != NULL, NULL);
#line 1154 "Utility/Device.vala"
	g_return_val_if_fail (_dev_alias != NULL, NULL);
#line 1156 "Utility/Device.vala"
	_tmp0_ = g_strdup (_dev_alias);
#line 1156 "Utility/Device.vala"
	dev_alias = _tmp0_;
#line 1158 "Utility/Device.vala"
	_tmp1_ = dev_alias;
#line 1158 "Utility/Device.vala"
	_tmp2_ = g_utf8_strdown (_tmp1_, (gssize) -1);
#line 1158 "Utility/Device.vala"
	_tmp3_ = _tmp2_;
#line 1158 "Utility/Device.vala"
	_tmp4_ = g_str_has_prefix (_tmp3_, "uuid=");
#line 1158 "Utility/Device.vala"
	_g_free0 (_tmp3_);
#line 1158 "Utility/Device.vala"
	if (_tmp4_) {
#line 7356 "Device.c"
		const gchar* _tmp5_;
		gchar** _tmp6_;
		gchar** _tmp7_;
		gchar** _tmp8_;
		gint _tmp8__length1;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
#line 1160 "Utility/Device.vala"
		_tmp5_ = dev_alias;
#line 1160 "Utility/Device.vala"
		_tmp7_ = _tmp6_ = g_strsplit (_tmp5_, "=", 2);
#line 1160 "Utility/Device.vala"
		_tmp8_ = _tmp7_;
#line 1160 "Utility/Device.vala"
		_tmp8__length1 = _vala_array_length (_tmp6_);
#line 1160 "Utility/Device.vala"
		_tmp9_ = _tmp8_[1];
#line 1160 "Utility/Device.vala"
		_tmp10_ = string_strip (_tmp9_);
#line 1160 "Utility/Device.vala"
		_tmp11_ = _tmp10_;
#line 1160 "Utility/Device.vala"
		_tmp12_ = g_utf8_strdown (_tmp11_, (gssize) -1);
#line 1160 "Utility/Device.vala"
		_g_free0 (dev_alias);
#line 1160 "Utility/Device.vala"
		dev_alias = _tmp12_;
#line 1160 "Utility/Device.vala"
		_g_free0 (_tmp11_);
#line 1160 "Utility/Device.vala"
		_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
#line 7390 "Device.c"
	} else {
		gboolean _tmp13_ = FALSE;
		const gchar* _tmp14_;
#line 1162 "Utility/Device.vala"
		_tmp14_ = dev_alias;
#line 1162 "Utility/Device.vala"
		if (tee_jee_file_system_file_exists (_tmp14_)) {
#line 7398 "Device.c"
			const gchar* _tmp15_;
#line 1162 "Utility/Device.vala"
			_tmp15_ = dev_alias;
#line 1162 "Utility/Device.vala"
			_tmp13_ = tee_jee_file_system_file_is_symlink (_tmp15_);
#line 7404 "Device.c"
		} else {
#line 1162 "Utility/Device.vala"
			_tmp13_ = FALSE;
#line 7408 "Device.c"
		}
#line 1162 "Utility/Device.vala"
		if (_tmp13_) {
#line 7412 "Device.c"
			gchar* link_path = NULL;
			const gchar* _tmp16_;
			gchar* _tmp17_;
			const gchar* _tmp18_;
			gchar* _tmp19_;
			gchar* _tmp20_;
			gchar* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
#line 1164 "Utility/Device.vala"
			_tmp16_ = dev_alias;
#line 1164 "Utility/Device.vala"
			_tmp17_ = tee_jee_file_system_file_get_symlink_target (_tmp16_);
#line 1164 "Utility/Device.vala"
			link_path = _tmp17_;
#line 1166 "Utility/Device.vala"
			_tmp18_ = link_path;
#line 1166 "Utility/Device.vala"
			_tmp19_ = string_replace (_tmp18_, "../../../", "/dev/");
#line 1166 "Utility/Device.vala"
			_tmp20_ = _tmp19_;
#line 1166 "Utility/Device.vala"
			_tmp21_ = string_replace (_tmp20_, "../../", "/dev/");
#line 1166 "Utility/Device.vala"
			_tmp22_ = _tmp21_;
#line 1166 "Utility/Device.vala"
			_tmp23_ = string_replace (_tmp22_, "../", "/dev/");
#line 1166 "Utility/Device.vala"
			_g_free0 (dev_alias);
#line 1166 "Utility/Device.vala"
			dev_alias = _tmp23_;
#line 1166 "Utility/Device.vala"
			_g_free0 (_tmp22_);
#line 1166 "Utility/Device.vala"
			_g_free0 (_tmp20_);
#line 1162 "Utility/Device.vala"
			_g_free0 (link_path);
#line 7450 "Device.c"
		}
	}
	{
		GeeArrayList* _dev_list = NULL;
		GeeArrayList* _tmp24_;
		gint _dev_size = 0;
		GeeArrayList* _tmp25_;
		gint _tmp26_;
		gint _tmp27_;
		gint _dev_index = 0;
#line 1169 "Utility/Device.vala"
		_tmp24_ = _g_object_ref0 (list);
#line 1169 "Utility/Device.vala"
		_dev_list = _tmp24_;
#line 1169 "Utility/Device.vala"
		_tmp25_ = _dev_list;
#line 1169 "Utility/Device.vala"
		_tmp26_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp25_);
#line 1169 "Utility/Device.vala"
		_tmp27_ = _tmp26_;
#line 1169 "Utility/Device.vala"
		_dev_size = _tmp27_;
#line 1169 "Utility/Device.vala"
		_dev_index = -1;
#line 1169 "Utility/Device.vala"
		while (TRUE) {
#line 7477 "Device.c"
			Device* dev = NULL;
			GeeArrayList* _tmp28_;
			gpointer _tmp29_;
			Device* _tmp30_;
			const gchar* _tmp31_;
			const gchar* _tmp32_;
#line 1169 "Utility/Device.vala"
			_dev_index = _dev_index + 1;
#line 1169 "Utility/Device.vala"
			if (!(_dev_index < _dev_size)) {
#line 1169 "Utility/Device.vala"
				break;
#line 7490 "Device.c"
			}
#line 1169 "Utility/Device.vala"
			_tmp28_ = _dev_list;
#line 1169 "Utility/Device.vala"
			_tmp29_ = gee_abstract_list_get ((GeeAbstractList*) _tmp28_, _dev_index);
#line 1169 "Utility/Device.vala"
			dev = (Device*) _tmp29_;
#line 1171 "Utility/Device.vala"
			_tmp30_ = dev;
#line 1171 "Utility/Device.vala"
			_tmp31_ = _tmp30_->device;
#line 1171 "Utility/Device.vala"
			_tmp32_ = dev_alias;
#line 1171 "Utility/Device.vala"
			if (g_strcmp0 (_tmp31_, _tmp32_) == 0) {
#line 1172 "Utility/Device.vala"
				result = dev;
#line 1172 "Utility/Device.vala"
				_g_object_unref0 (_dev_list);
#line 1172 "Utility/Device.vala"
				_g_free0 (dev_alias);
#line 1172 "Utility/Device.vala"
				return result;
#line 7514 "Device.c"
			} else {
				Device* _tmp33_;
				const gchar* _tmp34_;
				const gchar* _tmp35_;
#line 1174 "Utility/Device.vala"
				_tmp33_ = dev;
#line 1174 "Utility/Device.vala"
				_tmp34_ = _tmp33_->uuid;
#line 1174 "Utility/Device.vala"
				_tmp35_ = dev_alias;
#line 1174 "Utility/Device.vala"
				if (g_strcmp0 (_tmp34_, _tmp35_) == 0) {
#line 1175 "Utility/Device.vala"
					result = dev;
#line 1175 "Utility/Device.vala"
					_g_object_unref0 (_dev_list);
#line 1175 "Utility/Device.vala"
					_g_free0 (dev_alias);
#line 1175 "Utility/Device.vala"
					return result;
#line 7535 "Device.c"
				} else {
					Device* _tmp36_;
					const gchar* _tmp37_;
					const gchar* _tmp38_;
#line 1177 "Utility/Device.vala"
					_tmp36_ = dev;
#line 1177 "Utility/Device.vala"
					_tmp37_ = _tmp36_->label;
#line 1177 "Utility/Device.vala"
					_tmp38_ = dev_alias;
#line 1177 "Utility/Device.vala"
					if (g_strcmp0 (_tmp37_, _tmp38_) == 0) {
#line 1178 "Utility/Device.vala"
						result = dev;
#line 1178 "Utility/Device.vala"
						_g_object_unref0 (_dev_list);
#line 1178 "Utility/Device.vala"
						_g_free0 (dev_alias);
#line 1178 "Utility/Device.vala"
						return result;
#line 7556 "Device.c"
					} else {
						Device* _tmp39_;
						const gchar* _tmp40_;
						const gchar* _tmp41_;
#line 1180 "Utility/Device.vala"
						_tmp39_ = dev;
#line 1180 "Utility/Device.vala"
						_tmp40_ = _tmp39_->partuuid;
#line 1180 "Utility/Device.vala"
						_tmp41_ = dev_alias;
#line 1180 "Utility/Device.vala"
						if (g_strcmp0 (_tmp40_, _tmp41_) == 0) {
#line 1181 "Utility/Device.vala"
							result = dev;
#line 1181 "Utility/Device.vala"
							_g_object_unref0 (_dev_list);
#line 1181 "Utility/Device.vala"
							_g_free0 (dev_alias);
#line 1181 "Utility/Device.vala"
							return result;
#line 7577 "Device.c"
						} else {
							Device* _tmp42_;
							const gchar* _tmp43_;
							const gchar* _tmp44_;
#line 1183 "Utility/Device.vala"
							_tmp42_ = dev;
#line 1183 "Utility/Device.vala"
							_tmp43_ = _tmp42_->partlabel;
#line 1183 "Utility/Device.vala"
							_tmp44_ = dev_alias;
#line 1183 "Utility/Device.vala"
							if (g_strcmp0 (_tmp43_, _tmp44_) == 0) {
#line 1184 "Utility/Device.vala"
								result = dev;
#line 1184 "Utility/Device.vala"
								_g_object_unref0 (_dev_list);
#line 1184 "Utility/Device.vala"
								_g_free0 (dev_alias);
#line 1184 "Utility/Device.vala"
								return result;
#line 7598 "Device.c"
							} else {
								Device* _tmp45_;
								const gchar* _tmp46_;
								const gchar* _tmp47_;
#line 1186 "Utility/Device.vala"
								_tmp45_ = dev;
#line 1186 "Utility/Device.vala"
								_tmp46_ = _tmp45_->device_by_uuid;
#line 1186 "Utility/Device.vala"
								_tmp47_ = dev_alias;
#line 1186 "Utility/Device.vala"
								if (g_strcmp0 (_tmp46_, _tmp47_) == 0) {
#line 1187 "Utility/Device.vala"
									result = dev;
#line 1187 "Utility/Device.vala"
									_g_object_unref0 (_dev_list);
#line 1187 "Utility/Device.vala"
									_g_free0 (dev_alias);
#line 1187 "Utility/Device.vala"
									return result;
#line 7619 "Device.c"
								} else {
									Device* _tmp48_;
									const gchar* _tmp49_;
									const gchar* _tmp50_;
#line 1189 "Utility/Device.vala"
									_tmp48_ = dev;
#line 1189 "Utility/Device.vala"
									_tmp49_ = _tmp48_->device_by_label;
#line 1189 "Utility/Device.vala"
									_tmp50_ = dev_alias;
#line 1189 "Utility/Device.vala"
									if (g_strcmp0 (_tmp49_, _tmp50_) == 0) {
#line 1190 "Utility/Device.vala"
										result = dev;
#line 1190 "Utility/Device.vala"
										_g_object_unref0 (_dev_list);
#line 1190 "Utility/Device.vala"
										_g_free0 (dev_alias);
#line 1190 "Utility/Device.vala"
										return result;
#line 7640 "Device.c"
									} else {
										Device* _tmp51_;
										const gchar* _tmp52_;
										const gchar* _tmp53_;
#line 1192 "Utility/Device.vala"
										_tmp51_ = dev;
#line 1192 "Utility/Device.vala"
										_tmp52_ = _tmp51_->device_by_partuuid;
#line 1192 "Utility/Device.vala"
										_tmp53_ = dev_alias;
#line 1192 "Utility/Device.vala"
										if (g_strcmp0 (_tmp52_, _tmp53_) == 0) {
#line 1193 "Utility/Device.vala"
											result = dev;
#line 1193 "Utility/Device.vala"
											_g_object_unref0 (_dev_list);
#line 1193 "Utility/Device.vala"
											_g_free0 (dev_alias);
#line 1193 "Utility/Device.vala"
											return result;
#line 7661 "Device.c"
										} else {
											Device* _tmp54_;
											const gchar* _tmp55_;
											const gchar* _tmp56_;
#line 1195 "Utility/Device.vala"
											_tmp54_ = dev;
#line 1195 "Utility/Device.vala"
											_tmp55_ = _tmp54_->device_by_partlabel;
#line 1195 "Utility/Device.vala"
											_tmp56_ = dev_alias;
#line 1195 "Utility/Device.vala"
											if (g_strcmp0 (_tmp55_, _tmp56_) == 0) {
#line 1196 "Utility/Device.vala"
												result = dev;
#line 1196 "Utility/Device.vala"
												_g_object_unref0 (_dev_list);
#line 1196 "Utility/Device.vala"
												_g_free0 (dev_alias);
#line 1196 "Utility/Device.vala"
												return result;
#line 7682 "Device.c"
											} else {
												Device* _tmp57_;
												const gchar* _tmp58_;
												const gchar* _tmp59_;
#line 1198 "Utility/Device.vala"
												_tmp57_ = dev;
#line 1198 "Utility/Device.vala"
												_tmp58_ = _tmp57_->device_mapper;
#line 1198 "Utility/Device.vala"
												_tmp59_ = dev_alias;
#line 1198 "Utility/Device.vala"
												if (g_strcmp0 (_tmp58_, _tmp59_) == 0) {
#line 1199 "Utility/Device.vala"
													result = dev;
#line 1199 "Utility/Device.vala"
													_g_object_unref0 (_dev_list);
#line 1199 "Utility/Device.vala"
													_g_free0 (dev_alias);
#line 1199 "Utility/Device.vala"
													return result;
#line 7703 "Device.c"
												} else {
													Device* _tmp60_;
													const gchar* _tmp61_;
													const gchar* _tmp62_;
#line 1201 "Utility/Device.vala"
													_tmp60_ = dev;
#line 1201 "Utility/Device.vala"
													_tmp61_ = _tmp60_->mapped_name;
#line 1201 "Utility/Device.vala"
													_tmp62_ = dev_alias;
#line 1201 "Utility/Device.vala"
													if (g_strcmp0 (_tmp61_, _tmp62_) == 0) {
#line 1202 "Utility/Device.vala"
														result = dev;
#line 1202 "Utility/Device.vala"
														_g_object_unref0 (_dev_list);
#line 1202 "Utility/Device.vala"
														_g_free0 (dev_alias);
#line 1202 "Utility/Device.vala"
														return result;
#line 7724 "Device.c"
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
#line 1169 "Utility/Device.vala"
			_g_object_unref0 (dev);
#line 7738 "Device.c"
		}
#line 1169 "Utility/Device.vala"
		_g_object_unref0 (_dev_list);
#line 7742 "Device.c"
	}
#line 1206 "Utility/Device.vala"
	result = NULL;
#line 1206 "Utility/Device.vala"
	_g_free0 (dev_alias);
#line 1206 "Utility/Device.vala"
	return result;
#line 7750 "Device.c"
}

void
device_copy_fields_from (Device* self,
                         Device* dev2)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	GeeArrayList* _tmp18_;
	GeeArrayList* _tmp19_;
	GeeArrayList* _tmp20_;
	GeeArrayList* _tmp21_;
	Device* _tmp22_;
	Device* _tmp23_;
	GeeArrayList* _tmp24_;
	GeeArrayList* _tmp25_;
	const gchar* _tmp26_;
	gchar* _tmp27_;
	const gchar* _tmp28_;
	gchar* _tmp29_;
	const gchar* _tmp30_;
	gchar* _tmp31_;
	const gchar* _tmp32_;
	gchar* _tmp33_;
#line 1209 "Utility/Device.vala"
	g_return_if_fail (self != NULL);
#line 1209 "Utility/Device.vala"
	g_return_if_fail (dev2 != NULL);
#line 1211 "Utility/Device.vala"
	_tmp0_ = dev2->device;
#line 1211 "Utility/Device.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 1211 "Utility/Device.vala"
	_g_free0 (self->device);
#line 1211 "Utility/Device.vala"
	self->device = _tmp1_;
#line 1212 "Utility/Device.vala"
	_tmp2_ = dev2->name;
#line 1212 "Utility/Device.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 1212 "Utility/Device.vala"
	_g_free0 (self->name);
#line 1212 "Utility/Device.vala"
	self->name = _tmp3_;
#line 1213 "Utility/Device.vala"
	_tmp4_ = dev2->kname;
#line 1213 "Utility/Device.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 1213 "Utility/Device.vala"
	_g_free0 (self->kname);
#line 1213 "Utility/Device.vala"
	self->kname = _tmp5_;
#line 1214 "Utility/Device.vala"
	_tmp6_ = dev2->pkname;
#line 1214 "Utility/Device.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 1214 "Utility/Device.vala"
	_g_free0 (self->pkname);
#line 1214 "Utility/Device.vala"
	self->pkname = _tmp7_;
#line 1215 "Utility/Device.vala"
	_tmp8_ = dev2->label;
#line 1215 "Utility/Device.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 1215 "Utility/Device.vala"
	_g_free0 (self->label);
#line 1215 "Utility/Device.vala"
	self->label = _tmp9_;
#line 1216 "Utility/Device.vala"
	_tmp10_ = dev2->uuid;
#line 1216 "Utility/Device.vala"
	_tmp11_ = g_strdup (_tmp10_);
#line 1216 "Utility/Device.vala"
	_g_free0 (self->uuid);
#line 1216 "Utility/Device.vala"
	self->uuid = _tmp11_;
#line 1217 "Utility/Device.vala"
	_tmp12_ = dev2->mapped_name;
#line 1217 "Utility/Device.vala"
	_tmp13_ = g_strdup (_tmp12_);
#line 1217 "Utility/Device.vala"
	_g_free0 (self->mapped_name);
#line 1217 "Utility/Device.vala"
	self->mapped_name = _tmp13_;
#line 1219 "Utility/Device.vala"
	_tmp14_ = dev2->type;
#line 1219 "Utility/Device.vala"
	_tmp15_ = g_strdup (_tmp14_);
#line 1219 "Utility/Device.vala"
	_g_free0 (self->type);
#line 1219 "Utility/Device.vala"
	self->type = _tmp15_;
#line 1220 "Utility/Device.vala"
	_tmp16_ = dev2->fstype;
#line 1220 "Utility/Device.vala"
	_tmp17_ = g_strdup (_tmp16_);
#line 1220 "Utility/Device.vala"
	_g_free0 (self->fstype);
#line 1220 "Utility/Device.vala"
	self->fstype = _tmp17_;
#line 1222 "Utility/Device.vala"
	self->size_bytes = dev2->size_bytes;
#line 1223 "Utility/Device.vala"
	self->used_bytes = dev2->used_bytes;
#line 1224 "Utility/Device.vala"
	self->available_bytes = dev2->available_bytes;
#line 1226 "Utility/Device.vala"
	_tmp18_ = dev2->mount_points;
#line 1226 "Utility/Device.vala"
	_tmp19_ = _g_object_ref0 (_tmp18_);
#line 1226 "Utility/Device.vala"
	_g_object_unref0 (self->mount_points);
#line 1226 "Utility/Device.vala"
	self->mount_points = _tmp19_;
#line 1227 "Utility/Device.vala"
	_tmp20_ = dev2->symlinks;
#line 1227 "Utility/Device.vala"
	_tmp21_ = _g_object_ref0 (_tmp20_);
#line 1227 "Utility/Device.vala"
	_g_object_unref0 (self->symlinks);
#line 1227 "Utility/Device.vala"
	self->symlinks = _tmp21_;
#line 1228 "Utility/Device.vala"
	_tmp22_ = dev2->parent;
#line 1228 "Utility/Device.vala"
	_tmp23_ = _g_object_ref0 (_tmp22_);
#line 1228 "Utility/Device.vala"
	_g_object_unref0 (self->parent);
#line 1228 "Utility/Device.vala"
	self->parent = _tmp23_;
#line 1229 "Utility/Device.vala"
	_tmp24_ = dev2->children;
#line 1229 "Utility/Device.vala"
	_tmp25_ = _g_object_ref0 (_tmp24_);
#line 1229 "Utility/Device.vala"
	_g_object_unref0 (self->children);
#line 1229 "Utility/Device.vala"
	self->children = _tmp25_;
#line 1231 "Utility/Device.vala"
	_tmp26_ = dev2->vendor;
#line 1231 "Utility/Device.vala"
	_tmp27_ = g_strdup (_tmp26_);
#line 1231 "Utility/Device.vala"
	_g_free0 (self->vendor);
#line 1231 "Utility/Device.vala"
	self->vendor = _tmp27_;
#line 1232 "Utility/Device.vala"
	_tmp28_ = dev2->model;
#line 1232 "Utility/Device.vala"
	_tmp29_ = g_strdup (_tmp28_);
#line 1232 "Utility/Device.vala"
	_g_free0 (self->model);
#line 1232 "Utility/Device.vala"
	self->model = _tmp29_;
#line 1233 "Utility/Device.vala"
	_tmp30_ = dev2->serial;
#line 1233 "Utility/Device.vala"
	_tmp31_ = g_strdup (_tmp30_);
#line 1233 "Utility/Device.vala"
	_g_free0 (self->serial);
#line 1233 "Utility/Device.vala"
	self->serial = _tmp31_;
#line 1234 "Utility/Device.vala"
	_tmp32_ = dev2->revision;
#line 1234 "Utility/Device.vala"
	_tmp33_ = g_strdup (_tmp32_);
#line 1234 "Utility/Device.vala"
	_g_free0 (self->revision);
#line 1234 "Utility/Device.vala"
	self->revision = _tmp33_;
#line 1236 "Utility/Device.vala"
	self->removable = dev2->removable;
#line 1237 "Utility/Device.vala"
	self->read_only = dev2->read_only;
#line 7941 "Device.c"
}

Device*
device_query_changes (Device* self)
{
	Device* result = NULL;
	Device* dev_new = NULL;
#line 1240 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1242 "Utility/Device.vala"
	dev_new = NULL;
#line 7953 "Device.c"
	{
		GeeArrayList* _dev_list = NULL;
		GeeArrayList* _tmp0_;
		gint _dev_size = 0;
		GeeArrayList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _dev_index = 0;
#line 1244 "Utility/Device.vala"
		_tmp0_ = device_get_block_devices_using_lsblk ("");
#line 1244 "Utility/Device.vala"
		_dev_list = _tmp0_;
#line 1244 "Utility/Device.vala"
		_tmp1_ = _dev_list;
#line 1244 "Utility/Device.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 1244 "Utility/Device.vala"
		_tmp3_ = _tmp2_;
#line 1244 "Utility/Device.vala"
		_dev_size = _tmp3_;
#line 1244 "Utility/Device.vala"
		_dev_index = -1;
#line 1244 "Utility/Device.vala"
		while (TRUE) {
#line 7978 "Device.c"
			Device* dev = NULL;
			GeeArrayList* _tmp4_;
			gpointer _tmp5_;
			const gchar* _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
#line 1244 "Utility/Device.vala"
			_dev_index = _dev_index + 1;
#line 1244 "Utility/Device.vala"
			if (!(_dev_index < _dev_size)) {
#line 1244 "Utility/Device.vala"
				break;
#line 7991 "Device.c"
			}
#line 1244 "Utility/Device.vala"
			_tmp4_ = _dev_list;
#line 1244 "Utility/Device.vala"
			_tmp5_ = gee_abstract_list_get ((GeeAbstractList*) _tmp4_, _dev_index);
#line 1244 "Utility/Device.vala"
			dev = (Device*) _tmp5_;
#line 1245 "Utility/Device.vala"
			_tmp6_ = self->uuid;
#line 1245 "Utility/Device.vala"
			_tmp7_ = strlen (_tmp6_);
#line 1245 "Utility/Device.vala"
			_tmp8_ = _tmp7_;
#line 1245 "Utility/Device.vala"
			if (_tmp8_ > 0) {
#line 8007 "Device.c"
				Device* _tmp9_;
				const gchar* _tmp10_;
				const gchar* _tmp11_;
#line 1246 "Utility/Device.vala"
				_tmp9_ = dev;
#line 1246 "Utility/Device.vala"
				_tmp10_ = _tmp9_->uuid;
#line 1246 "Utility/Device.vala"
				_tmp11_ = self->uuid;
#line 1246 "Utility/Device.vala"
				if (g_strcmp0 (_tmp10_, _tmp11_) == 0) {
#line 8019 "Device.c"
					Device* _tmp12_;
					Device* _tmp13_;
#line 1247 "Utility/Device.vala"
					_tmp12_ = dev;
#line 1247 "Utility/Device.vala"
					_tmp13_ = _g_object_ref0 (_tmp12_);
#line 1247 "Utility/Device.vala"
					_g_object_unref0 (dev_new);
#line 1247 "Utility/Device.vala"
					dev_new = _tmp13_;
#line 1248 "Utility/Device.vala"
					_g_object_unref0 (dev);
#line 1248 "Utility/Device.vala"
					break;
#line 8034 "Device.c"
				}
			} else {
				Device* _tmp14_;
				const gchar* _tmp15_;
				const gchar* _tmp16_;
#line 1252 "Utility/Device.vala"
				_tmp14_ = dev;
#line 1252 "Utility/Device.vala"
				_tmp15_ = _tmp14_->device;
#line 1252 "Utility/Device.vala"
				_tmp16_ = self->device;
#line 1252 "Utility/Device.vala"
				if (g_strcmp0 (_tmp15_, _tmp16_) == 0) {
#line 8048 "Device.c"
					Device* _tmp17_;
					Device* _tmp18_;
#line 1253 "Utility/Device.vala"
					_tmp17_ = dev;
#line 1253 "Utility/Device.vala"
					_tmp18_ = _g_object_ref0 (_tmp17_);
#line 1253 "Utility/Device.vala"
					_g_object_unref0 (dev_new);
#line 1253 "Utility/Device.vala"
					dev_new = _tmp18_;
#line 1254 "Utility/Device.vala"
					_g_object_unref0 (dev);
#line 1254 "Utility/Device.vala"
					break;
#line 8063 "Device.c"
				}
			}
#line 1244 "Utility/Device.vala"
			_g_object_unref0 (dev);
#line 8068 "Device.c"
		}
#line 1244 "Utility/Device.vala"
		_g_object_unref0 (_dev_list);
#line 8072 "Device.c"
	}
#line 1259 "Utility/Device.vala"
	result = dev_new;
#line 1259 "Utility/Device.vala"
	return result;
#line 8078 "Device.c"
}

void
device_query_disk_space (Device* self)
{
	GeeArrayList* list_df = NULL;
	const gchar* _tmp0_;
	GeeArrayList* _tmp1_;
	Device* dev_df = NULL;
	GeeArrayList* _tmp2_;
	const gchar* _tmp3_;
	Device* _tmp4_;
	Device* _tmp5_;
#line 1262 "Utility/Device.vala"
	g_return_if_fail (self != NULL);
#line 1266 "Utility/Device.vala"
	_tmp0_ = self->device;
#line 1266 "Utility/Device.vala"
	_tmp1_ = device_get_disk_space_using_df (_tmp0_);
#line 1266 "Utility/Device.vala"
	list_df = _tmp1_;
#line 1268 "Utility/Device.vala"
	_tmp2_ = list_df;
#line 1268 "Utility/Device.vala"
	_tmp3_ = self->uuid;
#line 1268 "Utility/Device.vala"
	_tmp4_ = device_find_device_in_list (_tmp2_, _tmp3_);
#line 1268 "Utility/Device.vala"
	dev_df = _tmp4_;
#line 1270 "Utility/Device.vala"
	_tmp5_ = dev_df;
#line 1270 "Utility/Device.vala"
	if (_tmp5_ != NULL) {
#line 8112 "Device.c"
		Device* _tmp6_;
		Device* _tmp7_;
		Device* _tmp8_;
		Device* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
#line 1272 "Utility/Device.vala"
		_tmp6_ = dev_df;
#line 1272 "Utility/Device.vala"
		self->size_bytes = _tmp6_->size_bytes;
#line 1273 "Utility/Device.vala"
		_tmp7_ = dev_df;
#line 1273 "Utility/Device.vala"
		self->used_bytes = _tmp7_->used_bytes;
#line 1274 "Utility/Device.vala"
		_tmp8_ = dev_df;
#line 1274 "Utility/Device.vala"
		self->available_bytes = _tmp8_->available_bytes;
#line 1275 "Utility/Device.vala"
		_tmp9_ = dev_df;
#line 1275 "Utility/Device.vala"
		_tmp10_ = _tmp9_->used_percent;
#line 1275 "Utility/Device.vala"
		_tmp11_ = g_strdup (_tmp10_);
#line 1275 "Utility/Device.vala"
		_g_free0 (self->used_percent);
#line 1275 "Utility/Device.vala"
		self->used_percent = _tmp11_;
#line 8141 "Device.c"
	}
#line 1262 "Utility/Device.vala"
	_g_object_unref0 (dev_df);
#line 1262 "Utility/Device.vala"
	_g_object_unref0 (list_df);
#line 8147 "Device.c"
}

gboolean
device_automount_udisks (const gchar* dev_name_or_uuid,
                         GtkWindow* parent_window)
{
	gboolean result = FALSE;
	gint _tmp0_;
	gint _tmp1_;
	gchar* cmd = NULL;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gint status = 0;
	const gchar* _tmp4_;
#line 1281 "Utility/Device.vala"
	g_return_val_if_fail (dev_name_or_uuid != NULL, FALSE);
#line 1283 "Utility/Device.vala"
	_tmp0_ = strlen (dev_name_or_uuid);
#line 1283 "Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 1283 "Utility/Device.vala"
	if (_tmp1_ == 0) {
#line 1284 "Utility/Device.vala"
		tee_jee_logging_log_error (_ ("Device name is empty!"), FALSE, FALSE);
#line 1285 "Utility/Device.vala"
		result = FALSE;
#line 1285 "Utility/Device.vala"
		return result;
#line 8176 "Device.c"
	}
#line 1288 "Utility/Device.vala"
	_tmp2_ = g_strdup_printf ("udisksctl mount -b '%s'", dev_name_or_uuid);
#line 1288 "Utility/Device.vala"
	cmd = _tmp2_;
#line 1289 "Utility/Device.vala"
	_tmp3_ = cmd;
#line 1289 "Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp3_);
#line 1290 "Utility/Device.vala"
	_tmp4_ = cmd;
#line 1290 "Utility/Device.vala"
	status = system (_tmp4_);
#line 1292 "Utility/Device.vala"
	if (status != 0) {
#line 1293 "Utility/Device.vala"
		if (parent_window != NULL) {
#line 8194 "Device.c"
			gchar* msg = NULL;
			gchar* _tmp5_;
			const gchar* _tmp6_;
#line 1294 "Utility/Device.vala"
			_tmp5_ = g_strdup_printf ("Failed to mount: %s", dev_name_or_uuid);
#line 1294 "Utility/Device.vala"
			msg = _tmp5_;
#line 1295 "Utility/Device.vala"
			_tmp6_ = msg;
#line 1295 "Utility/Device.vala"
			tee_jee_gtk_helper_gtk_messagebox ("Error", _tmp6_, parent_window, TRUE);
#line 1293 "Utility/Device.vala"
			_g_free0 (msg);
#line 8208 "Device.c"
		}
	}
#line 1299 "Utility/Device.vala"
	result = status == 0;
#line 1299 "Utility/Device.vala"
	_g_free0 (cmd);
#line 1299 "Utility/Device.vala"
	return result;
#line 8217 "Device.c"
}

gboolean
device_automount_udisks_iso (const gchar* iso_file_path,
                             gchar* * loop_device,
                             GtkWindow* parent_window)
{
	gchar* _vala_loop_device = NULL;
	gboolean result = FALSE;
	gchar* _tmp0_;
	gchar* cmd = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gint exit_code = 0;
	const gchar* _tmp8_;
	gchar* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	gint _tmp11_;
#line 1302 "Utility/Device.vala"
	g_return_val_if_fail (iso_file_path != NULL, FALSE);
#line 1304 "Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1304 "Utility/Device.vala"
	_g_free0 (_vala_loop_device);
#line 1304 "Utility/Device.vala"
	_vala_loop_device = _tmp0_;
#line 1306 "Utility/Device.vala"
	if (!tee_jee_file_system_file_exists (iso_file_path)) {
#line 8251 "Device.c"
		gchar* msg = NULL;
		gchar* _tmp1_;
		const gchar* _tmp2_;
#line 1307 "Utility/Device.vala"
		_tmp1_ = g_strdup_printf ("%s: %s", _ ("Could not find file"), iso_file_path);
#line 1307 "Utility/Device.vala"
		msg = _tmp1_;
#line 1308 "Utility/Device.vala"
		_tmp2_ = msg;
#line 1308 "Utility/Device.vala"
		tee_jee_logging_log_error (_tmp2_, FALSE, FALSE);
#line 1309 "Utility/Device.vala"
		result = FALSE;
#line 1309 "Utility/Device.vala"
		_g_free0 (msg);
#line 1309 "Utility/Device.vala"
		if (loop_device) {
#line 1309 "Utility/Device.vala"
			*loop_device = _vala_loop_device;
#line 8271 "Device.c"
		} else {
#line 1309 "Utility/Device.vala"
			_g_free0 (_vala_loop_device);
#line 8275 "Device.c"
		}
#line 1309 "Utility/Device.vala"
		return result;
#line 8279 "Device.c"
	}
#line 1312 "Utility/Device.vala"
	_tmp3_ = tee_jee_file_system_escape_single_quote (iso_file_path);
#line 1312 "Utility/Device.vala"
	_tmp4_ = _tmp3_;
#line 1312 "Utility/Device.vala"
	_tmp5_ = g_strdup_printf ("udisksctl loop-setup -r -f '%s'", _tmp4_);
#line 1312 "Utility/Device.vala"
	_tmp6_ = _tmp5_;
#line 1312 "Utility/Device.vala"
	_g_free0 (_tmp4_);
#line 1312 "Utility/Device.vala"
	cmd = _tmp6_;
#line 1315 "Utility/Device.vala"
	_tmp7_ = cmd;
#line 1315 "Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp7_);
#line 1317 "Utility/Device.vala"
	_tmp8_ = cmd;
#line 1317 "Utility/Device.vala"
	_tmp11_ = tee_jee_process_helper_exec_sync (_tmp8_, &_tmp9_, &_tmp10_);
#line 1317 "Utility/Device.vala"
	_g_free0 (std_out);
#line 1317 "Utility/Device.vala"
	std_out = _tmp9_;
#line 1317 "Utility/Device.vala"
	_g_free0 (std_err);
#line 1317 "Utility/Device.vala"
	std_err = _tmp10_;
#line 1317 "Utility/Device.vala"
	exit_code = _tmp11_;
#line 1319 "Utility/Device.vala"
	if (exit_code == 0) {
#line 8313 "Device.c"
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		const gchar* _tmp15_;
		const gchar* _tmp16_;
		gchar** _tmp17_;
		gchar** _tmp18_;
		gchar** _tmp19_;
		gint _tmp19__length1;
		const gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		const gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		GeeArrayList* list = NULL;
		GeeArrayList* _tmp27_;
#line 1320 "Utility/Device.vala"
		_tmp12_ = std_out;
#line 1320 "Utility/Device.vala"
		_tmp13_ = g_strdup_printf ("%s", _tmp12_);
#line 1320 "Utility/Device.vala"
		_tmp14_ = _tmp13_;
#line 1320 "Utility/Device.vala"
		tee_jee_logging_log_msg (_tmp14_, FALSE);
#line 1320 "Utility/Device.vala"
		_g_free0 (_tmp14_);
#line 1323 "Utility/Device.vala"
		_tmp15_ = std_out;
#line 1323 "Utility/Device.vala"
		if (!string_contains (_tmp15_, " as ")) {
#line 1324 "Utility/Device.vala"
			tee_jee_logging_log_error ("Could not determine loop device", FALSE, FALSE);
#line 1325 "Utility/Device.vala"
			result = FALSE;
#line 1325 "Utility/Device.vala"
			_g_free0 (std_err);
#line 1325 "Utility/Device.vala"
			_g_free0 (std_out);
#line 1325 "Utility/Device.vala"
			_g_free0 (cmd);
#line 1325 "Utility/Device.vala"
			if (loop_device) {
#line 1325 "Utility/Device.vala"
				*loop_device = _vala_loop_device;
#line 8360 "Device.c"
			} else {
#line 1325 "Utility/Device.vala"
				_g_free0 (_vala_loop_device);
#line 8364 "Device.c"
			}
#line 1325 "Utility/Device.vala"
			return result;
#line 8368 "Device.c"
		}
#line 1328 "Utility/Device.vala"
		_tmp16_ = std_out;
#line 1328 "Utility/Device.vala"
		_tmp18_ = _tmp17_ = g_strsplit (_tmp16_, " as ", 0);
#line 1328 "Utility/Device.vala"
		_tmp19_ = _tmp18_;
#line 1328 "Utility/Device.vala"
		_tmp19__length1 = _vala_array_length (_tmp17_);
#line 1328 "Utility/Device.vala"
		_tmp20_ = _tmp19_[1];
#line 1328 "Utility/Device.vala"
		_tmp21_ = string_replace (_tmp20_, ".", "");
#line 1328 "Utility/Device.vala"
		_tmp22_ = _tmp21_;
#line 1328 "Utility/Device.vala"
		_tmp23_ = string_strip (_tmp22_);
#line 1328 "Utility/Device.vala"
		_g_free0 (_vala_loop_device);
#line 1328 "Utility/Device.vala"
		_vala_loop_device = _tmp23_;
#line 1328 "Utility/Device.vala"
		_g_free0 (_tmp22_);
#line 1328 "Utility/Device.vala"
		_tmp19_ = (_vala_array_free (_tmp19_, _tmp19__length1, (GDestroyNotify) g_free), NULL);
#line 1329 "Utility/Device.vala"
		_tmp24_ = _vala_loop_device;
#line 1329 "Utility/Device.vala"
		_tmp25_ = g_strdup_printf ("loop_device: %s", _tmp24_);
#line 1329 "Utility/Device.vala"
		_tmp26_ = _tmp25_;
#line 1329 "Utility/Device.vala"
		tee_jee_logging_log_msg (_tmp26_, FALSE);
#line 1329 "Utility/Device.vala"
		_g_free0 (_tmp26_);
#line 1331 "Utility/Device.vala"
		_tmp27_ = device_get_block_devices_using_lsblk ("");
#line 1331 "Utility/Device.vala"
		list = _tmp27_;
#line 8408 "Device.c"
		{
			GeeArrayList* _dev_list = NULL;
			GeeArrayList* _tmp28_;
			GeeArrayList* _tmp29_;
			gint _dev_size = 0;
			GeeArrayList* _tmp30_;
			gint _tmp31_;
			gint _tmp32_;
			gint _dev_index = 0;
#line 1332 "Utility/Device.vala"
			_tmp28_ = list;
#line 1332 "Utility/Device.vala"
			_tmp29_ = _g_object_ref0 (_tmp28_);
#line 1332 "Utility/Device.vala"
			_dev_list = _tmp29_;
#line 1332 "Utility/Device.vala"
			_tmp30_ = _dev_list;
#line 1332 "Utility/Device.vala"
			_tmp31_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp30_);
#line 1332 "Utility/Device.vala"
			_tmp32_ = _tmp31_;
#line 1332 "Utility/Device.vala"
			_dev_size = _tmp32_;
#line 1332 "Utility/Device.vala"
			_dev_index = -1;
#line 1332 "Utility/Device.vala"
			while (TRUE) {
#line 8436 "Device.c"
				Device* dev = NULL;
				GeeArrayList* _tmp33_;
				gpointer _tmp34_;
				gboolean _tmp35_ = FALSE;
				Device* _tmp36_;
				const gchar* _tmp37_;
				const gchar* _tmp38_;
				gchar* _tmp39_;
				gchar* _tmp40_;
				gboolean _tmp41_;
#line 1332 "Utility/Device.vala"
				_dev_index = _dev_index + 1;
#line 1332 "Utility/Device.vala"
				if (!(_dev_index < _dev_size)) {
#line 1332 "Utility/Device.vala"
					break;
#line 8453 "Device.c"
				}
#line 1332 "Utility/Device.vala"
				_tmp33_ = _dev_list;
#line 1332 "Utility/Device.vala"
				_tmp34_ = gee_abstract_list_get ((GeeAbstractList*) _tmp33_, _dev_index);
#line 1332 "Utility/Device.vala"
				dev = (Device*) _tmp34_;
#line 1333 "Utility/Device.vala"
				_tmp36_ = dev;
#line 1333 "Utility/Device.vala"
				_tmp37_ = _tmp36_->pkname;
#line 1333 "Utility/Device.vala"
				_tmp38_ = _vala_loop_device;
#line 1333 "Utility/Device.vala"
				_tmp39_ = string_replace (_tmp38_, "/dev/", "");
#line 1333 "Utility/Device.vala"
				_tmp40_ = _tmp39_;
#line 1333 "Utility/Device.vala"
				_tmp41_ = g_strcmp0 (_tmp37_, _tmp40_) == 0;
#line 1333 "Utility/Device.vala"
				_g_free0 (_tmp40_);
#line 1333 "Utility/Device.vala"
				if (_tmp41_) {
#line 8477 "Device.c"
					Device* _tmp42_;
					const gchar* _tmp43_;
#line 1333 "Utility/Device.vala"
					_tmp42_ = dev;
#line 1333 "Utility/Device.vala"
					_tmp43_ = _tmp42_->fstype;
#line 1333 "Utility/Device.vala"
					_tmp35_ = g_strcmp0 (_tmp43_, "iso9660") == 0;
#line 8486 "Device.c"
				} else {
#line 1333 "Utility/Device.vala"
					_tmp35_ = FALSE;
#line 8490 "Device.c"
				}
#line 1333 "Utility/Device.vala"
				if (_tmp35_) {
#line 8494 "Device.c"
					Device* _tmp44_;
					const gchar* _tmp45_;
					gchar* _tmp46_;
					Device* _tmp47_;
					const gchar* _tmp48_;
#line 1334 "Utility/Device.vala"
					_tmp44_ = dev;
#line 1334 "Utility/Device.vala"
					_tmp45_ = _tmp44_->device;
#line 1334 "Utility/Device.vala"
					_tmp46_ = g_strdup (_tmp45_);
#line 1334 "Utility/Device.vala"
					_g_free0 (_vala_loop_device);
#line 1334 "Utility/Device.vala"
					_vala_loop_device = _tmp46_;
#line 1335 "Utility/Device.vala"
					_tmp47_ = dev;
#line 1335 "Utility/Device.vala"
					_tmp48_ = _tmp47_->device;
#line 1335 "Utility/Device.vala"
					result = device_automount_udisks (_tmp48_, parent_window);
#line 1335 "Utility/Device.vala"
					_g_object_unref0 (dev);
#line 1335 "Utility/Device.vala"
					_g_object_unref0 (_dev_list);
#line 1335 "Utility/Device.vala"
					_g_object_unref0 (list);
#line 1335 "Utility/Device.vala"
					_g_free0 (std_err);
#line 1335 "Utility/Device.vala"
					_g_free0 (std_out);
#line 1335 "Utility/Device.vala"
					_g_free0 (cmd);
#line 1335 "Utility/Device.vala"
					if (loop_device) {
#line 1335 "Utility/Device.vala"
						*loop_device = _vala_loop_device;
#line 8532 "Device.c"
					} else {
#line 1335 "Utility/Device.vala"
						_g_free0 (_vala_loop_device);
#line 8536 "Device.c"
					}
#line 1335 "Utility/Device.vala"
					return result;
#line 8540 "Device.c"
				}
#line 1332 "Utility/Device.vala"
				_g_object_unref0 (dev);
#line 8544 "Device.c"
			}
#line 1332 "Utility/Device.vala"
			_g_object_unref0 (_dev_list);
#line 8548 "Device.c"
		}
#line 1319 "Utility/Device.vala"
		_g_object_unref0 (list);
#line 8552 "Device.c"
	}
#line 1340 "Utility/Device.vala"
	result = FALSE;
#line 1340 "Utility/Device.vala"
	_g_free0 (std_err);
#line 1340 "Utility/Device.vala"
	_g_free0 (std_out);
#line 1340 "Utility/Device.vala"
	_g_free0 (cmd);
#line 1340 "Utility/Device.vala"
	if (loop_device) {
#line 1340 "Utility/Device.vala"
		*loop_device = _vala_loop_device;
#line 8566 "Device.c"
	} else {
#line 1340 "Utility/Device.vala"
		_g_free0 (_vala_loop_device);
#line 8570 "Device.c"
	}
#line 1340 "Utility/Device.vala"
	return result;
#line 8574 "Device.c"
}

gboolean
device_unmount_udisks (const gchar* dev_name_or_uuid,
                       GtkWindow* parent_window)
{
	gboolean result = FALSE;
	gint _tmp0_;
	gint _tmp1_;
	gchar* cmd = NULL;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gint status = 0;
	const gchar* _tmp4_;
#line 1343 "Utility/Device.vala"
	g_return_val_if_fail (dev_name_or_uuid != NULL, FALSE);
#line 1345 "Utility/Device.vala"
	_tmp0_ = strlen (dev_name_or_uuid);
#line 1345 "Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 1345 "Utility/Device.vala"
	if (_tmp1_ == 0) {
#line 1346 "Utility/Device.vala"
		tee_jee_logging_log_error (_ ("Device name is empty!"), FALSE, FALSE);
#line 1347 "Utility/Device.vala"
		result = FALSE;
#line 1347 "Utility/Device.vala"
		return result;
#line 8603 "Device.c"
	}
#line 1350 "Utility/Device.vala"
	_tmp2_ = g_strdup_printf ("udisksctl unmount -b '%s'", dev_name_or_uuid);
#line 1350 "Utility/Device.vala"
	cmd = _tmp2_;
#line 1351 "Utility/Device.vala"
	_tmp3_ = cmd;
#line 1351 "Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp3_);
#line 1352 "Utility/Device.vala"
	_tmp4_ = cmd;
#line 1352 "Utility/Device.vala"
	status = system (_tmp4_);
#line 1354 "Utility/Device.vala"
	if (status != 0) {
#line 1355 "Utility/Device.vala"
		if (parent_window != NULL) {
#line 8621 "Device.c"
			gchar* msg = NULL;
			gchar* _tmp5_;
			const gchar* _tmp6_;
#line 1356 "Utility/Device.vala"
			_tmp5_ = g_strdup_printf ("Failed to unmount: %s", dev_name_or_uuid);
#line 1356 "Utility/Device.vala"
			msg = _tmp5_;
#line 1357 "Utility/Device.vala"
			_tmp6_ = msg;
#line 1357 "Utility/Device.vala"
			tee_jee_gtk_helper_gtk_messagebox ("Error", _tmp6_, parent_window, TRUE);
#line 1355 "Utility/Device.vala"
			_g_free0 (msg);
#line 8635 "Device.c"
		}
	}
#line 1361 "Utility/Device.vala"
	result = status == 0;
#line 1361 "Utility/Device.vala"
	_g_free0 (cmd);
#line 1361 "Utility/Device.vala"
	return result;
#line 8644 "Device.c"
}

Device*
device_luks_unlock (Device* luks_device,
                    const gchar* mapped_name,
                    const gchar* passphrase,
                    GtkWindow* parent_window,
                    gchar* * message,
                    gchar* * details)
{
	gchar* _vala_message = NULL;
	gchar* _vala_details = NULL;
	Device* result = NULL;
	Device* unlocked_device = NULL;
	gchar* std_out = NULL;
	gchar* _tmp0_;
	gchar* std_err = NULL;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp7_;
	gchar* luks_pass = NULL;
	gchar* _tmp24_;
	gchar* luks_name = NULL;
	gchar* _tmp25_;
	gboolean _tmp26_ = FALSE;
	const gchar* _tmp27_;
	GeeArrayList* _tmp95_;
	gboolean is_error = FALSE;
	Device* _tmp108_;
#line 1364 "Utility/Device.vala"
	g_return_val_if_fail (luks_device != NULL, NULL);
#line 1364 "Utility/Device.vala"
	g_return_val_if_fail (mapped_name != NULL, NULL);
#line 1364 "Utility/Device.vala"
	g_return_val_if_fail (passphrase != NULL, NULL);
#line 1374 "Utility/Device.vala"
	unlocked_device = NULL;
#line 1375 "Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1375 "Utility/Device.vala"
	std_out = _tmp0_;
#line 1375 "Utility/Device.vala"
	_tmp1_ = g_strdup ("");
#line 1375 "Utility/Device.vala"
	std_err = _tmp1_;
#line 1378 "Utility/Device.vala"
	_tmp3_ = luks_device->fstype;
#line 1378 "Utility/Device.vala"
	if (!string_contains (_tmp3_, "luks")) {
#line 8696 "Device.c"
		const gchar* _tmp4_;
#line 1378 "Utility/Device.vala"
		_tmp4_ = luks_device->fstype;
#line 1378 "Utility/Device.vala"
		_tmp2_ = !string_contains (_tmp4_, "crypt");
#line 8702 "Device.c"
	} else {
#line 1378 "Utility/Device.vala"
		_tmp2_ = FALSE;
#line 8706 "Device.c"
	}
#line 1378 "Utility/Device.vala"
	if (_tmp2_) {
#line 8710 "Device.c"
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 1379 "Utility/Device.vala"
		_tmp5_ = g_strdup (_ ("This device is not encrypted"));
#line 1379 "Utility/Device.vala"
		_g_free0 (_vala_message);
#line 1379 "Utility/Device.vala"
		_vala_message = _tmp5_;
#line 1380 "Utility/Device.vala"
		_tmp6_ = g_strdup (_ ("Failed to unlock device"));
#line 1380 "Utility/Device.vala"
		_g_free0 (_vala_details);
#line 1380 "Utility/Device.vala"
		_vala_details = _tmp6_;
#line 1381 "Utility/Device.vala"
		result = NULL;
#line 1381 "Utility/Device.vala"
		_g_free0 (std_err);
#line 1381 "Utility/Device.vala"
		_g_free0 (std_out);
#line 1381 "Utility/Device.vala"
		_g_object_unref0 (unlocked_device);
#line 1381 "Utility/Device.vala"
		if (message) {
#line 1381 "Utility/Device.vala"
			*message = _vala_message;
#line 8737 "Device.c"
		} else {
#line 1381 "Utility/Device.vala"
			_g_free0 (_vala_message);
#line 8741 "Device.c"
		}
#line 1381 "Utility/Device.vala"
		if (details) {
#line 1381 "Utility/Device.vala"
			*details = _vala_details;
#line 8747 "Device.c"
		} else {
#line 1381 "Utility/Device.vala"
			_g_free0 (_vala_details);
#line 8751 "Device.c"
		}
#line 1381 "Utility/Device.vala"
		return result;
#line 8755 "Device.c"
	}
#line 1385 "Utility/Device.vala"
	_tmp7_ = device_get_block_devices_using_lsblk ("");
#line 1385 "Utility/Device.vala"
	list = _tmp7_;
#line 8761 "Device.c"
	{
		GeeArrayList* _part_list = NULL;
		GeeArrayList* _tmp8_;
		GeeArrayList* _tmp9_;
		gint _part_size = 0;
		GeeArrayList* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		gint _part_index = 0;
#line 1386 "Utility/Device.vala"
		_tmp8_ = list;
#line 1386 "Utility/Device.vala"
		_tmp9_ = _g_object_ref0 (_tmp8_);
#line 1386 "Utility/Device.vala"
		_part_list = _tmp9_;
#line 1386 "Utility/Device.vala"
		_tmp10_ = _part_list;
#line 1386 "Utility/Device.vala"
		_tmp11_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp10_);
#line 1386 "Utility/Device.vala"
		_tmp12_ = _tmp11_;
#line 1386 "Utility/Device.vala"
		_part_size = _tmp12_;
#line 1386 "Utility/Device.vala"
		_part_index = -1;
#line 1386 "Utility/Device.vala"
		while (TRUE) {
#line 8789 "Device.c"
			Device* part = NULL;
			GeeArrayList* _tmp13_;
			gpointer _tmp14_;
			Device* _tmp15_;
			const gchar* _tmp16_;
			const gchar* _tmp17_;
#line 1386 "Utility/Device.vala"
			_part_index = _part_index + 1;
#line 1386 "Utility/Device.vala"
			if (!(_part_index < _part_size)) {
#line 1386 "Utility/Device.vala"
				break;
#line 8802 "Device.c"
			}
#line 1386 "Utility/Device.vala"
			_tmp13_ = _part_list;
#line 1386 "Utility/Device.vala"
			_tmp14_ = gee_abstract_list_get ((GeeAbstractList*) _tmp13_, _part_index);
#line 1386 "Utility/Device.vala"
			part = (Device*) _tmp14_;
#line 1387 "Utility/Device.vala"
			_tmp15_ = part;
#line 1387 "Utility/Device.vala"
			_tmp16_ = _tmp15_->pkname;
#line 1387 "Utility/Device.vala"
			_tmp17_ = luks_device->kname;
#line 1387 "Utility/Device.vala"
			if (g_strcmp0 (_tmp16_, _tmp17_) == 0) {
#line 8818 "Device.c"
				Device* _tmp18_;
				Device* _tmp19_;
				gchar* _tmp20_;
				Device* _tmp21_;
				const gchar* _tmp22_;
				gchar* _tmp23_;
#line 1388 "Utility/Device.vala"
				_tmp18_ = part;
#line 1388 "Utility/Device.vala"
				_tmp19_ = _g_object_ref0 (_tmp18_);
#line 1388 "Utility/Device.vala"
				_g_object_unref0 (unlocked_device);
#line 1388 "Utility/Device.vala"
				unlocked_device = _tmp19_;
#line 1389 "Utility/Device.vala"
				_tmp20_ = g_strdup (_ ("Device is unlocked"));
#line 1389 "Utility/Device.vala"
				_g_free0 (_vala_message);
#line 1389 "Utility/Device.vala"
				_vala_message = _tmp20_;
#line 1390 "Utility/Device.vala"
				_tmp21_ = part;
#line 1390 "Utility/Device.vala"
				_tmp22_ = _tmp21_->mapped_name;
#line 1390 "Utility/Device.vala"
				_tmp23_ = g_strdup_printf (_ ("Unlocked device is mapped to '%s'"), _tmp22_);
#line 1390 "Utility/Device.vala"
				_g_free0 (_vala_details);
#line 1390 "Utility/Device.vala"
				_vala_details = _tmp23_;
#line 1391 "Utility/Device.vala"
				result = part;
#line 1391 "Utility/Device.vala"
				_g_object_unref0 (_part_list);
#line 1391 "Utility/Device.vala"
				_g_object_unref0 (list);
#line 1391 "Utility/Device.vala"
				_g_free0 (std_err);
#line 1391 "Utility/Device.vala"
				_g_free0 (std_out);
#line 1391 "Utility/Device.vala"
				_g_object_unref0 (unlocked_device);
#line 1391 "Utility/Device.vala"
				if (message) {
#line 1391 "Utility/Device.vala"
					*message = _vala_message;
#line 8865 "Device.c"
				} else {
#line 1391 "Utility/Device.vala"
					_g_free0 (_vala_message);
#line 8869 "Device.c"
				}
#line 1391 "Utility/Device.vala"
				if (details) {
#line 1391 "Utility/Device.vala"
					*details = _vala_details;
#line 8875 "Device.c"
				} else {
#line 1391 "Utility/Device.vala"
					_g_free0 (_vala_details);
#line 8879 "Device.c"
				}
#line 1391 "Utility/Device.vala"
				return result;
#line 8883 "Device.c"
			}
#line 1386 "Utility/Device.vala"
			_g_object_unref0 (part);
#line 8887 "Device.c"
		}
#line 1386 "Utility/Device.vala"
		_g_object_unref0 (_part_list);
#line 8891 "Device.c"
	}
#line 1395 "Utility/Device.vala"
	_tmp24_ = g_strdup (passphrase);
#line 1395 "Utility/Device.vala"
	luks_pass = _tmp24_;
#line 1396 "Utility/Device.vala"
	_tmp25_ = g_strdup (mapped_name);
#line 1396 "Utility/Device.vala"
	luks_name = _tmp25_;
#line 1398 "Utility/Device.vala"
	_tmp27_ = luks_name;
#line 1398 "Utility/Device.vala"
	if (_tmp27_ == NULL) {
#line 1398 "Utility/Device.vala"
		_tmp26_ = TRUE;
#line 8907 "Device.c"
	} else {
		const gchar* _tmp28_;
		gint _tmp29_;
		gint _tmp30_;
#line 1398 "Utility/Device.vala"
		_tmp28_ = luks_name;
#line 1398 "Utility/Device.vala"
		_tmp29_ = strlen (_tmp28_);
#line 1398 "Utility/Device.vala"
		_tmp30_ = _tmp29_;
#line 1398 "Utility/Device.vala"
		_tmp26_ = _tmp30_ == 0;
#line 8920 "Device.c"
	}
#line 1398 "Utility/Device.vala"
	if (_tmp26_) {
#line 8924 "Device.c"
		const gchar* _tmp31_;
		gchar* _tmp32_;
#line 1399 "Utility/Device.vala"
		_tmp31_ = luks_device->kname;
#line 1399 "Utility/Device.vala"
		_tmp32_ = g_strdup_printf ("%s_crypt", _tmp31_);
#line 1399 "Utility/Device.vala"
		_g_free0 (luks_name);
#line 1399 "Utility/Device.vala"
		luks_name = _tmp32_;
#line 8935 "Device.c"
	}
#line 1402 "Utility/Device.vala"
	if (parent_window == NULL) {
#line 8939 "Device.c"
		gboolean _tmp33_ = FALSE;
		const gchar* _tmp34_;
#line 1406 "Utility/Device.vala"
		_tmp34_ = luks_pass;
#line 1406 "Utility/Device.vala"
		if (_tmp34_ == NULL) {
#line 1406 "Utility/Device.vala"
			_tmp33_ = TRUE;
#line 8948 "Device.c"
		} else {
			const gchar* _tmp35_;
			gint _tmp36_;
			gint _tmp37_;
#line 1406 "Utility/Device.vala"
			_tmp35_ = luks_pass;
#line 1406 "Utility/Device.vala"
			_tmp36_ = strlen (_tmp35_);
#line 1406 "Utility/Device.vala"
			_tmp37_ = _tmp36_;
#line 1406 "Utility/Device.vala"
			_tmp33_ = _tmp37_ == 0;
#line 8961 "Device.c"
		}
#line 1406 "Utility/Device.vala"
		if (_tmp33_) {
#line 8965 "Device.c"
			TimeoutCounter* counter = NULL;
			TimeoutCounter* _tmp38_;
			TimeoutCounter* _tmp39_;
			gchar* cmd = NULL;
			const gchar* _tmp40_;
			const gchar* _tmp41_;
			gchar* _tmp42_;
			const gchar* _tmp43_;
			const gchar* _tmp44_;
			TimeoutCounter* _tmp45_;
#line 1410 "Utility/Device.vala"
			_tmp38_ = timeout_counter_new ();
#line 1410 "Utility/Device.vala"
			counter = _tmp38_;
#line 1411 "Utility/Device.vala"
			_tmp39_ = counter;
#line 1411 "Utility/Device.vala"
			timeout_counter_kill_process_on_timeout (_tmp39_, "cryptsetup", 20, TRUE);
#line 1412 "Utility/Device.vala"
			_tmp40_ = luks_device->device;
#line 1412 "Utility/Device.vala"
			_tmp41_ = luks_name;
#line 1412 "Utility/Device.vala"
			_tmp42_ = g_strdup_printf ("cryptsetup luksOpen '%s' '%s'", _tmp40_, _tmp41_);
#line 1412 "Utility/Device.vala"
			cmd = _tmp42_;
#line 1414 "Utility/Device.vala"
			_tmp43_ = cmd;
#line 1414 "Utility/Device.vala"
			tee_jee_logging_log_debug (_tmp43_);
#line 1415 "Utility/Device.vala"
			_tmp44_ = cmd;
#line 1415 "Utility/Device.vala"
			system (_tmp44_);
#line 1416 "Utility/Device.vala"
			_tmp45_ = counter;
#line 1416 "Utility/Device.vala"
			timeout_counter_stop (_tmp45_);
#line 1417 "Utility/Device.vala"
			tee_jee_logging_log_msg ("", FALSE);
#line 1406 "Utility/Device.vala"
			_g_free0 (cmd);
#line 1406 "Utility/Device.vala"
			_g_object_unref0 (counter);
#line 9010 "Device.c"
		} else {
			gchar* cmd = NULL;
			const gchar* _tmp46_;
			const gchar* _tmp47_;
			const gchar* _tmp48_;
			gchar* _tmp49_;
			const gchar* _tmp50_;
			const gchar* _tmp51_;
			gchar* _tmp52_;
			gchar* _tmp53_;
			gint status = 0;
			const gchar* _tmp54_;
			gchar* _tmp55_ = NULL;
			gchar* _tmp56_ = NULL;
			gint _tmp57_;
#line 1424 "Utility/Device.vala"
			_tmp46_ = luks_pass;
#line 1424 "Utility/Device.vala"
			_tmp47_ = luks_device->device;
#line 1424 "Utility/Device.vala"
			_tmp48_ = luks_name;
#line 1424 "Utility/Device.vala"
			_tmp49_ = g_strdup_printf ("echo -n -e '%s' | cryptsetup luksOpen --key-file - '%s' '%s'\n", _tmp46_, _tmp47_, _tmp48_);
#line 1424 "Utility/Device.vala"
			cmd = _tmp49_;
#line 1427 "Utility/Device.vala"
			_tmp50_ = cmd;
#line 1427 "Utility/Device.vala"
			_tmp51_ = luks_pass;
#line 1427 "Utility/Device.vala"
			_tmp52_ = string_replace (_tmp50_, _tmp51_, "**PASSWORD**");
#line 1427 "Utility/Device.vala"
			_tmp53_ = _tmp52_;
#line 1427 "Utility/Device.vala"
			tee_jee_logging_log_debug (_tmp53_);
#line 1427 "Utility/Device.vala"
			_g_free0 (_tmp53_);
#line 1429 "Utility/Device.vala"
			_tmp54_ = cmd;
#line 1429 "Utility/Device.vala"
			_tmp57_ = tee_jee_process_helper_exec_script_sync (_tmp54_, &_tmp55_, &_tmp56_, FALSE, TRUE, TRUE, FALSE);
#line 1429 "Utility/Device.vala"
			_g_free0 (std_out);
#line 1429 "Utility/Device.vala"
			std_out = _tmp55_;
#line 1429 "Utility/Device.vala"
			_g_free0 (std_err);
#line 1429 "Utility/Device.vala"
			std_err = _tmp56_;
#line 1429 "Utility/Device.vala"
			status = _tmp57_;
#line 1431 "Utility/Device.vala"
			switch (status) {
#line 1431 "Utility/Device.vala"
				case 512:
#line 9066 "Device.c"
				{
					gchar* _tmp58_;
					gchar* _tmp59_;
					const gchar* _tmp60_;
					const gchar* _tmp61_;
#line 1433 "Utility/Device.vala"
					_tmp58_ = g_strdup (_ ("Wrong password"));
#line 1433 "Utility/Device.vala"
					_g_free0 (_vala_message);
#line 1433 "Utility/Device.vala"
					_vala_message = _tmp58_;
#line 1434 "Utility/Device.vala"
					_tmp59_ = g_strdup (_ ("Failed to unlock device"));
#line 1434 "Utility/Device.vala"
					_g_free0 (_vala_details);
#line 1434 "Utility/Device.vala"
					_vala_details = _tmp59_;
#line 1435 "Utility/Device.vala"
					_tmp60_ = _vala_message;
#line 1435 "Utility/Device.vala"
					tee_jee_logging_log_error (_tmp60_, FALSE, FALSE);
#line 1436 "Utility/Device.vala"
					_tmp61_ = _vala_details;
#line 1436 "Utility/Device.vala"
					tee_jee_logging_log_error (_tmp61_, FALSE, FALSE);
#line 1437 "Utility/Device.vala"
					break;
#line 9094 "Device.c"
				}
				default:
#line 1431 "Utility/Device.vala"
				break;
#line 9099 "Device.c"
			}
#line 1406 "Utility/Device.vala"
			_g_free0 (cmd);
#line 9103 "Device.c"
		}
	} else {
		gboolean _tmp62_ = FALSE;
		const gchar* _tmp63_;
		gboolean _tmp74_ = FALSE;
		const gchar* _tmp75_;
#line 1446 "Utility/Device.vala"
		_tmp63_ = luks_pass;
#line 1446 "Utility/Device.vala"
		if (_tmp63_ == NULL) {
#line 1446 "Utility/Device.vala"
			_tmp62_ = TRUE;
#line 9116 "Device.c"
		} else {
			const gchar* _tmp64_;
			gint _tmp65_;
			gint _tmp66_;
#line 1446 "Utility/Device.vala"
			_tmp64_ = luks_pass;
#line 1446 "Utility/Device.vala"
			_tmp65_ = strlen (_tmp64_);
#line 1446 "Utility/Device.vala"
			_tmp66_ = _tmp65_;
#line 1446 "Utility/Device.vala"
			_tmp62_ = _tmp66_ == 0;
#line 9129 "Device.c"
		}
#line 1446 "Utility/Device.vala"
		if (_tmp62_) {
#line 9133 "Device.c"
			const gchar* _tmp67_;
			gchar* _tmp68_;
			gchar* _tmp69_;
			gchar* _tmp70_;
			const gchar* _tmp71_;
#line 1450 "Utility/Device.vala"
			tee_jee_logging_log_debug ("Prompting user for passphrase..");
#line 1452 "Utility/Device.vala"
			_tmp67_ = luks_device->name;
#line 1452 "Utility/Device.vala"
			_tmp68_ = g_strdup_printf (_ ("Enter passphrase to unlock '%s'"), _tmp67_);
#line 1452 "Utility/Device.vala"
			_tmp69_ = _tmp68_;
#line 1452 "Utility/Device.vala"
			_tmp70_ = tee_jee_gtk_helper_gtk_inputbox (_ ("Encrypted Device"), _tmp69_, parent_window, TRUE);
#line 1452 "Utility/Device.vala"
			_g_free0 (luks_pass);
#line 1452 "Utility/Device.vala"
			luks_pass = _tmp70_;
#line 1452 "Utility/Device.vala"
			_g_free0 (_tmp69_);
#line 1457 "Utility/Device.vala"
			_tmp71_ = luks_pass;
#line 1457 "Utility/Device.vala"
			if (_tmp71_ == NULL) {
#line 9159 "Device.c"
				gchar* _tmp72_;
				gchar* _tmp73_;
#line 1459 "Utility/Device.vala"
				_tmp72_ = g_strdup (_ ("Failed to unlock device"));
#line 1459 "Utility/Device.vala"
				_g_free0 (_vala_message);
#line 1459 "Utility/Device.vala"
				_vala_message = _tmp72_;
#line 1460 "Utility/Device.vala"
				_tmp73_ = g_strdup (_ ("User cancelled the password prompt"));
#line 1460 "Utility/Device.vala"
				_g_free0 (_vala_details);
#line 1460 "Utility/Device.vala"
				_vala_details = _tmp73_;
#line 1461 "Utility/Device.vala"
				tee_jee_logging_log_debug ("User cancelled the password prompt");
#line 1462 "Utility/Device.vala"
				result = NULL;
#line 1462 "Utility/Device.vala"
				_g_free0 (luks_name);
#line 1462 "Utility/Device.vala"
				_g_free0 (luks_pass);
#line 1462 "Utility/Device.vala"
				_g_object_unref0 (list);
#line 1462 "Utility/Device.vala"
				_g_free0 (std_err);
#line 1462 "Utility/Device.vala"
				_g_free0 (std_out);
#line 1462 "Utility/Device.vala"
				_g_object_unref0 (unlocked_device);
#line 1462 "Utility/Device.vala"
				if (message) {
#line 1462 "Utility/Device.vala"
					*message = _vala_message;
#line 9194 "Device.c"
				} else {
#line 1462 "Utility/Device.vala"
					_g_free0 (_vala_message);
#line 9198 "Device.c"
				}
#line 1462 "Utility/Device.vala"
				if (details) {
#line 1462 "Utility/Device.vala"
					*details = _vala_details;
#line 9204 "Device.c"
				} else {
#line 1462 "Utility/Device.vala"
					_g_free0 (_vala_details);
#line 9208 "Device.c"
				}
#line 1462 "Utility/Device.vala"
				return result;
#line 9212 "Device.c"
			}
		}
#line 1466 "Utility/Device.vala"
		_tmp75_ = luks_pass;
#line 1466 "Utility/Device.vala"
		if (_tmp75_ != NULL) {
#line 9219 "Device.c"
			const gchar* _tmp76_;
			gint _tmp77_;
			gint _tmp78_;
#line 1466 "Utility/Device.vala"
			_tmp76_ = luks_pass;
#line 1466 "Utility/Device.vala"
			_tmp77_ = strlen (_tmp76_);
#line 1466 "Utility/Device.vala"
			_tmp78_ = _tmp77_;
#line 1466 "Utility/Device.vala"
			_tmp74_ = _tmp78_ > 0;
#line 9231 "Device.c"
		} else {
#line 1466 "Utility/Device.vala"
			_tmp74_ = FALSE;
#line 9235 "Device.c"
		}
#line 1466 "Utility/Device.vala"
		if (_tmp74_) {
#line 9239 "Device.c"
			gchar* cmd = NULL;
			const gchar* _tmp79_;
			const gchar* _tmp80_;
			const gchar* _tmp81_;
			gchar* _tmp82_;
			const gchar* _tmp83_;
			const gchar* _tmp84_;
			gchar* _tmp85_;
			gchar* _tmp86_;
			gint status = 0;
			const gchar* _tmp87_;
			gchar* _tmp88_ = NULL;
			gchar* _tmp89_ = NULL;
			gint _tmp90_;
#line 1470 "Utility/Device.vala"
			_tmp79_ = luks_pass;
#line 1470 "Utility/Device.vala"
			_tmp80_ = luks_device->device;
#line 1470 "Utility/Device.vala"
			_tmp81_ = luks_name;
#line 1470 "Utility/Device.vala"
			_tmp82_ = g_strdup_printf ("echo -n -e '%s' | cryptsetup luksOpen --key-file - '%s' '%s'\n", _tmp79_, _tmp80_, _tmp81_);
#line 1470 "Utility/Device.vala"
			cmd = _tmp82_;
#line 1473 "Utility/Device.vala"
			_tmp83_ = cmd;
#line 1473 "Utility/Device.vala"
			_tmp84_ = luks_pass;
#line 1473 "Utility/Device.vala"
			_tmp85_ = string_replace (_tmp83_, _tmp84_, "**PASSWORD**");
#line 1473 "Utility/Device.vala"
			_tmp86_ = _tmp85_;
#line 1473 "Utility/Device.vala"
			tee_jee_logging_log_debug (_tmp86_);
#line 1473 "Utility/Device.vala"
			_g_free0 (_tmp86_);
#line 1475 "Utility/Device.vala"
			_tmp87_ = cmd;
#line 1475 "Utility/Device.vala"
			_tmp90_ = tee_jee_process_helper_exec_script_sync (_tmp87_, &_tmp88_, &_tmp89_, FALSE, TRUE, TRUE, FALSE);
#line 1475 "Utility/Device.vala"
			_g_free0 (std_out);
#line 1475 "Utility/Device.vala"
			std_out = _tmp88_;
#line 1475 "Utility/Device.vala"
			_g_free0 (std_err);
#line 1475 "Utility/Device.vala"
			std_err = _tmp89_;
#line 1475 "Utility/Device.vala"
			status = _tmp90_;
#line 1477 "Utility/Device.vala"
			switch (status) {
#line 1477 "Utility/Device.vala"
				case 512:
#line 9294 "Device.c"
				{
					gchar* _tmp91_;
					gchar* _tmp92_;
					const gchar* _tmp93_;
					const gchar* _tmp94_;
#line 1479 "Utility/Device.vala"
					_tmp91_ = g_strdup (_ ("Wrong password"));
#line 1479 "Utility/Device.vala"
					_g_free0 (_vala_message);
#line 1479 "Utility/Device.vala"
					_vala_message = _tmp91_;
#line 1480 "Utility/Device.vala"
					_tmp92_ = g_strdup (_ ("Failed to unlock device"));
#line 1480 "Utility/Device.vala"
					_g_free0 (_vala_details);
#line 1480 "Utility/Device.vala"
					_vala_details = _tmp92_;
#line 1481 "Utility/Device.vala"
					_tmp93_ = _vala_message;
#line 1481 "Utility/Device.vala"
					tee_jee_logging_log_error (_tmp93_, FALSE, FALSE);
#line 1482 "Utility/Device.vala"
					_tmp94_ = _vala_details;
#line 1482 "Utility/Device.vala"
					tee_jee_logging_log_error (_tmp94_, FALSE, FALSE);
#line 1483 "Utility/Device.vala"
					break;
#line 9322 "Device.c"
				}
				default:
#line 1477 "Utility/Device.vala"
				break;
#line 9327 "Device.c"
			}
#line 1466 "Utility/Device.vala"
			_g_free0 (cmd);
#line 9331 "Device.c"
		}
	}
#line 1490 "Utility/Device.vala"
	_tmp95_ = device_get_block_devices_using_lsblk ("");
#line 1490 "Utility/Device.vala"
	_g_object_unref0 (list);
#line 1490 "Utility/Device.vala"
	list = _tmp95_;
#line 9340 "Device.c"
	{
		GeeArrayList* _part_list = NULL;
		GeeArrayList* _tmp96_;
		GeeArrayList* _tmp97_;
		gint _part_size = 0;
		GeeArrayList* _tmp98_;
		gint _tmp99_;
		gint _tmp100_;
		gint _part_index = 0;
#line 1491 "Utility/Device.vala"
		_tmp96_ = list;
#line 1491 "Utility/Device.vala"
		_tmp97_ = _g_object_ref0 (_tmp96_);
#line 1491 "Utility/Device.vala"
		_part_list = _tmp97_;
#line 1491 "Utility/Device.vala"
		_tmp98_ = _part_list;
#line 1491 "Utility/Device.vala"
		_tmp99_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp98_);
#line 1491 "Utility/Device.vala"
		_tmp100_ = _tmp99_;
#line 1491 "Utility/Device.vala"
		_part_size = _tmp100_;
#line 1491 "Utility/Device.vala"
		_part_index = -1;
#line 1491 "Utility/Device.vala"
		while (TRUE) {
#line 9368 "Device.c"
			Device* part = NULL;
			GeeArrayList* _tmp101_;
			gpointer _tmp102_;
			Device* _tmp103_;
			const gchar* _tmp104_;
			const gchar* _tmp105_;
#line 1491 "Utility/Device.vala"
			_part_index = _part_index + 1;
#line 1491 "Utility/Device.vala"
			if (!(_part_index < _part_size)) {
#line 1491 "Utility/Device.vala"
				break;
#line 9381 "Device.c"
			}
#line 1491 "Utility/Device.vala"
			_tmp101_ = _part_list;
#line 1491 "Utility/Device.vala"
			_tmp102_ = gee_abstract_list_get ((GeeAbstractList*) _tmp101_, _part_index);
#line 1491 "Utility/Device.vala"
			part = (Device*) _tmp102_;
#line 1492 "Utility/Device.vala"
			_tmp103_ = part;
#line 1492 "Utility/Device.vala"
			_tmp104_ = _tmp103_->pkname;
#line 1492 "Utility/Device.vala"
			_tmp105_ = luks_device->kname;
#line 1492 "Utility/Device.vala"
			if (g_strcmp0 (_tmp104_, _tmp105_) == 0) {
#line 9397 "Device.c"
				Device* _tmp106_;
				Device* _tmp107_;
#line 1493 "Utility/Device.vala"
				_tmp106_ = part;
#line 1493 "Utility/Device.vala"
				_tmp107_ = _g_object_ref0 (_tmp106_);
#line 1493 "Utility/Device.vala"
				_g_object_unref0 (unlocked_device);
#line 1493 "Utility/Device.vala"
				unlocked_device = _tmp107_;
#line 1494 "Utility/Device.vala"
				_g_object_unref0 (part);
#line 1494 "Utility/Device.vala"
				break;
#line 9412 "Device.c"
			}
#line 1491 "Utility/Device.vala"
			_g_object_unref0 (part);
#line 9416 "Device.c"
		}
#line 1491 "Utility/Device.vala"
		_g_object_unref0 (_part_list);
#line 9420 "Device.c"
	}
#line 1498 "Utility/Device.vala"
	is_error = FALSE;
#line 1499 "Utility/Device.vala"
	_tmp108_ = unlocked_device;
#line 1499 "Utility/Device.vala"
	if (_tmp108_ == NULL) {
#line 9428 "Device.c"
		const gchar* _tmp109_;
		gchar* _tmp110_;
		gchar* _tmp111_;
		gchar* _tmp112_;
		const gchar* _tmp113_;
		gchar* _tmp114_;
#line 1500 "Utility/Device.vala"
		_tmp109_ = luks_device->device;
#line 1500 "Utility/Device.vala"
		_tmp110_ = g_strdup_printf (" '%s'", _tmp109_);
#line 1500 "Utility/Device.vala"
		_tmp111_ = _tmp110_;
#line 1500 "Utility/Device.vala"
		_tmp112_ = g_strconcat (_ ("Failed to unlock device"), _tmp111_, NULL);
#line 1500 "Utility/Device.vala"
		_g_free0 (_vala_message);
#line 1500 "Utility/Device.vala"
		_vala_message = _tmp112_;
#line 1500 "Utility/Device.vala"
		_g_free0 (_tmp111_);
#line 1501 "Utility/Device.vala"
		_tmp113_ = std_err;
#line 1501 "Utility/Device.vala"
		_tmp114_ = g_strdup (_tmp113_);
#line 1501 "Utility/Device.vala"
		_g_free0 (_vala_details);
#line 1501 "Utility/Device.vala"
		_vala_details = _tmp114_;
#line 1502 "Utility/Device.vala"
		is_error = TRUE;
#line 9459 "Device.c"
	} else {
		gchar* _tmp115_;
		Device* _tmp116_;
		const gchar* _tmp117_;
		gchar* _tmp118_;
#line 1505 "Utility/Device.vala"
		_tmp115_ = g_strdup (_ ("Unlocked successfully"));
#line 1505 "Utility/Device.vala"
		_g_free0 (_vala_message);
#line 1505 "Utility/Device.vala"
		_vala_message = _tmp115_;
#line 1506 "Utility/Device.vala"
		_tmp116_ = unlocked_device;
#line 1506 "Utility/Device.vala"
		_tmp117_ = _tmp116_->mapped_name;
#line 1506 "Utility/Device.vala"
		_tmp118_ = g_strdup_printf (_ ("Unlocked device is mapped to '%s'"), _tmp117_);
#line 1506 "Utility/Device.vala"
		_g_free0 (_vala_details);
#line 1506 "Utility/Device.vala"
		_vala_details = _tmp118_;
#line 9481 "Device.c"
	}
#line 1509 "Utility/Device.vala"
	if (parent_window != NULL) {
#line 9485 "Device.c"
		const gchar* _tmp119_;
		const gchar* _tmp120_;
#line 1510 "Utility/Device.vala"
		_tmp119_ = _vala_message;
#line 1510 "Utility/Device.vala"
		_tmp120_ = _vala_details;
#line 1510 "Utility/Device.vala"
		tee_jee_gtk_helper_gtk_messagebox (_tmp119_, _tmp120_, parent_window, is_error);
#line 9494 "Device.c"
	}
#line 1513 "Utility/Device.vala"
	result = unlocked_device;
#line 1513 "Utility/Device.vala"
	_g_free0 (luks_name);
#line 1513 "Utility/Device.vala"
	_g_free0 (luks_pass);
#line 1513 "Utility/Device.vala"
	_g_object_unref0 (list);
#line 1513 "Utility/Device.vala"
	_g_free0 (std_err);
#line 1513 "Utility/Device.vala"
	_g_free0 (std_out);
#line 1513 "Utility/Device.vala"
	if (message) {
#line 1513 "Utility/Device.vala"
		*message = _vala_message;
#line 9512 "Device.c"
	} else {
#line 1513 "Utility/Device.vala"
		_g_free0 (_vala_message);
#line 9516 "Device.c"
	}
#line 1513 "Utility/Device.vala"
	if (details) {
#line 1513 "Utility/Device.vala"
		*details = _vala_details;
#line 9522 "Device.c"
	} else {
#line 1513 "Utility/Device.vala"
		_g_free0 (_vala_details);
#line 9526 "Device.c"
	}
#line 1513 "Utility/Device.vala"
	return result;
#line 9530 "Device.c"
}

gboolean
device_luks_lock (const gchar* kname,
                  GtkWindow* parent_window)
{
	gboolean result = FALSE;
	gchar* cmd = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gint status = 0;
	const gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gint _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
#line 1516 "Utility/Device.vala"
	g_return_val_if_fail (kname != NULL, FALSE);
#line 1517 "Utility/Device.vala"
	_tmp0_ = g_strdup_printf ("cryptsetup luksClose %s", kname);
#line 1517 "Utility/Device.vala"
	cmd = _tmp0_;
#line 1519 "Utility/Device.vala"
	_tmp1_ = cmd;
#line 1519 "Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp1_);
#line 1522 "Utility/Device.vala"
	_tmp2_ = cmd;
#line 1522 "Utility/Device.vala"
	_tmp5_ = tee_jee_process_helper_exec_script_sync (_tmp2_, &_tmp3_, &_tmp4_, FALSE, TRUE, TRUE, FALSE);
#line 1522 "Utility/Device.vala"
	_g_free0 (std_out);
#line 1522 "Utility/Device.vala"
	std_out = _tmp3_;
#line 1522 "Utility/Device.vala"
	_g_free0 (std_err);
#line 1522 "Utility/Device.vala"
	std_err = _tmp4_;
#line 1522 "Utility/Device.vala"
	status = _tmp5_;
#line 1523 "Utility/Device.vala"
	_tmp6_ = std_out;
#line 1523 "Utility/Device.vala"
	tee_jee_logging_log_msg (_tmp6_, FALSE);
#line 1524 "Utility/Device.vala"
	_tmp7_ = std_err;
#line 1524 "Utility/Device.vala"
	tee_jee_logging_log_msg (_tmp7_, FALSE);
#line 1526 "Utility/Device.vala"
	if (status != 0) {
#line 1527 "Utility/Device.vala"
		if (parent_window != NULL) {
#line 9586 "Device.c"
			gchar* msg = NULL;
			gchar* _tmp8_;
			const gchar* _tmp9_;
#line 1528 "Utility/Device.vala"
			_tmp8_ = g_strdup_printf ("Failed to lock device: %s", kname);
#line 1528 "Utility/Device.vala"
			msg = _tmp8_;
#line 1529 "Utility/Device.vala"
			_tmp9_ = msg;
#line 1529 "Utility/Device.vala"
			tee_jee_gtk_helper_gtk_messagebox ("Error", _tmp9_, parent_window, TRUE);
#line 1527 "Utility/Device.vala"
			_g_free0 (msg);
#line 9600 "Device.c"
		}
	}
#line 1533 "Utility/Device.vala"
	result = status == 0;
#line 1533 "Utility/Device.vala"
	_g_free0 (std_err);
#line 1533 "Utility/Device.vala"
	_g_free0 (std_out);
#line 1533 "Utility/Device.vala"
	_g_free0 (cmd);
#line 1533 "Utility/Device.vala"
	return result;
#line 9613 "Device.c"
}

gboolean
device_mount (const gchar* dev_name_or_uuid,
              const gchar* mount_point,
              const gchar* mount_options,
              gboolean silent)
{
	gboolean result = FALSE;
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gint ret_val = 0;
	gchar* device = NULL;
	gchar* _tmp1_;
	gchar* uuid = NULL;
	gchar* _tmp2_;
	GeeArrayList* mps = NULL;
	GeeArrayList* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gint _tmp48_;
	gint _tmp49_;
	const gchar* _tmp54_;
	gchar* _tmp55_ = NULL;
	gchar* _tmp56_ = NULL;
	gint _tmp57_;
#line 1547 "Utility/Device.vala"
	g_return_val_if_fail (dev_name_or_uuid != NULL, FALSE);
#line 1547 "Utility/Device.vala"
	g_return_val_if_fail (mount_point != NULL, FALSE);
#line 1547 "Utility/Device.vala"
	g_return_val_if_fail (mount_options != NULL, FALSE);
#line 1555 "Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1555 "Utility/Device.vala"
	cmd = _tmp0_;
#line 1560 "Utility/Device.vala"
	_tmp1_ = g_strdup ("");
#line 1560 "Utility/Device.vala"
	device = _tmp1_;
#line 1561 "Utility/Device.vala"
	_tmp2_ = g_strdup ("");
#line 1561 "Utility/Device.vala"
	uuid = _tmp2_;
#line 1565 "Utility/Device.vala"
	if (g_str_has_prefix (dev_name_or_uuid, "/dev")) {
#line 9663 "Device.c"
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 1566 "Utility/Device.vala"
		_tmp3_ = g_strdup (dev_name_or_uuid);
#line 1566 "Utility/Device.vala"
		_g_free0 (device);
#line 1566 "Utility/Device.vala"
		device = _tmp3_;
#line 1567 "Utility/Device.vala"
		_tmp4_ = device_get_device_uuid (dev_name_or_uuid);
#line 1567 "Utility/Device.vala"
		_g_free0 (uuid);
#line 1567 "Utility/Device.vala"
		uuid = _tmp4_;
#line 9678 "Device.c"
	} else {
		gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
#line 1570 "Utility/Device.vala"
		_tmp5_ = g_strdup (dev_name_or_uuid);
#line 1570 "Utility/Device.vala"
		_g_free0 (uuid);
#line 1570 "Utility/Device.vala"
		uuid = _tmp5_;
#line 1571 "Utility/Device.vala"
		_tmp6_ = uuid;
#line 1571 "Utility/Device.vala"
		_tmp7_ = g_strdup_printf ("/dev/disk/by-uuid/%s", _tmp6_);
#line 1571 "Utility/Device.vala"
		_g_free0 (device);
#line 1571 "Utility/Device.vala"
		device = _tmp7_;
#line 1572 "Utility/Device.vala"
		_tmp8_ = device;
#line 1572 "Utility/Device.vala"
		_tmp9_ = device_resolve_device_name (_tmp8_);
#line 1572 "Utility/Device.vala"
		_g_free0 (device);
#line 1572 "Utility/Device.vala"
		device = _tmp9_;
#line 9707 "Device.c"
	}
#line 1577 "Utility/Device.vala"
	_tmp10_ = device_get_device_mount_points (dev_name_or_uuid);
#line 1577 "Utility/Device.vala"
	mps = _tmp10_;
#line 1579 "Utility/Device.vala"
	tee_jee_logging_log_debug ("------------------");
#line 1580 "Utility/Device.vala"
	_tmp11_ = device;
#line 1580 "Utility/Device.vala"
	_tmp12_ = g_strdup_printf ("arg=%s, device=%s", dev_name_or_uuid, _tmp11_);
#line 1580 "Utility/Device.vala"
	_tmp13_ = _tmp12_;
#line 1580 "Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp13_);
#line 1580 "Utility/Device.vala"
	_g_free0 (_tmp13_);
#line 9725 "Device.c"
	{
		GeeArrayList* _mp_list = NULL;
		GeeArrayList* _tmp14_;
		GeeArrayList* _tmp15_;
		gint _mp_size = 0;
		GeeArrayList* _tmp16_;
		gint _tmp17_;
		gint _tmp18_;
		gint _mp_index = 0;
#line 1581 "Utility/Device.vala"
		_tmp14_ = mps;
#line 1581 "Utility/Device.vala"
		_tmp15_ = _g_object_ref0 (_tmp14_);
#line 1581 "Utility/Device.vala"
		_mp_list = _tmp15_;
#line 1581 "Utility/Device.vala"
		_tmp16_ = _mp_list;
#line 1581 "Utility/Device.vala"
		_tmp17_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp16_);
#line 1581 "Utility/Device.vala"
		_tmp18_ = _tmp17_;
#line 1581 "Utility/Device.vala"
		_mp_size = _tmp18_;
#line 1581 "Utility/Device.vala"
		_mp_index = -1;
#line 1581 "Utility/Device.vala"
		while (TRUE) {
#line 9753 "Device.c"
			MountEntry* mp = NULL;
			GeeArrayList* _tmp19_;
			gpointer _tmp20_;
			MountEntry* _tmp21_;
			const gchar* _tmp22_;
#line 1581 "Utility/Device.vala"
			_mp_index = _mp_index + 1;
#line 1581 "Utility/Device.vala"
			if (!(_mp_index < _mp_size)) {
#line 1581 "Utility/Device.vala"
				break;
#line 9765 "Device.c"
			}
#line 1581 "Utility/Device.vala"
			_tmp19_ = _mp_list;
#line 1581 "Utility/Device.vala"
			_tmp20_ = gee_abstract_list_get ((GeeAbstractList*) _tmp19_, _mp_index);
#line 1581 "Utility/Device.vala"
			mp = (MountEntry*) _tmp20_;
#line 1582 "Utility/Device.vala"
			_tmp21_ = mp;
#line 1582 "Utility/Device.vala"
			_tmp22_ = _tmp21_->mount_point;
#line 1582 "Utility/Device.vala"
			tee_jee_logging_log_debug (_tmp22_);
#line 1581 "Utility/Device.vala"
			_g_object_unref0 (mp);
#line 9781 "Device.c"
		}
#line 1581 "Utility/Device.vala"
		_g_object_unref0 (_mp_list);
#line 9785 "Device.c"
	}
#line 1584 "Utility/Device.vala"
	tee_jee_logging_log_debug ("------------------");
#line 9789 "Device.c"
	{
		GeeArrayList* _mp_list = NULL;
		GeeArrayList* _tmp23_;
		GeeArrayList* _tmp24_;
		gint _mp_size = 0;
		GeeArrayList* _tmp25_;
		gint _tmp26_;
		gint _tmp27_;
		gint _mp_index = 0;
#line 1586 "Utility/Device.vala"
		_tmp23_ = mps;
#line 1586 "Utility/Device.vala"
		_tmp24_ = _g_object_ref0 (_tmp23_);
#line 1586 "Utility/Device.vala"
		_mp_list = _tmp24_;
#line 1586 "Utility/Device.vala"
		_tmp25_ = _mp_list;
#line 1586 "Utility/Device.vala"
		_tmp26_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp25_);
#line 1586 "Utility/Device.vala"
		_tmp27_ = _tmp26_;
#line 1586 "Utility/Device.vala"
		_mp_size = _tmp27_;
#line 1586 "Utility/Device.vala"
		_mp_index = -1;
#line 1586 "Utility/Device.vala"
		while (TRUE) {
#line 9817 "Device.c"
			MountEntry* mp = NULL;
			GeeArrayList* _tmp28_;
			gpointer _tmp29_;
			gboolean _tmp30_ = FALSE;
			MountEntry* _tmp31_;
			const gchar* _tmp32_;
#line 1586 "Utility/Device.vala"
			_mp_index = _mp_index + 1;
#line 1586 "Utility/Device.vala"
			if (!(_mp_index < _mp_size)) {
#line 1586 "Utility/Device.vala"
				break;
#line 9830 "Device.c"
			}
#line 1586 "Utility/Device.vala"
			_tmp28_ = _mp_list;
#line 1586 "Utility/Device.vala"
			_tmp29_ = gee_abstract_list_get ((GeeAbstractList*) _tmp28_, _mp_index);
#line 1586 "Utility/Device.vala"
			mp = (MountEntry*) _tmp29_;
#line 1587 "Utility/Device.vala"
			_tmp31_ = mp;
#line 1587 "Utility/Device.vala"
			_tmp32_ = _tmp31_->mount_point;
#line 1587 "Utility/Device.vala"
			if (g_strcmp0 (_tmp32_, mount_point) == 0) {
#line 9844 "Device.c"
				MountEntry* _tmp33_;
				const gchar* _tmp34_;
#line 1587 "Utility/Device.vala"
				_tmp33_ = mp;
#line 1587 "Utility/Device.vala"
				_tmp34_ = _tmp33_->mount_options;
#line 1587 "Utility/Device.vala"
				_tmp30_ = string_contains (_tmp34_, mount_options);
#line 9853 "Device.c"
			} else {
#line 1587 "Utility/Device.vala"
				_tmp30_ = FALSE;
#line 9857 "Device.c"
			}
#line 1587 "Utility/Device.vala"
			if (_tmp30_) {
#line 1588 "Utility/Device.vala"
				if (!silent) {
#line 9863 "Device.c"
					gchar* msg = NULL;
					const gchar* _tmp35_;
					gchar* _tmp36_;
					MountEntry* _tmp37_;
					const gchar* _tmp38_;
					gint _tmp39_;
					gint _tmp40_;
					const gchar* _tmp47_;
#line 1589 "Utility/Device.vala"
					_tmp35_ = device;
#line 1589 "Utility/Device.vala"
					_tmp36_ = g_strdup_printf ("%s is mounted at: %s", _tmp35_, mount_point);
#line 1589 "Utility/Device.vala"
					msg = _tmp36_;
#line 1590 "Utility/Device.vala"
					_tmp37_ = mp;
#line 1590 "Utility/Device.vala"
					_tmp38_ = _tmp37_->mount_options;
#line 1590 "Utility/Device.vala"
					_tmp39_ = strlen (_tmp38_);
#line 1590 "Utility/Device.vala"
					_tmp40_ = _tmp39_;
#line 1590 "Utility/Device.vala"
					if (_tmp40_ > 0) {
#line 9888 "Device.c"
						const gchar* _tmp41_;
						MountEntry* _tmp42_;
						const gchar* _tmp43_;
						gchar* _tmp44_;
						gchar* _tmp45_;
						gchar* _tmp46_;
#line 1591 "Utility/Device.vala"
						_tmp41_ = msg;
#line 1591 "Utility/Device.vala"
						_tmp42_ = mp;
#line 1591 "Utility/Device.vala"
						_tmp43_ = _tmp42_->mount_options;
#line 1591 "Utility/Device.vala"
						_tmp44_ = g_strdup_printf (", options: %s", _tmp43_);
#line 1591 "Utility/Device.vala"
						_tmp45_ = _tmp44_;
#line 1591 "Utility/Device.vala"
						_tmp46_ = g_strconcat (_tmp41_, _tmp45_, NULL);
#line 1591 "Utility/Device.vala"
						_g_free0 (msg);
#line 1591 "Utility/Device.vala"
						msg = _tmp46_;
#line 1591 "Utility/Device.vala"
						_g_free0 (_tmp45_);
#line 9913 "Device.c"
					}
#line 1593 "Utility/Device.vala"
					_tmp47_ = msg;
#line 1593 "Utility/Device.vala"
					tee_jee_logging_log_msg (_tmp47_, FALSE);
#line 1588 "Utility/Device.vala"
					_g_free0 (msg);
#line 9921 "Device.c"
				}
#line 1595 "Utility/Device.vala"
				result = TRUE;
#line 1595 "Utility/Device.vala"
				_g_object_unref0 (mp);
#line 1595 "Utility/Device.vala"
				_g_object_unref0 (_mp_list);
#line 1595 "Utility/Device.vala"
				_g_object_unref0 (mps);
#line 1595 "Utility/Device.vala"
				_g_free0 (uuid);
#line 1595 "Utility/Device.vala"
				_g_free0 (device);
#line 1595 "Utility/Device.vala"
				_g_free0 (std_err);
#line 1595 "Utility/Device.vala"
				_g_free0 (std_out);
#line 1595 "Utility/Device.vala"
				_g_free0 (cmd);
#line 1595 "Utility/Device.vala"
				return result;
#line 9943 "Device.c"
			}
#line 1586 "Utility/Device.vala"
			_g_object_unref0 (mp);
#line 9947 "Device.c"
		}
#line 1586 "Utility/Device.vala"
		_g_object_unref0 (_mp_list);
#line 9951 "Device.c"
	}
#line 1599 "Utility/Device.vala"
	tee_jee_file_system_dir_create (mount_point, FALSE);
#line 1603 "Utility/Device.vala"
	device_unmount (mount_point);
#line 1607 "Utility/Device.vala"
	_tmp48_ = strlen (mount_options);
#line 1607 "Utility/Device.vala"
	_tmp49_ = _tmp48_;
#line 1607 "Utility/Device.vala"
	if (_tmp49_ > 0) {
#line 9963 "Device.c"
		const gchar* _tmp50_;
		gchar* _tmp51_;
#line 1608 "Utility/Device.vala"
		_tmp50_ = device;
#line 1608 "Utility/Device.vala"
		_tmp51_ = g_strdup_printf ("mount -o %s \"%s\" \"%s\"", mount_options, _tmp50_, mount_point);
#line 1608 "Utility/Device.vala"
		_g_free0 (cmd);
#line 1608 "Utility/Device.vala"
		cmd = _tmp51_;
#line 9974 "Device.c"
	} else {
		const gchar* _tmp52_;
		gchar* _tmp53_;
#line 1611 "Utility/Device.vala"
		_tmp52_ = device;
#line 1611 "Utility/Device.vala"
		_tmp53_ = g_strdup_printf ("mount \"%s\" \"%s\"", _tmp52_, mount_point);
#line 1611 "Utility/Device.vala"
		_g_free0 (cmd);
#line 1611 "Utility/Device.vala"
		cmd = _tmp53_;
#line 9986 "Device.c"
	}
#line 1614 "Utility/Device.vala"
	_tmp54_ = cmd;
#line 1614 "Utility/Device.vala"
	_tmp57_ = tee_jee_process_helper_exec_sync (_tmp54_, &_tmp55_, &_tmp56_);
#line 1614 "Utility/Device.vala"
	_g_free0 (std_out);
#line 1614 "Utility/Device.vala"
	std_out = _tmp55_;
#line 1614 "Utility/Device.vala"
	_g_free0 (std_err);
#line 1614 "Utility/Device.vala"
	std_err = _tmp56_;
#line 1614 "Utility/Device.vala"
	ret_val = _tmp57_;
#line 1616 "Utility/Device.vala"
	if (ret_val != 0) {
#line 10004 "Device.c"
		const gchar* _tmp58_;
		gchar* _tmp59_;
		gchar* _tmp60_;
		const gchar* _tmp61_;
#line 1617 "Utility/Device.vala"
		_tmp58_ = device;
#line 1617 "Utility/Device.vala"
		_tmp59_ = g_strdup_printf ("Failed to mount device '%s' at mount point '%s'", _tmp58_, mount_point);
#line 1617 "Utility/Device.vala"
		_tmp60_ = _tmp59_;
#line 1617 "Utility/Device.vala"
		tee_jee_logging_log_error (_tmp60_, FALSE, FALSE);
#line 1617 "Utility/Device.vala"
		_g_free0 (_tmp60_);
#line 1618 "Utility/Device.vala"
		_tmp61_ = std_err;
#line 1618 "Utility/Device.vala"
		tee_jee_logging_log_error (_tmp61_, FALSE, FALSE);
#line 1619 "Utility/Device.vala"
		result = FALSE;
#line 1619 "Utility/Device.vala"
		_g_object_unref0 (mps);
#line 1619 "Utility/Device.vala"
		_g_free0 (uuid);
#line 1619 "Utility/Device.vala"
		_g_free0 (device);
#line 1619 "Utility/Device.vala"
		_g_free0 (std_err);
#line 1619 "Utility/Device.vala"
		_g_free0 (std_out);
#line 1619 "Utility/Device.vala"
		_g_free0 (cmd);
#line 1619 "Utility/Device.vala"
		return result;
#line 10039 "Device.c"
	} else {
#line 1622 "Utility/Device.vala"
		if (!silent) {
#line 10043 "Device.c"
			Device* dev = NULL;
			const gchar* _tmp62_;
			Device* _tmp63_;
			gchar* _tmp64_ = NULL;
			Device* _tmp65_;
			gchar* _tmp71_ = NULL;
			gint _tmp72_;
			gint _tmp73_;
			gchar* _tmp76_;
			gchar* _tmp77_;
#line 1623 "Utility/Device.vala"
			_tmp62_ = device;
#line 1623 "Utility/Device.vala"
			_tmp63_ = device_get_device_by_name (_tmp62_);
#line 1623 "Utility/Device.vala"
			dev = _tmp63_;
#line 1625 "Utility/Device.vala"
			_tmp65_ = dev;
#line 1625 "Utility/Device.vala"
			if (_tmp65_ == NULL) {
#line 10064 "Device.c"
				const gchar* _tmp66_;
				gchar* _tmp67_;
#line 1625 "Utility/Device.vala"
				_tmp66_ = device;
#line 1625 "Utility/Device.vala"
				_tmp67_ = g_strdup (_tmp66_);
#line 1625 "Utility/Device.vala"
				_g_free0 (_tmp64_);
#line 1625 "Utility/Device.vala"
				_tmp64_ = _tmp67_;
#line 10075 "Device.c"
			} else {
				Device* _tmp68_;
				gchar* _tmp69_;
				gchar* _tmp70_;
#line 1625 "Utility/Device.vala"
				_tmp68_ = dev;
#line 1625 "Utility/Device.vala"
				_tmp69_ = device_get_device_name_with_parent (_tmp68_);
#line 1625 "Utility/Device.vala"
				_tmp70_ = _tmp69_;
#line 1625 "Utility/Device.vala"
				_g_free0 (_tmp64_);
#line 1625 "Utility/Device.vala"
				_tmp64_ = _tmp70_;
#line 10090 "Device.c"
			}
#line 1626 "Utility/Device.vala"
			_tmp72_ = strlen (mount_options);
#line 1626 "Utility/Device.vala"
			_tmp73_ = _tmp72_;
#line 1626 "Utility/Device.vala"
			if (_tmp73_ > 0) {
#line 10098 "Device.c"
				gchar* _tmp74_;
#line 1626 "Utility/Device.vala"
				_tmp74_ = g_strdup_printf (" (%s)", mount_options);
#line 1626 "Utility/Device.vala"
				_g_free0 (_tmp71_);
#line 1626 "Utility/Device.vala"
				_tmp71_ = _tmp74_;
#line 10106 "Device.c"
			} else {
				gchar* _tmp75_;
#line 1626 "Utility/Device.vala"
				_tmp75_ = g_strdup ("");
#line 1626 "Utility/Device.vala"
				_g_free0 (_tmp71_);
#line 1626 "Utility/Device.vala"
				_tmp71_ = _tmp75_;
#line 10115 "Device.c"
			}
#line 1624 "Utility/Device.vala"
			_tmp76_ = g_strdup_printf ("Mounted '%s'%s at '%s'", _tmp64_, _tmp71_, mount_point);
#line 1624 "Utility/Device.vala"
			_tmp77_ = _tmp76_;
#line 1624 "Utility/Device.vala"
			tee_jee_logging_log_msg (_tmp77_, FALSE);
#line 1624 "Utility/Device.vala"
			_g_free0 (_tmp77_);
#line 1622 "Utility/Device.vala"
			_g_free0 (_tmp71_);
#line 1622 "Utility/Device.vala"
			_g_free0 (_tmp64_);
#line 1622 "Utility/Device.vala"
			_g_object_unref0 (dev);
#line 10131 "Device.c"
		}
#line 1629 "Utility/Device.vala"
		result = TRUE;
#line 1629 "Utility/Device.vala"
		_g_object_unref0 (mps);
#line 1629 "Utility/Device.vala"
		_g_free0 (uuid);
#line 1629 "Utility/Device.vala"
		_g_free0 (device);
#line 1629 "Utility/Device.vala"
		_g_free0 (std_err);
#line 1629 "Utility/Device.vala"
		_g_free0 (std_out);
#line 1629 "Utility/Device.vala"
		_g_free0 (cmd);
#line 1629 "Utility/Device.vala"
		return result;
#line 10149 "Device.c"
	}
#line 1547 "Utility/Device.vala"
	_g_object_unref0 (mps);
#line 1547 "Utility/Device.vala"
	_g_free0 (uuid);
#line 1547 "Utility/Device.vala"
	_g_free0 (device);
#line 1547 "Utility/Device.vala"
	_g_free0 (std_err);
#line 1547 "Utility/Device.vala"
	_g_free0 (std_out);
#line 1547 "Utility/Device.vala"
	_g_free0 (cmd);
#line 10163 "Device.c"
}

gchar*
device_automount (const gchar* dev_name_or_uuid,
                  const gchar* mount_options,
                  const gchar* mount_prefix)
{
	gchar* result = NULL;
	gchar* device = NULL;
	gchar* _tmp0_;
	gchar* uuid = NULL;
	gchar* _tmp1_;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp9_;
	Device* dev = NULL;
	GeeArrayList* _tmp10_;
	const gchar* _tmp11_;
	Device* _tmp12_;
	Device* _tmp13_;
	gchar* mount_point = NULL;
	const gchar* _tmp21_;
	gchar* _tmp22_;
	const gchar* _tmp30_;
	const gchar* _tmp31_;
	GError* _inner_error0_ = NULL;
#line 1644 "Utility/Device.vala"
	g_return_val_if_fail (dev_name_or_uuid != NULL, NULL);
#line 1644 "Utility/Device.vala"
	g_return_val_if_fail (mount_options != NULL, NULL);
#line 1644 "Utility/Device.vala"
	g_return_val_if_fail (mount_prefix != NULL, NULL);
#line 1651 "Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1651 "Utility/Device.vala"
	device = _tmp0_;
#line 1652 "Utility/Device.vala"
	_tmp1_ = g_strdup ("");
#line 1652 "Utility/Device.vala"
	uuid = _tmp1_;
#line 1656 "Utility/Device.vala"
	if (g_str_has_prefix (dev_name_or_uuid, "/dev")) {
#line 10205 "Device.c"
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 1657 "Utility/Device.vala"
		_tmp2_ = g_strdup (dev_name_or_uuid);
#line 1657 "Utility/Device.vala"
		_g_free0 (device);
#line 1657 "Utility/Device.vala"
		device = _tmp2_;
#line 1658 "Utility/Device.vala"
		_tmp3_ = device_get_device_uuid (dev_name_or_uuid);
#line 1658 "Utility/Device.vala"
		_g_free0 (uuid);
#line 1658 "Utility/Device.vala"
		uuid = _tmp3_;
#line 10220 "Device.c"
	} else {
		gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
#line 1661 "Utility/Device.vala"
		_tmp4_ = g_strdup (dev_name_or_uuid);
#line 1661 "Utility/Device.vala"
		_g_free0 (uuid);
#line 1661 "Utility/Device.vala"
		uuid = _tmp4_;
#line 1662 "Utility/Device.vala"
		_tmp5_ = uuid;
#line 1662 "Utility/Device.vala"
		_tmp6_ = g_strdup_printf ("/dev/disk/by-uuid/%s", _tmp5_);
#line 1662 "Utility/Device.vala"
		_g_free0 (device);
#line 1662 "Utility/Device.vala"
		device = _tmp6_;
#line 1663 "Utility/Device.vala"
		_tmp7_ = device;
#line 1663 "Utility/Device.vala"
		_tmp8_ = device_resolve_device_name (_tmp7_);
#line 1663 "Utility/Device.vala"
		_g_free0 (device);
#line 1663 "Utility/Device.vala"
		device = _tmp8_;
#line 10249 "Device.c"
	}
#line 1668 "Utility/Device.vala"
	_tmp9_ = device_get_block_devices_using_lsblk ("");
#line 1668 "Utility/Device.vala"
	list = _tmp9_;
#line 1669 "Utility/Device.vala"
	_tmp10_ = list;
#line 1669 "Utility/Device.vala"
	_tmp11_ = uuid;
#line 1669 "Utility/Device.vala"
	_tmp12_ = device_find_device_in_list (_tmp10_, _tmp11_);
#line 1669 "Utility/Device.vala"
	dev = _tmp12_;
#line 1670 "Utility/Device.vala"
	_tmp13_ = dev;
#line 1670 "Utility/Device.vala"
	if (_tmp13_ != NULL) {
#line 10267 "Device.c"
		Device* _tmp14_;
		GeeArrayList* _tmp15_;
		gpointer _tmp16_;
		MountEntry* _tmp17_;
		const gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
#line 1671 "Utility/Device.vala"
		_tmp14_ = dev;
#line 1671 "Utility/Device.vala"
		_tmp15_ = _tmp14_->mount_points;
#line 1671 "Utility/Device.vala"
		_tmp16_ = gee_abstract_list_get ((GeeAbstractList*) _tmp15_, 0);
#line 1671 "Utility/Device.vala"
		_tmp17_ = (MountEntry*) _tmp16_;
#line 1671 "Utility/Device.vala"
		_tmp18_ = _tmp17_->mount_point;
#line 1671 "Utility/Device.vala"
		_tmp19_ = g_strdup (_tmp18_);
#line 1671 "Utility/Device.vala"
		_tmp20_ = _tmp19_;
#line 1671 "Utility/Device.vala"
		_g_object_unref0 (_tmp17_);
#line 1671 "Utility/Device.vala"
		result = _tmp20_;
#line 1671 "Utility/Device.vala"
		_g_object_unref0 (dev);
#line 1671 "Utility/Device.vala"
		_g_object_unref0 (list);
#line 1671 "Utility/Device.vala"
		_g_free0 (uuid);
#line 1671 "Utility/Device.vala"
		_g_free0 (device);
#line 1671 "Utility/Device.vala"
		return result;
#line 10303 "Device.c"
	}
#line 1676 "Utility/Device.vala"
	_tmp21_ = uuid;
#line 1676 "Utility/Device.vala"
	_tmp22_ = g_strdup_printf ("%s/%s", mount_prefix, _tmp21_);
#line 1676 "Utility/Device.vala"
	mount_point = _tmp22_;
#line 10311 "Device.c"
	{
		GFile* file = NULL;
		const gchar* _tmp23_;
		GFile* _tmp24_;
		GFile* _tmp25_;
#line 1679 "Utility/Device.vala"
		_tmp23_ = mount_point;
#line 1679 "Utility/Device.vala"
		_tmp24_ = g_file_new_for_path (_tmp23_);
#line 1679 "Utility/Device.vala"
		file = _tmp24_;
#line 1680 "Utility/Device.vala"
		_tmp25_ = file;
#line 1680 "Utility/Device.vala"
		if (!g_file_query_exists (_tmp25_, NULL)) {
#line 10327 "Device.c"
			GFile* _tmp26_;
#line 1681 "Utility/Device.vala"
			_tmp26_ = file;
#line 1681 "Utility/Device.vala"
			g_file_make_directory_with_parents (_tmp26_, NULL, &_inner_error0_);
#line 1681 "Utility/Device.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1681 "Utility/Device.vala"
				_g_object_unref0 (file);
#line 10337 "Device.c"
				goto __catch47_g_error;
			}
		}
#line 1678 "Utility/Device.vala"
		_g_object_unref0 (file);
#line 10343 "Device.c"
	}
	goto __finally47;
	__catch47_g_error:
	{
		GError* e = NULL;
		GError* _tmp27_;
		const gchar* _tmp28_;
		gchar* _tmp29_;
#line 1678 "Utility/Device.vala"
		e = _inner_error0_;
#line 1678 "Utility/Device.vala"
		_inner_error0_ = NULL;
#line 1685 "Utility/Device.vala"
		_tmp27_ = e;
#line 1685 "Utility/Device.vala"
		_tmp28_ = _tmp27_->message;
#line 1685 "Utility/Device.vala"
		tee_jee_logging_log_error (_tmp28_, FALSE, FALSE);
#line 1686 "Utility/Device.vala"
		_tmp29_ = g_strdup ("");
#line 1686 "Utility/Device.vala"
		result = _tmp29_;
#line 1686 "Utility/Device.vala"
		_g_error_free0 (e);
#line 1686 "Utility/Device.vala"
		_g_free0 (mount_point);
#line 1686 "Utility/Device.vala"
		_g_object_unref0 (dev);
#line 1686 "Utility/Device.vala"
		_g_object_unref0 (list);
#line 1686 "Utility/Device.vala"
		_g_free0 (uuid);
#line 1686 "Utility/Device.vala"
		_g_free0 (device);
#line 1686 "Utility/Device.vala"
		return result;
#line 10380 "Device.c"
	}
	__finally47:
#line 1678 "Utility/Device.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1678 "Utility/Device.vala"
		_g_free0 (mount_point);
#line 1678 "Utility/Device.vala"
		_g_object_unref0 (dev);
#line 1678 "Utility/Device.vala"
		_g_object_unref0 (list);
#line 1678 "Utility/Device.vala"
		_g_free0 (uuid);
#line 1678 "Utility/Device.vala"
		_g_free0 (device);
#line 1678 "Utility/Device.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1678 "Utility/Device.vala"
		g_clear_error (&_inner_error0_);
#line 1678 "Utility/Device.vala"
		return NULL;
#line 10401 "Device.c"
	}
#line 1691 "Utility/Device.vala"
	_tmp30_ = uuid;
#line 1691 "Utility/Device.vala"
	_tmp31_ = mount_point;
#line 1691 "Utility/Device.vala"
	if (device_mount (_tmp30_, _tmp31_, mount_options, FALSE)) {
#line 1692 "Utility/Device.vala"
		result = mount_point;
#line 1692 "Utility/Device.vala"
		_g_object_unref0 (dev);
#line 1692 "Utility/Device.vala"
		_g_object_unref0 (list);
#line 1692 "Utility/Device.vala"
		_g_free0 (uuid);
#line 1692 "Utility/Device.vala"
		_g_free0 (device);
#line 1692 "Utility/Device.vala"
		return result;
#line 10421 "Device.c"
	} else {
		gchar* _tmp32_;
#line 1695 "Utility/Device.vala"
		_tmp32_ = g_strdup ("");
#line 1695 "Utility/Device.vala"
		result = _tmp32_;
#line 1695 "Utility/Device.vala"
		_g_free0 (mount_point);
#line 1695 "Utility/Device.vala"
		_g_object_unref0 (dev);
#line 1695 "Utility/Device.vala"
		_g_object_unref0 (list);
#line 1695 "Utility/Device.vala"
		_g_free0 (uuid);
#line 1695 "Utility/Device.vala"
		_g_free0 (device);
#line 1695 "Utility/Device.vala"
		return result;
#line 10440 "Device.c"
	}
#line 1644 "Utility/Device.vala"
	_g_free0 (mount_point);
#line 1644 "Utility/Device.vala"
	_g_object_unref0 (dev);
#line 1644 "Utility/Device.vala"
	_g_object_unref0 (list);
#line 1644 "Utility/Device.vala"
	_g_free0 (uuid);
#line 1644 "Utility/Device.vala"
	_g_free0 (device);
#line 10452 "Device.c"
}

gboolean
device_unmount (const gchar* mount_point)
{
	gboolean result = FALSE;
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gint ret_val = 0;
	GError* _inner_error0_ = NULL;
#line 1699 "Utility/Device.vala"
	g_return_val_if_fail (mount_point != NULL, FALSE);
#line 1704 "Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1704 "Utility/Device.vala"
	cmd = _tmp0_;
#line 1710 "Utility/Device.vala"
	if (!device_mount_point_in_use (mount_point)) {
#line 1711 "Utility/Device.vala"
		result = TRUE;
#line 1711 "Utility/Device.vala"
		_g_free0 (std_err);
#line 1711 "Utility/Device.vala"
		_g_free0 (std_out);
#line 1711 "Utility/Device.vala"
		_g_free0 (cmd);
#line 1711 "Utility/Device.vala"
		return result;
#line 10483 "Device.c"
	}
	{
		gchar* cmd_unmount = NULL;
		gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		gint _tmp10_ = 0;
		const gchar* _tmp11_;
		gchar* _tmp12_ = NULL;
		gchar* _tmp13_ = NULL;
		gint _tmp14_;
#line 1718 "Utility/Device.vala"
		_tmp1_ = g_strdup_printf ("cat /proc/mounts | awk '{print $2}' | grep '%s' | sort -r | xargs umou" \
"nt", mount_point);
#line 1718 "Utility/Device.vala"
		cmd_unmount = _tmp1_;
#line 1720 "Utility/Device.vala"
		_tmp2_ = g_strdup_printf (": '%s'", mount_point);
#line 1720 "Utility/Device.vala"
		_tmp3_ = _tmp2_;
#line 1720 "Utility/Device.vala"
		_tmp4_ = g_strconcat (_ ("Unmounting from"), _tmp3_, NULL);
#line 1720 "Utility/Device.vala"
		_tmp5_ = _tmp4_;
#line 1720 "Utility/Device.vala"
		tee_jee_logging_log_debug (_tmp5_);
#line 1720 "Utility/Device.vala"
		_g_free0 (_tmp5_);
#line 1720 "Utility/Device.vala"
		_g_free0 (_tmp3_);
#line 1723 "Utility/Device.vala"
		_tmp6_ = g_strdup ("sync");
#line 1723 "Utility/Device.vala"
		_g_free0 (cmd);
#line 1723 "Utility/Device.vala"
		cmd = _tmp6_;
#line 1724 "Utility/Device.vala"
		_tmp7_ = cmd;
#line 1724 "Utility/Device.vala"
		g_spawn_command_line_sync (_tmp7_, &_tmp8_, &_tmp9_, &_tmp10_, &_inner_error0_);
#line 1724 "Utility/Device.vala"
		_g_free0 (std_out);
#line 1724 "Utility/Device.vala"
		std_out = _tmp8_;
#line 1724 "Utility/Device.vala"
		_g_free0 (std_err);
#line 1724 "Utility/Device.vala"
		std_err = _tmp9_;
#line 1724 "Utility/Device.vala"
		ret_val = _tmp10_;
#line 1724 "Utility/Device.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1724 "Utility/Device.vala"
			_g_free0 (cmd_unmount);
#line 10543 "Device.c"
			goto __catch48_g_error;
		}
#line 1728 "Utility/Device.vala"
		_tmp11_ = cmd_unmount;
#line 1728 "Utility/Device.vala"
		_tmp14_ = tee_jee_process_helper_exec_script_sync (_tmp11_, &_tmp12_, &_tmp13_, FALSE, FALSE, TRUE, FALSE);
#line 1728 "Utility/Device.vala"
		_g_free0 (std_out);
#line 1728 "Utility/Device.vala"
		std_out = _tmp12_;
#line 1728 "Utility/Device.vala"
		_g_free0 (std_err);
#line 1728 "Utility/Device.vala"
		std_err = _tmp13_;
#line 1728 "Utility/Device.vala"
		ret_val = _tmp14_;
#line 1730 "Utility/Device.vala"
		if (ret_val != 0) {
#line 10562 "Device.c"
			const gchar* _tmp15_;
#line 1731 "Utility/Device.vala"
			tee_jee_logging_log_error (_ ("Failed to unmount"), FALSE, FALSE);
#line 1732 "Utility/Device.vala"
			_tmp15_ = std_err;
#line 1732 "Utility/Device.vala"
			tee_jee_logging_log_error (_tmp15_, FALSE, FALSE);
#line 10570 "Device.c"
		}
#line 1716 "Utility/Device.vala"
		_g_free0 (cmd_unmount);
#line 10574 "Device.c"
	}
	goto __finally48;
	__catch48_g_error:
	{
		GError* e = NULL;
		GError* _tmp16_;
		const gchar* _tmp17_;
#line 1716 "Utility/Device.vala"
		e = _inner_error0_;
#line 1716 "Utility/Device.vala"
		_inner_error0_ = NULL;
#line 1736 "Utility/Device.vala"
		_tmp16_ = e;
#line 1736 "Utility/Device.vala"
		_tmp17_ = _tmp16_->message;
#line 1736 "Utility/Device.vala"
		tee_jee_logging_log_error (_tmp17_, FALSE, FALSE);
#line 1737 "Utility/Device.vala"
		result = FALSE;
#line 1737 "Utility/Device.vala"
		_g_error_free0 (e);
#line 1737 "Utility/Device.vala"
		_g_free0 (std_err);
#line 1737 "Utility/Device.vala"
		_g_free0 (std_out);
#line 1737 "Utility/Device.vala"
		_g_free0 (cmd);
#line 1737 "Utility/Device.vala"
		return result;
#line 10604 "Device.c"
	}
	__finally48:
#line 1716 "Utility/Device.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 10609 "Device.c"
		gboolean _tmp18_ = FALSE;
#line 1716 "Utility/Device.vala"
		_g_free0 (std_err);
#line 1716 "Utility/Device.vala"
		_g_free0 (std_out);
#line 1716 "Utility/Device.vala"
		_g_free0 (cmd);
#line 1716 "Utility/Device.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1716 "Utility/Device.vala"
		g_clear_error (&_inner_error0_);
#line 1716 "Utility/Device.vala"
		return _tmp18_;
#line 10623 "Device.c"
	}
#line 1741 "Utility/Device.vala"
	if (!device_mount_point_in_use (mount_point)) {
#line 1742 "Utility/Device.vala"
		result = TRUE;
#line 1742 "Utility/Device.vala"
		_g_free0 (std_err);
#line 1742 "Utility/Device.vala"
		_g_free0 (std_out);
#line 1742 "Utility/Device.vala"
		_g_free0 (cmd);
#line 1742 "Utility/Device.vala"
		return result;
#line 10637 "Device.c"
	} else {
#line 1745 "Utility/Device.vala"
		result = FALSE;
#line 1745 "Utility/Device.vala"
		_g_free0 (std_err);
#line 1745 "Utility/Device.vala"
		_g_free0 (std_out);
#line 1745 "Utility/Device.vala"
		_g_free0 (cmd);
#line 1745 "Utility/Device.vala"
		return result;
#line 10649 "Device.c"
	}
#line 1699 "Utility/Device.vala"
	_g_free0 (std_err);
#line 1699 "Utility/Device.vala"
	_g_free0 (std_out);
#line 1699 "Utility/Device.vala"
	_g_free0 (cmd);
#line 10657 "Device.c"
}

gchar*
device_description (Device* self)
{
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 1801 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1802 "Utility/Device.vala"
	_tmp0_ = device_description_formatted (self);
#line 1802 "Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 1802 "Utility/Device.vala"
	_tmp2_ = string_replace (_tmp1_, "<b>", "");
#line 1802 "Utility/Device.vala"
	_tmp3_ = _tmp2_;
#line 1802 "Utility/Device.vala"
	_tmp4_ = string_replace (_tmp3_, "</b>", "");
#line 1802 "Utility/Device.vala"
	_tmp5_ = _tmp4_;
#line 1802 "Utility/Device.vala"
	_g_free0 (_tmp3_);
#line 1802 "Utility/Device.vala"
	_g_free0 (_tmp1_);
#line 1802 "Utility/Device.vala"
	result = _tmp5_;
#line 1802 "Utility/Device.vala"
	return result;
#line 10692 "Device.c"
}

gchar*
device_description_formatted (Device* self)
{
	gchar* result = NULL;
	gchar* s = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp66_;
	gchar* _tmp67_;
#line 1805 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1806 "Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1806 "Utility/Device.vala"
	s = _tmp0_;
#line 1808 "Utility/Device.vala"
	_tmp1_ = self->type;
#line 1808 "Utility/Device.vala"
	if (g_strcmp0 (_tmp1_, "disk") == 0) {
#line 10714 "Device.c"
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		const gchar* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		const gchar* _tmp17_;
		gint _tmp18_;
		gint _tmp19_;
#line 1809 "Utility/Device.vala"
		_tmp2_ = s;
#line 1809 "Utility/Device.vala"
		_tmp3_ = self->kname;
#line 1809 "Utility/Device.vala"
		_tmp4_ = g_strconcat ("<b>", _tmp3_, NULL);
#line 1809 "Utility/Device.vala"
		_tmp5_ = _tmp4_;
#line 1809 "Utility/Device.vala"
		_tmp6_ = g_strconcat (_tmp5_, "</b> ~", NULL);
#line 1809 "Utility/Device.vala"
		_tmp7_ = _tmp6_;
#line 1809 "Utility/Device.vala"
		_tmp8_ = g_strconcat (_tmp2_, _tmp7_, NULL);
#line 1809 "Utility/Device.vala"
		_g_free0 (s);
#line 1809 "Utility/Device.vala"
		s = _tmp8_;
#line 1809 "Utility/Device.vala"
		_g_free0 (_tmp7_);
#line 1809 "Utility/Device.vala"
		_g_free0 (_tmp5_);
#line 1810 "Utility/Device.vala"
		_tmp9_ = self->vendor;
#line 1810 "Utility/Device.vala"
		_tmp10_ = strlen (_tmp9_);
#line 1810 "Utility/Device.vala"
		_tmp11_ = _tmp10_;
#line 1810 "Utility/Device.vala"
		if (_tmp11_ > 0) {
#line 10758 "Device.c"
			const gchar* _tmp12_;
			const gchar* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
#line 1811 "Utility/Device.vala"
			_tmp12_ = s;
#line 1811 "Utility/Device.vala"
			_tmp13_ = self->vendor;
#line 1811 "Utility/Device.vala"
			_tmp14_ = g_strconcat (" ", _tmp13_, NULL);
#line 1811 "Utility/Device.vala"
			_tmp15_ = _tmp14_;
#line 1811 "Utility/Device.vala"
			_tmp16_ = g_strconcat (_tmp12_, _tmp15_, NULL);
#line 1811 "Utility/Device.vala"
			_g_free0 (s);
#line 1811 "Utility/Device.vala"
			s = _tmp16_;
#line 1811 "Utility/Device.vala"
			_g_free0 (_tmp15_);
#line 10780 "Device.c"
		}
#line 1813 "Utility/Device.vala"
		_tmp17_ = self->model;
#line 1813 "Utility/Device.vala"
		_tmp18_ = strlen (_tmp17_);
#line 1813 "Utility/Device.vala"
		_tmp19_ = _tmp18_;
#line 1813 "Utility/Device.vala"
		if (_tmp19_ > 0) {
#line 10790 "Device.c"
			const gchar* _tmp20_;
			const gchar* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
			gchar* _tmp24_;
#line 1814 "Utility/Device.vala"
			_tmp20_ = s;
#line 1814 "Utility/Device.vala"
			_tmp21_ = self->model;
#line 1814 "Utility/Device.vala"
			_tmp22_ = g_strconcat (" ", _tmp21_, NULL);
#line 1814 "Utility/Device.vala"
			_tmp23_ = _tmp22_;
#line 1814 "Utility/Device.vala"
			_tmp24_ = g_strconcat (_tmp20_, _tmp23_, NULL);
#line 1814 "Utility/Device.vala"
			_g_free0 (s);
#line 1814 "Utility/Device.vala"
			s = _tmp24_;
#line 1814 "Utility/Device.vala"
			_g_free0 (_tmp23_);
#line 10812 "Device.c"
		}
#line 1816 "Utility/Device.vala"
		if (self->size_bytes > ((guint64) 0)) {
#line 10816 "Device.c"
			const gchar* _tmp25_;
			gchar* _tmp26_;
			gchar* _tmp27_;
			gchar* _tmp28_;
			gchar* _tmp29_;
			gchar* _tmp30_;
#line 1817 "Utility/Device.vala"
			_tmp25_ = s;
#line 1817 "Utility/Device.vala"
			_tmp26_ = tee_jee_file_system_format_file_size (self->size_bytes, FALSE, "", TRUE, 0);
#line 1817 "Utility/Device.vala"
			_tmp27_ = _tmp26_;
#line 1817 "Utility/Device.vala"
			_tmp28_ = g_strdup_printf (" (%s)", _tmp27_);
#line 1817 "Utility/Device.vala"
			_tmp29_ = _tmp28_;
#line 1817 "Utility/Device.vala"
			_tmp30_ = g_strconcat (_tmp25_, _tmp29_, NULL);
#line 1817 "Utility/Device.vala"
			_g_free0 (s);
#line 1817 "Utility/Device.vala"
			s = _tmp30_;
#line 1817 "Utility/Device.vala"
			_g_free0 (_tmp29_);
#line 1817 "Utility/Device.vala"
			_g_free0 (_tmp27_);
#line 10843 "Device.c"
		}
	} else {
		const gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		gchar* _tmp40_ = NULL;
		const gchar* _tmp41_;
		gint _tmp42_;
		gint _tmp43_;
		const gchar* _tmp49_;
		gchar* _tmp50_;
		gchar* _tmp51_ = NULL;
		const gchar* _tmp52_;
		gint _tmp53_;
		gint _tmp54_;
		const gchar* _tmp58_;
		gchar* _tmp59_;
#line 1821 "Utility/Device.vala"
		_tmp31_ = s;
#line 1821 "Utility/Device.vala"
		_tmp32_ = device_get_short_name_with_parent (self);
#line 1821 "Utility/Device.vala"
		_tmp33_ = _tmp32_;
#line 1821 "Utility/Device.vala"
		_tmp34_ = _tmp33_;
#line 1821 "Utility/Device.vala"
		_tmp35_ = g_strconcat ("<b>", _tmp34_, NULL);
#line 1821 "Utility/Device.vala"
		_tmp36_ = _tmp35_;
#line 1821 "Utility/Device.vala"
		_tmp37_ = g_strconcat (_tmp36_, "</b>", NULL);
#line 1821 "Utility/Device.vala"
		_tmp38_ = _tmp37_;
#line 1821 "Utility/Device.vala"
		_tmp39_ = g_strconcat (_tmp31_, _tmp38_, NULL);
#line 1821 "Utility/Device.vala"
		_g_free0 (s);
#line 1821 "Utility/Device.vala"
		s = _tmp39_;
#line 1821 "Utility/Device.vala"
		_g_free0 (_tmp38_);
#line 1821 "Utility/Device.vala"
		_g_free0 (_tmp36_);
#line 1821 "Utility/Device.vala"
		_g_free0 (_tmp34_);
#line 1822 "Utility/Device.vala"
		_tmp41_ = self->label;
#line 1822 "Utility/Device.vala"
		_tmp42_ = strlen (_tmp41_);
#line 1822 "Utility/Device.vala"
		_tmp43_ = _tmp42_;
#line 1822 "Utility/Device.vala"
		if (_tmp43_ > 0) {
#line 10903 "Device.c"
			const gchar* _tmp44_;
			gchar* _tmp45_;
			gchar* _tmp46_;
			gchar* _tmp47_;
#line 1822 "Utility/Device.vala"
			_tmp44_ = self->label;
#line 1822 "Utility/Device.vala"
			_tmp45_ = g_strconcat (" (", _tmp44_, NULL);
#line 1822 "Utility/Device.vala"
			_tmp46_ = _tmp45_;
#line 1822 "Utility/Device.vala"
			_tmp47_ = g_strconcat (_tmp46_, ")", NULL);
#line 1822 "Utility/Device.vala"
			_g_free0 (_tmp40_);
#line 1822 "Utility/Device.vala"
			_tmp40_ = _tmp47_;
#line 1822 "Utility/Device.vala"
			_g_free0 (_tmp46_);
#line 10922 "Device.c"
		} else {
			gchar* _tmp48_;
#line 1822 "Utility/Device.vala"
			_tmp48_ = g_strdup ("");
#line 1822 "Utility/Device.vala"
			_g_free0 (_tmp40_);
#line 1822 "Utility/Device.vala"
			_tmp40_ = _tmp48_;
#line 10931 "Device.c"
		}
#line 1822 "Utility/Device.vala"
		_tmp49_ = s;
#line 1822 "Utility/Device.vala"
		_tmp50_ = g_strconcat (_tmp49_, _tmp40_, NULL);
#line 1822 "Utility/Device.vala"
		_g_free0 (s);
#line 1822 "Utility/Device.vala"
		s = _tmp50_;
#line 1823 "Utility/Device.vala"
		_tmp52_ = self->fstype;
#line 1823 "Utility/Device.vala"
		_tmp53_ = strlen (_tmp52_);
#line 1823 "Utility/Device.vala"
		_tmp54_ = _tmp53_;
#line 1823 "Utility/Device.vala"
		if (_tmp54_ > 0) {
#line 10949 "Device.c"
			const gchar* _tmp55_;
			gchar* _tmp56_;
#line 1823 "Utility/Device.vala"
			_tmp55_ = self->fstype;
#line 1823 "Utility/Device.vala"
			_tmp56_ = g_strconcat (" ~ ", _tmp55_, NULL);
#line 1823 "Utility/Device.vala"
			_g_free0 (_tmp51_);
#line 1823 "Utility/Device.vala"
			_tmp51_ = _tmp56_;
#line 10960 "Device.c"
		} else {
			gchar* _tmp57_;
#line 1823 "Utility/Device.vala"
			_tmp57_ = g_strdup ("");
#line 1823 "Utility/Device.vala"
			_g_free0 (_tmp51_);
#line 1823 "Utility/Device.vala"
			_tmp51_ = _tmp57_;
#line 10969 "Device.c"
		}
#line 1823 "Utility/Device.vala"
		_tmp58_ = s;
#line 1823 "Utility/Device.vala"
		_tmp59_ = g_strconcat (_tmp58_, _tmp51_, NULL);
#line 1823 "Utility/Device.vala"
		_g_free0 (s);
#line 1823 "Utility/Device.vala"
		s = _tmp59_;
#line 1824 "Utility/Device.vala"
		if (self->size_bytes > ((guint64) 0)) {
#line 10981 "Device.c"
			const gchar* _tmp60_;
			gchar* _tmp61_;
			gchar* _tmp62_;
			gchar* _tmp63_;
			gchar* _tmp64_;
			gchar* _tmp65_;
#line 1825 "Utility/Device.vala"
			_tmp60_ = s;
#line 1825 "Utility/Device.vala"
			_tmp61_ = tee_jee_file_system_format_file_size (self->size_bytes, FALSE, "", TRUE, 0);
#line 1825 "Utility/Device.vala"
			_tmp62_ = _tmp61_;
#line 1825 "Utility/Device.vala"
			_tmp63_ = g_strdup_printf (" (%s)", _tmp62_);
#line 1825 "Utility/Device.vala"
			_tmp64_ = _tmp63_;
#line 1825 "Utility/Device.vala"
			_tmp65_ = g_strconcat (_tmp60_, _tmp64_, NULL);
#line 1825 "Utility/Device.vala"
			_g_free0 (s);
#line 1825 "Utility/Device.vala"
			s = _tmp65_;
#line 1825 "Utility/Device.vala"
			_g_free0 (_tmp64_);
#line 1825 "Utility/Device.vala"
			_g_free0 (_tmp62_);
#line 11008 "Device.c"
		}
#line 1808 "Utility/Device.vala"
		_g_free0 (_tmp51_);
#line 1808 "Utility/Device.vala"
		_g_free0 (_tmp40_);
#line 11014 "Device.c"
	}
#line 1829 "Utility/Device.vala"
	_tmp66_ = s;
#line 1829 "Utility/Device.vala"
	_tmp67_ = string_strip (_tmp66_);
#line 1829 "Utility/Device.vala"
	result = _tmp67_;
#line 1829 "Utility/Device.vala"
	_g_free0 (s);
#line 1829 "Utility/Device.vala"
	return result;
#line 11026 "Device.c"
}

gchar*
device_description_simple (Device* self)
{
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 1832 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1833 "Utility/Device.vala"
	_tmp0_ = device_description_simple_formatted (self);
#line 1833 "Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 1833 "Utility/Device.vala"
	_tmp2_ = string_replace (_tmp1_, "<b>", "");
#line 1833 "Utility/Device.vala"
	_tmp3_ = _tmp2_;
#line 1833 "Utility/Device.vala"
	_tmp4_ = string_replace (_tmp3_, "</b>", "");
#line 1833 "Utility/Device.vala"
	_tmp5_ = _tmp4_;
#line 1833 "Utility/Device.vala"
	_g_free0 (_tmp3_);
#line 1833 "Utility/Device.vala"
	_g_free0 (_tmp1_);
#line 1833 "Utility/Device.vala"
	result = _tmp5_;
#line 1833 "Utility/Device.vala"
	return result;
#line 11061 "Device.c"
}

gchar*
device_description_simple_formatted (Device* self)
{
	gchar* result = NULL;
	gchar* s = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp71_;
	gchar* _tmp72_;
#line 1836 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1838 "Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1838 "Utility/Device.vala"
	s = _tmp0_;
#line 1840 "Utility/Device.vala"
	_tmp1_ = self->type;
#line 1840 "Utility/Device.vala"
	if (g_strcmp0 (_tmp1_, "disk") == 0) {
#line 11083 "Device.c"
		const gchar* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		const gchar* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
#line 1841 "Utility/Device.vala"
		_tmp2_ = self->vendor;
#line 1841 "Utility/Device.vala"
		_tmp3_ = strlen (_tmp2_);
#line 1841 "Utility/Device.vala"
		_tmp4_ = _tmp3_;
#line 1841 "Utility/Device.vala"
		if (_tmp4_ > 0) {
#line 11098 "Device.c"
			const gchar* _tmp5_;
			const gchar* _tmp6_;
			gchar* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
#line 1842 "Utility/Device.vala"
			_tmp5_ = s;
#line 1842 "Utility/Device.vala"
			_tmp6_ = self->vendor;
#line 1842 "Utility/Device.vala"
			_tmp7_ = g_strconcat (" ", _tmp6_, NULL);
#line 1842 "Utility/Device.vala"
			_tmp8_ = _tmp7_;
#line 1842 "Utility/Device.vala"
			_tmp9_ = g_strconcat (_tmp5_, _tmp8_, NULL);
#line 1842 "Utility/Device.vala"
			_g_free0 (s);
#line 1842 "Utility/Device.vala"
			s = _tmp9_;
#line 1842 "Utility/Device.vala"
			_g_free0 (_tmp8_);
#line 11120 "Device.c"
		}
#line 1844 "Utility/Device.vala"
		_tmp10_ = self->model;
#line 1844 "Utility/Device.vala"
		_tmp11_ = strlen (_tmp10_);
#line 1844 "Utility/Device.vala"
		_tmp12_ = _tmp11_;
#line 1844 "Utility/Device.vala"
		if (_tmp12_ > 0) {
#line 11130 "Device.c"
			const gchar* _tmp13_;
			const gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
#line 1845 "Utility/Device.vala"
			_tmp13_ = s;
#line 1845 "Utility/Device.vala"
			_tmp14_ = self->model;
#line 1845 "Utility/Device.vala"
			_tmp15_ = g_strconcat (" ", _tmp14_, NULL);
#line 1845 "Utility/Device.vala"
			_tmp16_ = _tmp15_;
#line 1845 "Utility/Device.vala"
			_tmp17_ = g_strconcat (_tmp13_, _tmp16_, NULL);
#line 1845 "Utility/Device.vala"
			_g_free0 (s);
#line 1845 "Utility/Device.vala"
			s = _tmp17_;
#line 1845 "Utility/Device.vala"
			_g_free0 (_tmp16_);
#line 11152 "Device.c"
		}
#line 1847 "Utility/Device.vala"
		if (self->size_bytes > ((guint64) 0)) {
#line 11156 "Device.c"
			const gchar* _tmp18_;
			gchar* _tmp19_;
			gchar* _tmp20_;
			gint _tmp21_;
			gint _tmp22_;
			gboolean _tmp23_;
#line 1848 "Utility/Device.vala"
			_tmp18_ = s;
#line 1848 "Utility/Device.vala"
			_tmp19_ = string_strip (_tmp18_);
#line 1848 "Utility/Device.vala"
			_tmp20_ = _tmp19_;
#line 1848 "Utility/Device.vala"
			_tmp21_ = strlen (_tmp20_);
#line 1848 "Utility/Device.vala"
			_tmp22_ = _tmp21_;
#line 1848 "Utility/Device.vala"
			_tmp23_ = _tmp22_ == 0;
#line 1848 "Utility/Device.vala"
			_g_free0 (_tmp20_);
#line 1848 "Utility/Device.vala"
			if (_tmp23_) {
#line 11179 "Device.c"
				const gchar* _tmp24_;
				gchar* _tmp25_;
				gchar* _tmp26_;
				gchar* _tmp27_;
				gchar* _tmp28_;
				gchar* _tmp29_;
#line 1849 "Utility/Device.vala"
				_tmp24_ = s;
#line 1849 "Utility/Device.vala"
				_tmp25_ = tee_jee_file_system_format_file_size (self->size_bytes, FALSE, "", TRUE, 0);
#line 1849 "Utility/Device.vala"
				_tmp26_ = _tmp25_;
#line 1849 "Utility/Device.vala"
				_tmp27_ = g_strdup_printf ("%s Device", _tmp26_);
#line 1849 "Utility/Device.vala"
				_tmp28_ = _tmp27_;
#line 1849 "Utility/Device.vala"
				_tmp29_ = g_strconcat (_tmp24_, _tmp28_, NULL);
#line 1849 "Utility/Device.vala"
				_g_free0 (s);
#line 1849 "Utility/Device.vala"
				s = _tmp29_;
#line 1849 "Utility/Device.vala"
				_g_free0 (_tmp28_);
#line 1849 "Utility/Device.vala"
				_g_free0 (_tmp26_);
#line 11206 "Device.c"
			} else {
				const gchar* _tmp30_;
				gchar* _tmp31_;
				gchar* _tmp32_;
				gchar* _tmp33_;
				gchar* _tmp34_;
				gchar* _tmp35_;
#line 1852 "Utility/Device.vala"
				_tmp30_ = s;
#line 1852 "Utility/Device.vala"
				_tmp31_ = tee_jee_file_system_format_file_size (self->size_bytes, FALSE, "", TRUE, 0);
#line 1852 "Utility/Device.vala"
				_tmp32_ = _tmp31_;
#line 1852 "Utility/Device.vala"
				_tmp33_ = g_strdup_printf (" (%s)", _tmp32_);
#line 1852 "Utility/Device.vala"
				_tmp34_ = _tmp33_;
#line 1852 "Utility/Device.vala"
				_tmp35_ = g_strconcat (_tmp30_, _tmp34_, NULL);
#line 1852 "Utility/Device.vala"
				_g_free0 (s);
#line 1852 "Utility/Device.vala"
				s = _tmp35_;
#line 1852 "Utility/Device.vala"
				_g_free0 (_tmp34_);
#line 1852 "Utility/Device.vala"
				_g_free0 (_tmp32_);
#line 11234 "Device.c"
			}
		}
	} else {
		const gchar* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		gchar* _tmp40_;
		gchar* _tmp41_;
		gchar* _tmp42_;
		gchar* _tmp43_;
		gchar* _tmp44_;
		gchar* _tmp45_ = NULL;
		const gchar* _tmp46_;
		gint _tmp47_;
		gint _tmp48_;
		const gchar* _tmp54_;
		gchar* _tmp55_;
		gchar* _tmp56_ = NULL;
		const gchar* _tmp57_;
		gint _tmp58_;
		gint _tmp59_;
		const gchar* _tmp63_;
		gchar* _tmp64_;
#line 1857 "Utility/Device.vala"
		_tmp36_ = s;
#line 1857 "Utility/Device.vala"
		_tmp37_ = device_get_short_name_with_parent (self);
#line 1857 "Utility/Device.vala"
		_tmp38_ = _tmp37_;
#line 1857 "Utility/Device.vala"
		_tmp39_ = _tmp38_;
#line 1857 "Utility/Device.vala"
		_tmp40_ = g_strconcat ("<b>", _tmp39_, NULL);
#line 1857 "Utility/Device.vala"
		_tmp41_ = _tmp40_;
#line 1857 "Utility/Device.vala"
		_tmp42_ = g_strconcat (_tmp41_, "</b>", NULL);
#line 1857 "Utility/Device.vala"
		_tmp43_ = _tmp42_;
#line 1857 "Utility/Device.vala"
		_tmp44_ = g_strconcat (_tmp36_, _tmp43_, NULL);
#line 1857 "Utility/Device.vala"
		_g_free0 (s);
#line 1857 "Utility/Device.vala"
		s = _tmp44_;
#line 1857 "Utility/Device.vala"
		_g_free0 (_tmp43_);
#line 1857 "Utility/Device.vala"
		_g_free0 (_tmp41_);
#line 1857 "Utility/Device.vala"
		_g_free0 (_tmp39_);
#line 1858 "Utility/Device.vala"
		_tmp46_ = self->label;
#line 1858 "Utility/Device.vala"
		_tmp47_ = strlen (_tmp46_);
#line 1858 "Utility/Device.vala"
		_tmp48_ = _tmp47_;
#line 1858 "Utility/Device.vala"
		if (_tmp48_ > 0) {
#line 11295 "Device.c"
			const gchar* _tmp49_;
			gchar* _tmp50_;
			gchar* _tmp51_;
			gchar* _tmp52_;
#line 1858 "Utility/Device.vala"
			_tmp49_ = self->label;
#line 1858 "Utility/Device.vala"
			_tmp50_ = g_strconcat (" (", _tmp49_, NULL);
#line 1858 "Utility/Device.vala"
			_tmp51_ = _tmp50_;
#line 1858 "Utility/Device.vala"
			_tmp52_ = g_strconcat (_tmp51_, ")", NULL);
#line 1858 "Utility/Device.vala"
			_g_free0 (_tmp45_);
#line 1858 "Utility/Device.vala"
			_tmp45_ = _tmp52_;
#line 1858 "Utility/Device.vala"
			_g_free0 (_tmp51_);
#line 11314 "Device.c"
		} else {
			gchar* _tmp53_;
#line 1858 "Utility/Device.vala"
			_tmp53_ = g_strdup ("");
#line 1858 "Utility/Device.vala"
			_g_free0 (_tmp45_);
#line 1858 "Utility/Device.vala"
			_tmp45_ = _tmp53_;
#line 11323 "Device.c"
		}
#line 1858 "Utility/Device.vala"
		_tmp54_ = s;
#line 1858 "Utility/Device.vala"
		_tmp55_ = g_strconcat (_tmp54_, _tmp45_, NULL);
#line 1858 "Utility/Device.vala"
		_g_free0 (s);
#line 1858 "Utility/Device.vala"
		s = _tmp55_;
#line 1859 "Utility/Device.vala"
		_tmp57_ = self->fstype;
#line 1859 "Utility/Device.vala"
		_tmp58_ = strlen (_tmp57_);
#line 1859 "Utility/Device.vala"
		_tmp59_ = _tmp58_;
#line 1859 "Utility/Device.vala"
		if (_tmp59_ > 0) {
#line 11341 "Device.c"
			const gchar* _tmp60_;
			gchar* _tmp61_;
#line 1859 "Utility/Device.vala"
			_tmp60_ = self->fstype;
#line 1859 "Utility/Device.vala"
			_tmp61_ = g_strconcat (" ~ ", _tmp60_, NULL);
#line 1859 "Utility/Device.vala"
			_g_free0 (_tmp56_);
#line 1859 "Utility/Device.vala"
			_tmp56_ = _tmp61_;
#line 11352 "Device.c"
		} else {
			gchar* _tmp62_;
#line 1859 "Utility/Device.vala"
			_tmp62_ = g_strdup ("");
#line 1859 "Utility/Device.vala"
			_g_free0 (_tmp56_);
#line 1859 "Utility/Device.vala"
			_tmp56_ = _tmp62_;
#line 11361 "Device.c"
		}
#line 1859 "Utility/Device.vala"
		_tmp63_ = s;
#line 1859 "Utility/Device.vala"
		_tmp64_ = g_strconcat (_tmp63_, _tmp56_, NULL);
#line 1859 "Utility/Device.vala"
		_g_free0 (s);
#line 1859 "Utility/Device.vala"
		s = _tmp64_;
#line 1860 "Utility/Device.vala"
		if (self->size_bytes > ((guint64) 0)) {
#line 11373 "Device.c"
			const gchar* _tmp65_;
			gchar* _tmp66_;
			gchar* _tmp67_;
			gchar* _tmp68_;
			gchar* _tmp69_;
			gchar* _tmp70_;
#line 1861 "Utility/Device.vala"
			_tmp65_ = s;
#line 1861 "Utility/Device.vala"
			_tmp66_ = tee_jee_file_system_format_file_size (self->size_bytes, FALSE, "", TRUE, 0);
#line 1861 "Utility/Device.vala"
			_tmp67_ = _tmp66_;
#line 1861 "Utility/Device.vala"
			_tmp68_ = g_strdup_printf (" (%s)", _tmp67_);
#line 1861 "Utility/Device.vala"
			_tmp69_ = _tmp68_;
#line 1861 "Utility/Device.vala"
			_tmp70_ = g_strconcat (_tmp65_, _tmp69_, NULL);
#line 1861 "Utility/Device.vala"
			_g_free0 (s);
#line 1861 "Utility/Device.vala"
			s = _tmp70_;
#line 1861 "Utility/Device.vala"
			_g_free0 (_tmp69_);
#line 1861 "Utility/Device.vala"
			_g_free0 (_tmp67_);
#line 11400 "Device.c"
		}
#line 1840 "Utility/Device.vala"
		_g_free0 (_tmp56_);
#line 1840 "Utility/Device.vala"
		_g_free0 (_tmp45_);
#line 11406 "Device.c"
	}
#line 1865 "Utility/Device.vala"
	_tmp71_ = s;
#line 1865 "Utility/Device.vala"
	_tmp72_ = string_strip (_tmp71_);
#line 1865 "Utility/Device.vala"
	result = _tmp72_;
#line 1865 "Utility/Device.vala"
	_g_free0 (s);
#line 1865 "Utility/Device.vala"
	return result;
#line 11418 "Device.c"
}

gchar*
device_description_full_free (Device* self)
{
	gchar* result = NULL;
	gchar* s = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1868 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1869 "Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1869 "Utility/Device.vala"
	s = _tmp0_;
#line 1871 "Utility/Device.vala"
	_tmp1_ = self->type;
#line 1871 "Utility/Device.vala"
	if (g_strcmp0 (_tmp1_, "disk") == 0) {
#line 11438 "Device.c"
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		const gchar* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
#line 1872 "Utility/Device.vala"
		_tmp2_ = s;
#line 1872 "Utility/Device.vala"
		_tmp3_ = self->model;
#line 1872 "Utility/Device.vala"
		_tmp4_ = self->vendor;
#line 1872 "Utility/Device.vala"
		_tmp5_ = g_strdup_printf ("%s %s", _tmp3_, _tmp4_);
#line 1872 "Utility/Device.vala"
		_tmp6_ = _tmp5_;
#line 1872 "Utility/Device.vala"
		_tmp7_ = string_strip (_tmp6_);
#line 1872 "Utility/Device.vala"
		_tmp8_ = _tmp7_;
#line 1872 "Utility/Device.vala"
		_tmp9_ = g_strconcat (_tmp2_, _tmp8_, NULL);
#line 1872 "Utility/Device.vala"
		_g_free0 (s);
#line 1872 "Utility/Device.vala"
		s = _tmp9_;
#line 1872 "Utility/Device.vala"
		_g_free0 (_tmp8_);
#line 1872 "Utility/Device.vala"
		_g_free0 (_tmp6_);
#line 1873 "Utility/Device.vala"
		_tmp10_ = s;
#line 1873 "Utility/Device.vala"
		_tmp11_ = strlen (_tmp10_);
#line 1873 "Utility/Device.vala"
		_tmp12_ = _tmp11_;
#line 1873 "Utility/Device.vala"
		if (_tmp12_ == 0) {
#line 11482 "Device.c"
			gchar* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
#line 1874 "Utility/Device.vala"
			_tmp13_ = tee_jee_file_system_format_file_size (self->size_bytes, FALSE, "", TRUE, 1);
#line 1874 "Utility/Device.vala"
			_tmp14_ = _tmp13_;
#line 1874 "Utility/Device.vala"
			_tmp15_ = g_strdup_printf ("%s Disk", _tmp14_);
#line 1874 "Utility/Device.vala"
			_g_free0 (s);
#line 1874 "Utility/Device.vala"
			s = _tmp15_;
#line 1874 "Utility/Device.vala"
			_g_free0 (_tmp14_);
#line 11498 "Device.c"
		} else {
			const gchar* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
			gchar* _tmp20_;
			gchar* _tmp21_;
#line 1877 "Utility/Device.vala"
			_tmp16_ = s;
#line 1877 "Utility/Device.vala"
			_tmp17_ = tee_jee_file_system_format_file_size (self->size_bytes, FALSE, "", TRUE, 1);
#line 1877 "Utility/Device.vala"
			_tmp18_ = _tmp17_;
#line 1877 "Utility/Device.vala"
			_tmp19_ = g_strdup_printf (" (%s Disk)", _tmp18_);
#line 1877 "Utility/Device.vala"
			_tmp20_ = _tmp19_;
#line 1877 "Utility/Device.vala"
			_tmp21_ = g_strconcat (_tmp16_, _tmp20_, NULL);
#line 1877 "Utility/Device.vala"
			_g_free0 (s);
#line 1877 "Utility/Device.vala"
			s = _tmp21_;
#line 1877 "Utility/Device.vala"
			_g_free0 (_tmp20_);
#line 1877 "Utility/Device.vala"
			_g_free0 (_tmp18_);
#line 11526 "Device.c"
		}
	} else {
		const gchar* _tmp22_;
		const gchar* _tmp23_;
		gchar* _tmp24_;
		const gchar* _tmp25_;
		gint _tmp26_;
		gint _tmp27_;
		const gchar* _tmp33_;
		gint _tmp34_;
		gint _tmp35_;
		guint64 _tmp41_;
		guint64 _tmp42_;
#line 1881 "Utility/Device.vala"
		_tmp22_ = s;
#line 1881 "Utility/Device.vala"
		_tmp23_ = self->kname;
#line 1881 "Utility/Device.vala"
		_tmp24_ = g_strconcat (_tmp22_, _tmp23_, NULL);
#line 1881 "Utility/Device.vala"
		_g_free0 (s);
#line 1881 "Utility/Device.vala"
		s = _tmp24_;
#line 1882 "Utility/Device.vala"
		_tmp25_ = self->label;
#line 1882 "Utility/Device.vala"
		_tmp26_ = strlen (_tmp25_);
#line 1882 "Utility/Device.vala"
		_tmp27_ = _tmp26_;
#line 1882 "Utility/Device.vala"
		if (_tmp27_ > 0) {
#line 11558 "Device.c"
			const gchar* _tmp28_;
			const gchar* _tmp29_;
			gchar* _tmp30_;
			gchar* _tmp31_;
			gchar* _tmp32_;
#line 1883 "Utility/Device.vala"
			_tmp28_ = s;
#line 1883 "Utility/Device.vala"
			_tmp29_ = self->label;
#line 1883 "Utility/Device.vala"
			_tmp30_ = g_strdup_printf (" (%s)", _tmp29_);
#line 1883 "Utility/Device.vala"
			_tmp31_ = _tmp30_;
#line 1883 "Utility/Device.vala"
			_tmp32_ = g_strconcat (_tmp28_, _tmp31_, NULL);
#line 1883 "Utility/Device.vala"
			_g_free0 (s);
#line 1883 "Utility/Device.vala"
			s = _tmp32_;
#line 1883 "Utility/Device.vala"
			_g_free0 (_tmp31_);
#line 11580 "Device.c"
		}
#line 1885 "Utility/Device.vala"
		_tmp33_ = self->fstype;
#line 1885 "Utility/Device.vala"
		_tmp34_ = strlen (_tmp33_);
#line 1885 "Utility/Device.vala"
		_tmp35_ = _tmp34_;
#line 1885 "Utility/Device.vala"
		if (_tmp35_ > 0) {
#line 11590 "Device.c"
			const gchar* _tmp36_;
			const gchar* _tmp37_;
			gchar* _tmp38_;
			gchar* _tmp39_;
			gchar* _tmp40_;
#line 1886 "Utility/Device.vala"
			_tmp36_ = s;
#line 1886 "Utility/Device.vala"
			_tmp37_ = self->fstype;
#line 1886 "Utility/Device.vala"
			_tmp38_ = g_strdup_printf (" ~ %s", _tmp37_);
#line 1886 "Utility/Device.vala"
			_tmp39_ = _tmp38_;
#line 1886 "Utility/Device.vala"
			_tmp40_ = g_strconcat (_tmp36_, _tmp39_, NULL);
#line 1886 "Utility/Device.vala"
			_g_free0 (s);
#line 1886 "Utility/Device.vala"
			s = _tmp40_;
#line 1886 "Utility/Device.vala"
			_g_free0 (_tmp39_);
#line 11612 "Device.c"
		}
#line 1888 "Utility/Device.vala"
		_tmp41_ = device_get_free_bytes (self);
#line 1888 "Utility/Device.vala"
		_tmp42_ = _tmp41_;
#line 1888 "Utility/Device.vala"
		if (_tmp42_ > ((guint64) 0)) {
#line 11620 "Device.c"
			const gchar* _tmp43_;
			gchar* _tmp44_;
			gchar* _tmp45_;
			gchar* _tmp46_;
			gchar* _tmp47_;
			gchar* _tmp48_;
#line 1889 "Utility/Device.vala"
			_tmp43_ = s;
#line 1889 "Utility/Device.vala"
			_tmp44_ = device_description_free (self);
#line 1889 "Utility/Device.vala"
			_tmp45_ = _tmp44_;
#line 1889 "Utility/Device.vala"
			_tmp46_ = g_strdup_printf (" ~ %s", _tmp45_);
#line 1889 "Utility/Device.vala"
			_tmp47_ = _tmp46_;
#line 1889 "Utility/Device.vala"
			_tmp48_ = g_strconcat (_tmp43_, _tmp47_, NULL);
#line 1889 "Utility/Device.vala"
			_g_free0 (s);
#line 1889 "Utility/Device.vala"
			s = _tmp48_;
#line 1889 "Utility/Device.vala"
			_g_free0 (_tmp47_);
#line 1889 "Utility/Device.vala"
			_g_free0 (_tmp45_);
#line 11647 "Device.c"
		}
	}
#line 1893 "Utility/Device.vala"
	result = s;
#line 1893 "Utility/Device.vala"
	return result;
#line 11654 "Device.c"
}

gchar*
device_description_full (Device* self)
{
	gchar* result = NULL;
	gchar* s = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_ = NULL;
	const gchar* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_ = NULL;
	const gchar* _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	const gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_ = NULL;
	const gchar* _tmp25_;
	gint _tmp26_;
	gint _tmp27_;
	const gchar* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_ = NULL;
	gchar* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	gint _tmp37_;
	gint _tmp38_;
	gboolean _tmp39_;
	const gchar* _tmp59_;
	gchar* _tmp60_;
#line 1896 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1897 "Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1897 "Utility/Device.vala"
	s = _tmp0_;
#line 1898 "Utility/Device.vala"
	_tmp1_ = s;
#line 1898 "Utility/Device.vala"
	_tmp2_ = self->device;
#line 1898 "Utility/Device.vala"
	_tmp3_ = g_strconcat (_tmp1_, _tmp2_, NULL);
#line 1898 "Utility/Device.vala"
	_g_free0 (s);
#line 1898 "Utility/Device.vala"
	s = _tmp3_;
#line 1899 "Utility/Device.vala"
	_tmp5_ = self->label;
#line 1899 "Utility/Device.vala"
	_tmp6_ = strlen (_tmp5_);
#line 1899 "Utility/Device.vala"
	_tmp7_ = _tmp6_;
#line 1899 "Utility/Device.vala"
	if (_tmp7_ > 0) {
#line 11717 "Device.c"
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 1899 "Utility/Device.vala"
		_tmp8_ = self->label;
#line 1899 "Utility/Device.vala"
		_tmp9_ = g_strconcat (" (", _tmp8_, NULL);
#line 1899 "Utility/Device.vala"
		_tmp10_ = _tmp9_;
#line 1899 "Utility/Device.vala"
		_tmp11_ = g_strconcat (_tmp10_, ")", NULL);
#line 1899 "Utility/Device.vala"
		_g_free0 (_tmp4_);
#line 1899 "Utility/Device.vala"
		_tmp4_ = _tmp11_;
#line 1899 "Utility/Device.vala"
		_g_free0 (_tmp10_);
#line 11736 "Device.c"
	} else {
		gchar* _tmp12_;
#line 1899 "Utility/Device.vala"
		_tmp12_ = g_strdup ("");
#line 1899 "Utility/Device.vala"
		_g_free0 (_tmp4_);
#line 1899 "Utility/Device.vala"
		_tmp4_ = _tmp12_;
#line 11745 "Device.c"
	}
#line 1899 "Utility/Device.vala"
	_tmp13_ = s;
#line 1899 "Utility/Device.vala"
	_tmp14_ = g_strconcat (_tmp13_, _tmp4_, NULL);
#line 1899 "Utility/Device.vala"
	_g_free0 (s);
#line 1899 "Utility/Device.vala"
	s = _tmp14_;
#line 1900 "Utility/Device.vala"
	_tmp16_ = self->uuid;
#line 1900 "Utility/Device.vala"
	_tmp17_ = strlen (_tmp16_);
#line 1900 "Utility/Device.vala"
	_tmp18_ = _tmp17_;
#line 1900 "Utility/Device.vala"
	if (_tmp18_ > 0) {
#line 11763 "Device.c"
		const gchar* _tmp19_;
		gchar* _tmp20_;
#line 1900 "Utility/Device.vala"
		_tmp19_ = self->uuid;
#line 1900 "Utility/Device.vala"
		_tmp20_ = g_strconcat (" ~ ", _tmp19_, NULL);
#line 1900 "Utility/Device.vala"
		_g_free0 (_tmp15_);
#line 1900 "Utility/Device.vala"
		_tmp15_ = _tmp20_;
#line 11774 "Device.c"
	} else {
		gchar* _tmp21_;
#line 1900 "Utility/Device.vala"
		_tmp21_ = g_strdup ("");
#line 1900 "Utility/Device.vala"
		_g_free0 (_tmp15_);
#line 1900 "Utility/Device.vala"
		_tmp15_ = _tmp21_;
#line 11783 "Device.c"
	}
#line 1900 "Utility/Device.vala"
	_tmp22_ = s;
#line 1900 "Utility/Device.vala"
	_tmp23_ = g_strconcat (_tmp22_, _tmp15_, NULL);
#line 1900 "Utility/Device.vala"
	_g_free0 (s);
#line 1900 "Utility/Device.vala"
	s = _tmp23_;
#line 1901 "Utility/Device.vala"
	_tmp25_ = self->fstype;
#line 1901 "Utility/Device.vala"
	_tmp26_ = strlen (_tmp25_);
#line 1901 "Utility/Device.vala"
	_tmp27_ = _tmp26_;
#line 1901 "Utility/Device.vala"
	if (_tmp27_ > 0) {
#line 11801 "Device.c"
		const gchar* _tmp28_;
		gchar* _tmp29_;
#line 1901 "Utility/Device.vala"
		_tmp28_ = self->fstype;
#line 1901 "Utility/Device.vala"
		_tmp29_ = g_strconcat (" ~ ", _tmp28_, NULL);
#line 1901 "Utility/Device.vala"
		_g_free0 (_tmp24_);
#line 1901 "Utility/Device.vala"
		_tmp24_ = _tmp29_;
#line 11812 "Device.c"
	} else {
		gchar* _tmp30_;
#line 1901 "Utility/Device.vala"
		_tmp30_ = g_strdup ("");
#line 1901 "Utility/Device.vala"
		_g_free0 (_tmp24_);
#line 1901 "Utility/Device.vala"
		_tmp24_ = _tmp30_;
#line 11821 "Device.c"
	}
#line 1901 "Utility/Device.vala"
	_tmp31_ = s;
#line 1901 "Utility/Device.vala"
	_tmp32_ = g_strconcat (_tmp31_, _tmp24_, NULL);
#line 1901 "Utility/Device.vala"
	_g_free0 (s);
#line 1901 "Utility/Device.vala"
	s = _tmp32_;
#line 1902 "Utility/Device.vala"
	_tmp34_ = device_get_used (self);
#line 1902 "Utility/Device.vala"
	_tmp35_ = _tmp34_;
#line 1902 "Utility/Device.vala"
	_tmp36_ = _tmp35_;
#line 1902 "Utility/Device.vala"
	_tmp37_ = strlen (_tmp36_);
#line 1902 "Utility/Device.vala"
	_tmp38_ = _tmp37_;
#line 1902 "Utility/Device.vala"
	_tmp39_ = _tmp38_ > 0;
#line 1902 "Utility/Device.vala"
	_g_free0 (_tmp36_);
#line 1902 "Utility/Device.vala"
	if (_tmp39_) {
#line 11847 "Device.c"
		gchar* _tmp40_;
		gchar* _tmp41_;
		gchar* _tmp42_;
		gchar* _tmp43_;
		gchar* _tmp44_;
		gchar* _tmp45_;
		gchar* _tmp46_;
		gchar* _tmp47_;
		gchar* _tmp48_;
		gchar* _tmp49_;
		gchar* _tmp50_;
		gchar* _tmp51_;
		gchar* _tmp52_;
		gchar* _tmp53_;
		const gchar* _tmp54_;
		gchar* _tmp55_;
		gchar* _tmp56_;
		gchar* _tmp57_;
#line 1902 "Utility/Device.vala"
		_tmp40_ = device_get_used (self);
#line 1902 "Utility/Device.vala"
		_tmp41_ = _tmp40_;
#line 1902 "Utility/Device.vala"
		_tmp42_ = _tmp41_;
#line 1902 "Utility/Device.vala"
		_tmp43_ = g_strconcat (" ~ ", _tmp42_, NULL);
#line 1902 "Utility/Device.vala"
		_tmp44_ = _tmp43_;
#line 1902 "Utility/Device.vala"
		_tmp45_ = g_strconcat (_tmp44_, " / ", NULL);
#line 1902 "Utility/Device.vala"
		_tmp46_ = _tmp45_;
#line 1902 "Utility/Device.vala"
		_tmp47_ = device_get_size (self);
#line 1902 "Utility/Device.vala"
		_tmp48_ = _tmp47_;
#line 1902 "Utility/Device.vala"
		_tmp49_ = _tmp48_;
#line 1902 "Utility/Device.vala"
		_tmp50_ = g_strconcat (_tmp46_, _tmp49_, NULL);
#line 1902 "Utility/Device.vala"
		_tmp51_ = _tmp50_;
#line 1902 "Utility/Device.vala"
		_tmp52_ = g_strconcat (_tmp51_, " GB used (", NULL);
#line 1902 "Utility/Device.vala"
		_tmp53_ = _tmp52_;
#line 1902 "Utility/Device.vala"
		_tmp54_ = self->used_percent;
#line 1902 "Utility/Device.vala"
		_tmp55_ = g_strconcat (_tmp53_, _tmp54_, NULL);
#line 1902 "Utility/Device.vala"
		_tmp56_ = _tmp55_;
#line 1902 "Utility/Device.vala"
		_tmp57_ = g_strconcat (_tmp56_, ")", NULL);
#line 1902 "Utility/Device.vala"
		_g_free0 (_tmp33_);
#line 1902 "Utility/Device.vala"
		_tmp33_ = _tmp57_;
#line 1902 "Utility/Device.vala"
		_g_free0 (_tmp56_);
#line 1902 "Utility/Device.vala"
		_g_free0 (_tmp53_);
#line 1902 "Utility/Device.vala"
		_g_free0 (_tmp51_);
#line 1902 "Utility/Device.vala"
		_g_free0 (_tmp49_);
#line 1902 "Utility/Device.vala"
		_g_free0 (_tmp46_);
#line 1902 "Utility/Device.vala"
		_g_free0 (_tmp44_);
#line 1902 "Utility/Device.vala"
		_g_free0 (_tmp42_);
#line 11920 "Device.c"
	} else {
		gchar* _tmp58_;
#line 1902 "Utility/Device.vala"
		_tmp58_ = g_strdup ("");
#line 1902 "Utility/Device.vala"
		_g_free0 (_tmp33_);
#line 1902 "Utility/Device.vala"
		_tmp33_ = _tmp58_;
#line 11929 "Device.c"
	}
#line 1902 "Utility/Device.vala"
	_tmp59_ = s;
#line 1902 "Utility/Device.vala"
	_tmp60_ = g_strconcat (_tmp59_, _tmp33_, NULL);
#line 1902 "Utility/Device.vala"
	_g_free0 (s);
#line 1902 "Utility/Device.vala"
	s = _tmp60_;
#line 1904 "Utility/Device.vala"
	result = s;
#line 1904 "Utility/Device.vala"
	_g_free0 (_tmp33_);
#line 1904 "Utility/Device.vala"
	_g_free0 (_tmp24_);
#line 1904 "Utility/Device.vala"
	_g_free0 (_tmp15_);
#line 1904 "Utility/Device.vala"
	_g_free0 (_tmp4_);
#line 1904 "Utility/Device.vala"
	return result;
#line 11951 "Device.c"
}

gchar*
device_description_usage (Device* self)
{
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean _tmp5_;
#line 1907 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1908 "Utility/Device.vala"
	_tmp0_ = device_get_used (self);
#line 1908 "Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 1908 "Utility/Device.vala"
	_tmp2_ = _tmp1_;
#line 1908 "Utility/Device.vala"
	_tmp3_ = strlen (_tmp2_);
#line 1908 "Utility/Device.vala"
	_tmp4_ = _tmp3_;
#line 1908 "Utility/Device.vala"
	_tmp5_ = _tmp4_ > 0;
#line 1908 "Utility/Device.vala"
	_g_free0 (_tmp2_);
#line 1908 "Utility/Device.vala"
	if (_tmp5_) {
#line 11982 "Device.c"
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		const gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
#line 1909 "Utility/Device.vala"
		_tmp6_ = device_get_used (self);
#line 1909 "Utility/Device.vala"
		_tmp7_ = _tmp6_;
#line 1909 "Utility/Device.vala"
		_tmp8_ = _tmp7_;
#line 1909 "Utility/Device.vala"
		_tmp9_ = g_strconcat (_tmp8_, " / ", NULL);
#line 1909 "Utility/Device.vala"
		_tmp10_ = _tmp9_;
#line 1909 "Utility/Device.vala"
		_tmp11_ = device_get_size (self);
#line 1909 "Utility/Device.vala"
		_tmp12_ = _tmp11_;
#line 1909 "Utility/Device.vala"
		_tmp13_ = _tmp12_;
#line 1909 "Utility/Device.vala"
		_tmp14_ = g_strconcat (_tmp10_, _tmp13_, NULL);
#line 1909 "Utility/Device.vala"
		_tmp15_ = _tmp14_;
#line 1909 "Utility/Device.vala"
		_tmp16_ = g_strconcat (_tmp15_, " used (", NULL);
#line 1909 "Utility/Device.vala"
		_tmp17_ = _tmp16_;
#line 1909 "Utility/Device.vala"
		_tmp18_ = self->used_percent;
#line 1909 "Utility/Device.vala"
		_tmp19_ = g_strconcat (_tmp17_, _tmp18_, NULL);
#line 1909 "Utility/Device.vala"
		_tmp20_ = _tmp19_;
#line 1909 "Utility/Device.vala"
		_tmp21_ = g_strconcat (_tmp20_, ")", NULL);
#line 1909 "Utility/Device.vala"
		_tmp22_ = _tmp21_;
#line 1909 "Utility/Device.vala"
		_g_free0 (_tmp20_);
#line 1909 "Utility/Device.vala"
		_g_free0 (_tmp17_);
#line 1909 "Utility/Device.vala"
		_g_free0 (_tmp15_);
#line 1909 "Utility/Device.vala"
		_g_free0 (_tmp13_);
#line 1909 "Utility/Device.vala"
		_g_free0 (_tmp10_);
#line 1909 "Utility/Device.vala"
		_g_free0 (_tmp8_);
#line 1909 "Utility/Device.vala"
		result = _tmp22_;
#line 1909 "Utility/Device.vala"
		return result;
#line 12050 "Device.c"
	} else {
		gchar* _tmp23_;
#line 1912 "Utility/Device.vala"
		_tmp23_ = g_strdup ("");
#line 1912 "Utility/Device.vala"
		result = _tmp23_;
#line 1912 "Utility/Device.vala"
		return result;
#line 12059 "Device.c"
	}
}

gchar*
device_description_free (Device* self)
{
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean _tmp5_;
#line 1916 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1917 "Utility/Device.vala"
	_tmp0_ = device_get_used (self);
#line 1917 "Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 1917 "Utility/Device.vala"
	_tmp2_ = _tmp1_;
#line 1917 "Utility/Device.vala"
	_tmp3_ = strlen (_tmp2_);
#line 1917 "Utility/Device.vala"
	_tmp4_ = _tmp3_;
#line 1917 "Utility/Device.vala"
	_tmp5_ = _tmp4_ > 0;
#line 1917 "Utility/Device.vala"
	_g_free0 (_tmp2_);
#line 1917 "Utility/Device.vala"
	if (_tmp5_) {
#line 12091 "Device.c"
		guint64 _tmp6_;
		guint64 _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
#line 1918 "Utility/Device.vala"
		_tmp6_ = device_get_free_bytes (self);
#line 1918 "Utility/Device.vala"
		_tmp7_ = _tmp6_;
#line 1918 "Utility/Device.vala"
		_tmp8_ = tee_jee_file_system_format_file_size (_tmp7_, FALSE, "g", FALSE, 1);
#line 1918 "Utility/Device.vala"
		_tmp9_ = _tmp8_;
#line 1918 "Utility/Device.vala"
		_tmp10_ = g_strconcat (_tmp9_, " / ", NULL);
#line 1918 "Utility/Device.vala"
		_tmp11_ = _tmp10_;
#line 1918 "Utility/Device.vala"
		_tmp12_ = tee_jee_file_system_format_file_size (self->size_bytes, FALSE, "g", TRUE, 1);
#line 1918 "Utility/Device.vala"
		_tmp13_ = _tmp12_;
#line 1918 "Utility/Device.vala"
		_tmp14_ = g_strconcat (_tmp11_, _tmp13_, NULL);
#line 1918 "Utility/Device.vala"
		_tmp15_ = _tmp14_;
#line 1918 "Utility/Device.vala"
		_tmp16_ = g_strconcat (_tmp15_, " free", NULL);
#line 1918 "Utility/Device.vala"
		_tmp17_ = _tmp16_;
#line 1918 "Utility/Device.vala"
		_g_free0 (_tmp15_);
#line 1918 "Utility/Device.vala"
		_g_free0 (_tmp13_);
#line 1918 "Utility/Device.vala"
		_g_free0 (_tmp11_);
#line 1918 "Utility/Device.vala"
		_g_free0 (_tmp9_);
#line 1918 "Utility/Device.vala"
		result = _tmp17_;
#line 1918 "Utility/Device.vala"
		return result;
#line 12140 "Device.c"
	} else {
		gchar* _tmp18_;
#line 1922 "Utility/Device.vala"
		_tmp18_ = g_strdup ("");
#line 1922 "Utility/Device.vala"
		result = _tmp18_;
#line 1922 "Utility/Device.vala"
		return result;
#line 12149 "Device.c"
	}
}

gchar*
device_tooltip_text (Device* self)
{
	gchar* result = NULL;
	gchar* tt = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp92_;
	gchar* _tmp93_;
#line 1926 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1927 "Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1927 "Utility/Device.vala"
	tt = _tmp0_;
#line 1929 "Utility/Device.vala"
	_tmp1_ = self->type;
#line 1929 "Utility/Device.vala"
	if (g_strcmp0 (_tmp1_, "disk") == 0) {
#line 12172 "Device.c"
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		const gchar* _tmp17_;
		const gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		const gchar* _tmp22_;
		const gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_ = NULL;
		const gchar* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
#line 1930 "Utility/Device.vala"
		_tmp2_ = tt;
#line 1930 "Utility/Device.vala"
		_tmp3_ = self->device;
#line 1930 "Utility/Device.vala"
		_tmp4_ = g_strdup_printf ("%-15s: %s\n", _ ("Device"), _tmp3_);
#line 1930 "Utility/Device.vala"
		_tmp5_ = _tmp4_;
#line 1930 "Utility/Device.vala"
		_tmp6_ = g_strconcat (_tmp2_, _tmp5_, NULL);
#line 1930 "Utility/Device.vala"
		_g_free0 (tt);
#line 1930 "Utility/Device.vala"
		tt = _tmp6_;
#line 1930 "Utility/Device.vala"
		_g_free0 (_tmp5_);
#line 1931 "Utility/Device.vala"
		_tmp7_ = tt;
#line 1931 "Utility/Device.vala"
		_tmp8_ = self->vendor;
#line 1931 "Utility/Device.vala"
		_tmp9_ = g_strdup_printf ("%-15s: %s\n", _ ("Vendor"), _tmp8_);
#line 1931 "Utility/Device.vala"
		_tmp10_ = _tmp9_;
#line 1931 "Utility/Device.vala"
		_tmp11_ = g_strconcat (_tmp7_, _tmp10_, NULL);
#line 1931 "Utility/Device.vala"
		_g_free0 (tt);
#line 1931 "Utility/Device.vala"
		tt = _tmp11_;
#line 1931 "Utility/Device.vala"
		_g_free0 (_tmp10_);
#line 1932 "Utility/Device.vala"
		_tmp12_ = tt;
#line 1932 "Utility/Device.vala"
		_tmp13_ = self->model;
#line 1932 "Utility/Device.vala"
		_tmp14_ = g_strdup_printf ("%-15s: %s\n", _ ("Model"), _tmp13_);
#line 1932 "Utility/Device.vala"
		_tmp15_ = _tmp14_;
#line 1932 "Utility/Device.vala"
		_tmp16_ = g_strconcat (_tmp12_, _tmp15_, NULL);
#line 1932 "Utility/Device.vala"
		_g_free0 (tt);
#line 1932 "Utility/Device.vala"
		tt = _tmp16_;
#line 1932 "Utility/Device.vala"
		_g_free0 (_tmp15_);
#line 1933 "Utility/Device.vala"
		_tmp17_ = tt;
#line 1933 "Utility/Device.vala"
		_tmp18_ = self->serial;
#line 1933 "Utility/Device.vala"
		_tmp19_ = g_strdup_printf ("%-15s: %s\n", _ ("Serial"), _tmp18_);
#line 1933 "Utility/Device.vala"
		_tmp20_ = _tmp19_;
#line 1933 "Utility/Device.vala"
		_tmp21_ = g_strconcat (_tmp17_, _tmp20_, NULL);
#line 1933 "Utility/Device.vala"
		_g_free0 (tt);
#line 1933 "Utility/Device.vala"
		tt = _tmp21_;
#line 1933 "Utility/Device.vala"
		_g_free0 (_tmp20_);
#line 1934 "Utility/Device.vala"
		_tmp22_ = tt;
#line 1934 "Utility/Device.vala"
		_tmp23_ = self->revision;
#line 1934 "Utility/Device.vala"
		_tmp24_ = g_strdup_printf ("%-15s: %s\n", _ ("Revision"), _tmp23_);
#line 1934 "Utility/Device.vala"
		_tmp25_ = _tmp24_;
#line 1934 "Utility/Device.vala"
		_tmp26_ = g_strconcat (_tmp22_, _tmp25_, NULL);
#line 1934 "Utility/Device.vala"
		_g_free0 (tt);
#line 1934 "Utility/Device.vala"
		tt = _tmp26_;
#line 1934 "Utility/Device.vala"
		_g_free0 (_tmp25_);
#line 1937 "Utility/Device.vala"
		if (self->size_bytes > ((guint64) 0)) {
#line 12285 "Device.c"
			gchar* _tmp28_;
#line 1937 "Utility/Device.vala"
			_tmp28_ = tee_jee_file_system_format_file_size (self->size_bytes, FALSE, "", TRUE, 1);
#line 1937 "Utility/Device.vala"
			_g_free0 (_tmp27_);
#line 1937 "Utility/Device.vala"
			_tmp27_ = _tmp28_;
#line 12293 "Device.c"
		} else {
			gchar* _tmp29_;
#line 1937 "Utility/Device.vala"
			_tmp29_ = g_strdup ("N/A");
#line 1937 "Utility/Device.vala"
			_g_free0 (_tmp27_);
#line 1937 "Utility/Device.vala"
			_tmp27_ = _tmp29_;
#line 12302 "Device.c"
		}
#line 1936 "Utility/Device.vala"
		_tmp30_ = tt;
#line 1936 "Utility/Device.vala"
		_tmp31_ = g_strdup_printf ("%-15s: %s\n", _ ("Size"), _tmp27_);
#line 1936 "Utility/Device.vala"
		_tmp32_ = _tmp31_;
#line 1936 "Utility/Device.vala"
		_tmp33_ = g_strconcat (_tmp30_, _tmp32_, NULL);
#line 1936 "Utility/Device.vala"
		_g_free0 (tt);
#line 1936 "Utility/Device.vala"
		tt = _tmp33_;
#line 1936 "Utility/Device.vala"
		_g_free0 (_tmp32_);
#line 1929 "Utility/Device.vala"
		_g_free0 (_tmp27_);
#line 12320 "Device.c"
	} else {
		gchar* _tmp34_ = NULL;
		const gchar* _tmp35_;
		gint _tmp36_;
		gint _tmp37_;
		const gchar* _tmp43_;
		gchar* _tmp44_;
		gchar* _tmp45_;
		gchar* _tmp46_;
		const gchar* _tmp53_;
		const gchar* _tmp54_;
		gchar* _tmp55_;
		gchar* _tmp56_;
		gchar* _tmp57_;
		const gchar* _tmp58_;
		const gchar* _tmp59_;
		gchar* _tmp60_;
		gchar* _tmp61_;
		gchar* _tmp62_;
		const gchar* _tmp63_;
		const gchar* _tmp64_;
		gchar* _tmp65_;
		gchar* _tmp66_;
		gchar* _tmp67_;
		const gchar* _tmp68_;
		const gchar* _tmp69_;
		gchar* _tmp70_;
		gchar* _tmp71_;
		gchar* _tmp72_;
		gchar* _tmp73_ = NULL;
		const gchar* _tmp76_;
		gchar* _tmp77_;
		gchar* _tmp78_;
		gchar* _tmp79_;
		gchar* _tmp80_ = NULL;
		const gchar* _tmp83_;
		gchar* _tmp84_;
		gchar* _tmp85_;
		gchar* _tmp86_;
		const gchar* _tmp87_;
		const gchar* _tmp88_;
		gchar* _tmp89_;
		gchar* _tmp90_;
		gchar* _tmp91_;
#line 1941 "Utility/Device.vala"
		_tmp35_ = self->mapped_name;
#line 1941 "Utility/Device.vala"
		_tmp36_ = strlen (_tmp35_);
#line 1941 "Utility/Device.vala"
		_tmp37_ = _tmp36_;
#line 1941 "Utility/Device.vala"
		if (_tmp37_ > 0) {
#line 12373 "Device.c"
			const gchar* _tmp38_;
			const gchar* _tmp39_;
			gchar* _tmp40_;
#line 1941 "Utility/Device.vala"
			_tmp38_ = self->device;
#line 1941 "Utility/Device.vala"
			_tmp39_ = self->mapped_name;
#line 1941 "Utility/Device.vala"
			_tmp40_ = g_strdup_printf ("%s → %s", _tmp38_, _tmp39_);
#line 1941 "Utility/Device.vala"
			_g_free0 (_tmp34_);
#line 1941 "Utility/Device.vala"
			_tmp34_ = _tmp40_;
#line 12387 "Device.c"
		} else {
			const gchar* _tmp41_;
			gchar* _tmp42_;
#line 1941 "Utility/Device.vala"
			_tmp41_ = self->device;
#line 1941 "Utility/Device.vala"
			_tmp42_ = g_strdup (_tmp41_);
#line 1941 "Utility/Device.vala"
			_g_free0 (_tmp34_);
#line 1941 "Utility/Device.vala"
			_tmp34_ = _tmp42_;
#line 12399 "Device.c"
		}
#line 1940 "Utility/Device.vala"
		_tmp43_ = tt;
#line 1940 "Utility/Device.vala"
		_tmp44_ = g_strdup_printf ("%-15s: %s\n", _ ("Device"), _tmp34_);
#line 1940 "Utility/Device.vala"
		_tmp45_ = _tmp44_;
#line 1940 "Utility/Device.vala"
		_tmp46_ = g_strconcat (_tmp43_, _tmp45_, NULL);
#line 1940 "Utility/Device.vala"
		_g_free0 (tt);
#line 1940 "Utility/Device.vala"
		tt = _tmp46_;
#line 1940 "Utility/Device.vala"
		_g_free0 (_tmp45_);
#line 1943 "Utility/Device.vala"
		if (device_has_parent (self)) {
#line 12417 "Device.c"
			const gchar* _tmp47_;
			Device* _tmp48_;
			const gchar* _tmp49_;
			gchar* _tmp50_;
			gchar* _tmp51_;
			gchar* _tmp52_;
#line 1944 "Utility/Device.vala"
			_tmp47_ = tt;
#line 1944 "Utility/Device.vala"
			_tmp48_ = self->parent;
#line 1944 "Utility/Device.vala"
			_tmp49_ = _tmp48_->device;
#line 1944 "Utility/Device.vala"
			_tmp50_ = g_strdup_printf ("%-15s: %s\n", _ ("Parent Device"), _tmp49_);
#line 1944 "Utility/Device.vala"
			_tmp51_ = _tmp50_;
#line 1944 "Utility/Device.vala"
			_tmp52_ = g_strconcat (_tmp47_, _tmp51_, NULL);
#line 1944 "Utility/Device.vala"
			_g_free0 (tt);
#line 1944 "Utility/Device.vala"
			tt = _tmp52_;
#line 1944 "Utility/Device.vala"
			_g_free0 (_tmp51_);
#line 12442 "Device.c"
		}
#line 1946 "Utility/Device.vala"
		_tmp53_ = tt;
#line 1946 "Utility/Device.vala"
		_tmp54_ = self->uuid;
#line 1946 "Utility/Device.vala"
		_tmp55_ = g_strdup_printf ("%-15s: %s\n", _ ("UUID"), _tmp54_);
#line 1946 "Utility/Device.vala"
		_tmp56_ = _tmp55_;
#line 1946 "Utility/Device.vala"
		_tmp57_ = g_strconcat (_tmp53_, _tmp56_, NULL);
#line 1946 "Utility/Device.vala"
		_g_free0 (tt);
#line 1946 "Utility/Device.vala"
		tt = _tmp57_;
#line 1946 "Utility/Device.vala"
		_g_free0 (_tmp56_);
#line 1947 "Utility/Device.vala"
		_tmp58_ = tt;
#line 1947 "Utility/Device.vala"
		_tmp59_ = self->type;
#line 1947 "Utility/Device.vala"
		_tmp60_ = g_strdup_printf ("%-15s: %s\n", _ ("Type"), _tmp59_);
#line 1947 "Utility/Device.vala"
		_tmp61_ = _tmp60_;
#line 1947 "Utility/Device.vala"
		_tmp62_ = g_strconcat (_tmp58_, _tmp61_, NULL);
#line 1947 "Utility/Device.vala"
		_g_free0 (tt);
#line 1947 "Utility/Device.vala"
		tt = _tmp62_;
#line 1947 "Utility/Device.vala"
		_g_free0 (_tmp61_);
#line 1948 "Utility/Device.vala"
		_tmp63_ = tt;
#line 1948 "Utility/Device.vala"
		_tmp64_ = self->fstype;
#line 1948 "Utility/Device.vala"
		_tmp65_ = g_strdup_printf ("%-15s: %s\n", _ ("Filesystem"), _tmp64_);
#line 1948 "Utility/Device.vala"
		_tmp66_ = _tmp65_;
#line 1948 "Utility/Device.vala"
		_tmp67_ = g_strconcat (_tmp63_, _tmp66_, NULL);
#line 1948 "Utility/Device.vala"
		_g_free0 (tt);
#line 1948 "Utility/Device.vala"
		tt = _tmp67_;
#line 1948 "Utility/Device.vala"
		_g_free0 (_tmp66_);
#line 1949 "Utility/Device.vala"
		_tmp68_ = tt;
#line 1949 "Utility/Device.vala"
		_tmp69_ = self->label;
#line 1949 "Utility/Device.vala"
		_tmp70_ = g_strdup_printf ("%-15s: %s\n", _ ("Label"), _tmp69_);
#line 1949 "Utility/Device.vala"
		_tmp71_ = _tmp70_;
#line 1949 "Utility/Device.vala"
		_tmp72_ = g_strconcat (_tmp68_, _tmp71_, NULL);
#line 1949 "Utility/Device.vala"
		_g_free0 (tt);
#line 1949 "Utility/Device.vala"
		tt = _tmp72_;
#line 1949 "Utility/Device.vala"
		_g_free0 (_tmp71_);
#line 1952 "Utility/Device.vala"
		if (self->size_bytes > ((guint64) 0)) {
#line 12510 "Device.c"
			gchar* _tmp74_;
#line 1952 "Utility/Device.vala"
			_tmp74_ = tee_jee_file_system_format_file_size (self->size_bytes, FALSE, "", TRUE, 1);
#line 1952 "Utility/Device.vala"
			_g_free0 (_tmp73_);
#line 1952 "Utility/Device.vala"
			_tmp73_ = _tmp74_;
#line 12518 "Device.c"
		} else {
			gchar* _tmp75_;
#line 1952 "Utility/Device.vala"
			_tmp75_ = g_strdup ("N/A");
#line 1952 "Utility/Device.vala"
			_g_free0 (_tmp73_);
#line 1952 "Utility/Device.vala"
			_tmp73_ = _tmp75_;
#line 12527 "Device.c"
		}
#line 1951 "Utility/Device.vala"
		_tmp76_ = tt;
#line 1951 "Utility/Device.vala"
		_tmp77_ = g_strdup_printf ("%-15s: %s\n", _ ("Size"), _tmp73_);
#line 1951 "Utility/Device.vala"
		_tmp78_ = _tmp77_;
#line 1951 "Utility/Device.vala"
		_tmp79_ = g_strconcat (_tmp76_, _tmp78_, NULL);
#line 1951 "Utility/Device.vala"
		_g_free0 (tt);
#line 1951 "Utility/Device.vala"
		tt = _tmp79_;
#line 1951 "Utility/Device.vala"
		_g_free0 (_tmp78_);
#line 1955 "Utility/Device.vala"
		if (self->used_bytes > ((guint64) 0)) {
#line 12545 "Device.c"
			gchar* _tmp81_;
#line 1955 "Utility/Device.vala"
			_tmp81_ = tee_jee_file_system_format_file_size (self->used_bytes, FALSE, "", TRUE, 1);
#line 1955 "Utility/Device.vala"
			_g_free0 (_tmp80_);
#line 1955 "Utility/Device.vala"
			_tmp80_ = _tmp81_;
#line 12553 "Device.c"
		} else {
			gchar* _tmp82_;
#line 1955 "Utility/Device.vala"
			_tmp82_ = g_strdup ("N/A");
#line 1955 "Utility/Device.vala"
			_g_free0 (_tmp80_);
#line 1955 "Utility/Device.vala"
			_tmp80_ = _tmp82_;
#line 12562 "Device.c"
		}
#line 1954 "Utility/Device.vala"
		_tmp83_ = tt;
#line 1954 "Utility/Device.vala"
		_tmp84_ = g_strdup_printf ("%-15s: %s\n", _ ("Used"), _tmp80_);
#line 1954 "Utility/Device.vala"
		_tmp85_ = _tmp84_;
#line 1954 "Utility/Device.vala"
		_tmp86_ = g_strconcat (_tmp83_, _tmp85_, NULL);
#line 1954 "Utility/Device.vala"
		_g_free0 (tt);
#line 1954 "Utility/Device.vala"
		tt = _tmp86_;
#line 1954 "Utility/Device.vala"
		_g_free0 (_tmp85_);
#line 1957 "Utility/Device.vala"
		_tmp87_ = tt;
#line 1957 "Utility/Device.vala"
		_tmp88_ = self->dist_info;
#line 1957 "Utility/Device.vala"
		_tmp89_ = g_strdup_printf ("%-15s: %s\n", _ ("System"), _tmp88_);
#line 1957 "Utility/Device.vala"
		_tmp90_ = _tmp89_;
#line 1957 "Utility/Device.vala"
		_tmp91_ = g_strconcat (_tmp87_, _tmp90_, NULL);
#line 1957 "Utility/Device.vala"
		_g_free0 (tt);
#line 1957 "Utility/Device.vala"
		tt = _tmp91_;
#line 1957 "Utility/Device.vala"
		_g_free0 (_tmp90_);
#line 1929 "Utility/Device.vala"
		_g_free0 (_tmp80_);
#line 1929 "Utility/Device.vala"
		_g_free0 (_tmp73_);
#line 1929 "Utility/Device.vala"
		_g_free0 (_tmp34_);
#line 12600 "Device.c"
	}
#line 1960 "Utility/Device.vala"
	_tmp92_ = tt;
#line 1960 "Utility/Device.vala"
	_tmp93_ = g_strdup_printf ("<tt>%s</tt>", _tmp92_);
#line 1960 "Utility/Device.vala"
	result = _tmp93_;
#line 1960 "Utility/Device.vala"
	_g_free0 (tt);
#line 1960 "Utility/Device.vala"
	return result;
#line 12612 "Device.c"
}

static gchar*
device_display_name (Device* self,
                     gboolean short_name,
                     gboolean show_label,
                     gboolean show_parent,
                     gboolean show_alias)
{
	gchar* result = NULL;
	gchar* txt = NULL;
	gchar* _tmp0_;
	const gchar* _tmp7_;
#line 1963 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1965 "Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 1965 "Utility/Device.vala"
	txt = _tmp0_;
#line 1967 "Utility/Device.vala"
	if (short_name) {
#line 12634 "Device.c"
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_;
#line 1968 "Utility/Device.vala"
		_tmp1_ = txt;
#line 1968 "Utility/Device.vala"
		_tmp2_ = self->kname;
#line 1968 "Utility/Device.vala"
		_tmp3_ = g_strconcat (_tmp1_, _tmp2_, NULL);
#line 1968 "Utility/Device.vala"
		_g_free0 (txt);
#line 1968 "Utility/Device.vala"
		txt = _tmp3_;
#line 12648 "Device.c"
	} else {
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
#line 1971 "Utility/Device.vala"
		_tmp4_ = txt;
#line 1971 "Utility/Device.vala"
		_tmp5_ = self->device;
#line 1971 "Utility/Device.vala"
		_tmp6_ = g_strconcat (_tmp4_, _tmp5_, NULL);
#line 1971 "Utility/Device.vala"
		_g_free0 (txt);
#line 1971 "Utility/Device.vala"
		txt = _tmp6_;
#line 12663 "Device.c"
	}
#line 1974 "Utility/Device.vala"
	_tmp7_ = self->type;
#line 1974 "Utility/Device.vala"
	if (g_strcmp0 (_tmp7_, "disk") == 0) {
#line 12669 "Device.c"
		const gchar* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		const gchar* _tmp16_;
		gint _tmp17_;
		gint _tmp18_;
#line 1975 "Utility/Device.vala"
		_tmp8_ = self->vendor;
#line 1975 "Utility/Device.vala"
		_tmp9_ = strlen (_tmp8_);
#line 1975 "Utility/Device.vala"
		_tmp10_ = _tmp9_;
#line 1975 "Utility/Device.vala"
		if (_tmp10_ > 0) {
#line 12684 "Device.c"
			const gchar* _tmp11_;
			const gchar* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
#line 1976 "Utility/Device.vala"
			_tmp11_ = txt;
#line 1976 "Utility/Device.vala"
			_tmp12_ = self->vendor;
#line 1976 "Utility/Device.vala"
			_tmp13_ = g_strconcat (" ", _tmp12_, NULL);
#line 1976 "Utility/Device.vala"
			_tmp14_ = _tmp13_;
#line 1976 "Utility/Device.vala"
			_tmp15_ = g_strconcat (_tmp11_, _tmp14_, NULL);
#line 1976 "Utility/Device.vala"
			_g_free0 (txt);
#line 1976 "Utility/Device.vala"
			txt = _tmp15_;
#line 1976 "Utility/Device.vala"
			_g_free0 (_tmp14_);
#line 12706 "Device.c"
		}
#line 1978 "Utility/Device.vala"
		_tmp16_ = self->model;
#line 1978 "Utility/Device.vala"
		_tmp17_ = strlen (_tmp16_);
#line 1978 "Utility/Device.vala"
		_tmp18_ = _tmp17_;
#line 1978 "Utility/Device.vala"
		if (_tmp18_ > 0) {
#line 12716 "Device.c"
			const gchar* _tmp19_;
			const gchar* _tmp20_;
			gchar* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
#line 1979 "Utility/Device.vala"
			_tmp19_ = txt;
#line 1979 "Utility/Device.vala"
			_tmp20_ = self->model;
#line 1979 "Utility/Device.vala"
			_tmp21_ = g_strconcat (" ", _tmp20_, NULL);
#line 1979 "Utility/Device.vala"
			_tmp22_ = _tmp21_;
#line 1979 "Utility/Device.vala"
			_tmp23_ = g_strconcat (_tmp19_, _tmp22_, NULL);
#line 1979 "Utility/Device.vala"
			_g_free0 (txt);
#line 1979 "Utility/Device.vala"
			txt = _tmp23_;
#line 1979 "Utility/Device.vala"
			_g_free0 (_tmp22_);
#line 12738 "Device.c"
		}
#line 1981 "Utility/Device.vala"
		if (self->size_bytes > ((guint64) 0)) {
#line 12742 "Device.c"
			const gchar* _tmp24_;
			gchar* _tmp25_;
			gchar* _tmp26_;
			gint _tmp27_;
			gint _tmp28_;
			gboolean _tmp29_;
#line 1982 "Utility/Device.vala"
			_tmp24_ = txt;
#line 1982 "Utility/Device.vala"
			_tmp25_ = string_strip (_tmp24_);
#line 1982 "Utility/Device.vala"
			_tmp26_ = _tmp25_;
#line 1982 "Utility/Device.vala"
			_tmp27_ = strlen (_tmp26_);
#line 1982 "Utility/Device.vala"
			_tmp28_ = _tmp27_;
#line 1982 "Utility/Device.vala"
			_tmp29_ = _tmp28_ == 0;
#line 1982 "Utility/Device.vala"
			_g_free0 (_tmp26_);
#line 1982 "Utility/Device.vala"
			if (_tmp29_) {
#line 12765 "Device.c"
				const gchar* _tmp30_;
				gchar* _tmp31_;
				gchar* _tmp32_;
				gchar* _tmp33_;
				gchar* _tmp34_;
				gchar* _tmp35_;
#line 1983 "Utility/Device.vala"
				_tmp30_ = txt;
#line 1983 "Utility/Device.vala"
				_tmp31_ = tee_jee_file_system_format_file_size (self->size_bytes, FALSE, "", TRUE, 0);
#line 1983 "Utility/Device.vala"
				_tmp32_ = _tmp31_;
#line 1983 "Utility/Device.vala"
				_tmp33_ = g_strdup_printf ("%s Device", _tmp32_);
#line 1983 "Utility/Device.vala"
				_tmp34_ = _tmp33_;
#line 1983 "Utility/Device.vala"
				_tmp35_ = g_strconcat (_tmp30_, _tmp34_, NULL);
#line 1983 "Utility/Device.vala"
				_g_free0 (txt);
#line 1983 "Utility/Device.vala"
				txt = _tmp35_;
#line 1983 "Utility/Device.vala"
				_g_free0 (_tmp34_);
#line 1983 "Utility/Device.vala"
				_g_free0 (_tmp32_);
#line 12792 "Device.c"
			} else {
				const gchar* _tmp36_;
				gchar* _tmp37_;
				gchar* _tmp38_;
				gchar* _tmp39_;
				gchar* _tmp40_;
				gchar* _tmp41_;
#line 1986 "Utility/Device.vala"
				_tmp36_ = txt;
#line 1986 "Utility/Device.vala"
				_tmp37_ = tee_jee_file_system_format_file_size (self->size_bytes, FALSE, "", TRUE, 0);
#line 1986 "Utility/Device.vala"
				_tmp38_ = _tmp37_;
#line 1986 "Utility/Device.vala"
				_tmp39_ = g_strdup_printf (" (%s)", _tmp38_);
#line 1986 "Utility/Device.vala"
				_tmp40_ = _tmp39_;
#line 1986 "Utility/Device.vala"
				_tmp41_ = g_strconcat (_tmp36_, _tmp40_, NULL);
#line 1986 "Utility/Device.vala"
				_g_free0 (txt);
#line 1986 "Utility/Device.vala"
				txt = _tmp41_;
#line 1986 "Utility/Device.vala"
				_g_free0 (_tmp40_);
#line 1986 "Utility/Device.vala"
				_g_free0 (_tmp38_);
#line 12820 "Device.c"
			}
		}
	} else {
		gboolean _tmp42_ = FALSE;
		gboolean _tmp51_ = FALSE;
		gboolean _tmp52_ = FALSE;
		gboolean _tmp60_ = FALSE;
#line 1991 "Utility/Device.vala"
		if (show_label) {
#line 12830 "Device.c"
			const gchar* _tmp43_;
			gint _tmp44_;
			gint _tmp45_;
#line 1991 "Utility/Device.vala"
			_tmp43_ = self->label;
#line 1991 "Utility/Device.vala"
			_tmp44_ = strlen (_tmp43_);
#line 1991 "Utility/Device.vala"
			_tmp45_ = _tmp44_;
#line 1991 "Utility/Device.vala"
			_tmp42_ = _tmp45_ > 0;
#line 12842 "Device.c"
		} else {
#line 1991 "Utility/Device.vala"
			_tmp42_ = FALSE;
#line 12846 "Device.c"
		}
#line 1991 "Utility/Device.vala"
		if (_tmp42_) {
#line 12850 "Device.c"
			const gchar* _tmp46_;
			const gchar* _tmp47_;
			gchar* _tmp48_;
			gchar* _tmp49_;
			gchar* _tmp50_;
#line 1992 "Utility/Device.vala"
			_tmp46_ = txt;
#line 1992 "Utility/Device.vala"
			_tmp47_ = self->label;
#line 1992 "Utility/Device.vala"
			_tmp48_ = g_strdup_printf ("(%s)", _tmp47_);
#line 1992 "Utility/Device.vala"
			_tmp49_ = _tmp48_;
#line 1992 "Utility/Device.vala"
			_tmp50_ = g_strconcat (_tmp46_, _tmp49_, NULL);
#line 1992 "Utility/Device.vala"
			_g_free0 (txt);
#line 1992 "Utility/Device.vala"
			txt = _tmp50_;
#line 1992 "Utility/Device.vala"
			_g_free0 (_tmp49_);
#line 12872 "Device.c"
		}
#line 1994 "Utility/Device.vala"
		if (show_parent) {
#line 1994 "Utility/Device.vala"
			_tmp52_ = device_has_parent (self);
#line 12878 "Device.c"
		} else {
#line 1994 "Utility/Device.vala"
			_tmp52_ = FALSE;
#line 12882 "Device.c"
		}
#line 1994 "Utility/Device.vala"
		if (_tmp52_) {
#line 12886 "Device.c"
			Device* _tmp53_;
			const gchar* _tmp54_;
#line 1994 "Utility/Device.vala"
			_tmp53_ = self->parent;
#line 1994 "Utility/Device.vala"
			_tmp54_ = _tmp53_->type;
#line 1994 "Utility/Device.vala"
			_tmp51_ = g_strcmp0 (_tmp54_, "part") == 0;
#line 12895 "Device.c"
		} else {
#line 1994 "Utility/Device.vala"
			_tmp51_ = FALSE;
#line 12899 "Device.c"
		}
#line 1994 "Utility/Device.vala"
		if (_tmp51_) {
#line 12903 "Device.c"
			const gchar* _tmp55_;
			const gchar* _tmp56_;
			gchar* _tmp57_;
			gchar* _tmp58_;
			gchar* _tmp59_;
#line 1995 "Utility/Device.vala"
			_tmp55_ = txt;
#line 1995 "Utility/Device.vala"
			_tmp56_ = self->pkname;
#line 1995 "Utility/Device.vala"
			_tmp57_ = g_strdup_printf ("(%s)", _tmp56_);
#line 1995 "Utility/Device.vala"
			_tmp58_ = _tmp57_;
#line 1995 "Utility/Device.vala"
			_tmp59_ = g_strconcat (_tmp55_, _tmp58_, NULL);
#line 1995 "Utility/Device.vala"
			_g_free0 (txt);
#line 1995 "Utility/Device.vala"
			txt = _tmp59_;
#line 1995 "Utility/Device.vala"
			_g_free0 (_tmp58_);
#line 12925 "Device.c"
		}
#line 1997 "Utility/Device.vala"
		if (show_alias) {
#line 12929 "Device.c"
			const gchar* _tmp61_;
			gint _tmp62_;
			gint _tmp63_;
#line 1997 "Utility/Device.vala"
			_tmp61_ = self->mapped_name;
#line 1997 "Utility/Device.vala"
			_tmp62_ = strlen (_tmp61_);
#line 1997 "Utility/Device.vala"
			_tmp63_ = _tmp62_;
#line 1997 "Utility/Device.vala"
			_tmp60_ = _tmp63_ > 0;
#line 12941 "Device.c"
		} else {
#line 1997 "Utility/Device.vala"
			_tmp60_ = FALSE;
#line 12945 "Device.c"
		}
#line 1997 "Utility/Device.vala"
		if (_tmp60_) {
#line 12949 "Device.c"
			const gchar* _tmp64_;
			const gchar* _tmp65_;
			gchar* _tmp66_;
			gchar* _tmp67_;
			gchar* _tmp68_;
#line 1998 "Utility/Device.vala"
			_tmp64_ = txt;
#line 1998 "Utility/Device.vala"
			_tmp65_ = self->mapped_name;
#line 1998 "Utility/Device.vala"
			_tmp66_ = g_strdup_printf ("(%s)", _tmp65_);
#line 1998 "Utility/Device.vala"
			_tmp67_ = _tmp66_;
#line 1998 "Utility/Device.vala"
			_tmp68_ = g_strconcat (_tmp64_, _tmp67_, NULL);
#line 1998 "Utility/Device.vala"
			_g_free0 (txt);
#line 1998 "Utility/Device.vala"
			txt = _tmp68_;
#line 1998 "Utility/Device.vala"
			_g_free0 (_tmp67_);
#line 12971 "Device.c"
		}
	}
#line 2002 "Utility/Device.vala"
	result = txt;
#line 2002 "Utility/Device.vala"
	return result;
#line 12978 "Device.c"
}

void
device_test_all (void)
{
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	GeeArrayList* _tmp4_;
	GeeArrayList* _tmp5_;
	GeeArrayList* _tmp6_;
	GeeArrayList* _tmp7_;
	GeeArrayList* _tmp8_;
	GeeArrayList* _tmp9_;
#line 2008 "Utility/Device.vala"
	_tmp0_ = device_get_block_devices_using_lsblk ("");
#line 2008 "Utility/Device.vala"
	list = _tmp0_;
#line 2009 "Utility/Device.vala"
	tee_jee_logging_log_msg ("\n> get_block_devices_using_lsblk()", FALSE);
#line 2010 "Utility/Device.vala"
	_tmp1_ = list;
#line 2010 "Utility/Device.vala"
	device_print_device_list (_tmp1_);
#line 2012 "Utility/Device.vala"
	tee_jee_logging_log_msg ("", FALSE);
#line 2018 "Utility/Device.vala"
	_tmp2_ = device_get_mounted_filesystems_using_mtab ();
#line 2018 "Utility/Device.vala"
	_g_object_unref0 (list);
#line 2018 "Utility/Device.vala"
	list = _tmp2_;
#line 2019 "Utility/Device.vala"
	tee_jee_logging_log_msg ("\n> get_mounted_filesystems_using_mtab()", FALSE);
#line 2020 "Utility/Device.vala"
	_tmp3_ = list;
#line 2020 "Utility/Device.vala"
	device_print_device_mounts (_tmp3_);
#line 2022 "Utility/Device.vala"
	tee_jee_logging_log_msg ("", FALSE);
#line 2024 "Utility/Device.vala"
	_tmp4_ = device_get_disk_space_using_df ("");
#line 2024 "Utility/Device.vala"
	_g_object_unref0 (list);
#line 2024 "Utility/Device.vala"
	list = _tmp4_;
#line 2025 "Utility/Device.vala"
	tee_jee_logging_log_msg ("\n> get_disk_space_using_df()", FALSE);
#line 2026 "Utility/Device.vala"
	_tmp5_ = list;
#line 2026 "Utility/Device.vala"
	device_print_device_disk_space (_tmp5_);
#line 2028 "Utility/Device.vala"
	tee_jee_logging_log_msg ("", FALSE);
#line 2030 "Utility/Device.vala"
	_tmp6_ = device_get_filesystems (TRUE, TRUE);
#line 2030 "Utility/Device.vala"
	_g_object_unref0 (list);
#line 2030 "Utility/Device.vala"
	list = _tmp6_;
#line 2031 "Utility/Device.vala"
	tee_jee_logging_log_msg ("\n> get_filesystems()", FALSE);
#line 2032 "Utility/Device.vala"
	_tmp7_ = list;
#line 2032 "Utility/Device.vala"
	device_print_device_list (_tmp7_);
#line 2033 "Utility/Device.vala"
	_tmp8_ = list;
#line 2033 "Utility/Device.vala"
	device_print_device_mounts (_tmp8_);
#line 2034 "Utility/Device.vala"
	_tmp9_ = list;
#line 2034 "Utility/Device.vala"
	device_print_device_disk_space (_tmp9_);
#line 2036 "Utility/Device.vala"
	tee_jee_logging_log_msg ("", FALSE);
#line 2007 "Utility/Device.vala"
	_g_object_unref0 (list);
#line 13059 "Device.c"
}

void
device_print_device_list (GeeArrayList* list)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 2039 "Utility/Device.vala"
	g_return_if_fail (list != NULL);
#line 2041 "Utility/Device.vala"
	tee_jee_logging_log_debug ("");
#line 2043 "Utility/Device.vala"
	_tmp0_ = g_strdup_printf ("%-12s ,%-5s ,%-5s ,%-36s ,%s", "device", "pkname", "kname", "uuid", "mapped_name");
#line 2043 "Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 2043 "Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp1_);
#line 2043 "Utility/Device.vala"
	_g_free0 (_tmp1_);
#line 2050 "Utility/Device.vala"
	_tmp2_ = g_strnfill ((gsize) 100, '-');
#line 2050 "Utility/Device.vala"
	_tmp3_ = _tmp2_;
#line 2050 "Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp3_);
#line 2050 "Utility/Device.vala"
	_g_free0 (_tmp3_);
#line 13089 "Device.c"
	{
		GeeArrayList* _dev_list = NULL;
		GeeArrayList* _tmp4_;
		gint _dev_size = 0;
		GeeArrayList* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		gint _dev_index = 0;
#line 2052 "Utility/Device.vala"
		_tmp4_ = _g_object_ref0 (list);
#line 2052 "Utility/Device.vala"
		_dev_list = _tmp4_;
#line 2052 "Utility/Device.vala"
		_tmp5_ = _dev_list;
#line 2052 "Utility/Device.vala"
		_tmp6_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp5_);
#line 2052 "Utility/Device.vala"
		_tmp7_ = _tmp6_;
#line 2052 "Utility/Device.vala"
		_dev_size = _tmp7_;
#line 2052 "Utility/Device.vala"
		_dev_index = -1;
#line 2052 "Utility/Device.vala"
		while (TRUE) {
#line 13114 "Device.c"
			Device* dev = NULL;
			GeeArrayList* _tmp8_;
			gpointer _tmp9_;
			Device* _tmp10_;
			const gchar* _tmp11_;
			Device* _tmp12_;
			const gchar* _tmp13_;
			Device* _tmp14_;
			const gchar* _tmp15_;
			Device* _tmp16_;
			const gchar* _tmp17_;
			Device* _tmp18_;
			const gchar* _tmp19_;
			gchar* _tmp20_;
			gchar* _tmp21_;
#line 2052 "Utility/Device.vala"
			_dev_index = _dev_index + 1;
#line 2052 "Utility/Device.vala"
			if (!(_dev_index < _dev_size)) {
#line 2052 "Utility/Device.vala"
				break;
#line 13136 "Device.c"
			}
#line 2052 "Utility/Device.vala"
			_tmp8_ = _dev_list;
#line 2052 "Utility/Device.vala"
			_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _dev_index);
#line 2052 "Utility/Device.vala"
			dev = (Device*) _tmp9_;
#line 2053 "Utility/Device.vala"
			_tmp10_ = dev;
#line 2053 "Utility/Device.vala"
			_tmp11_ = _tmp10_->device;
#line 2053 "Utility/Device.vala"
			_tmp12_ = dev;
#line 2053 "Utility/Device.vala"
			_tmp13_ = _tmp12_->pkname;
#line 2053 "Utility/Device.vala"
			_tmp14_ = dev;
#line 2053 "Utility/Device.vala"
			_tmp15_ = _tmp14_->kname;
#line 2053 "Utility/Device.vala"
			_tmp16_ = dev;
#line 2053 "Utility/Device.vala"
			_tmp17_ = _tmp16_->uuid;
#line 2053 "Utility/Device.vala"
			_tmp18_ = dev;
#line 2053 "Utility/Device.vala"
			_tmp19_ = _tmp18_->mapped_name;
#line 2053 "Utility/Device.vala"
			_tmp20_ = g_strdup_printf ("%-12s ,%-5s ,%-5s ,%-36s ,%s", _tmp11_, _tmp13_, _tmp15_, _tmp17_, _tmp19_);
#line 2053 "Utility/Device.vala"
			_tmp21_ = _tmp20_;
#line 2053 "Utility/Device.vala"
			tee_jee_logging_log_debug (_tmp21_);
#line 2053 "Utility/Device.vala"
			_g_free0 (_tmp21_);
#line 2052 "Utility/Device.vala"
			_g_object_unref0 (dev);
#line 13174 "Device.c"
		}
#line 2052 "Utility/Device.vala"
		_g_object_unref0 (_dev_list);
#line 13178 "Device.c"
	}
#line 2062 "Utility/Device.vala"
	tee_jee_logging_log_debug ("");
#line 13182 "Device.c"
}

void
device_print_device_mounts (GeeArrayList* list)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 2115 "Utility/Device.vala"
	g_return_if_fail (list != NULL);
#line 2117 "Utility/Device.vala"
	tee_jee_logging_log_debug ("");
#line 2119 "Utility/Device.vala"
	_tmp0_ = g_strdup_printf ("%-15s %s", "device", "> mount_points (mount_options)");
#line 2119 "Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 2119 "Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp1_);
#line 2119 "Utility/Device.vala"
	_g_free0 (_tmp1_);
#line 2125 "Utility/Device.vala"
	_tmp2_ = g_strnfill ((gsize) 100, '-');
#line 2125 "Utility/Device.vala"
	_tmp3_ = _tmp2_;
#line 2125 "Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp3_);
#line 2125 "Utility/Device.vala"
	_g_free0 (_tmp3_);
#line 13212 "Device.c"
	{
		GeeArrayList* _dev_list = NULL;
		GeeArrayList* _tmp4_;
		gint _dev_size = 0;
		GeeArrayList* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		gint _dev_index = 0;
#line 2127 "Utility/Device.vala"
		_tmp4_ = _g_object_ref0 (list);
#line 2127 "Utility/Device.vala"
		_dev_list = _tmp4_;
#line 2127 "Utility/Device.vala"
		_tmp5_ = _dev_list;
#line 2127 "Utility/Device.vala"
		_tmp6_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp5_);
#line 2127 "Utility/Device.vala"
		_tmp7_ = _tmp6_;
#line 2127 "Utility/Device.vala"
		_dev_size = _tmp7_;
#line 2127 "Utility/Device.vala"
		_dev_index = -1;
#line 2127 "Utility/Device.vala"
		while (TRUE) {
#line 13237 "Device.c"
			Device* dev = NULL;
			GeeArrayList* _tmp8_;
			gpointer _tmp9_;
			gchar* mps = NULL;
			gchar* _tmp10_;
			Device* _tmp35_;
			const gchar* _tmp36_;
			const gchar* _tmp37_;
			gchar* _tmp38_;
			gchar* _tmp39_;
#line 2127 "Utility/Device.vala"
			_dev_index = _dev_index + 1;
#line 2127 "Utility/Device.vala"
			if (!(_dev_index < _dev_size)) {
#line 2127 "Utility/Device.vala"
				break;
#line 13254 "Device.c"
			}
#line 2127 "Utility/Device.vala"
			_tmp8_ = _dev_list;
#line 2127 "Utility/Device.vala"
			_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _dev_index);
#line 2127 "Utility/Device.vala"
			dev = (Device*) _tmp9_;
#line 2129 "Utility/Device.vala"
			_tmp10_ = g_strdup ("");
#line 2129 "Utility/Device.vala"
			mps = _tmp10_;
#line 13266 "Device.c"
			{
				GeeArrayList* _mp_list = NULL;
				Device* _tmp11_;
				GeeArrayList* _tmp12_;
				GeeArrayList* _tmp13_;
				gint _mp_size = 0;
				GeeArrayList* _tmp14_;
				gint _tmp15_;
				gint _tmp16_;
				gint _mp_index = 0;
#line 2130 "Utility/Device.vala"
				_tmp11_ = dev;
#line 2130 "Utility/Device.vala"
				_tmp12_ = _tmp11_->mount_points;
#line 2130 "Utility/Device.vala"
				_tmp13_ = _g_object_ref0 (_tmp12_);
#line 2130 "Utility/Device.vala"
				_mp_list = _tmp13_;
#line 2130 "Utility/Device.vala"
				_tmp14_ = _mp_list;
#line 2130 "Utility/Device.vala"
				_tmp15_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp14_);
#line 2130 "Utility/Device.vala"
				_tmp16_ = _tmp15_;
#line 2130 "Utility/Device.vala"
				_mp_size = _tmp16_;
#line 2130 "Utility/Device.vala"
				_mp_index = -1;
#line 2130 "Utility/Device.vala"
				while (TRUE) {
#line 13297 "Device.c"
					MountEntry* mp = NULL;
					GeeArrayList* _tmp17_;
					gpointer _tmp18_;
					const gchar* _tmp19_;
					MountEntry* _tmp20_;
					const gchar* _tmp21_;
					gchar* _tmp22_;
					gchar* _tmp23_;
					gchar* _tmp24_;
					MountEntry* _tmp25_;
					const gchar* _tmp26_;
					gint _tmp27_;
					gint _tmp28_;
#line 2130 "Utility/Device.vala"
					_mp_index = _mp_index + 1;
#line 2130 "Utility/Device.vala"
					if (!(_mp_index < _mp_size)) {
#line 2130 "Utility/Device.vala"
						break;
#line 13317 "Device.c"
					}
#line 2130 "Utility/Device.vala"
					_tmp17_ = _mp_list;
#line 2130 "Utility/Device.vala"
					_tmp18_ = gee_abstract_list_get ((GeeAbstractList*) _tmp17_, _mp_index);
#line 2130 "Utility/Device.vala"
					mp = (MountEntry*) _tmp18_;
#line 2131 "Utility/Device.vala"
					_tmp19_ = mps;
#line 2131 "Utility/Device.vala"
					_tmp20_ = mp;
#line 2131 "Utility/Device.vala"
					_tmp21_ = _tmp20_->mount_point;
#line 2131 "Utility/Device.vala"
					_tmp22_ = g_strdup_printf ("\n    %s -> ", _tmp21_);
#line 2131 "Utility/Device.vala"
					_tmp23_ = _tmp22_;
#line 2131 "Utility/Device.vala"
					_tmp24_ = g_strconcat (_tmp19_, _tmp23_, NULL);
#line 2131 "Utility/Device.vala"
					_g_free0 (mps);
#line 2131 "Utility/Device.vala"
					mps = _tmp24_;
#line 2131 "Utility/Device.vala"
					_g_free0 (_tmp23_);
#line 2132 "Utility/Device.vala"
					_tmp25_ = mp;
#line 2132 "Utility/Device.vala"
					_tmp26_ = _tmp25_->mount_options;
#line 2132 "Utility/Device.vala"
					_tmp27_ = strlen (_tmp26_);
#line 2132 "Utility/Device.vala"
					_tmp28_ = _tmp27_;
#line 2132 "Utility/Device.vala"
					if (_tmp28_ > 0) {
#line 13353 "Device.c"
						const gchar* _tmp29_;
						MountEntry* _tmp30_;
						const gchar* _tmp31_;
						gchar* _tmp32_;
						gchar* _tmp33_;
						gchar* _tmp34_;
#line 2133 "Utility/Device.vala"
						_tmp29_ = mps;
#line 2133 "Utility/Device.vala"
						_tmp30_ = mp;
#line 2133 "Utility/Device.vala"
						_tmp31_ = _tmp30_->mount_options;
#line 2133 "Utility/Device.vala"
						_tmp32_ = g_strdup_printf (" %s", _tmp31_);
#line 2133 "Utility/Device.vala"
						_tmp33_ = _tmp32_;
#line 2133 "Utility/Device.vala"
						_tmp34_ = g_strconcat (_tmp29_, _tmp33_, NULL);
#line 2133 "Utility/Device.vala"
						_g_free0 (mps);
#line 2133 "Utility/Device.vala"
						mps = _tmp34_;
#line 2133 "Utility/Device.vala"
						_g_free0 (_tmp33_);
#line 13378 "Device.c"
					}
#line 2130 "Utility/Device.vala"
					_g_object_unref0 (mp);
#line 13382 "Device.c"
				}
#line 2130 "Utility/Device.vala"
				_g_object_unref0 (_mp_list);
#line 13386 "Device.c"
			}
#line 2137 "Utility/Device.vala"
			_tmp35_ = dev;
#line 2137 "Utility/Device.vala"
			_tmp36_ = _tmp35_->device;
#line 2137 "Utility/Device.vala"
			_tmp37_ = mps;
#line 2137 "Utility/Device.vala"
			_tmp38_ = g_strdup_printf ("%-15s %s", _tmp36_, _tmp37_);
#line 2137 "Utility/Device.vala"
			_tmp39_ = _tmp38_;
#line 2137 "Utility/Device.vala"
			tee_jee_logging_log_debug (_tmp39_);
#line 2137 "Utility/Device.vala"
			_g_free0 (_tmp39_);
#line 2127 "Utility/Device.vala"
			_g_free0 (mps);
#line 2127 "Utility/Device.vala"
			_g_object_unref0 (dev);
#line 13406 "Device.c"
		}
#line 2127 "Utility/Device.vala"
		_g_object_unref0 (_dev_list);
#line 13410 "Device.c"
	}
#line 2145 "Utility/Device.vala"
	tee_jee_logging_log_debug ("");
#line 13414 "Device.c"
}

void
device_print_device_disk_space (GeeArrayList* list)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 2148 "Utility/Device.vala"
	g_return_if_fail (list != NULL);
#line 2149 "Utility/Device.vala"
	tee_jee_logging_log_debug ("");
#line 2151 "Utility/Device.vala"
	_tmp0_ = g_strdup_printf ("%-15s %-12s %15s %15s %15s %10s", "device", "fstype", "size", "used", "available", "used_percent");
#line 2151 "Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 2151 "Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp1_);
#line 2151 "Utility/Device.vala"
	_g_free0 (_tmp1_);
#line 2160 "Utility/Device.vala"
	_tmp2_ = g_strnfill ((gsize) 100, '-');
#line 2160 "Utility/Device.vala"
	_tmp3_ = _tmp2_;
#line 2160 "Utility/Device.vala"
	tee_jee_logging_log_debug (_tmp3_);
#line 2160 "Utility/Device.vala"
	_g_free0 (_tmp3_);
#line 13444 "Device.c"
	{
		GeeArrayList* _dev_list = NULL;
		GeeArrayList* _tmp4_;
		gint _dev_size = 0;
		GeeArrayList* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		gint _dev_index = 0;
#line 2162 "Utility/Device.vala"
		_tmp4_ = _g_object_ref0 (list);
#line 2162 "Utility/Device.vala"
		_dev_list = _tmp4_;
#line 2162 "Utility/Device.vala"
		_tmp5_ = _dev_list;
#line 2162 "Utility/Device.vala"
		_tmp6_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp5_);
#line 2162 "Utility/Device.vala"
		_tmp7_ = _tmp6_;
#line 2162 "Utility/Device.vala"
		_dev_size = _tmp7_;
#line 2162 "Utility/Device.vala"
		_dev_index = -1;
#line 2162 "Utility/Device.vala"
		while (TRUE) {
#line 13469 "Device.c"
			Device* dev = NULL;
			GeeArrayList* _tmp8_;
			gpointer _tmp9_;
			Device* _tmp10_;
			const gchar* _tmp11_;
			Device* _tmp12_;
			const gchar* _tmp13_;
			Device* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			Device* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
			Device* _tmp20_;
			gchar* _tmp21_;
			gchar* _tmp22_;
			Device* _tmp23_;
			const gchar* _tmp24_;
			gchar* _tmp25_;
			gchar* _tmp26_;
#line 2162 "Utility/Device.vala"
			_dev_index = _dev_index + 1;
#line 2162 "Utility/Device.vala"
			if (!(_dev_index < _dev_size)) {
#line 2162 "Utility/Device.vala"
				break;
#line 13496 "Device.c"
			}
#line 2162 "Utility/Device.vala"
			_tmp8_ = _dev_list;
#line 2162 "Utility/Device.vala"
			_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _dev_index);
#line 2162 "Utility/Device.vala"
			dev = (Device*) _tmp9_;
#line 2163 "Utility/Device.vala"
			_tmp10_ = dev;
#line 2163 "Utility/Device.vala"
			_tmp11_ = _tmp10_->device;
#line 2163 "Utility/Device.vala"
			_tmp12_ = dev;
#line 2163 "Utility/Device.vala"
			_tmp13_ = _tmp12_->fstype;
#line 2163 "Utility/Device.vala"
			_tmp14_ = dev;
#line 2163 "Utility/Device.vala"
			_tmp15_ = tee_jee_file_system_format_file_size (_tmp14_->size_bytes, TRUE, "", TRUE, 1);
#line 2163 "Utility/Device.vala"
			_tmp16_ = _tmp15_;
#line 2163 "Utility/Device.vala"
			_tmp17_ = dev;
#line 2163 "Utility/Device.vala"
			_tmp18_ = tee_jee_file_system_format_file_size (_tmp17_->used_bytes, TRUE, "", TRUE, 1);
#line 2163 "Utility/Device.vala"
			_tmp19_ = _tmp18_;
#line 2163 "Utility/Device.vala"
			_tmp20_ = dev;
#line 2163 "Utility/Device.vala"
			_tmp21_ = tee_jee_file_system_format_file_size (_tmp20_->available_bytes, TRUE, "", TRUE, 1);
#line 2163 "Utility/Device.vala"
			_tmp22_ = _tmp21_;
#line 2163 "Utility/Device.vala"
			_tmp23_ = dev;
#line 2163 "Utility/Device.vala"
			_tmp24_ = _tmp23_->used_percent;
#line 2163 "Utility/Device.vala"
			_tmp25_ = g_strdup_printf ("%-15s %-12s %15s %15s %15s %10s", _tmp11_, _tmp13_, _tmp16_, _tmp19_, _tmp22_, _tmp24_);
#line 2163 "Utility/Device.vala"
			_tmp26_ = _tmp25_;
#line 2163 "Utility/Device.vala"
			tee_jee_logging_log_debug (_tmp26_);
#line 2163 "Utility/Device.vala"
			_g_free0 (_tmp26_);
#line 2163 "Utility/Device.vala"
			_g_free0 (_tmp22_);
#line 2163 "Utility/Device.vala"
			_g_free0 (_tmp19_);
#line 2163 "Utility/Device.vala"
			_g_free0 (_tmp16_);
#line 2162 "Utility/Device.vala"
			_g_object_unref0 (dev);
#line 13550 "Device.c"
		}
#line 2162 "Utility/Device.vala"
		_g_object_unref0 (_dev_list);
#line 13554 "Device.c"
	}
#line 2173 "Utility/Device.vala"
	tee_jee_logging_log_debug ("");
#line 13558 "Device.c"
}

guint64
device_get_free_bytes (Device* self)
{
	guint64 result;
	guint64 _tmp0_ = 0ULL;
#line 121 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 122 "Utility/Device.vala"
	if (self->used_bytes == ((guint64) 0)) {
#line 122 "Utility/Device.vala"
		_tmp0_ = (guint64) 0;
#line 13572 "Device.c"
	} else {
#line 122 "Utility/Device.vala"
		_tmp0_ = self->size_bytes - self->used_bytes;
#line 13576 "Device.c"
	}
#line 122 "Utility/Device.vala"
	result = _tmp0_;
#line 122 "Utility/Device.vala"
	return result;
#line 13582 "Device.c"
}

gchar*
device_get_size (Device* self)
{
	gchar* result;
#line 127 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 128 "Utility/Device.vala"
	if (((gdouble) self->size_bytes) < device_GB) {
#line 13593 "Device.c"
		gchar* _tmp0_;
#line 129 "Utility/Device.vala"
		_tmp0_ = g_strdup_printf ("%.1f MB", self->size_bytes / device_MB);
#line 129 "Utility/Device.vala"
		result = _tmp0_;
#line 129 "Utility/Device.vala"
		return result;
#line 13601 "Device.c"
	} else {
#line 131 "Utility/Device.vala"
		if (self->size_bytes > ((guint64) 0)) {
#line 13605 "Device.c"
			gchar* _tmp1_;
#line 132 "Utility/Device.vala"
			_tmp1_ = g_strdup_printf ("%.1f GB", self->size_bytes / device_GB);
#line 132 "Utility/Device.vala"
			result = _tmp1_;
#line 132 "Utility/Device.vala"
			return result;
#line 13613 "Device.c"
		} else {
			gchar* _tmp2_;
#line 135 "Utility/Device.vala"
			_tmp2_ = g_strdup ("");
#line 135 "Utility/Device.vala"
			result = _tmp2_;
#line 135 "Utility/Device.vala"
			return result;
#line 13622 "Device.c"
		}
	}
}

gchar*
device_get_used (Device* self)
{
	gchar* result;
	gchar* _tmp0_ = NULL;
#line 141 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 142 "Utility/Device.vala"
	if (self->used_bytes == ((guint64) 0)) {
#line 13636 "Device.c"
		gchar* _tmp1_;
#line 142 "Utility/Device.vala"
		_tmp1_ = g_strdup ("");
#line 142 "Utility/Device.vala"
		_g_free0 (_tmp0_);
#line 142 "Utility/Device.vala"
		_tmp0_ = _tmp1_;
#line 13644 "Device.c"
	} else {
		gchar* _tmp2_;
#line 142 "Utility/Device.vala"
		_tmp2_ = g_strdup_printf ("%.1f GB", self->used_bytes / device_GB);
#line 142 "Utility/Device.vala"
		_g_free0 (_tmp0_);
#line 142 "Utility/Device.vala"
		_tmp0_ = _tmp2_;
#line 13653 "Device.c"
	}
#line 142 "Utility/Device.vala"
	result = _tmp0_;
#line 142 "Utility/Device.vala"
	return result;
#line 13659 "Device.c"
}

gchar*
device_get_free (Device* self)
{
	gchar* result;
	gchar* _tmp0_ = NULL;
	guint64 _tmp1_;
	guint64 _tmp2_;
#line 147 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 148 "Utility/Device.vala"
	_tmp1_ = device_get_free_bytes (self);
#line 148 "Utility/Device.vala"
	_tmp2_ = _tmp1_;
#line 148 "Utility/Device.vala"
	if (_tmp2_ == ((guint64) 0)) {
#line 13677 "Device.c"
		gchar* _tmp3_;
#line 148 "Utility/Device.vala"
		_tmp3_ = g_strdup ("");
#line 148 "Utility/Device.vala"
		_g_free0 (_tmp0_);
#line 148 "Utility/Device.vala"
		_tmp0_ = _tmp3_;
#line 13685 "Device.c"
	} else {
		guint64 _tmp4_;
		guint64 _tmp5_;
		gchar* _tmp6_;
#line 148 "Utility/Device.vala"
		_tmp4_ = device_get_free_bytes (self);
#line 148 "Utility/Device.vala"
		_tmp5_ = _tmp4_;
#line 148 "Utility/Device.vala"
		_tmp6_ = g_strdup_printf ("%.1f GB", _tmp5_ / device_GB);
#line 148 "Utility/Device.vala"
		_g_free0 (_tmp0_);
#line 148 "Utility/Device.vala"
		_tmp0_ = _tmp6_;
#line 13700 "Device.c"
	}
#line 148 "Utility/Device.vala"
	result = _tmp0_;
#line 148 "Utility/Device.vala"
	return result;
#line 13706 "Device.c"
}

gboolean
device_get_is_mounted (Device* self)
{
	gboolean result;
	GeeArrayList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 153 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 154 "Utility/Device.vala"
	_tmp0_ = self->mount_points;
#line 154 "Utility/Device.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 154 "Utility/Device.vala"
	_tmp2_ = _tmp1_;
#line 154 "Utility/Device.vala"
	result = _tmp2_ > 0;
#line 154 "Utility/Device.vala"
	return result;
#line 13728 "Device.c"
}

gchar*
device_get_full_name_with_alias (Device* self)
{
	gchar* result;
	gchar* text = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
#line 1752 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1753 "Utility/Device.vala"
	_tmp0_ = self->device;
#line 1753 "Utility/Device.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 1753 "Utility/Device.vala"
	text = _tmp1_;
#line 1754 "Utility/Device.vala"
	_tmp2_ = self->mapped_name;
#line 1754 "Utility/Device.vala"
	_tmp3_ = strlen (_tmp2_);
#line 1754 "Utility/Device.vala"
	_tmp4_ = _tmp3_;
#line 1754 "Utility/Device.vala"
	if (_tmp4_ > 0) {
#line 13757 "Device.c"
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 1755 "Utility/Device.vala"
		_tmp5_ = text;
#line 1755 "Utility/Device.vala"
		_tmp6_ = self->mapped_name;
#line 1755 "Utility/Device.vala"
		_tmp7_ = g_strdup_printf (" (%s)", _tmp6_);
#line 1755 "Utility/Device.vala"
		_tmp8_ = _tmp7_;
#line 1755 "Utility/Device.vala"
		_tmp9_ = g_strconcat (_tmp5_, _tmp8_, NULL);
#line 1755 "Utility/Device.vala"
		_g_free0 (text);
#line 1755 "Utility/Device.vala"
		text = _tmp9_;
#line 1755 "Utility/Device.vala"
		_g_free0 (_tmp8_);
#line 13779 "Device.c"
	}
#line 1757 "Utility/Device.vala"
	result = text;
#line 1757 "Utility/Device.vala"
	return result;
#line 13785 "Device.c"
}

gchar*
device_get_full_name_with_parent (Device* self)
{
	gchar* result;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1762 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1763 "Utility/Device.vala"
	_tmp0_ = device_get_device_name_with_parent (self);
#line 1763 "Utility/Device.vala"
	_tmp1_ = _tmp0_;
#line 1763 "Utility/Device.vala"
	result = _tmp1_;
#line 1763 "Utility/Device.vala"
	return result;
#line 13804 "Device.c"
}

gchar*
device_get_short_name_with_alias (Device* self)
{
	gchar* result;
	gchar* text = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
#line 1768 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1769 "Utility/Device.vala"
	_tmp0_ = self->kname;
#line 1769 "Utility/Device.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 1769 "Utility/Device.vala"
	text = _tmp1_;
#line 1770 "Utility/Device.vala"
	_tmp2_ = self->mapped_name;
#line 1770 "Utility/Device.vala"
	_tmp3_ = strlen (_tmp2_);
#line 1770 "Utility/Device.vala"
	_tmp4_ = _tmp3_;
#line 1770 "Utility/Device.vala"
	if (_tmp4_ > 0) {
#line 13833 "Device.c"
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 1771 "Utility/Device.vala"
		_tmp5_ = text;
#line 1771 "Utility/Device.vala"
		_tmp6_ = self->mapped_name;
#line 1771 "Utility/Device.vala"
		_tmp7_ = g_strdup_printf (" (%s)", _tmp6_);
#line 1771 "Utility/Device.vala"
		_tmp8_ = _tmp7_;
#line 1771 "Utility/Device.vala"
		_tmp9_ = g_strconcat (_tmp5_, _tmp8_, NULL);
#line 1771 "Utility/Device.vala"
		_g_free0 (text);
#line 1771 "Utility/Device.vala"
		text = _tmp9_;
#line 1771 "Utility/Device.vala"
		_g_free0 (_tmp8_);
#line 13855 "Device.c"
	}
#line 1773 "Utility/Device.vala"
	result = text;
#line 1773 "Utility/Device.vala"
	return result;
#line 13861 "Device.c"
}

gchar*
device_get_short_name_with_parent (Device* self)
{
	gchar* result;
	gchar* text = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
#line 1778 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1779 "Utility/Device.vala"
	_tmp0_ = self->kname;
#line 1779 "Utility/Device.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 1779 "Utility/Device.vala"
	text = _tmp1_;
#line 1781 "Utility/Device.vala"
	if (device_has_parent (self)) {
#line 13882 "Device.c"
		Device* _tmp3_;
		const gchar* _tmp4_;
#line 1781 "Utility/Device.vala"
		_tmp3_ = self->parent;
#line 1781 "Utility/Device.vala"
		_tmp4_ = _tmp3_->type;
#line 1781 "Utility/Device.vala"
		_tmp2_ = g_strcmp0 (_tmp4_, "part") == 0;
#line 13891 "Device.c"
	} else {
#line 1781 "Utility/Device.vala"
		_tmp2_ = FALSE;
#line 13895 "Device.c"
	}
#line 1781 "Utility/Device.vala"
	if (_tmp2_) {
#line 13899 "Device.c"
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 1782 "Utility/Device.vala"
		_tmp5_ = text;
#line 1782 "Utility/Device.vala"
		_tmp6_ = self->pkname;
#line 1782 "Utility/Device.vala"
		_tmp7_ = g_strdup_printf (" (%s)", _tmp6_);
#line 1782 "Utility/Device.vala"
		_tmp8_ = _tmp7_;
#line 1782 "Utility/Device.vala"
		_tmp9_ = g_strconcat (_tmp5_, _tmp8_, NULL);
#line 1782 "Utility/Device.vala"
		_g_free0 (text);
#line 1782 "Utility/Device.vala"
		text = _tmp9_;
#line 1782 "Utility/Device.vala"
		_g_free0 (_tmp8_);
#line 13921 "Device.c"
	}
#line 1785 "Utility/Device.vala"
	result = text;
#line 1785 "Utility/Device.vala"
	return result;
#line 13927 "Device.c"
}

gchar*
device_get_device_name_with_parent (Device* self)
{
	gchar* result;
	gchar* text = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
#line 1790 "Utility/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1791 "Utility/Device.vala"
	_tmp0_ = self->device;
#line 1791 "Utility/Device.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 1791 "Utility/Device.vala"
	text = _tmp1_;
#line 1793 "Utility/Device.vala"
	if (device_has_parent (self)) {
#line 13948 "Device.c"
		Device* _tmp3_;
		const gchar* _tmp4_;
#line 1793 "Utility/Device.vala"
		_tmp3_ = self->parent;
#line 1793 "Utility/Device.vala"
		_tmp4_ = _tmp3_->type;
#line 1793 "Utility/Device.vala"
		_tmp2_ = g_strcmp0 (_tmp4_, "part") == 0;
#line 13957 "Device.c"
	} else {
#line 1793 "Utility/Device.vala"
		_tmp2_ = FALSE;
#line 13961 "Device.c"
	}
#line 1793 "Utility/Device.vala"
	if (_tmp2_) {
#line 13965 "Device.c"
		const gchar* _tmp5_;
		Device* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1794 "Utility/Device.vala"
		_tmp5_ = text;
#line 1794 "Utility/Device.vala"
		_tmp6_ = self->parent;
#line 1794 "Utility/Device.vala"
		_tmp7_ = _tmp6_->kname;
#line 1794 "Utility/Device.vala"
		_tmp8_ = g_strdup_printf (" (%s)", _tmp7_);
#line 1794 "Utility/Device.vala"
		_tmp9_ = _tmp8_;
#line 1794 "Utility/Device.vala"
		_tmp10_ = g_strconcat (_tmp5_, _tmp9_, NULL);
#line 1794 "Utility/Device.vala"
		_g_free0 (text);
#line 1794 "Utility/Device.vala"
		text = _tmp10_;
#line 1794 "Utility/Device.vala"
		_g_free0 (_tmp9_);
#line 13990 "Device.c"
	}
#line 1797 "Utility/Device.vala"
	result = text;
#line 1797 "Utility/Device.vala"
	return result;
#line 13996 "Device.c"
}

static void
device_class_init (DeviceClass * klass,
                   gpointer klass_data)
{
	gchar* _tmp0_;
#line 32 "Utility/Device.vala"
	device_parent_class = g_type_class_peek_parent (klass);
#line 32 "Utility/Device.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_device_get_property;
#line 32 "Utility/Device.vala"
	G_OBJECT_CLASS (klass)->finalize = device_finalize;
#line 32 "Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_FREE_BYTES_PROPERTY, device_properties[DEVICE_FREE_BYTES_PROPERTY] = g_param_spec_uint64 ("free-bytes", "free-bytes", "free-bytes", 0, G_MAXUINT64, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_SIZE_PROPERTY, device_properties[DEVICE_SIZE_PROPERTY] = g_param_spec_string ("size", "size", "size", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_USED_PROPERTY, device_properties[DEVICE_USED_PROPERTY] = g_param_spec_string ("used", "used", "used", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_FREE_PROPERTY, device_properties[DEVICE_FREE_PROPERTY] = g_param_spec_string ("free", "free", "free", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_IS_MOUNTED_PROPERTY, device_properties[DEVICE_IS_MOUNTED_PROPERTY] = g_param_spec_boolean ("is-mounted", "is-mounted", "is-mounted", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_FULL_NAME_WITH_ALIAS_PROPERTY, device_properties[DEVICE_FULL_NAME_WITH_ALIAS_PROPERTY] = g_param_spec_string ("full-name-with-alias", "full-name-with-alias", "full-name-with-alias", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_FULL_NAME_WITH_PARENT_PROPERTY, device_properties[DEVICE_FULL_NAME_WITH_PARENT_PROPERTY] = g_param_spec_string ("full-name-with-parent", "full-name-with-parent", "full-name-with-parent", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_SHORT_NAME_WITH_ALIAS_PROPERTY, device_properties[DEVICE_SHORT_NAME_WITH_ALIAS_PROPERTY] = g_param_spec_string ("short-name-with-alias", "short-name-with-alias", "short-name-with-alias", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_SHORT_NAME_WITH_PARENT_PROPERTY, device_properties[DEVICE_SHORT_NAME_WITH_PARENT_PROPERTY] = g_param_spec_string ("short-name-with-parent", "short-name-with-parent", "short-name-with-parent", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 32 "Utility/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DEVICE_DEVICE_NAME_WITH_PARENT_PROPERTY, device_properties[DEVICE_DEVICE_NAME_WITH_PARENT_PROPERTY] = g_param_spec_string ("device-name-with-parent", "device-name-with-parent", "device-name-with-parent", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 37 "Utility/Device.vala"
	device_MB = 1000 * device_KB;
#line 38 "Utility/Device.vala"
	device_GB = 1000 * device_MB;
#line 41 "Utility/Device.vala"
	device_MiB = 1024 * device_KiB;
#line 42 "Utility/Device.vala"
	device_GiB = 1024 * device_MiB;
#line 89 "Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 89 "Utility/Device.vala"
	device_lsblk_version = _tmp0_;
#line 14042 "Device.c"
}

static void
device_instance_init (Device * self,
                      gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
#line 44 "Utility/Device.vala"
	_tmp0_ = g_strdup ("");
#line 44 "Utility/Device.vala"
	self->device = _tmp0_;
#line 45 "Utility/Device.vala"
	_tmp1_ = g_strdup ("");
#line 45 "Utility/Device.vala"
	self->name = _tmp1_;
#line 46 "Utility/Device.vala"
	_tmp2_ = g_strdup ("");
#line 46 "Utility/Device.vala"
	self->kname = _tmp2_;
#line 47 "Utility/Device.vala"
	_tmp3_ = g_strdup ("");
#line 47 "Utility/Device.vala"
	self->pkname = _tmp3_;
#line 48 "Utility/Device.vala"
	_tmp4_ = g_strdup ("");
#line 48 "Utility/Device.vala"
	self->pkname_toplevel = _tmp4_;
#line 49 "Utility/Device.vala"
	_tmp5_ = g_strdup ("");
#line 49 "Utility/Device.vala"
	self->mapped_name = _tmp5_;
#line 50 "Utility/Device.vala"
	_tmp6_ = g_strdup ("");
#line 50 "Utility/Device.vala"
	self->uuid = _tmp6_;
#line 51 "Utility/Device.vala"
	_tmp7_ = g_strdup ("");
#line 51 "Utility/Device.vala"
	self->label = _tmp7_;
#line 52 "Utility/Device.vala"
	_tmp8_ = g_strdup ("");
#line 52 "Utility/Device.vala"
	self->partuuid = _tmp8_;
#line 53 "Utility/Device.vala"
	_tmp9_ = g_strdup ("");
#line 53 "Utility/Device.vala"
	self->partlabel = _tmp9_;
#line 55 "Utility/Device.vala"
	self->major = -1;
#line 56 "Utility/Device.vala"
	self->minor = -1;
#line 58 "Utility/Device.vala"
	_tmp10_ = g_strdup ("");
#line 58 "Utility/Device.vala"
	self->device_mapper = _tmp10_;
#line 59 "Utility/Device.vala"
	_tmp11_ = g_strdup ("");
#line 59 "Utility/Device.vala"
	self->device_by_uuid = _tmp11_;
#line 60 "Utility/Device.vala"
	_tmp12_ = g_strdup ("");
#line 60 "Utility/Device.vala"
	self->device_by_label = _tmp12_;
#line 61 "Utility/Device.vala"
	_tmp13_ = g_strdup ("");
#line 61 "Utility/Device.vala"
	self->device_by_partuuid = _tmp13_;
#line 62 "Utility/Device.vala"
	_tmp14_ = g_strdup ("");
#line 62 "Utility/Device.vala"
	self->device_by_partlabel = _tmp14_;
#line 64 "Utility/Device.vala"
	_tmp15_ = g_strdup ("");
#line 64 "Utility/Device.vala"
	self->type = _tmp15_;
#line 65 "Utility/Device.vala"
	_tmp16_ = g_strdup ("");
#line 65 "Utility/Device.vala"
	self->fstype = _tmp16_;
#line 67 "Utility/Device.vala"
	self->order = -1;
#line 69 "Utility/Device.vala"
	_tmp17_ = g_strdup ("");
#line 69 "Utility/Device.vala"
	self->vendor = _tmp17_;
#line 70 "Utility/Device.vala"
	_tmp18_ = g_strdup ("");
#line 70 "Utility/Device.vala"
	self->model = _tmp18_;
#line 71 "Utility/Device.vala"
	_tmp19_ = g_strdup ("");
#line 71 "Utility/Device.vala"
	self->serial = _tmp19_;
#line 72 "Utility/Device.vala"
	_tmp20_ = g_strdup ("");
#line 72 "Utility/Device.vala"
	self->revision = _tmp20_;
#line 74 "Utility/Device.vala"
	self->removable = FALSE;
#line 75 "Utility/Device.vala"
	self->read_only = FALSE;
#line 77 "Utility/Device.vala"
	self->size_bytes = (guint64) 0;
#line 78 "Utility/Device.vala"
	self->used_bytes = (guint64) 0;
#line 79 "Utility/Device.vala"
	self->available_bytes = (guint64) 0;
#line 81 "Utility/Device.vala"
	_tmp21_ = g_strdup ("");
#line 81 "Utility/Device.vala"
	self->used_percent = _tmp21_;
#line 82 "Utility/Device.vala"
	_tmp22_ = g_strdup ("");
#line 82 "Utility/Device.vala"
	self->dist_info = _tmp22_;
#line 86 "Utility/Device.vala"
	self->parent = NULL;
#line 87 "Utility/Device.vala"
	self->children = NULL;
#line 14184 "Device.c"
}

static void
device_finalize (GObject * obj)
{
	Device * self;
#line 32 "Utility/Device.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DEVICE, Device);
#line 44 "Utility/Device.vala"
	_g_free0 (self->device);
#line 45 "Utility/Device.vala"
	_g_free0 (self->name);
#line 46 "Utility/Device.vala"
	_g_free0 (self->kname);
#line 47 "Utility/Device.vala"
	_g_free0 (self->pkname);
#line 48 "Utility/Device.vala"
	_g_free0 (self->pkname_toplevel);
#line 49 "Utility/Device.vala"
	_g_free0 (self->mapped_name);
#line 50 "Utility/Device.vala"
	_g_free0 (self->uuid);
#line 51 "Utility/Device.vala"
	_g_free0 (self->label);
#line 52 "Utility/Device.vala"
	_g_free0 (self->partuuid);
#line 53 "Utility/Device.vala"
	_g_free0 (self->partlabel);
#line 58 "Utility/Device.vala"
	_g_free0 (self->device_mapper);
#line 59 "Utility/Device.vala"
	_g_free0 (self->device_by_uuid);
#line 60 "Utility/Device.vala"
	_g_free0 (self->device_by_label);
#line 61 "Utility/Device.vala"
	_g_free0 (self->device_by_partuuid);
#line 62 "Utility/Device.vala"
	_g_free0 (self->device_by_partlabel);
#line 64 "Utility/Device.vala"
	_g_free0 (self->type);
#line 65 "Utility/Device.vala"
	_g_free0 (self->fstype);
#line 69 "Utility/Device.vala"
	_g_free0 (self->vendor);
#line 70 "Utility/Device.vala"
	_g_free0 (self->model);
#line 71 "Utility/Device.vala"
	_g_free0 (self->serial);
#line 72 "Utility/Device.vala"
	_g_free0 (self->revision);
#line 81 "Utility/Device.vala"
	_g_free0 (self->used_percent);
#line 82 "Utility/Device.vala"
	_g_free0 (self->dist_info);
#line 83 "Utility/Device.vala"
	_g_object_unref0 (self->mount_points);
#line 84 "Utility/Device.vala"
	_g_object_unref0 (self->symlinks);
#line 86 "Utility/Device.vala"
	_g_object_unref0 (self->parent);
#line 87 "Utility/Device.vala"
	_g_object_unref0 (self->children);
#line 32 "Utility/Device.vala"
	G_OBJECT_CLASS (device_parent_class)->finalize (obj);
#line 14249 "Device.c"
}

GType
device_get_type (void)
{
	static volatile gsize device_type_id__volatile = 0;
	if (g_once_init_enter (&device_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DeviceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) device_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Device), 0, (GInstanceInitFunc) device_instance_init, NULL };
		GType device_type_id;
		device_type_id = g_type_register_static (G_TYPE_OBJECT, "Device", &g_define_type_info, 0);
		g_once_init_leave (&device_type_id__volatile, device_type_id);
	}
	return device_type_id__volatile;
}

static void
_vala_device_get_property (GObject * object,
                           guint property_id,
                           GValue * value,
                           GParamSpec * pspec)
{
	Device * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DEVICE, Device);
#line 32 "Utility/Device.vala"
	switch (property_id) {
#line 32 "Utility/Device.vala"
		case DEVICE_FREE_BYTES_PROPERTY:
#line 32 "Utility/Device.vala"
		g_value_set_uint64 (value, device_get_free_bytes (self));
#line 32 "Utility/Device.vala"
		break;
#line 32 "Utility/Device.vala"
		case DEVICE_SIZE_PROPERTY:
#line 32 "Utility/Device.vala"
		g_value_take_string (value, device_get_size (self));
#line 32 "Utility/Device.vala"
		break;
#line 32 "Utility/Device.vala"
		case DEVICE_USED_PROPERTY:
#line 32 "Utility/Device.vala"
		g_value_take_string (value, device_get_used (self));
#line 32 "Utility/Device.vala"
		break;
#line 32 "Utility/Device.vala"
		case DEVICE_FREE_PROPERTY:
#line 32 "Utility/Device.vala"
		g_value_take_string (value, device_get_free (self));
#line 32 "Utility/Device.vala"
		break;
#line 32 "Utility/Device.vala"
		case DEVICE_IS_MOUNTED_PROPERTY:
#line 32 "Utility/Device.vala"
		g_value_set_boolean (value, device_get_is_mounted (self));
#line 32 "Utility/Device.vala"
		break;
#line 32 "Utility/Device.vala"
		case DEVICE_FULL_NAME_WITH_ALIAS_PROPERTY:
#line 32 "Utility/Device.vala"
		g_value_take_string (value, device_get_full_name_with_alias (self));
#line 32 "Utility/Device.vala"
		break;
#line 32 "Utility/Device.vala"
		case DEVICE_FULL_NAME_WITH_PARENT_PROPERTY:
#line 32 "Utility/Device.vala"
		g_value_take_string (value, device_get_full_name_with_parent (self));
#line 32 "Utility/Device.vala"
		break;
#line 32 "Utility/Device.vala"
		case DEVICE_SHORT_NAME_WITH_ALIAS_PROPERTY:
#line 32 "Utility/Device.vala"
		g_value_take_string (value, device_get_short_name_with_alias (self));
#line 32 "Utility/Device.vala"
		break;
#line 32 "Utility/Device.vala"
		case DEVICE_SHORT_NAME_WITH_PARENT_PROPERTY:
#line 32 "Utility/Device.vala"
		g_value_take_string (value, device_get_short_name_with_parent (self));
#line 32 "Utility/Device.vala"
		break;
#line 32 "Utility/Device.vala"
		case DEVICE_DEVICE_NAME_WITH_PARENT_PROPERTY:
#line 32 "Utility/Device.vala"
		g_value_take_string (value, device_get_device_name_with_parent (self));
#line 32 "Utility/Device.vala"
		break;
#line 14335 "Device.c"
		default:
#line 32 "Utility/Device.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 32 "Utility/Device.vala"
		break;
#line 14341 "Device.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

